/**
 * Datascript-Async
 *
 * Copyright 2015 Icon Systems, Inc.
 *
 * Query Engine originally from Datascript v0.11.5 <https://github.com/tonsky/datascript>
 * which is Copyright 2014-2015 Nikita Prokopov
 *
 * Licensed under Eclipse Public License;
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * https://github.com/tonsky/datascript/blob/master/LICENSE
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function (definition) {
    // This file will function properly as a <script> tag, or a module
    // using CommonJS and NodeJS or RequireJS module formats. In
    // Common/Node/RequireJS, the module exports the mori API and when
    // executed as a simple <script>, it creates a mori global
    // instead.

    // Wrapper gratefully adapted from:
    // https://github.com/kriskowal/q/blob/v1/q.js
    // https://github.com/swannodette/mori/blob/master/support/wrapper.js

    // CommonJS
    if (typeof exports === "object") {
        module.exports = definition();

    // RequireJS
    } else if (typeof define === "function" && define.amd) {
        define(definition);

    // <script>
    } else {
        datascript = definition();
    }
})(function () {
    return function () {
if(typeof Math.imul == "undefined" || (Math.imul(0xffffffff,5) == 0)) {
    Math.imul = function (a, b) {
        var ah  = (a >>> 16) & 0xffff;
        var al = a & 0xffff;
        var bh  = (b >>> 16) & 0xffff;
        var bl = b & 0xffff;
        // the shift by 0 fixes the sign on the high part
        // the final |0 converts the unsigned value into a signed value
        return ((al * bl) + (((ah * bl + al * bh) << 16) >>> 0)|0);
    }
}


var g,aa=this;
function ba(b){var a=typeof b;if("object"==a)if(b){if(b instanceof Array)return"array";if(b instanceof Object)return a;var c=Object.prototype.toString.call(b);if("[object Window]"==c)return"object";if("[object Array]"==c||"number"==typeof b.length&&"undefined"!=typeof b.splice&&"undefined"!=typeof b.propertyIsEnumerable&&!b.propertyIsEnumerable("splice"))return"array";if("[object Function]"==c||"undefined"!=typeof b.call&&"undefined"!=typeof b.propertyIsEnumerable&&!b.propertyIsEnumerable("call"))return"function"}else return"null";else if("function"==
a&&"undefined"==typeof b.call)return"object";return a}var ca="closure_uid_"+(1E9*Math.random()>>>0),da=0;function fa(b,a,c){return b.call.apply(b.bind,arguments)}function ga(b,a,c){if(!b)throw Error();if(2<arguments.length){var d=Array.prototype.slice.call(arguments,2);return function(){var c=Array.prototype.slice.call(arguments);Array.prototype.unshift.apply(c,d);return b.apply(a,c)}}return function(){return b.apply(a,arguments)}}
function ha(b,a,c){ha=Function.prototype.bind&&-1!=Function.prototype.bind.toString().indexOf("native code")?fa:ga;return ha.apply(null,arguments)}function ia(b,a){var c=b.split("."),d=aa;c[0]in d||!d.execScript||d.execScript("var "+c[0]);for(var e;c.length&&(e=c.shift());)c.length||void 0===a?d=d[e]?d[e]:d[e]={}:d[e]=a};function ja(b){return Array.prototype.join.call(arguments,"")};function ka(b,a){for(var c in b)a.call(void 0,b[c],c,b)};function la(b,a){null!=b&&this.append.apply(this,arguments)}g=la.prototype;g.Jb="";g.set=function(b){this.Jb=""+b};g.append=function(b,a,c){this.Jb+=b;if(null!=a)for(var d=1;d<arguments.length;d++)this.Jb+=arguments[d];return this};g.clear=function(){this.Jb=""};g.toString=function(){return this.Jb};function ma(b,a){b.sort(a||oa)}function qa(b,a){for(var c=0;c<b.length;c++)b[c]={index:c,value:b[c]};var d=a||oa;ma(b,function(a,b){return d(a.value,b.value)||a.index-b.index});for(c=0;c<b.length;c++)b[c]=b[c].value}function oa(b,a){return b>a?1:b<a?-1:0};if("undefined"===typeof ra)var ra=function(){throw Error("No *print-fn* fn set for evaluation environment");};var sa=!0,ua=null;if("undefined"===typeof va)var va=null;function wa(){return new m(null,5,[xa,!0,ya,!0,za,!1,Aa,!1,Ba,null],null)}
function Ca(){sa=!1;ra=function(){function b(b){var d=null;if(0<arguments.length){for(var d=0,e=Array(arguments.length-0);d<e.length;)e[d]=arguments[d+0],++d;d=new Da(e,0)}return a.call(this,d)}function a(a){return console.log.apply(console,Ea?Ga(a):Ha.call(null,a))}b.G=0;b.I=function(b){b=q(b);return a(b)};b.j=a;return b}()}function r(b){return null!=b&&!1!==b}function Ia(b){return null==b}function Ja(b){return Array.isArray(b)}function Ka(b){return r(b)?!1:!0}
function La(b,a){return b[ba(null==a?null:a)]?!0:b._?!0:!1}var Oa=null;function Pa(b){return null==b?null:b.constructor}function Qa(b,a){var c=Pa(a),c=r(r(c)?c.Nc:c)?c.Mc:ba(a);return Error(["No protocol method ",b," defined for type ",c,": ",a].join(""))}function Ra(b){var a=b.Mc;return r(a)?a:""+u(b)}var Sa="undefined"!==typeof Symbol&&"function"===ba(Symbol)?Symbol.iterator:"@@iterator";
function Ta(){switch(arguments.length){case 1:return Array(arguments[0]);case 2:return Array(arguments[1]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}function Ua(b){return Array(b)}function Va(b){for(var a=b.length,c=Array(a),d=0;;)if(d<a)c[d]=b[d],d+=1;else break;return c}function Ha(){switch(arguments.length){case 1:return Ga(arguments[0]);case 2:return Ga(arguments[1]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}
function Ea(b){return Ga(b)}function Ga(b){function a(a,b){a.push(b);return a}var c=[];return w?w(a,c,b):Wa.call(null,a,c,b)}
var Xa={},Ya={},Za=function Za(a){if(a?a.O:a)return a.O(a);var c;c=Za[ba(null==a?null:a)];if(!c&&(c=Za._,!c))throw Qa("ICounted.-count",a);return c.call(null,a)},ab=function ab(a){if(a?a.ea:a)return a.ea(a);var c;c=ab[ba(null==a?null:a)];if(!c&&(c=ab._,!c))throw Qa("IEmptyableCollection.-empty",a);return c.call(null,a)},bb={},cb=function cb(a,c){if(a?a.P:a)return a.P(a,c);var d;d=cb[ba(null==a?null:a)];if(!d&&(d=cb._,!d))throw Qa("ICollection.-conj",a);return d.call(null,a,c)},db={},x=function x(){switch(arguments.length){case 2:return x.b(arguments[0],
arguments[1]);case 3:return x.g(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};x.b=function(b,a){if(b?b.R:b)return b.R(b,a);var c;c=x[ba(null==b?null:b)];if(!c&&(c=x._,!c))throw Qa("IIndexed.-nth",b);return c.call(null,b,a)};x.g=function(b,a,c){if(b?b.za:b)return b.za(b,a,c);var d;d=x[ba(null==b?null:b)];if(!d&&(d=x._,!d))throw Qa("IIndexed.-nth",b);return d.call(null,b,a,c)};x.G=3;
var eb={},fb=function fb(a){if(a?a.ka:a)return a.ka(a);var c;c=fb[ba(null==a?null:a)];if(!c&&(c=fb._,!c))throw Qa("ISeq.-first",a);return c.call(null,a)},hb=function hb(a){if(a?a.oa:a)return a.oa(a);var c;c=hb[ba(null==a?null:a)];if(!c&&(c=hb._,!c))throw Qa("ISeq.-rest",a);return c.call(null,a)},kb={},mb={},nb=function nb(){switch(arguments.length){case 2:return nb.b(arguments[0],arguments[1]);case 3:return nb.g(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));
}};nb.b=function(b,a){if(b?b.D:b)return b.D(b,a);var c;c=nb[ba(null==b?null:b)];if(!c&&(c=nb._,!c))throw Qa("ILookup.-lookup",b);return c.call(null,b,a)};nb.g=function(b,a,c){if(b?b.C:b)return b.C(b,a,c);var d;d=nb[ba(null==b?null:b)];if(!d&&(d=nb._,!d))throw Qa("ILookup.-lookup",b);return d.call(null,b,a,c)};nb.G=3;
var pb=function pb(a,c){if(a?a.Vb:a)return a.Vb(a,c);var d;d=pb[ba(null==a?null:a)];if(!d&&(d=pb._,!d))throw Qa("IAssociative.-contains-key?",a);return d.call(null,a,c)},qb=function qb(a,c,d){if(a?a.T:a)return a.T(a,c,d);var e;e=qb[ba(null==a?null:a)];if(!e&&(e=qb._,!e))throw Qa("IAssociative.-assoc",a);return e.call(null,a,c,d)},rb={},sb=function sb(a,c){if(a?a.V:a)return a.V(a,c);var d;d=sb[ba(null==a?null:a)];if(!d&&(d=sb._,!d))throw Qa("IMap.-dissoc",a);return d.call(null,a,c)},tb={},ub=function ub(a){if(a?
a.rc:a)return a.rc(a);var c;c=ub[ba(null==a?null:a)];if(!c&&(c=ub._,!c))throw Qa("IMapEntry.-key",a);return c.call(null,a)},vb=function vb(a){if(a?a.sc:a)return a.sc(a);var c;c=vb[ba(null==a?null:a)];if(!c&&(c=vb._,!c))throw Qa("IMapEntry.-val",a);return c.call(null,a)},wb={},xb=function xb(a,c){if(a?a.Kc:a)return a.Kc(a,c);var d;d=xb[ba(null==a?null:a)];if(!d&&(d=xb._,!d))throw Qa("ISet.-disjoin",a);return d.call(null,a,c)},yb=function yb(a){if(a?a.Lb:a)return a.Lb(a);var c;c=yb[ba(null==a?null:
a)];if(!c&&(c=yb._,!c))throw Qa("IStack.-peek",a);return c.call(null,a)},Ab={},Bb=function Bb(a,c,d){if(a?a.Yb:a)return a.Yb(a,c,d);var e;e=Bb[ba(null==a?null:a)];if(!e&&(e=Bb._,!e))throw Qa("IVector.-assoc-n",a);return e.call(null,a,c,d)},Cb=function Cb(a){if(a?a.pc:a)return a.pc(a);var c;c=Cb[ba(null==a?null:a)];if(!c&&(c=Cb._,!c))throw Qa("IDeref.-deref",a);return c.call(null,a)},Db={},Fb=function Fb(a){if(a?a.M:a)return a.M(a);var c;c=Fb[ba(null==a?null:a)];if(!c&&(c=Fb._,!c))throw Qa("IMeta.-meta",
a);return c.call(null,a)},Hb={},Ib=function Ib(a,c){if(a?a.N:a)return a.N(a,c);var d;d=Ib[ba(null==a?null:a)];if(!d&&(d=Ib._,!d))throw Qa("IWithMeta.-with-meta",a);return d.call(null,a,c)},Jb={},Kb=function Kb(){switch(arguments.length){case 2:return Kb.b(arguments[0],arguments[1]);case 3:return Kb.g(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};
Kb.b=function(b,a){if(b?b.la:b)return b.la(b,a);var c;c=Kb[ba(null==b?null:b)];if(!c&&(c=Kb._,!c))throw Qa("IReduce.-reduce",b);return c.call(null,b,a)};Kb.g=function(b,a,c){if(b?b.ma:b)return b.ma(b,a,c);var d;d=Kb[ba(null==b?null:b)];if(!d&&(d=Kb._,!d))throw Qa("IReduce.-reduce",b);return d.call(null,b,a,c)};Kb.G=3;
var Mb=function Mb(a,c,d){if(a?a.jc:a)return a.jc(a,c,d);var e;e=Mb[ba(null==a?null:a)];if(!e&&(e=Mb._,!e))throw Qa("IKVReduce.-kv-reduce",a);return e.call(null,a,c,d)},Nb=function Nb(a,c){if(a?a.u:a)return a.u(a,c);var d;d=Nb[ba(null==a?null:a)];if(!d&&(d=Nb._,!d))throw Qa("IEquiv.-equiv",a);return d.call(null,a,c)},Ob=function Ob(a){if(a?a.J:a)return a.J(a);var c;c=Ob[ba(null==a?null:a)];if(!c&&(c=Ob._,!c))throw Qa("IHash.-hash",a);return c.call(null,a)},Pb={},Qb=function Qb(a){if(a?a.K:a)return a.K(a);
var c;c=Qb[ba(null==a?null:a)];if(!c&&(c=Qb._,!c))throw Qa("ISeqable.-seq",a);return c.call(null,a)},Rb={},Sb={},Ub=function Ub(a){if(a?a.Za:a)return a.Za(a);var c;c=Ub[ba(null==a?null:a)];if(!c&&(c=Ub._,!c))throw Qa("IReversible.-rseq",a);return c.call(null,a)},Vb=function Vb(a,c){if(a?a.Ad:a)return a.Ad(0,c);var d;d=Vb[ba(null==a?null:a)];if(!d&&(d=Vb._,!d))throw Qa("IWriter.-write",a);return d.call(null,a,c)},Wb={},Yb=function Yb(a,c,d){if(a?a.H:a)return a.H(a,c,d);var e;e=Yb[ba(null==a?null:a)];
if(!e&&(e=Yb._,!e))throw Qa("IPrintWithWriter.-pr-writer",a);return e.call(null,a,c,d)},Zb=function Zb(a,c,d){if(a?a.zd:a)return a.zd(0,c,d);var e;e=Zb[ba(null==a?null:a)];if(!e&&(e=Zb._,!e))throw Qa("IWatchable.-notify-watches",a);return e.call(null,a,c,d)},$b=function $b(a){if(a?a.ic:a)return a.ic(a);var c;c=$b[ba(null==a?null:a)];if(!c&&(c=$b._,!c))throw Qa("IEditableCollection.-as-transient",a);return c.call(null,a)},ac=function ac(a,c){if(a?a.Xb:a)return a.Xb(a,c);var d;d=ac[ba(null==a?null:
a)];if(!d&&(d=ac._,!d))throw Qa("ITransientCollection.-conj!",a);return d.call(null,a,c)},bc=function bc(a){if(a?a.kc:a)return a.kc(a);var c;c=bc[ba(null==a?null:a)];if(!c&&(c=bc._,!c))throw Qa("ITransientCollection.-persistent!",a);return c.call(null,a)},cc=function cc(a,c,d){if(a?a.uc:a)return a.uc(a,c,d);var e;e=cc[ba(null==a?null:a)];if(!e&&(e=cc._,!e))throw Qa("ITransientAssociative.-assoc!",a);return e.call(null,a,c,d)},dc=function dc(a,c,d){if(a?a.xd:a)return a.xd(0,c,d);var e;e=dc[ba(null==
a?null:a)];if(!e&&(e=dc._,!e))throw Qa("ITransientVector.-assoc-n!",a);return e.call(null,a,c,d)},ec={},fc=function fc(a,c){if(a?a.Wb:a)return a.Wb(a,c);var d;d=fc[ba(null==a?null:a)];if(!d&&(d=fc._,!d))throw Qa("IComparable.-compare",a);return d.call(null,a,c)},gc=function gc(a){if(a?a.ud:a)return a.ud();var c;c=gc[ba(null==a?null:a)];if(!c&&(c=gc._,!c))throw Qa("IChunk.-drop-first",a);return c.call(null,a)},hc=function hc(a){if(a?a.Gc:a)return a.Gc(a);var c;c=hc[ba(null==a?null:a)];if(!c&&(c=hc._,
!c))throw Qa("IChunkedSeq.-chunked-first",a);return c.call(null,a)},ic=function ic(a){if(a?a.Hc:a)return a.Hc(a);var c;c=ic[ba(null==a?null:a)];if(!c&&(c=ic._,!c))throw Qa("IChunkedSeq.-chunked-rest",a);return c.call(null,a)},jc=function jc(a){if(a?a.Fc:a)return a.Fc(a);var c;c=jc[ba(null==a?null:a)];if(!c&&(c=jc._,!c))throw Qa("IChunkedNext.-chunked-next",a);return c.call(null,a)},kc=function kc(a,c){if(a?a.$d:a)return a.$d(a,c);var d;d=kc[ba(null==a?null:a)];if(!d&&(d=kc._,!d))throw Qa("IReset.-reset!",
a);return d.call(null,a,c)},lc=function lc(){switch(arguments.length){case 2:return lc.b(arguments[0],arguments[1]);case 3:return lc.g(arguments[0],arguments[1],arguments[2]);case 4:return lc.S(arguments[0],arguments[1],arguments[2],arguments[3]);case 5:return lc.Z(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};
lc.b=function(b,a){if(b?b.be:b)return b.be(b,a);var c;c=lc[ba(null==b?null:b)];if(!c&&(c=lc._,!c))throw Qa("ISwap.-swap!",b);return c.call(null,b,a)};lc.g=function(b,a,c){if(b?b.ce:b)return b.ce(b,a,c);var d;d=lc[ba(null==b?null:b)];if(!d&&(d=lc._,!d))throw Qa("ISwap.-swap!",b);return d.call(null,b,a,c)};lc.S=function(b,a,c,d){if(b?b.de:b)return b.de(b,a,c,d);var e;e=lc[ba(null==b?null:b)];if(!e&&(e=lc._,!e))throw Qa("ISwap.-swap!",b);return e.call(null,b,a,c,d)};
lc.Z=function(b,a,c,d,e){if(b?b.ee:b)return b.ee(b,a,c,d,e);var f;f=lc[ba(null==b?null:b)];if(!f&&(f=lc._,!f))throw Qa("ISwap.-swap!",b);return f.call(null,b,a,c,d,e)};lc.G=5;var mc=function mc(a,c){if(a?a.yd:a)return a.yd(0,c);var d;d=mc[ba(null==a?null:a)];if(!d&&(d=mc._,!d))throw Qa("IVolatile.-vreset!",a);return d.call(null,a,c)},nc=function nc(a){if(a?a.qc:a)return a.qc(a);var c;c=nc[ba(null==a?null:a)];if(!c&&(c=nc._,!c))throw Qa("IIterable.-iterator",a);return c.call(null,a)};
function oc(b){this.ke=b;this.m=1073741824;this.B=0}oc.prototype.Ad=function(b,a){return this.ke.append(a)};function pc(b){var a=new la;b.H(null,new oc(a),wa());return""+u(a)}var qc="undefined"!==typeof Math.imul&&0!==Math.imul(4294967295,5)?function(b,a){return Math.imul(b,a)}:function(b,a){var c=b&65535,d=a&65535;return c*d+((b>>>16&65535)*d+c*(a>>>16&65535)<<16>>>0)|0};function rc(b){b=qc(b|0,-862048943);return qc(b<<15|b>>>-15,461845907)}
function sc(b,a){var c=(b|0)^(a|0);return qc(c<<13|c>>>-13,5)+-430675100|0}function tc(b,a){var c=(b|0)^a,c=qc(c^c>>>16,-2048144789),c=qc(c^c>>>13,-1028477387);return c^c>>>16}function uc(b){var a;a:{a=1;for(var c=0;;)if(a<b.length){var d=a+2,c=sc(c,rc(b.charCodeAt(a-1)|b.charCodeAt(a)<<16));a=d}else{a=c;break a}}a=1===(b.length&1)?a^rc(b.charCodeAt(b.length-1)):a;return tc(a,qc(2,b.length))}var vc={},wc=0;
function Bc(b){255<wc&&(vc={},wc=0);var a=vc[b];if("number"!==typeof a){a:if(null!=b)if(a=b.length,0<a)for(var c=0,d=0;;)if(c<a)var e=c+1,d=qc(31,d)+b.charCodeAt(c),c=e;else{a=d;break a}else a=0;else a=0;vc[b]=a;wc+=1}return b=a}function Cc(b){b&&(b.m&4194304||b.vd)?b=b.J(null):"number"===typeof b?b=Math.floor(b)%2147483647:!0===b?b=1:!1===b?b=0:"string"===typeof b?(b=Bc(b),0!==b&&(b=rc(b),b=sc(0,b),b=tc(b,4))):b=b instanceof Date?b.valueOf():null==b?0:Ob(b);return b}
function Fc(b,a){return b^a+2654435769+(b<<6)+(b>>2)}function Gc(b){return b instanceof A}function Hc(b,a){if(b.hb===a.hb)return 0;var c=Ka(b.wa);if(r(c?a.wa:c))return-1;if(r(b.wa)){if(Ka(a.wa))return 1;c=oa(b.wa,a.wa);return 0===c?oa(b.name,a.name):c}return oa(b.name,a.name)}function A(b,a,c,d,e){this.wa=b;this.name=a;this.hb=c;this.hc=d;this.xa=e;this.m=2154168321;this.B=4096}g=A.prototype;g.toString=function(){return this.hb};g.equiv=function(b){return this.u(null,b)};
g.u=function(b,a){return a instanceof A?this.hb===a.hb:!1};g.call=function(){var b=null,b=function(a,b,d){switch(arguments.length){case 2:return nb.g(b,this,null);case 3:return nb.g(b,this,d)}throw Error("Invalid arity: "+arguments.length);};b.b=function(a,b){return nb.g(b,this,null)};b.g=function(a,b,d){return nb.g(b,this,d)};return b}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return nb.g(b,this,null)};g.b=function(b,a){return nb.g(b,this,a)};
g.M=function(){return this.xa};g.N=function(b,a){return new A(this.wa,this.name,this.hb,this.hc,a)};g.J=function(){var b=this.hc;return null!=b?b:this.hc=b=Fc(uc(this.name),Bc(this.wa))};g.H=function(b,a){return Vb(a,this.hb)};function Ic(b){return b instanceof A?b:Kc(null,b)}function Kc(b,a){var c=null!=b?[u(b),u("/"),u(a)].join(""):a;return new A(b,a,c,null,null)}
function q(b){if(null==b)return null;if(b&&(b.m&8388608||b.Wc))return b.K(null);if(Ja(b)||"string"===typeof b)return 0===b.length?null:new Da(b,0);if(La(Pb,b))return Qb(b);throw Error([u(b),u(" is not ISeqable")].join(""));}function B(b){if(null==b)return null;if(b&&(b.m&64||b.tc))return b.ka(null);b=q(b);return null==b?null:fb(b)}function Mc(b){return null!=b?b&&(b.m&64||b.tc)?b.oa(null):(b=q(b))?hb(b):Nc:Nc}function C(b){return null==b?null:b&&(b.m&128||b.Jc)?b.sa(null):q(Mc(b))}
var E=function E(){switch(arguments.length){case 1:return E.c(arguments[0]);case 2:return E.b(arguments[0],arguments[1]);default:return E.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};E.c=function(){return!0};E.b=function(b,a){return null==b?null==a:b===a||Nb(b,a)};E.j=function(b,a,c){for(;;)if(E.b(b,a))if(C(c))b=a,a=B(c),c=C(c);else return E.b(a,B(c));else return!1};E.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return E.j(a,b,c)};E.G=2;
function Pc(b){this.Y=b}Pc.prototype.next=function(){if(null!=this.Y){var b=B(this.Y);this.Y=C(this.Y);return{value:b,done:!1}}return{value:null,done:!0}};function Qc(b){return new Pc(q(b))}function Rc(b,a){var c=rc(b),c=sc(0,c);return tc(c,a)}function Sc(b){var a=0,c=1;for(b=q(b);;)if(null!=b)a+=1,c=qc(31,c)+Cc(B(b))|0,b=C(b);else return Rc(c,a)}var Uc=Rc(1,0);function Vc(b){var a=0,c=0;for(b=q(b);;)if(null!=b)a+=1,c=c+Cc(B(b))|0,b=C(b);else return Rc(c,a)}var Wc=Rc(0,0);Ya["null"]=!0;
Za["null"]=function(){return 0};Date.prototype.u=function(b,a){return a instanceof Date&&this.valueOf()===a.valueOf()};Date.prototype.oc=!0;Date.prototype.Wb=function(b,a){if(a instanceof Date)return oa(this.valueOf(),a.valueOf());throw Error([u("Cannot compare "),u(this),u(" to "),u(a)].join(""));};Nb.number=function(b,a){return b===a};Xa["function"]=!0;Db["function"]=!0;Fb["function"]=function(){return null};Ob._=function(b){return b[ca]||(b[ca]=++da)};function Xc(b){return b+1}
function Yc(b){this.F=b;this.m=32768;this.B=0}Yc.prototype.pc=function(){return this.F};function Zc(b){return b instanceof Yc}function $c(b){return Cb(b)}function ad(b,a){var c=Za(b);if(0===c)return a.w?a.w():a.call(null);for(var d=x.b(b,0),e=1;;)if(e<c){var f=x.b(b,e),d=a.b?a.b(d,f):a.call(null,d,f);if(Zc(d))return Cb(d);e+=1}else return d}function ed(b,a,c){var d=Za(b),e=c;for(c=0;;)if(c<d){var f=x.b(b,c),e=a.b?a.b(e,f):a.call(null,e,f);if(Zc(e))return Cb(e);c+=1}else return e}
function fd(b,a){var c=b.length;if(0===b.length)return a.w?a.w():a.call(null);for(var d=b[0],e=1;;)if(e<c){var f=b[e],d=a.b?a.b(d,f):a.call(null,d,f);if(Zc(d))return Cb(d);e+=1}else return d}function gd(b,a,c){var d=b.length,e=c;for(c=0;;)if(c<d){var f=b[c],e=a.b?a.b(e,f):a.call(null,e,f);if(Zc(e))return Cb(e);c+=1}else return e}function hd(b,a,c,d){for(var e=b.length;;)if(d<e){var f=b[d];c=a.b?a.b(c,f):a.call(null,c,f);if(Zc(c))return Cb(c);d+=1}else return c}
function jd(b){return b?b.m&2||b.Uc?!0:b.m?!1:La(Ya,b):La(Ya,b)}function kd(b){return b?b.m&16||b.wd?!0:b.m?!1:La(db,b):La(db,b)}function ld(b,a){this.l=b;this.L=a}ld.prototype.Rc=function(){return this.L<this.l.length};ld.prototype.next=function(){var b=this.l[this.L];this.L+=1;return b};function Da(b,a){this.l=b;this.L=a;this.m=166199550;this.B=8192}g=Da.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};
g.R=function(b,a){var c=a+this.L;return c<this.l.length?this.l[c]:null};g.za=function(b,a,c){b=a+this.L;return b<this.l.length?this.l[b]:c};g.qc=function(){return new ld(this.l,this.L)};g.sa=function(){return this.L+1<this.l.length?new Da(this.l,this.L+1):null};g.O=function(){var b=this.l.length-this.L;return 0>b?0:b};g.Za=function(){var b=Za(this);return 0<b?new md(this,b-1,null):null};g.J=function(){return Sc(this)};g.u=function(b,a){return sd.b?sd.b(this,a):sd.call(null,this,a)};g.ea=function(){return Nc};
g.la=function(b,a){return hd(this.l,a,this.l[this.L],this.L+1)};g.ma=function(b,a,c){return hd(this.l,a,c,this.L)};g.ka=function(){return this.l[this.L]};g.oa=function(){return this.L+1<this.l.length?new Da(this.l,this.L+1):Nc};g.K=function(){return this.L<this.l.length?this:null};g.P=function(b,a){return td.b?td.b(a,this):td.call(null,a,this)};Da.prototype[Sa]=function(){return Qc(this)};function ud(b,a){return a<b.length?new Da(b,a):null}
function F(){switch(arguments.length){case 1:return ud(arguments[0],0);case 2:return ud(arguments[0],arguments[1]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}function md(b,a,c){this.Ec=b;this.L=a;this.A=c;this.m=32374990;this.B=8192}g=md.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.M=function(){return this.A};g.sa=function(){return 0<this.L?new md(this.Ec,this.L-1,null):null};g.O=function(){return this.L+1};g.J=function(){return Sc(this)};
g.u=function(b,a){return sd.b?sd.b(this,a):sd.call(null,this,a)};g.ea=function(){var b=this.A;return wd.b?wd.b(Nc,b):wd.call(null,Nc,b)};g.la=function(b,a){return xd?xd(a,this):yd.call(null,a,this)};g.ma=function(b,a,c){return zd?zd(a,c,this):yd.call(null,a,c,this)};g.ka=function(){return x.b(this.Ec,this.L)};g.oa=function(){return 0<this.L?new md(this.Ec,this.L-1,null):Nc};g.K=function(){return this};g.N=function(b,a){return new md(this.Ec,this.L,a)};
g.P=function(b,a){return td.b?td.b(a,this):td.call(null,a,this)};md.prototype[Sa]=function(){return Qc(this)};function Ad(b){return B(C(b))}function Bd(b){return B(B(b))}function Cd(b){for(;;){var a=C(b);if(null!=a)b=a;else return B(b)}}Nb._=function(b,a){return b===a};
var Dd=function Dd(){switch(arguments.length){case 0:return Dd.w();case 1:return Dd.c(arguments[0]);case 2:return Dd.b(arguments[0],arguments[1]);default:return Dd.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};Dd.w=function(){return Ed};Dd.c=function(b){return b};Dd.b=function(b,a){return null!=b?cb(b,a):cb(Nc,a)};Dd.j=function(b,a,c){for(;;)if(r(c))b=Dd.b(b,a),a=B(c),c=C(c);else return Dd.b(b,a)};
Dd.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return Dd.j(a,b,c)};Dd.G=2;function G(b){if(null!=b)if(b&&(b.m&2||b.Uc))b=b.O(null);else if(Ja(b))b=b.length;else if("string"===typeof b)b=b.length;else if(La(Ya,b))b=Za(b);else a:{b=q(b);for(var a=0;;){if(jd(b)){b=a+Za(b);break a}b=C(b);a+=1}}else b=0;return b}function Fd(b,a){for(var c=null;;){if(null==b)return c;if(0===a)return q(b)?B(b):c;if(kd(b))return x.g(b,a,c);if(q(b)){var d=C(b),e=a-1;b=d;a=e}else return c}}
function Hd(b,a){if("number"!==typeof a)throw Error("index argument to nth must be a number");if(null==b)return b;if(b&&(b.m&16||b.wd))return b.R(null,a);if(Ja(b)||"string"===typeof b)return a<b.length?b[a]:null;if(La(db,b))return x.b(b,a);if(b?b.m&64||b.tc||(b.m?0:La(eb,b)):La(eb,b)){var c;a:{c=b;for(var d=a;;){if(null==c)throw Error("Index out of bounds");if(0===d){if(q(c)){c=B(c);break a}throw Error("Index out of bounds");}if(kd(c)){c=x.b(c,d);break a}if(q(c))c=C(c),--d;else throw Error("Index out of bounds");
}}return c}throw Error([u("nth not supported on this type "),u(Ra(Pa(b)))].join(""));}function H(b,a){if("number"!==typeof a)throw Error("index argument to nth must be a number.");if(null==b)return null;if(b&&(b.m&16||b.wd))return b.za(null,a,null);if(Ja(b)||"string"===typeof b)return a<b.length?b[a]:null;if(La(db,b))return x.b(b,a);if(b?b.m&64||b.tc||(b.m?0:La(eb,b)):La(eb,b))return Fd(b,a);throw Error([u("nth not supported on this type "),u(Ra(Pa(b)))].join(""));}
function Id(b,a){return null==b?null:b&&(b.m&256||b.Vc)?b.D(null,a):Ja(b)?a<b.length?b[a|0]:null:"string"===typeof b?a<b.length?b[a|0]:null:La(mb,b)?nb.b(b,a):null}function Jd(b,a,c){return null!=b?b&&(b.m&256||b.Vc)?b.C(null,a,c):Ja(b)?a<b.length?b[a]:c:"string"===typeof b?a<b.length?b[a]:c:La(mb,b)?nb.g(b,a,c):c:c}
var I=function I(){switch(arguments.length){case 3:return I.g(arguments[0],arguments[1],arguments[2]);default:return I.j(arguments[0],arguments[1],arguments[2],new Da(Array.prototype.slice.call(arguments,3),0))}};I.g=function(b,a,c){return null!=b?qb(b,a,c):Md([a],[c])};I.j=function(b,a,c,d){for(;;)if(b=I.g(b,a,c),r(d))a=B(d),c=Ad(d),d=C(C(d));else return b};I.I=function(b){var a=B(b),c=C(b);b=B(c);var d=C(c),c=B(d),d=C(d);return I.j(a,b,c,d)};I.G=3;
var Nd=function Nd(){switch(arguments.length){case 1:return Nd.c(arguments[0]);case 2:return Nd.b(arguments[0],arguments[1]);default:return Nd.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};Nd.c=function(b){return b};Nd.b=function(b,a){return null==b?null:sb(b,a)};Nd.j=function(b,a,c){for(;;){if(null==b)return null;b=Nd.b(b,a);if(r(c))a=B(c),c=C(c);else return b}};Nd.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return Nd.j(a,b,c)};Nd.G=2;
function Od(b){var a="function"==ba(b);return r(a)?a:b?r(r(null)?null:b.Pd)?!0:b.Mb?!1:La(Xa,b):La(Xa,b)}function Pd(b,a){this.o=b;this.A=a;this.m=393217;this.B=0}g=Pd.prototype;g.M=function(){return this.A};g.N=function(b,a){return new Pd(this.o,a)};g.Pd=!0;
g.call=function(){function b(a,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J,V,ta,Fa,Ma){a=this.o;return Qd.Ic?Qd.Ic(a,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J,V,ta,Fa,Ma):Qd.call(null,a,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J,V,ta,Fa,Ma)}function a(a,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J,V,ta,Fa){a=this;return a.o.yb?a.o.yb(b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J,V,ta,Fa):a.o.call(null,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J,V,ta,Fa)}function c(a,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J,V,ta){a=this;return a.o.xb?a.o.xb(b,c,d,e,k,f,h,p,l,n,t,
v,y,D,z,L,J,V,ta):a.o.call(null,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J,V,ta)}function d(a,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J,V){a=this;return a.o.wb?a.o.wb(b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J,V):a.o.call(null,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J,V)}function e(a,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J){a=this;return a.o.vb?a.o.vb(b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J):a.o.call(null,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L,J)}function f(a,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L){a=this;return a.o.ub?a.o.ub(b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,
L):a.o.call(null,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z,L)}function h(a,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z){a=this;return a.o.tb?a.o.tb(b,c,d,e,k,f,h,p,l,n,t,v,y,D,z):a.o.call(null,b,c,d,e,k,f,h,p,l,n,t,v,y,D,z)}function k(a,b,c,d,e,k,f,h,p,l,n,t,v,y,D){a=this;return a.o.sb?a.o.sb(b,c,d,e,k,f,h,p,l,n,t,v,y,D):a.o.call(null,b,c,d,e,k,f,h,p,l,n,t,v,y,D)}function l(a,b,c,d,e,k,f,h,p,l,n,t,v,y){a=this;return a.o.rb?a.o.rb(b,c,d,e,k,f,h,p,l,n,t,v,y):a.o.call(null,b,c,d,e,k,f,h,p,l,n,t,v,y)}function p(a,b,c,d,e,k,f,
h,p,l,n,t,v){a=this;return a.o.qb?a.o.qb(b,c,d,e,k,f,h,p,l,n,t,v):a.o.call(null,b,c,d,e,k,f,h,p,l,n,t,v)}function n(a,b,c,d,e,k,f,h,p,l,n,t){a=this;return a.o.pb?a.o.pb(b,c,d,e,k,f,h,p,l,n,t):a.o.call(null,b,c,d,e,k,f,h,p,l,n,t)}function t(a,b,c,d,e,k,f,h,p,l,n){a=this;return a.o.ob?a.o.ob(b,c,d,e,k,f,h,p,l,n):a.o.call(null,b,c,d,e,k,f,h,p,l,n)}function y(a,b,c,d,e,k,f,h,p,l){a=this;return a.o.Bb?a.o.Bb(b,c,d,e,k,f,h,p,l):a.o.call(null,b,c,d,e,k,f,h,p,l)}function v(a,b,c,d,e,k,f,h,p){a=this;return a.o.Ab?
a.o.Ab(b,c,d,e,k,f,h,p):a.o.call(null,b,c,d,e,k,f,h,p)}function D(a,b,c,d,e,k,f,h){a=this;return a.o.zb?a.o.zb(b,c,d,e,k,f,h):a.o.call(null,b,c,d,e,k,f,h)}function z(a,b,c,d,e,k,f){a=this;return a.o.ya?a.o.ya(b,c,d,e,k,f):a.o.call(null,b,c,d,e,k,f)}function L(a,b,c,d,e,k){a=this;return a.o.Z?a.o.Z(b,c,d,e,k):a.o.call(null,b,c,d,e,k)}function V(a,b,c,d,e){a=this;return a.o.S?a.o.S(b,c,d,e):a.o.call(null,b,c,d,e)}function ta(a,b,c,d){a=this;return a.o.g?a.o.g(b,c,d):a.o.call(null,b,c,d)}function Na(a,
b,c){a=this;return a.o.b?a.o.b(b,c):a.o.call(null,b,c)}function Ma(a,b){a=this;return a.o.c?a.o.c(b):a.o.call(null,b)}function Fa(a){a=this;return a.o.w?a.o.w():a.o.call(null)}var J=null,J=function(J,W,Q,P,ea,pa,na,$a,lb,jb,gb,zb,ob,Eb,Lb,Xb,Dc,Lc,Ec,Tc,vd,id){switch(arguments.length){case 1:return Fa.call(this,J);case 2:return Ma.call(this,J,W);case 3:return Na.call(this,J,W,Q);case 4:return ta.call(this,J,W,Q,P);case 5:return V.call(this,J,W,Q,P,ea);case 6:return L.call(this,J,W,Q,P,ea,pa);case 7:return z.call(this,
J,W,Q,P,ea,pa,na);case 8:return D.call(this,J,W,Q,P,ea,pa,na,$a);case 9:return v.call(this,J,W,Q,P,ea,pa,na,$a,lb);case 10:return y.call(this,J,W,Q,P,ea,pa,na,$a,lb,jb);case 11:return t.call(this,J,W,Q,P,ea,pa,na,$a,lb,jb,gb);case 12:return n.call(this,J,W,Q,P,ea,pa,na,$a,lb,jb,gb,zb);case 13:return p.call(this,J,W,Q,P,ea,pa,na,$a,lb,jb,gb,zb,ob);case 14:return l.call(this,J,W,Q,P,ea,pa,na,$a,lb,jb,gb,zb,ob,Eb);case 15:return k.call(this,J,W,Q,P,ea,pa,na,$a,lb,jb,gb,zb,ob,Eb,Lb);case 16:return h.call(this,
J,W,Q,P,ea,pa,na,$a,lb,jb,gb,zb,ob,Eb,Lb,Xb);case 17:return f.call(this,J,W,Q,P,ea,pa,na,$a,lb,jb,gb,zb,ob,Eb,Lb,Xb,Dc);case 18:return e.call(this,J,W,Q,P,ea,pa,na,$a,lb,jb,gb,zb,ob,Eb,Lb,Xb,Dc,Lc);case 19:return d.call(this,J,W,Q,P,ea,pa,na,$a,lb,jb,gb,zb,ob,Eb,Lb,Xb,Dc,Lc,Ec);case 20:return c.call(this,J,W,Q,P,ea,pa,na,$a,lb,jb,gb,zb,ob,Eb,Lb,Xb,Dc,Lc,Ec,Tc);case 21:return a.call(this,J,W,Q,P,ea,pa,na,$a,lb,jb,gb,zb,ob,Eb,Lb,Xb,Dc,Lc,Ec,Tc,vd);case 22:return b.call(this,J,W,Q,P,ea,pa,na,$a,lb,jb,
gb,zb,ob,Eb,Lb,Xb,Dc,Lc,Ec,Tc,vd,id)}throw Error("Invalid arity: "+arguments.length);};J.c=Fa;J.b=Ma;J.g=Na;J.S=ta;J.Z=V;J.ya=L;J.zb=z;J.Ab=D;J.Bb=v;J.ob=y;J.pb=t;J.qb=n;J.rb=p;J.sb=l;J.tb=k;J.ub=h;J.vb=f;J.wb=e;J.xb=d;J.yb=c;J.Ud=a;J.Ic=b;return J}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.w=function(){return this.o.w?this.o.w():this.o.call(null)};g.c=function(b){return this.o.c?this.o.c(b):this.o.call(null,b)};
g.b=function(b,a){return this.o.b?this.o.b(b,a):this.o.call(null,b,a)};g.g=function(b,a,c){return this.o.g?this.o.g(b,a,c):this.o.call(null,b,a,c)};g.S=function(b,a,c,d){return this.o.S?this.o.S(b,a,c,d):this.o.call(null,b,a,c,d)};g.Z=function(b,a,c,d,e){return this.o.Z?this.o.Z(b,a,c,d,e):this.o.call(null,b,a,c,d,e)};g.ya=function(b,a,c,d,e,f){return this.o.ya?this.o.ya(b,a,c,d,e,f):this.o.call(null,b,a,c,d,e,f)};
g.zb=function(b,a,c,d,e,f,h){return this.o.zb?this.o.zb(b,a,c,d,e,f,h):this.o.call(null,b,a,c,d,e,f,h)};g.Ab=function(b,a,c,d,e,f,h,k){return this.o.Ab?this.o.Ab(b,a,c,d,e,f,h,k):this.o.call(null,b,a,c,d,e,f,h,k)};g.Bb=function(b,a,c,d,e,f,h,k,l){return this.o.Bb?this.o.Bb(b,a,c,d,e,f,h,k,l):this.o.call(null,b,a,c,d,e,f,h,k,l)};g.ob=function(b,a,c,d,e,f,h,k,l,p){return this.o.ob?this.o.ob(b,a,c,d,e,f,h,k,l,p):this.o.call(null,b,a,c,d,e,f,h,k,l,p)};
g.pb=function(b,a,c,d,e,f,h,k,l,p,n){return this.o.pb?this.o.pb(b,a,c,d,e,f,h,k,l,p,n):this.o.call(null,b,a,c,d,e,f,h,k,l,p,n)};g.qb=function(b,a,c,d,e,f,h,k,l,p,n,t){return this.o.qb?this.o.qb(b,a,c,d,e,f,h,k,l,p,n,t):this.o.call(null,b,a,c,d,e,f,h,k,l,p,n,t)};g.rb=function(b,a,c,d,e,f,h,k,l,p,n,t,y){return this.o.rb?this.o.rb(b,a,c,d,e,f,h,k,l,p,n,t,y):this.o.call(null,b,a,c,d,e,f,h,k,l,p,n,t,y)};
g.sb=function(b,a,c,d,e,f,h,k,l,p,n,t,y,v){return this.o.sb?this.o.sb(b,a,c,d,e,f,h,k,l,p,n,t,y,v):this.o.call(null,b,a,c,d,e,f,h,k,l,p,n,t,y,v)};g.tb=function(b,a,c,d,e,f,h,k,l,p,n,t,y,v,D){return this.o.tb?this.o.tb(b,a,c,d,e,f,h,k,l,p,n,t,y,v,D):this.o.call(null,b,a,c,d,e,f,h,k,l,p,n,t,y,v,D)};g.ub=function(b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z){return this.o.ub?this.o.ub(b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z):this.o.call(null,b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z)};
g.vb=function(b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L){return this.o.vb?this.o.vb(b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L):this.o.call(null,b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L)};g.wb=function(b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V){return this.o.wb?this.o.wb(b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V):this.o.call(null,b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V)};
g.xb=function(b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta){return this.o.xb?this.o.xb(b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta):this.o.call(null,b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta)};g.yb=function(b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na){return this.o.yb?this.o.yb(b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na):this.o.call(null,b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na)};
g.Ud=function(b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na,Ma){var Fa=this.o;return Qd.Ic?Qd.Ic(Fa,b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na,Ma):Qd.call(null,Fa,b,a,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na,Ma)};function wd(b,a){return Od(b)&&!(b?b.m&262144||b.fe||(b.m?0:La(Hb,b)):La(Hb,b))?new Pd(b,a):null==b?null:Ib(b,a)}function Rd(b){var a=null!=b;return(a?b?b.m&131072||b.Xd||(b.m?0:La(Db,b)):La(Db,b):a)?Fb(b):null}
var Sd=function Sd(){switch(arguments.length){case 1:return Sd.c(arguments[0]);case 2:return Sd.b(arguments[0],arguments[1]);default:return Sd.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};Sd.c=function(b){return b};Sd.b=function(b,a){return null==b?null:xb(b,a)};Sd.j=function(b,a,c){for(;;){if(null==b)return null;b=Sd.b(b,a);if(r(c))a=B(c),c=C(c);else return b}};Sd.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return Sd.j(a,b,c)};Sd.G=2;
function Td(b){return null==b||Ka(q(b))}function Ud(b){return null==b?!1:b?b.m&8||b.ne?!0:b.m?!1:La(bb,b):La(bb,b)}function Vd(b){return null==b?!1:b?b.m&4096||b.qe?!0:b.m?!1:La(wb,b):La(wb,b)}function Wd(b){return b?b.m&16777216||b.pe?!0:b.m?!1:La(Rb,b):La(Rb,b)}function Yd(b){return null==b?!1:b?b.m&1024||b.Vd?!0:b.m?!1:La(rb,b):La(rb,b)}function Zd(b){return b?b.m&16384||b.re?!0:b.m?!1:La(Ab,b):La(Ab,b)}function $d(b){return b?b.B&512||b.me?!0:!1:!1}
function ae(b){var a=[];ka(b,function(a,b){return function(a,c){return b.push(c)}}(b,a));return a}function be(b,a,c,d,e){for(;0!==e;)c[d]=b[a],d+=1,--e,a+=1}var ce={};function de(b){return null==b?!1:b?b.m&64||b.tc?!0:b.m?!1:La(eb,b):La(eb,b)}function ee(b){return b?b.m&8388608||b.Wc?!0:b.m?!1:La(Pb,b):La(Pb,b)}function fe(b){return r(b)?!0:!1}function ge(b,a){return Jd(b,a,ce)===ce?!1:!0}
var he=function he(){switch(arguments.length){case 1:return he.c(arguments[0]);case 2:return he.b(arguments[0],arguments[1]);default:return he.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};he.c=function(){return!0};he.b=function(b,a){return!E.b(b,a)};
he.j=function(b,a,c){if(E.b(b,a))return!1;a:if(b=[b,a],a=b.length,a<=ie)for(var d=0,e=$b(je);;)if(d<a)var f=d+1,e=cc(e,b[d],null),d=f;else{b=new ke(null,bc(e),null);break a}else for(d=0,e=$b(le);;)if(d<a)f=d+1,e=ac(e,b[d]),d=f;else{b=bc(e);break a}for(a=c;;)if(d=B(a),c=C(a),r(a)){if(ge(b,d))return!1;b=Dd.b(b,d);a=c}else return!0};he.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return he.j(a,b,c)};he.G=2;
function me(b,a){if(b===a)return 0;if(null==b)return-1;if(null==a)return 1;if("number"===typeof b){if("number"===typeof a)return oa(b,a);throw Error([u("Cannot compare "),u(b),u(" to "),u(a)].join(""));}if(b?b.B&2048||b.oc||(b.B?0:La(ec,b)):La(ec,b))return fc(b,a);if("string"!==typeof b&&!Ja(b)&&!0!==b&&!1!==b||Pa(b)!==Pa(a))throw Error([u("Cannot compare "),u(b),u(" to "),u(a)].join(""));return oa(b,a)}
function ne(b,a){var c=G(b),d=G(a);if(c<d)c=-1;else if(c>d)c=1;else if(0===c)c=0;else a:for(d=0;;){var e=me(Hd(b,d),Hd(a,d));if(0===e&&d+1<c)d+=1;else{c=e;break a}}return c}function oe(b){return E.b(b,me)?me:function(a,c){var d=b.b?b.b(a,c):b.call(null,a,c);return"number"===typeof d?d:r(d)?-1:r(b.b?b.b(c,a):b.call(null,c,a))?1:0}}function pe(b,a){if(q(a)){var c=qe.c?qe.c(a):qe.call(null,a),d=oe(b);qa(c,d);return q(c)}return Nc}
function yd(){switch(arguments.length){case 2:return xd(arguments[0],arguments[1]);case 3:return zd(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}function xd(b,a){var c=q(a);if(c){var d=B(c),c=C(c);return w?w(b,d,c):Wa.call(null,b,d,c)}return b.w?b.w():b.call(null)}function zd(b,a,c){for(c=q(c);;)if(c){var d=B(c);a=b.b?b.b(a,d):b.call(null,a,d);if(Zc(a))return Cb(a);c=C(c)}else return a}
function re(b){b=qe.c?qe.c(b):qe.call(null,b);for(var a=Math.random,c=b.length-1;0<c;c--){var d=Math.floor(a()*(c+1)),e=b[c];b[c]=b[d];b[d]=e}return se.c?se.c(b):se.call(null,b)}function Wa(){switch(arguments.length){case 2:return te(arguments[0],arguments[1]);case 3:return w(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}
function te(b,a){return a&&(a.m&524288||a.Zd)?a.la(null,b):Ja(a)?fd(a,b):"string"===typeof a?fd(a,b):La(Jb,a)?Kb.b(a,b):xd(b,a)}function w(b,a,c){return c&&(c.m&524288||c.Zd)?c.ma(null,b,a):Ja(c)?gd(c,b,a):"string"===typeof c?gd(c,b,a):La(Jb,c)?Kb.g(c,b,a):zd(b,a,c)}function ue(b,a,c){return null!=c?Mb(c,b,a):a}function ve(b){return b}function we(b,a,c,d){b=b.c?b.c(a):b.call(null,a);c=w(b,c,d);return b.c?b.c(c):b.call(null,c)}
var xe=function xe(){switch(arguments.length){case 0:return xe.w();case 1:return xe.c(arguments[0]);case 2:return xe.b(arguments[0],arguments[1]);default:return xe.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};xe.w=function(){return 0};xe.c=function(b){return b};xe.b=function(b,a){return b+a};xe.j=function(b,a,c){return w(xe,b+a,c)};xe.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return xe.j(a,b,c)};xe.G=2;
var ye=function ye(){switch(arguments.length){case 1:return ye.c(arguments[0]);case 2:return ye.b(arguments[0],arguments[1]);default:return ye.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};ye.c=function(b){return-b};ye.b=function(b,a){return b-a};ye.j=function(b,a,c){return w(ye,b-a,c)};ye.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return ye.j(a,b,c)};ye.G=2;
var ze=function ze(){switch(arguments.length){case 0:return ze.w();case 1:return ze.c(arguments[0]);case 2:return ze.b(arguments[0],arguments[1]);default:return ze.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};ze.w=function(){return 1};ze.c=function(b){return b};ze.b=function(b,a){return b*a};ze.j=function(b,a,c){return w(ze,b*a,c)};ze.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return ze.j(a,b,c)};ze.G=2;
var Ae=function Ae(){switch(arguments.length){case 1:return Ae.c(arguments[0]);case 2:return Ae.b(arguments[0],arguments[1]);default:return Ae.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};Ae.c=function(b){return 1/b};Ae.b=function(b,a){return b/a};Ae.j=function(b,a,c){return w(Ae,b/a,c)};Ae.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return Ae.j(a,b,c)};Ae.G=2;
var Be=function Be(){switch(arguments.length){case 1:return Be.c(arguments[0]);case 2:return Be.b(arguments[0],arguments[1]);default:return Be.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};Be.c=function(){return!0};Be.b=function(b,a){return b<a};Be.j=function(b,a,c){for(;;)if(b<a)if(C(c))b=a,a=B(c),c=C(c);else return a<B(c);else return!1};Be.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return Be.j(a,b,c)};Be.G=2;
var Ce=function Ce(){switch(arguments.length){case 1:return Ce.c(arguments[0]);case 2:return Ce.b(arguments[0],arguments[1]);default:return Ce.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};Ce.c=function(){return!0};Ce.b=function(b,a){return b<=a};Ce.j=function(b,a,c){for(;;)if(b<=a)if(C(c))b=a,a=B(c),c=C(c);else return a<=B(c);else return!1};Ce.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return Ce.j(a,b,c)};Ce.G=2;
var De=function De(){switch(arguments.length){case 1:return De.c(arguments[0]);case 2:return De.b(arguments[0],arguments[1]);default:return De.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};De.c=function(){return!0};De.b=function(b,a){return b>a};De.j=function(b,a,c){for(;;)if(b>a)if(C(c))b=a,a=B(c),c=C(c);else return a>B(c);else return!1};De.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return De.j(a,b,c)};De.G=2;
var Ee=function Ee(){switch(arguments.length){case 1:return Ee.c(arguments[0]);case 2:return Ee.b(arguments[0],arguments[1]);default:return Ee.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};Ee.c=function(){return!0};Ee.b=function(b,a){return b>=a};Ee.j=function(b,a,c){for(;;)if(b>=a)if(C(c))b=a,a=B(c),c=C(c);else return a>=B(c);else return!1};Ee.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return Ee.j(a,b,c)};Ee.G=2;
var Fe=function Fe(){switch(arguments.length){case 1:return Fe.c(arguments[0]);case 2:return Fe.b(arguments[0],arguments[1]);default:return Fe.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};Fe.c=function(b){return b};Fe.b=function(b,a){return b>a?b:a};Fe.j=function(b,a,c){return w(Fe,b>a?b:a,c)};Fe.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return Fe.j(a,b,c)};Fe.G=2;
var Ge=function Ge(){switch(arguments.length){case 1:return Ge.c(arguments[0]);case 2:return Ge.b(arguments[0],arguments[1]);default:return Ge.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};Ge.c=function(b){return b};Ge.b=function(b,a){return b<a?b:a};Ge.j=function(b,a,c){return w(Ge,b<a?b:a,c)};Ge.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return Ge.j(a,b,c)};Ge.G=2;function He(b){return 0<=b?Math.floor(b):Math.ceil(b)}function Ie(b,a){return(b%a+a)%a}
function Je(b,a){return He((b-b%a)/a)}function Ke(b){b-=b>>1&1431655765;b=(b&858993459)+(b>>2&858993459);return 16843009*(b+(b>>4)&252645135)>>24}var Le=function Le(){switch(arguments.length){case 1:return Le.c(arguments[0]);case 2:return Le.b(arguments[0],arguments[1]);default:return Le.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};Le.c=function(){return!0};Le.b=function(b,a){return Nb(b,a)};
Le.j=function(b,a,c){for(;;)if(b===a)if(C(c))b=a,a=B(c),c=C(c);else return a===B(c);else return!1};Le.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return Le.j(a,b,c)};Le.G=2;function Me(b){return 0>b}function Ne(b,a){for(var c=a,d=q(b);;)if(d&&0<c)--c,d=C(d);else return d}var u=function u(){switch(arguments.length){case 0:return u.w();case 1:return u.c(arguments[0]);default:return u.j(arguments[0],new Da(Array.prototype.slice.call(arguments,1),0))}};u.w=function(){return""};
u.c=function(b){return null==b?"":ja(b)};u.j=function(b,a){for(var c=new la(""+u(b)),d=a;;)if(r(d))c=c.append(""+u(B(d))),d=C(d);else return c.toString()};u.I=function(b){var a=B(b);b=C(b);return u.j(a,b)};u.G=1;function Oe(b,a){return b.substring(a)}function sd(b,a){var c;if(Wd(a))if(jd(b)&&jd(a)&&G(b)!==G(a))c=!1;else a:{c=q(b);for(var d=q(a);;){if(null==c){c=null==d;break a}if(null!=d&&E.b(B(c),B(d)))c=C(c),d=C(d);else{c=!1;break a}}}else c=null;return fe(c)}
function Pe(b){var a=0;for(b=q(b);;)if(b){var c=B(b),a=(a+(Cc(function(){var a=c;return Qe.c?Qe.c(a):Qe.call(null,a)}())^Cc(function(){var a=c;return Re.c?Re.c(a):Re.call(null,a)}())))%4503599627370496;b=C(b)}else return a}function Se(b,a,c,d,e){this.A=b;this.first=a;this.Eb=c;this.count=d;this.i=e;this.m=65937646;this.B=8192}g=Se.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.M=function(){return this.A};g.sa=function(){return 1===this.count?null:this.Eb};
g.O=function(){return this.count};g.Lb=function(){return this.first};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return Ib(Nc,this.A)};g.la=function(b,a){return xd(a,this)};g.ma=function(b,a,c){return zd(a,c,this)};g.ka=function(){return this.first};g.oa=function(){return 1===this.count?Nc:this.Eb};g.K=function(){return this};g.N=function(b,a){return new Se(a,this.first,this.Eb,this.count,this.i)};
g.P=function(b,a){return new Se(this.A,a,this,this.count+1,null)};Se.prototype[Sa]=function(){return Qc(this)};function Te(b){this.A=b;this.m=65937614;this.B=8192}g=Te.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.M=function(){return this.A};g.sa=function(){return null};g.O=function(){return 0};g.Lb=function(){return null};g.J=function(){return Uc};g.u=function(b,a){return sd(this,a)};g.ea=function(){return this};g.la=function(b,a){return xd(a,this)};
g.ma=function(b,a,c){return zd(a,c,this)};g.ka=function(){return null};g.oa=function(){return Nc};g.K=function(){return null};g.N=function(b,a){return new Te(a)};g.P=function(b,a){return new Se(this.A,a,null,1,null)};var Nc=new Te(null);Te.prototype[Sa]=function(){return Qc(this)};function Ue(b){return(b?b.m&134217728||b.ae||(b.m?0:La(Sb,b)):La(Sb,b))?Ub(b):w(Dd,Nc,b)}var Ve=function Ve(){return Ve.j(0<arguments.length?new Da(Array.prototype.slice.call(arguments,0),0):null)};
Ve.j=function(b){var a;if(b instanceof Da&&0===b.L)a=b.l;else a:for(a=[];;)if(null!=b)a.push(b.ka(null)),b=b.sa(null);else break a;b=a.length;for(var c=Nc;;)if(0<b){var d=b-1,c=c.P(null,a[b-1]);b=d}else return c};Ve.G=0;Ve.I=function(b){return Ve.j(q(b))};function We(b,a,c,d){this.A=b;this.first=a;this.Eb=c;this.i=d;this.m=65929452;this.B=8192}g=We.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.M=function(){return this.A};
g.sa=function(){return null==this.Eb?null:q(this.Eb)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return wd(Nc,this.A)};g.la=function(b,a){return xd(a,this)};g.ma=function(b,a,c){return zd(a,c,this)};g.ka=function(){return this.first};g.oa=function(){return null==this.Eb?Nc:this.Eb};g.K=function(){return this};g.N=function(b,a){return new We(a,this.first,this.Eb,this.i)};g.P=function(b,a){return new We(null,a,this,this.i)};
We.prototype[Sa]=function(){return Qc(this)};function td(b,a){var c=null==a;return(c?c:a&&(a.m&64||a.tc))?new We(null,b,a,null):new We(null,b,q(a),null)}function Xe(b,a){if(b.U===a.U)return 0;var c=Ka(b.wa);if(r(c?a.wa:c))return-1;if(r(b.wa)){if(Ka(a.wa))return 1;c=oa(b.wa,a.wa);return 0===c?oa(b.name,a.name):c}return oa(b.name,a.name)}function K(b,a,c,d){this.wa=b;this.name=a;this.U=c;this.hc=d;this.m=2153775105;this.B=4096}g=K.prototype;g.toString=function(){return[u(":"),u(this.U)].join("")};
g.equiv=function(b){return this.u(null,b)};g.u=function(b,a){return a instanceof K?this.U===a.U:!1};g.call=function(){var b=null,b=function(a,b,d){switch(arguments.length){case 2:return Id(b,this);case 3:return Jd(b,this,d)}throw Error("Invalid arity: "+arguments.length);};b.b=function(a,b){return Id(b,this)};b.g=function(a,b,d){return Jd(b,this,d)};return b}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return Id(b,this)};
g.b=function(b,a){return Jd(b,this,a)};g.J=function(){var b=this.hc;return null!=b?b:this.hc=b=Fc(uc(this.name),Bc(this.wa))+2654435769|0};g.H=function(b,a){return Vb(a,[u(":"),u(this.U)].join(""))};function M(b,a){return b===a?!0:b instanceof K&&a instanceof K?b.U===a.U:!1}function Ye(b){if(b&&(b.B&4096||b.Yd))return b.wa;throw Error([u("Doesn't support namespace: "),u(b)].join(""));}
var Ze=function Ze(){switch(arguments.length){case 1:return Ze.c(arguments[0]);case 2:return Ze.b(arguments[0],arguments[1]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};Ze.c=function(b){if(b instanceof K)return b;if(b instanceof A)return new K(Ye(b),$e.c?$e.c(b):$e.call(null,b),b.hb,null);if("string"===typeof b){var a=b.split("/");return 2===a.length?new K(a[0],a[1],b,null):new K(null,a[0],b,null)}return null};
Ze.b=function(b,a){return new K(b,a,[u(r(b)?[u(b),u("/")].join(""):null),u(a)].join(""),null)};Ze.G=2;function af(b,a,c,d){this.A=b;this.$=a;this.Y=c;this.i=d;this.m=32374988;this.B=0}g=af.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};function bf(b){null!=b.$&&(b.Y=b.$.w?b.$.w():b.$.call(null),b.$=null);return b.Y}g.M=function(){return this.A};g.sa=function(){Qb(this);return null==this.Y?null:C(this.Y)};
g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return wd(Nc,this.A)};g.la=function(b,a){return xd(a,this)};g.ma=function(b,a,c){return zd(a,c,this)};g.ka=function(){Qb(this);return null==this.Y?null:B(this.Y)};g.oa=function(){Qb(this);return null!=this.Y?Mc(this.Y):Nc};g.K=function(){bf(this);if(null==this.Y)return null;for(var b=this.Y;;)if(b instanceof af)b=bf(b);else return this.Y=b,q(this.Y)};
g.N=function(b,a){return new af(a,this.$,this.Y,this.i)};g.P=function(b,a){return td(a,this)};af.prototype[Sa]=function(){return Qc(this)};function cf(b,a){this.aa=b;this.end=a;this.m=2;this.B=0}cf.prototype.add=function(b){this.aa[this.end]=b;return this.end+=1};cf.prototype.nb=function(){var b=new df(this.aa,0,this.end);this.aa=null;return b};cf.prototype.O=function(){return this.end};function ef(b){return new cf(Array(b),0)}
function df(b,a,c){this.l=b;this.ta=a;this.end=c;this.m=524306;this.B=0}g=df.prototype;g.O=function(){return this.end-this.ta};g.R=function(b,a){return this.l[this.ta+a]};g.za=function(b,a,c){return 0<=a&&a<this.end-this.ta?this.l[this.ta+a]:c};g.ud=function(){if(this.ta===this.end)throw Error("-drop-first of empty chunk");return new df(this.l,this.ta+1,this.end)};g.la=function(b,a){return hd(this.l,a,this.l[this.ta],this.ta+1)};g.ma=function(b,a,c){return hd(this.l,a,c,this.ta)};
function ff(b,a,c,d){this.nb=b;this.eb=a;this.A=c;this.i=d;this.m=31850732;this.B=1536}g=ff.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.M=function(){return this.A};g.sa=function(){if(1<Za(this.nb))return new ff(gc(this.nb),this.eb,this.A,null);var b=Qb(this.eb);return null==b?null:b};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return wd(Nc,this.A)};
g.ka=function(){return x.b(this.nb,0)};g.oa=function(){return 1<Za(this.nb)?new ff(gc(this.nb),this.eb,this.A,null):null==this.eb?Nc:this.eb};g.K=function(){return this};g.Gc=function(){return this.nb};g.Hc=function(){return null==this.eb?Nc:this.eb};g.N=function(b,a){return new ff(this.nb,this.eb,a,this.i)};g.P=function(b,a){return td(a,this)};g.Fc=function(){return null==this.eb?null:this.eb};ff.prototype[Sa]=function(){return Qc(this)};
function gf(b,a){return 0===Za(b)?a:new ff(b,a,null,null)}function hf(b,a){b.add(a)}function jf(b){return b.nb()}function qe(b){for(var a=[];;)if(q(b))a.push(B(b)),b=C(b);else return a}function kf(b,a){if(jd(b))return G(b);for(var c=b,d=a,e=0;;)if(0<d&&q(c))c=C(c),--d,e+=1;else return e}
var lf=function lf(a){return null==a?null:null==C(a)?q(B(a)):td(B(a),lf(C(a)))},N=function N(){switch(arguments.length){case 0:return N.w();case 1:return N.c(arguments[0]);case 2:return N.b(arguments[0],arguments[1]);default:return N.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};N.w=function(){return new af(null,function(){return null},null,null)};N.c=function(b){return new af(null,function(){return b},null,null)};
N.b=function(b,a){return new af(null,function(){var c=q(b);return c?$d(c)?gf(hc(c),N.b(ic(c),a)):td(B(c),N.b(Mc(c),a)):a},null,null)};N.j=function(b,a,c){return function e(a,b){return new af(null,function(){var c=q(a);return c?$d(c)?gf(hc(c),e(ic(c),b)):td(B(c),e(Mc(c),b)):r(b)?e(B(b),C(b)):null},null,null)}(N.b(b,a),c)};N.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return N.j(a,b,c)};N.G=2;function mf(b){return q(b)}function nf(b){return $b(b)}function of(b){return bc(b)}
var pf=function pf(){switch(arguments.length){case 0:return pf.w();case 1:return pf.c(arguments[0]);case 2:return pf.b(arguments[0],arguments[1]);default:return pf.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};pf.w=function(){return $b(Ed)};pf.c=function(b){return b};pf.b=function(b,a){return ac(b,a)};pf.j=function(b,a,c){for(;;)if(b=ac(b,a),r(c))a=B(c),c=C(c);else return b};pf.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return pf.j(a,b,c)};pf.G=2;
var vf=function vf(){switch(arguments.length){case 3:return vf.g(arguments[0],arguments[1],arguments[2]);default:return vf.j(arguments[0],arguments[1],arguments[2],new Da(Array.prototype.slice.call(arguments,3),0))}};vf.g=function(b,a,c){return cc(b,a,c)};vf.j=function(b,a,c,d){for(;;)if(b=cc(b,a,c),r(d))a=B(d),c=Ad(d),d=C(C(d));else return b};vf.I=function(b){var a=B(b),c=C(b);b=B(c);var d=C(c),c=B(d),d=C(d);return vf.j(a,b,c,d)};vf.G=3;
function wf(b,a,c){var d=q(c);if(0===a)return b.w?b.w():b.call(null);c=fb(d);var e=hb(d);if(1===a)return b.c?b.c(c):b.c?b.c(c):b.call(null,c);var d=fb(e),f=hb(e);if(2===a)return b.b?b.b(c,d):b.b?b.b(c,d):b.call(null,c,d);var e=fb(f),h=hb(f);if(3===a)return b.g?b.g(c,d,e):b.g?b.g(c,d,e):b.call(null,c,d,e);var f=fb(h),k=hb(h);if(4===a)return b.S?b.S(c,d,e,f):b.S?b.S(c,d,e,f):b.call(null,c,d,e,f);var h=fb(k),l=hb(k);if(5===a)return b.Z?b.Z(c,d,e,f,h):b.Z?b.Z(c,d,e,f,h):b.call(null,c,d,e,f,h);var k=fb(l),
p=hb(l);if(6===a)return b.ya?b.ya(c,d,e,f,h,k):b.ya?b.ya(c,d,e,f,h,k):b.call(null,c,d,e,f,h,k);var l=fb(p),n=hb(p);if(7===a)return b.zb?b.zb(c,d,e,f,h,k,l):b.zb?b.zb(c,d,e,f,h,k,l):b.call(null,c,d,e,f,h,k,l);var p=fb(n),t=hb(n);if(8===a)return b.Ab?b.Ab(c,d,e,f,h,k,l,p):b.Ab?b.Ab(c,d,e,f,h,k,l,p):b.call(null,c,d,e,f,h,k,l,p);var n=fb(t),y=hb(t);if(9===a)return b.Bb?b.Bb(c,d,e,f,h,k,l,p,n):b.Bb?b.Bb(c,d,e,f,h,k,l,p,n):b.call(null,c,d,e,f,h,k,l,p,n);var t=fb(y),v=hb(y);if(10===a)return b.ob?b.ob(c,
d,e,f,h,k,l,p,n,t):b.ob?b.ob(c,d,e,f,h,k,l,p,n,t):b.call(null,c,d,e,f,h,k,l,p,n,t);var y=fb(v),D=hb(v);if(11===a)return b.pb?b.pb(c,d,e,f,h,k,l,p,n,t,y):b.pb?b.pb(c,d,e,f,h,k,l,p,n,t,y):b.call(null,c,d,e,f,h,k,l,p,n,t,y);var v=fb(D),z=hb(D);if(12===a)return b.qb?b.qb(c,d,e,f,h,k,l,p,n,t,y,v):b.qb?b.qb(c,d,e,f,h,k,l,p,n,t,y,v):b.call(null,c,d,e,f,h,k,l,p,n,t,y,v);var D=fb(z),L=hb(z);if(13===a)return b.rb?b.rb(c,d,e,f,h,k,l,p,n,t,y,v,D):b.rb?b.rb(c,d,e,f,h,k,l,p,n,t,y,v,D):b.call(null,c,d,e,f,h,k,l,
p,n,t,y,v,D);var z=fb(L),V=hb(L);if(14===a)return b.sb?b.sb(c,d,e,f,h,k,l,p,n,t,y,v,D,z):b.sb?b.sb(c,d,e,f,h,k,l,p,n,t,y,v,D,z):b.call(null,c,d,e,f,h,k,l,p,n,t,y,v,D,z);var L=fb(V),ta=hb(V);if(15===a)return b.tb?b.tb(c,d,e,f,h,k,l,p,n,t,y,v,D,z,L):b.tb?b.tb(c,d,e,f,h,k,l,p,n,t,y,v,D,z,L):b.call(null,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L);var V=fb(ta),Na=hb(ta);if(16===a)return b.ub?b.ub(c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V):b.ub?b.ub(c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V):b.call(null,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V);
var ta=fb(Na),Ma=hb(Na);if(17===a)return b.vb?b.vb(c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta):b.vb?b.vb(c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta):b.call(null,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta);var Na=fb(Ma),Fa=hb(Ma);if(18===a)return b.wb?b.wb(c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na):b.wb?b.wb(c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na):b.call(null,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na);Ma=fb(Fa);Fa=hb(Fa);if(19===a)return b.xb?b.xb(c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na,Ma):b.xb?b.xb(c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,
ta,Na,Ma):b.call(null,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na,Ma);var J=fb(Fa);hb(Fa);if(20===a)return b.yb?b.yb(c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na,Ma,J):b.yb?b.yb(c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na,Ma,J):b.call(null,c,d,e,f,h,k,l,p,n,t,y,v,D,z,L,V,ta,Na,Ma,J);throw Error("Only up to 20 arguments supported on functions");}
function Qd(){switch(arguments.length){case 2:return xf(arguments[0],arguments[1]);case 3:return yf(arguments[0],arguments[1],arguments[2]);case 4:return zf(arguments[0],arguments[1],arguments[2],arguments[3]);case 5:return Af(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]);default:return Bf(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4],new Da(Array.prototype.slice.call(arguments,5),0))}}
function xf(b,a){var c=b.G;if(b.I){var d=kf(a,c+1);return d<=c?wf(b,d,a):b.I(a)}return b.apply(b,qe(a))}function yf(b,a,c){a=td(a,c);c=b.G;if(b.I){var d=kf(a,c+1);return d<=c?wf(b,d,a):b.I(a)}return b.apply(b,qe(a))}function zf(b,a,c,d){a=td(a,td(c,d));c=b.G;return b.I?(d=kf(a,c+1),d<=c?wf(b,d,a):b.I(a)):b.apply(b,qe(a))}function Af(b,a,c,d,e){a=td(a,td(c,td(d,e)));c=b.G;return b.I?(d=kf(a,c+1),d<=c?wf(b,d,a):b.I(a)):b.apply(b,qe(a))}
function Bf(b,a,c,d,e,f){a=td(a,td(c,td(d,td(e,lf(f)))));c=b.G;return b.I?(d=kf(a,c+1),d<=c?wf(b,d,a):b.I(a)):b.apply(b,qe(a))}var Ef=function Ef(){switch(arguments.length){case 1:return Ef.c(arguments[0]);case 2:return Ef.b(arguments[0],arguments[1]);default:return Ef.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};Ef.c=function(){return!1};Ef.b=function(b,a){return!E.b(b,a)};Ef.j=function(b,a,c){return Ka(zf(E,b,a,c))};
Ef.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return Ef.j(a,b,c)};Ef.G=2;function Ff(b){return q(b)?b:null}function Gf(b,a){for(;;){if(null==q(a))return!0;var c;c=B(a);c=b.c?b.c(c):b.call(null,c);if(r(c)){c=b;var d=C(a);b=c;a=d}else return!1}}function Hf(b,a){for(;;)if(q(a)){var c;c=B(a);c=b.c?b.c(c):b.call(null,c);if(r(c))return c;c=b;var d=C(a);b=c;a=d}else return null}
function If(b){if("number"===typeof b&&Ka(isNaN(b))&&Infinity!==b&&parseFloat(b)===parseInt(b,10))return 0===(b&1);throw Error([u("Argument must be an integer: "),u(b)].join(""));}function Jf(b){return!If(b)}
function Kf(b){return function(){function a(a,c){return Ka(b.b?b.b(a,c):b.call(null,a,c))}function c(a){return Ka(b.c?b.c(a):b.call(null,a))}function d(){return Ka(b.w?b.w():b.call(null))}var e=null,f=function(){function a(b,d,e){var f=null;if(2<arguments.length){for(var f=0,h=Array(arguments.length-2);f<h.length;)h[f]=arguments[f+2],++f;f=new Da(h,0)}return c.call(this,b,d,f)}function c(a,d,e){return Ka(zf(b,a,d,e))}a.G=2;a.I=function(a){var b=B(a);a=C(a);var d=B(a);a=Mc(a);return c(b,d,a)};a.j=
c;return a}(),e=function(b,e,l){switch(arguments.length){case 0:return d.call(this);case 1:return c.call(this,b);case 2:return a.call(this,b,e);default:var p=null;if(2<arguments.length){for(var p=0,n=Array(arguments.length-2);p<n.length;)n[p]=arguments[p+2],++p;p=new Da(n,0)}return f.j(b,e,p)}throw Error("Invalid arity: "+arguments.length);};e.G=2;e.I=f.I;e.w=d;e.c=c;e.b=a;e.j=f.j;return e}()}
function Lf(){return function(){function b(a){if(0<arguments.length)for(var b=0,d=Array(arguments.length-0);b<d.length;)d[b]=arguments[b+0],++b;return!1}b.G=0;b.I=function(a){q(a);return!1};b.j=function(){return!1};return b}()}
var Mf=function Mf(){switch(arguments.length){case 0:return Mf.w();case 1:return Mf.c(arguments[0]);case 2:return Mf.b(arguments[0],arguments[1]);case 3:return Mf.g(arguments[0],arguments[1],arguments[2]);default:return Mf.j(arguments[0],arguments[1],arguments[2],new Da(Array.prototype.slice.call(arguments,3),0))}};Mf.w=function(){return ve};Mf.c=function(b){return b};
Mf.b=function(b,a){return function(){function c(c,d,e){c=a.g?a.g(c,d,e):a.call(null,c,d,e);return b.c?b.c(c):b.call(null,c)}function d(c,d){var e=a.b?a.b(c,d):a.call(null,c,d);return b.c?b.c(e):b.call(null,e)}function e(c){c=a.c?a.c(c):a.call(null,c);return b.c?b.c(c):b.call(null,c)}function f(){var c=a.w?a.w():a.call(null);return b.c?b.c(c):b.call(null,c)}var h=null,k=function(){function c(a,b,e,k){var f=null;if(3<arguments.length){for(var f=0,h=Array(arguments.length-3);f<h.length;)h[f]=arguments[f+
3],++f;f=new Da(h,0)}return d.call(this,a,b,e,f)}function d(c,e,k,f){c=Af(a,c,e,k,f);return b.c?b.c(c):b.call(null,c)}c.G=3;c.I=function(a){var b=B(a);a=C(a);var c=B(a);a=C(a);var e=B(a);a=Mc(a);return d(b,c,e,a)};c.j=d;return c}(),h=function(a,b,h,t){switch(arguments.length){case 0:return f.call(this);case 1:return e.call(this,a);case 2:return d.call(this,a,b);case 3:return c.call(this,a,b,h);default:var y=null;if(3<arguments.length){for(var y=0,v=Array(arguments.length-3);y<v.length;)v[y]=arguments[y+
3],++y;y=new Da(v,0)}return k.j(a,b,h,y)}throw Error("Invalid arity: "+arguments.length);};h.G=3;h.I=k.I;h.w=f;h.c=e;h.b=d;h.g=c;h.j=k.j;return h}()};
Mf.g=function(b,a,c){return function(){function d(d,e,k){d=c.g?c.g(d,e,k):c.call(null,d,e,k);d=a.c?a.c(d):a.call(null,d);return b.c?b.c(d):b.call(null,d)}function e(d,e){var k;k=c.b?c.b(d,e):c.call(null,d,e);k=a.c?a.c(k):a.call(null,k);return b.c?b.c(k):b.call(null,k)}function f(d){d=c.c?c.c(d):c.call(null,d);d=a.c?a.c(d):a.call(null,d);return b.c?b.c(d):b.call(null,d)}function h(){var d;d=c.w?c.w():c.call(null);d=a.c?a.c(d):a.call(null,d);return b.c?b.c(d):b.call(null,d)}var k=null,l=function(){function d(a,
b,c,k){var f=null;if(3<arguments.length){for(var f=0,h=Array(arguments.length-3);f<h.length;)h[f]=arguments[f+3],++f;f=new Da(h,0)}return e.call(this,a,b,c,f)}function e(d,k,f,h){d=Af(c,d,k,f,h);d=a.c?a.c(d):a.call(null,d);return b.c?b.c(d):b.call(null,d)}d.G=3;d.I=function(a){var b=B(a);a=C(a);var c=B(a);a=C(a);var d=B(a);a=Mc(a);return e(b,c,d,a)};d.j=e;return d}(),k=function(a,b,c,k){switch(arguments.length){case 0:return h.call(this);case 1:return f.call(this,a);case 2:return e.call(this,a,b);
case 3:return d.call(this,a,b,c);default:var v=null;if(3<arguments.length){for(var v=0,D=Array(arguments.length-3);v<D.length;)D[v]=arguments[v+3],++v;v=new Da(D,0)}return l.j(a,b,c,v)}throw Error("Invalid arity: "+arguments.length);};k.G=3;k.I=l.I;k.w=h;k.c=f;k.b=e;k.g=d;k.j=l.j;return k}()};
Mf.j=function(b,a,c,d){return function(a){return function(){function b(a){var d=null;if(0<arguments.length){for(var d=0,e=Array(arguments.length-0);d<e.length;)e[d]=arguments[d+0],++d;d=new Da(e,0)}return c.call(this,d)}function c(b){b=xf(B(a),b);for(var d=C(a);;)if(d)b=B(d).call(null,b),d=C(d);else return b}b.G=0;b.I=function(a){a=q(a);return c(a)};b.j=c;return b}()}(Ue(td(b,td(a,td(c,d)))))};Mf.I=function(b){var a=B(b),c=C(b);b=B(c);var d=C(c),c=B(d),d=C(d);return Mf.j(a,b,c,d)};Mf.G=3;
function Nf(b,a){return function(){function c(c,d,e){return b.S?b.S(a,c,d,e):b.call(null,a,c,d,e)}function d(c,d){return b.g?b.g(a,c,d):b.call(null,a,c,d)}function e(c){return b.b?b.b(a,c):b.call(null,a,c)}function f(){return b.c?b.c(a):b.call(null,a)}var h=null,k=function(){function c(a,b,e,k){var f=null;if(3<arguments.length){for(var f=0,h=Array(arguments.length-3);f<h.length;)h[f]=arguments[f+3],++f;f=new Da(h,0)}return d.call(this,a,b,e,f)}function d(c,e,k,f){return Bf(b,a,c,e,k,F([f],0))}c.G=
3;c.I=function(a){var b=B(a);a=C(a);var c=B(a);a=C(a);var e=B(a);a=Mc(a);return d(b,c,e,a)};c.j=d;return c}(),h=function(a,b,h,t){switch(arguments.length){case 0:return f.call(this);case 1:return e.call(this,a);case 2:return d.call(this,a,b);case 3:return c.call(this,a,b,h);default:var y=null;if(3<arguments.length){for(var y=0,v=Array(arguments.length-3);y<v.length;)v[y]=arguments[y+3],++y;y=new Da(v,0)}return k.j(a,b,h,y)}throw Error("Invalid arity: "+arguments.length);};h.G=3;h.I=k.I;h.w=f;h.c=
e;h.b=d;h.g=c;h.j=k.j;return h}()}
function Of(b,a){return function(){function c(c,d,e){c=null==c?a:c;return b.g?b.g(c,d,e):b.call(null,c,d,e)}function d(c,d){var e=null==c?a:c;return b.b?b.b(e,d):b.call(null,e,d)}function e(c){c=null==c?a:c;return b.c?b.c(c):b.call(null,c)}var f=null,h=function(){function c(a,b,e,f){var k=null;if(3<arguments.length){for(var k=0,h=Array(arguments.length-3);k<h.length;)h[k]=arguments[k+3],++k;k=new Da(h,0)}return d.call(this,a,b,e,k)}function d(c,e,f,k){return Af(b,null==c?a:c,e,f,k)}c.G=3;c.I=function(a){var b=
B(a);a=C(a);var c=B(a);a=C(a);var e=B(a);a=Mc(a);return d(b,c,e,a)};c.j=d;return c}(),f=function(a,b,f,n){switch(arguments.length){case 1:return e.call(this,a);case 2:return d.call(this,a,b);case 3:return c.call(this,a,b,f);default:var t=null;if(3<arguments.length){for(var t=0,y=Array(arguments.length-3);t<y.length;)y[t]=arguments[t+3],++t;t=new Da(y,0)}return h.j(a,b,f,t)}throw Error("Invalid arity: "+arguments.length);};f.G=3;f.I=h.I;f.c=e;f.b=d;f.g=c;f.j=h.j;return f}()}
function Pf(b,a,c,d){this.state=b;this.A=a;this.Nd=d;this.B=16386;this.m=6455296}g=Pf.prototype;g.equiv=function(b){return this.u(null,b)};g.u=function(b,a){return this===a};g.pc=function(){return this.state};g.M=function(){return this.A};
g.zd=function(b,a,c){for(var d=q(this.Nd),e=null,f=0,h=0;;)if(h<f){b=e.R(null,h);var k=H(b,0);b=H(b,1);var l=a,p=c;b.S?b.S(k,this,l,p):b.call(null,k,this,l,p);h+=1}else if(b=q(d))d=b,$d(d)?(e=hc(d),d=ic(d),b=e,f=G(e),e=b):(b=B(d),k=H(b,0),b=H(b,1),e=k,f=a,h=c,b.S?b.S(e,this,f,h):b.call(null,e,this,f,h),d=C(d),e=null,f=0),h=0;else return null};g.J=function(){return this[ca]||(this[ca]=++da)};
function Qf(){switch(arguments.length){case 1:return Rf(arguments[0]);default:var b=arguments[0],a=new Da(Array.prototype.slice.call(arguments,1),0),a=de(a)?xf(Sf,a):a,c=Id(a,za);Id(a,Tf);return new Pf(b,c,0,null)}}function Rf(b){return new Pf(b,null,0,null)}function Uf(b,a){if(b instanceof Pf){var c=b.state;b.state=a;null!=b.Nd&&Zb(b,c,a);return a}return kc(b,a)}
var Vf=function Vf(){switch(arguments.length){case 2:return Vf.b(arguments[0],arguments[1]);case 3:return Vf.g(arguments[0],arguments[1],arguments[2]);case 4:return Vf.S(arguments[0],arguments[1],arguments[2],arguments[3]);default:return Vf.j(arguments[0],arguments[1],arguments[2],arguments[3],new Da(Array.prototype.slice.call(arguments,4),0))}};Vf.b=function(b,a){var c;b instanceof Pf?(c=b.state,c=a.c?a.c(c):a.call(null,c),c=Uf(b,c)):c=lc.b(b,a);return c};
Vf.g=function(b,a,c){if(b instanceof Pf){var d=b.state;a=a.b?a.b(d,c):a.call(null,d,c);b=Uf(b,a)}else b=lc.g(b,a,c);return b};Vf.S=function(b,a,c,d){if(b instanceof Pf){var e=b.state;a=a.g?a.g(e,c,d):a.call(null,e,c,d);b=Uf(b,a)}else b=lc.S(b,a,c,d);return b};Vf.j=function(b,a,c,d,e){return b instanceof Pf?Uf(b,Af(a,b.state,c,d,e)):lc.Z(b,a,c,d,e)};Vf.I=function(b){var a=B(b),c=C(b);b=B(c);var d=C(c),c=B(d),e=C(d),d=B(e),e=C(e);return Vf.j(a,b,c,d,e)};Vf.G=4;
function Wf(b){this.state=b;this.m=32768;this.B=0}Wf.prototype.yd=function(b,a){return this.state=a};Wf.prototype.pc=function(){return this.state};function Zf(b){return new Wf(b)}function $f(b,a){mc(b,a)}
function ag(){var b=bg,a=cg;return function(){function c(c,d,e){var f=b.c?b.c(c):b.call(null,c);if(r(f))return f;f=b.c?b.c(d):b.call(null,d);if(r(f))return f;f=b.c?b.c(e):b.call(null,e);if(r(f))return f;c=a.c?a.c(c):a.call(null,c);if(r(c))return c;d=a.c?a.c(d):a.call(null,d);return r(d)?d:a.c?a.c(e):a.call(null,e)}function d(c,d){var e=b.c?b.c(c):b.call(null,c);if(r(e))return e;e=b.c?b.c(d):b.call(null,d);if(r(e))return e;e=a.c?a.c(c):a.call(null,c);return r(e)?e:a.c?a.c(d):a.call(null,d)}function e(c){var d=
b.c?b.c(c):b.call(null,c);return r(d)?d:a.c?a.c(c):a.call(null,c)}var f=null,h=function(){function c(a,b,e,f){var k=null;if(3<arguments.length){for(var k=0,h=Array(arguments.length-3);k<h.length;)h[k]=arguments[k+3],++k;k=new Da(h,0)}return d.call(this,a,b,e,k)}function d(c,e,k,h){c=f.g(c,e,k);return r(c)?c:Hf(function(){return function(c){var d=b.c?b.c(c):b.call(null,c);return r(d)?d:a.c?a.c(c):a.call(null,c)}}(c),h)}c.G=3;c.I=function(a){var b=B(a);a=C(a);var c=B(a);a=C(a);var e=B(a);a=Mc(a);return d(b,
c,e,a)};c.j=d;return c}(),f=function(a,b,f,n){switch(arguments.length){case 0:return null;case 1:return e.call(this,a);case 2:return d.call(this,a,b);case 3:return c.call(this,a,b,f);default:var t=null;if(3<arguments.length){for(var t=0,y=Array(arguments.length-3);t<y.length;)y[t]=arguments[t+3],++t;t=new Da(y,0)}return h.j(a,b,f,t)}throw Error("Invalid arity: "+arguments.length);};f.G=3;f.I=h.I;f.w=function(){return null};f.c=e;f.b=d;f.g=c;f.j=h.j;return f}()}
var dg=function dg(){switch(arguments.length){case 1:return dg.c(arguments[0]);case 2:return dg.b(arguments[0],arguments[1]);case 3:return dg.g(arguments[0],arguments[1],arguments[2]);case 4:return dg.S(arguments[0],arguments[1],arguments[2],arguments[3]);default:return dg.j(arguments[0],arguments[1],arguments[2],arguments[3],new Da(Array.prototype.slice.call(arguments,4),0))}};
dg.c=function(b){return function(a){return function(){function c(c,d){var e=b.c?b.c(d):b.call(null,d);return a.b?a.b(c,e):a.call(null,c,e)}function d(b){return a.c?a.c(b):a.call(null,b)}function e(){return a.w?a.w():a.call(null)}var f=null,h=function(){function c(a,b,e){var f=null;if(2<arguments.length){for(var f=0,k=Array(arguments.length-2);f<k.length;)k[f]=arguments[f+2],++f;f=new Da(k,0)}return d.call(this,a,b,f)}function d(c,e,f){e=yf(b,e,f);return a.b?a.b(c,e):a.call(null,c,e)}c.G=2;c.I=function(a){var b=
B(a);a=C(a);var c=B(a);a=Mc(a);return d(b,c,a)};c.j=d;return c}(),f=function(a,b,f){switch(arguments.length){case 0:return e.call(this);case 1:return d.call(this,a);case 2:return c.call(this,a,b);default:var n=null;if(2<arguments.length){for(var n=0,t=Array(arguments.length-2);n<t.length;)t[n]=arguments[n+2],++n;n=new Da(t,0)}return h.j(a,b,n)}throw Error("Invalid arity: "+arguments.length);};f.G=2;f.I=h.I;f.w=e;f.c=d;f.b=c;f.j=h.j;return f}()}};
dg.b=function(b,a){return new af(null,function(){var c=q(a);if(c){if($d(c)){for(var d=hc(c),e=G(d),f=ef(e),h=0;;)if(h<e)hf(f,function(){var a=x.b(d,h);return b.c?b.c(a):b.call(null,a)}()),h+=1;else break;return gf(jf(f),dg.b(b,ic(c)))}return td(function(){var a=B(c);return b.c?b.c(a):b.call(null,a)}(),dg.b(b,Mc(c)))}return null},null,null)};
dg.g=function(b,a,c){return new af(null,function(){var d=q(a),e=q(c);if(d&&e){var f=td,h;h=B(d);var k=B(e);h=b.b?b.b(h,k):b.call(null,h,k);d=f(h,dg.g(b,Mc(d),Mc(e)))}else d=null;return d},null,null)};dg.S=function(b,a,c,d){return new af(null,function(){var e=q(a),f=q(c),h=q(d);if(e&&f&&h){var k=td,l;l=B(e);var p=B(f),n=B(h);l=b.g?b.g(l,p,n):b.call(null,l,p,n);e=k(l,dg.S(b,Mc(e),Mc(f),Mc(h)))}else e=null;return e},null,null)};
dg.j=function(b,a,c,d,e){var f=function k(a){return new af(null,function(){var b=dg.b(q,a);return Gf(ve,b)?td(dg.b(B,b),k(dg.b(Mc,b))):null},null,null)};return dg.b(function(){return function(a){return xf(b,a)}}(f),f(Dd.j(e,d,F([c,a],0))))};dg.I=function(b){var a=B(b),c=C(b);b=B(c);var d=C(c),c=B(d),e=C(d),d=B(e),e=C(e);return dg.j(a,b,c,d,e)};dg.G=4;
function eg(b){return function(a){return function(b){return function(){function d(d,e){var f=Cb(b),h=mc(b,Cb(b)-1),f=0<f?a.b?a.b(d,e):a.call(null,d,e):d;return 0<h?f:Zc(f)?f:new Yc(f)}function e(b){return a.c?a.c(b):a.call(null,b)}function f(){return a.w?a.w():a.call(null)}var h=null,h=function(a,b){switch(arguments.length){case 0:return f.call(this);case 1:return e.call(this,a);case 2:return d.call(this,a,b)}throw Error("Invalid arity: "+arguments.length);};h.w=f;h.c=e;h.b=d;return h}()}(Zf(b))}}
function fg(b,a){return new af(null,function(){if(0<b){var c=q(a);return c?td(B(c),fg(b-1,Mc(c))):null}return null},null,null)}function gg(b,a){return new af(null,function(c){return function(){return c(b,a)}}(function(a,b){for(;;){var e=q(b);if(0<a&&e){var f=a-1,e=Mc(e);a=f;b=e}else return e}}),null,null)}
function hg(b,a){return new af(null,function(c){return function(){return c(b,a)}}(function(a,b){for(;;){var e=q(b),f;if(f=e)f=B(e),f=a.c?a.c(f):a.call(null,f);if(r(f))f=a,e=Mc(e),a=f,b=e;else return e}}),null,null)}function ig(b){return new af(null,function(){return td(b,ig(b))},null,null)}function jg(b,a){return fg(b,ig(a))}function kg(b){return new af(null,function(){return td(b.w?b.w():b.call(null),kg(b))},null,null)}function lg(b,a){return fg(b,kg(a))}
function mg(b,a){return xf(N,yf(dg,b,a))}function ng(b){return function(a){return function(){function c(c,d){return r(b.c?b.c(d):b.call(null,d))?a.b?a.b(c,d):a.call(null,c,d):c}function d(b){return a.c?a.c(b):a.call(null,b)}function e(){return a.w?a.w():a.call(null)}var f=null,f=function(a,b){switch(arguments.length){case 0:return e.call(this);case 1:return d.call(this,a);case 2:return c.call(this,a,b)}throw Error("Invalid arity: "+arguments.length);};f.w=e;f.c=d;f.b=c;return f}()}}
function og(b,a){return new af(null,function(){var c=q(a);if(c){if($d(c)){for(var d=hc(c),e=G(d),f=ef(e),h=0;;)if(h<e){var k;k=x.b(d,h);k=b.c?b.c(k):b.call(null,k);r(k)&&(k=x.b(d,h),f.add(k));h+=1}else break;return gf(jf(f),og(b,ic(c)))}d=B(c);c=Mc(c);return r(b.c?b.c(d):b.call(null,d))?td(d,og(b,c)):og(b,c)}return null},null,null)}function pg(b,a){return og(Kf(b),a)}
var O=function O(){switch(arguments.length){case 2:return O.b(arguments[0],arguments[1]);case 3:return O.g(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};O.b=function(b,a){return null!=b?b&&(b.B&4||b.Qd)?wd(of(w(ac,$b(b),a)),Rd(b)):w(cb,b,a):w(Dd,Nc,a)};O.g=function(b,a,c){return b&&(b.B&4||b.Qd)?wd(of(we(a,pf,$b(b),c)),Rd(b)):we(a,Dd,b,c)};O.G=3;
function qg(b,a){return of(w(function(a,d){return pf.b(a,b.c?b.c(d):b.call(null,d))},$b(Ed),a))}function rg(b,a,c){return O.b(Ed,dg.g(b,a,c))}function sg(b,a,c){return O.b(Ed,dg.S(b,a,c,tg()))}function ug(b,a){return vg(b,a,null)}function vg(b,a,c){var d=ce;for(a=q(a);;)if(a){var e=b;if(e?e.m&256||e.Vc||(e.m?0:La(mb,e)):La(mb,e)){b=Jd(b,B(a),d);if(d===b)return c;a=C(a)}else return c}else return b}
var wg=function wg(a,c,d){var e=H(c,0);c=Ne(c,1);return r(c)?I.g(a,e,wg(Id(a,e),c,d)):I.g(a,e,d)},xg=function xg(){switch(arguments.length){case 3:return xg.g(arguments[0],arguments[1],arguments[2]);case 4:return xg.S(arguments[0],arguments[1],arguments[2],arguments[3]);case 5:return xg.Z(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]);case 6:return xg.ya(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4],arguments[5]);default:return xg.j(arguments[0],arguments[1],
arguments[2],arguments[3],arguments[4],arguments[5],new Da(Array.prototype.slice.call(arguments,6),0))}};xg.g=function(b,a,c){var d=H(a,0);a=Ne(a,1);return r(a)?I.g(b,d,xg.g(Id(b,d),a,c)):I.g(b,d,function(){var a=Id(b,d);return c.c?c.c(a):c.call(null,a)}())};xg.S=function(b,a,c,d){var e=H(a,0);a=Ne(a,1);return r(a)?I.g(b,e,xg.S(Id(b,e),a,c,d)):I.g(b,e,function(){var a=Id(b,e);return c.b?c.b(a,d):c.call(null,a,d)}())};
xg.Z=function(b,a,c,d,e){var f=H(a,0);a=Ne(a,1);return r(a)?I.g(b,f,xg.Z(Id(b,f),a,c,d,e)):I.g(b,f,function(){var a=Id(b,f);return c.g?c.g(a,d,e):c.call(null,a,d,e)}())};xg.ya=function(b,a,c,d,e,f){var h=H(a,0);a=Ne(a,1);return r(a)?I.g(b,h,xg.ya(Id(b,h),a,c,d,e,f)):I.g(b,h,function(){var a=Id(b,h);return c.S?c.S(a,d,e,f):c.call(null,a,d,e,f)}())};xg.j=function(b,a,c,d,e,f,h){var k=H(a,0);a=Ne(a,1);return r(a)?I.g(b,k,Bf(xg,Id(b,k),a,c,d,F([e,f,h],0))):I.g(b,k,Bf(c,Id(b,k),d,e,f,F([h],0)))};
xg.I=function(b){var a=B(b),c=C(b);b=B(c);var d=C(c),c=B(d),e=C(d),d=B(e),f=C(e),e=B(f),h=C(f),f=B(h),h=C(h);return xg.j(a,b,c,d,e,f,h)};xg.G=6;function yg(b,a,c){return I.g(b,a,function(){var d=Id(b,a);return c.c?c.c(d):c.call(null,d)}())}function zg(b,a,c,d){return I.g(b,a,function(){var e=Id(b,a);return c.b?c.b(e,d):c.call(null,e,d)}())}function Ag(b,a,c,d,e){return I.g(b,a,function(){var f=Id(b,a);return c.g?c.g(f,d,e):c.call(null,f,d,e)}())}function Bg(b,a){this.fa=b;this.l=a}
function Cg(b){return new Bg(b,[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null])}function Dg(b){b=b.s;return 32>b?0:b-1>>>5<<5}function Eg(b,a,c){for(;;){if(0===a)return c;var d=Cg(b);d.l[0]=c;c=d;a-=5}}var Fg=function Fg(a,c,d,e){var f=new Bg(d.fa,Va(d.l)),h=a.s-1>>>c&31;5===c?f.l[h]=e:(d=d.l[h],a=null!=d?Fg(a,c-5,d,e):Eg(null,c-5,e),f.l[h]=a);return f};
function Gg(b,a){throw Error([u("No item "),u(b),u(" in vector of length "),u(a)].join(""));}function Hg(b,a){if(a>=Dg(b))return b.ca;for(var c=b.root,d=b.shift;;)if(0<d)var e=d-5,c=c.l[a>>>d&31],d=e;else return c.l}function Ig(b,a){return 0<=a&&a<b.s?Hg(b,a):Gg(a,b.s)}var Jg=function Jg(a,c,d,e,f){var h=new Bg(d.fa,Va(d.l));if(0===c)h.l[e&31]=f;else{var k=e>>>c&31;a=Jg(a,c-5,d.l[k],e,f);h.l[k]=a}return h};function Kg(b,a,c,d,e,f){this.L=b;this.Tc=a;this.l=c;this.v=d;this.start=e;this.end=f}
Kg.prototype.Rc=function(){return this.L<this.end};Kg.prototype.next=function(){32===this.L-this.Tc&&(this.l=Hg(this.v,this.L),this.Tc+=32);var b=this.l[this.L&31];this.L+=1;return b};function R(b,a,c,d,e,f){this.A=b;this.s=a;this.shift=c;this.root=d;this.ca=e;this.i=f;this.m=167668511;this.B=8196}g=R.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){return"number"===typeof a?x.g(this,a,c):c};
g.jc=function(b,a,c){b=0;for(var d=c;;)if(b<this.s){var e=Hg(this,b);c=e.length;a:for(var f=0;;)if(f<c){var h=f+b,k=e[f],d=a.g?a.g(d,h,k):a.call(null,d,h,k);if(Zc(d)){e=d;break a}f+=1}else{e=d;break a}if(Zc(e))return a=e,$c.c?$c.c(a):$c.call(null,a);b+=c;d=e}else return d};g.R=function(b,a){return Ig(this,a)[a&31]};g.za=function(b,a,c){return 0<=a&&a<this.s?Hg(this,a)[a&31]:c};
g.Yb=function(b,a,c){if(0<=a&&a<this.s)return Dg(this)<=a?(b=Va(this.ca),b[a&31]=c,new R(this.A,this.s,this.shift,this.root,b,null)):new R(this.A,this.s,this.shift,Jg(this,this.shift,this.root,a,c),this.ca,null);if(a===this.s)return cb(this,c);throw Error([u("Index "),u(a),u(" out of bounds  [0,"),u(this.s),u("]")].join(""));};g.qc=function(){var b=this.s;return new Kg(0,0,0<G(this)?Hg(this,0):null,this,0,b)};g.M=function(){return this.A};g.O=function(){return this.s};
g.rc=function(){return x.b(this,0)};g.sc=function(){return x.b(this,1)};g.Lb=function(){return 0<this.s?x.b(this,this.s-1):null};g.Za=function(){return 0<this.s?new md(this,this.s-1,null):null};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){if(a instanceof R)if(this.s===G(a))for(var c=nc(this),d=nc(a);;)if(r(c.Rc())){var e=c.next(),f=d.next();if(!E.b(e,f))return!1}else return!0;else return!1;else return sd(this,a)};
g.ic=function(){var b=this;return new Ng(b.s,b.shift,function(){var a=b.root;return Og.c?Og.c(a):Og.call(null,a)}(),function(){var a=b.ca;return Pg.c?Pg.c(a):Pg.call(null,a)}())};g.ea=function(){return wd(Ed,this.A)};g.la=function(b,a){return ad(this,a)};
g.ma=function(b,a,c){b=0;for(var d=c;;)if(b<this.s){var e=Hg(this,b);c=e.length;a:for(var f=0;;)if(f<c){var h=e[f],d=a.b?a.b(d,h):a.call(null,d,h);if(Zc(d)){e=d;break a}f+=1}else{e=d;break a}if(Zc(e))return a=e,$c.c?$c.c(a):$c.call(null,a);b+=c;d=e}else return d};g.T=function(b,a,c){if("number"===typeof a)return Bb(this,a,c);throw Error("Vector's key for assoc must be a number.");};
g.K=function(){if(0===this.s)return null;if(32>=this.s)return new Da(this.ca,0);var b;a:{b=this.root;for(var a=this.shift;;)if(0<a)a-=5,b=b.l[0];else{b=b.l;break a}}return Qg?Qg(this,b,0,0):Rg.call(null,this,b,0,0)};g.N=function(b,a){return new R(a,this.s,this.shift,this.root,this.ca,this.i)};
g.P=function(b,a){if(32>this.s-Dg(this)){for(var c=this.ca.length,d=Array(c+1),e=0;;)if(e<c)d[e]=this.ca[e],e+=1;else break;d[c]=a;return new R(this.A,this.s+1,this.shift,this.root,d,null)}c=(d=this.s>>>5>1<<this.shift)?this.shift+5:this.shift;d?(d=Cg(null),d.l[0]=this.root,e=Eg(null,this.shift,new Bg(null,this.ca)),d.l[1]=e):d=Fg(this,this.shift,this.root,new Bg(null,this.ca));return new R(this.A,this.s+1,c,d,[a],null)};
g.call=function(){var b=null,b=function(a,b,d){switch(arguments.length){case 2:return this.R(null,b);case 3:return this.za(null,b,d)}throw Error("Invalid arity: "+arguments.length);};b.b=function(a,b){return this.R(null,b)};b.g=function(a,b,d){return this.za(null,b,d)};return b}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return this.R(null,b)};g.b=function(b,a){return this.za(null,b,a)};
var S=new Bg(null,[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null]),Ed=new R(null,0,5,S,[],Uc);function Sg(b){var a=b.length;if(32>a)return new R(null,a,5,S,b,null);for(var c=32,d=(new R(null,32,5,S,b.slice(0,32),null)).ic(null);;)if(c<a)var e=c+1,d=pf.b(d,b[c]),c=e;else return bc(d)}R.prototype[Sa]=function(){return Qc(this)};function se(b){return Ja(b)?Sg(b):bc(w(ac,$b(Ed),b))}
var Tg=function Tg(){return Tg.j(0<arguments.length?new Da(Array.prototype.slice.call(arguments,0),0):null)};Tg.j=function(b){return b instanceof Da&&0===b.L?Sg(b.l):se(b)};Tg.G=0;Tg.I=function(b){return Tg.j(q(b))};function Ug(b,a,c,d,e,f){this.Ia=b;this.node=a;this.L=c;this.ta=d;this.A=e;this.i=f;this.m=32375020;this.B=1536}g=Ug.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.M=function(){return this.A};
g.sa=function(){if(this.ta+1<this.node.length){var b;b=this.Ia;var a=this.node,c=this.L,d=this.ta+1;b=Qg?Qg(b,a,c,d):Rg.call(null,b,a,c,d);return null==b?null:b}return jc(this)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return wd(Ed,this.A)};g.la=function(b,a){var c;c=this.Ia;var d=this.L+this.ta,e=G(this.Ia);c=Vg?Vg(c,d,e):Wg.call(null,c,d,e);return ad(c,a)};
g.ma=function(b,a,c){b=this.Ia;var d=this.L+this.ta,e=G(this.Ia);b=Vg?Vg(b,d,e):Wg.call(null,b,d,e);return ed(b,a,c)};g.ka=function(){return this.node[this.ta]};g.oa=function(){if(this.ta+1<this.node.length){var b;b=this.Ia;var a=this.node,c=this.L,d=this.ta+1;b=Qg?Qg(b,a,c,d):Rg.call(null,b,a,c,d);return null==b?Nc:b}return ic(this)};g.K=function(){return this};g.Gc=function(){var b=this.node;return new df(b,this.ta,b.length)};
g.Hc=function(){var b=this.L+this.node.length;if(b<Za(this.Ia)){var a=this.Ia,c=Hg(this.Ia,b);return Qg?Qg(a,c,b,0):Rg.call(null,a,c,b,0)}return Nc};g.N=function(b,a){var c=this.Ia,d=this.node,e=this.L,f=this.ta;return Xg?Xg(c,d,e,f,a):Rg.call(null,c,d,e,f,a)};g.P=function(b,a){return td(a,this)};g.Fc=function(){var b=this.L+this.node.length;if(b<Za(this.Ia)){var a=this.Ia,c=Hg(this.Ia,b);return Qg?Qg(a,c,b,0):Rg.call(null,a,c,b,0)}return null};Ug.prototype[Sa]=function(){return Qc(this)};
function Rg(){switch(arguments.length){case 3:var b=arguments[0],a=arguments[1],c=arguments[2];return new Ug(b,Ig(b,a),a,c,null,null);case 4:return Qg(arguments[0],arguments[1],arguments[2],arguments[3]);case 5:return Xg(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}function Qg(b,a,c,d){return new Ug(b,a,c,d,null,null)}function Xg(b,a,c,d,e){return new Ug(b,a,c,d,e,null)}
function Yg(b,a,c,d,e){this.A=b;this.v=a;this.start=c;this.end=d;this.i=e;this.m=167666463;this.B=8192}g=Yg.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){return"number"===typeof a?x.g(this,a,c):c};g.jc=function(b,a,c){b=this.start;for(var d=0;;)if(b<this.end){var e=d,f=x.b(this.v,b);c=a.g?a.g(c,e,f):a.call(null,c,e,f);if(Zc(c))return a=c,$c.c?$c.c(a):$c.call(null,a);d+=1;b+=1}else return c};
g.R=function(b,a){return 0>a||this.end<=this.start+a?Gg(a,this.end-this.start):x.b(this.v,this.start+a)};g.za=function(b,a,c){return 0>a||this.end<=this.start+a?c:x.g(this.v,this.start+a,c)};g.Yb=function(b,a,c){var d=this.start+a;b=this.A;c=I.g(this.v,d,c);a=this.start;var e=this.end,d=d+1,d=e>d?e:d;return Zg.Z?Zg.Z(b,c,a,d,null):Zg.call(null,b,c,a,d,null)};g.M=function(){return this.A};g.O=function(){return this.end-this.start};g.Lb=function(){return x.b(this.v,this.end-1)};
g.Za=function(){return this.start!==this.end?new md(this,this.end-this.start-1,null):null};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return wd(Ed,this.A)};g.la=function(b,a){return ad(this,a)};g.ma=function(b,a,c){return ed(this,a,c)};g.T=function(b,a,c){if("number"===typeof a)return Bb(this,a,c);throw Error("Subvec's key for assoc must be a number.");};
g.K=function(){var b=this;return function(a){return function d(e){return e===b.end?null:td(x.b(b.v,e),new af(null,function(){return function(){return d(e+1)}}(a),null,null))}}(this)(b.start)};g.N=function(b,a){var c=this.v,d=this.start,e=this.end,f=this.i;return Zg.Z?Zg.Z(a,c,d,e,f):Zg.call(null,a,c,d,e,f)};g.P=function(b,a){var c=this.A,d=Bb(this.v,this.end,a),e=this.start,f=this.end+1;return Zg.Z?Zg.Z(c,d,e,f,null):Zg.call(null,c,d,e,f,null)};
g.call=function(){var b=null,b=function(a,b,d){switch(arguments.length){case 2:return this.R(null,b);case 3:return this.za(null,b,d)}throw Error("Invalid arity: "+arguments.length);};b.b=function(a,b){return this.R(null,b)};b.g=function(a,b,d){return this.za(null,b,d)};return b}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return this.R(null,b)};g.b=function(b,a){return this.za(null,b,a)};Yg.prototype[Sa]=function(){return Qc(this)};
function Zg(b,a,c,d,e){for(;;)if(a instanceof Yg)c=a.start+c,d=a.start+d,a=a.v;else{var f=G(a);if(0>c||0>d||c>f||d>f)throw Error("Index out of bounds");return new Yg(b,a,c,d,e)}}function Wg(){switch(arguments.length){case 2:var b=arguments[0];return Vg(b,arguments[1],G(b));case 3:return Vg(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}function Vg(b,a,c){return Zg(null,b,a,c,null)}
function ah(b,a){return b===a.fa?a:new Bg(b,Va(a.l))}function Og(b){return new Bg({},Va(b.l))}function Pg(b){var a=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];be(b,0,a,0,b.length);return a}var bh=function bh(a,c,d,e){d=ah(a.root.fa,d);var f=a.s-1>>>c&31;if(5===c)a=e;else{var h=d.l[f];a=null!=h?bh(a,c-5,h,e):Eg(a.root.fa,c-5,e)}d.l[f]=a;return d};
function Ng(b,a,c,d){this.s=b;this.shift=a;this.root=c;this.ca=d;this.B=88;this.m=275}g=Ng.prototype;
g.Xb=function(b,a){if(this.root.fa){if(32>this.s-Dg(this))this.ca[this.s&31]=a;else{var c=new Bg(this.root.fa,this.ca),d=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];d[0]=a;this.ca=d;if(this.s>>>5>1<<this.shift){var d=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null],e=this.shift+
5;d[0]=this.root;d[1]=Eg(this.root.fa,this.shift,c);this.root=new Bg(this.root.fa,d);this.shift=e}else this.root=bh(this,this.shift,this.root,c)}this.s+=1;return this}throw Error("conj! after persistent!");};g.kc=function(){if(this.root.fa){this.root.fa=null;var b=this.s-Dg(this),a=Array(b);be(this.ca,0,a,0,b);return new R(null,this.s,this.shift,this.root,a,null)}throw Error("persistent! called twice");};
g.uc=function(b,a,c){if("number"===typeof a)return dc(this,a,c);throw Error("TransientVector's key for assoc! must be a number.");};
g.xd=function(b,a,c){var d=this;if(d.root.fa){if(0<=a&&a<d.s)return Dg(this)<=a?d.ca[a&31]=c:(b=function(){return function f(b,k){var l=ah(d.root.fa,k);if(0===b)l.l[a&31]=c;else{var p=a>>>b&31,n=f(b-5,l.l[p]);l.l[p]=n}return l}}(this).call(null,d.shift,d.root),d.root=b),this;if(a===d.s)return ac(this,c);throw Error([u("Index "),u(a),u(" out of bounds for TransientVector of length"),u(d.s)].join(""));}throw Error("assoc! after persistent!");};
g.O=function(){if(this.root.fa)return this.s;throw Error("count after persistent!");};g.R=function(b,a){if(this.root.fa)return Ig(this,a)[a&31];throw Error("nth after persistent!");};g.za=function(b,a,c){return 0<=a&&a<this.s?x.b(this,a):c};g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){return"number"===typeof a?x.g(this,a,c):c};
g.call=function(){var b=null,b=function(a,b,d){switch(arguments.length){case 2:return this.D(null,b);case 3:return this.C(null,b,d)}throw Error("Invalid arity: "+arguments.length);};b.b=function(a,b){return this.D(null,b)};b.g=function(a,b,d){return this.C(null,b,d)};return b}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return this.D(null,b)};g.b=function(b,a){return this.C(null,b,a)};
function ch(b,a,c,d){this.A=b;this.Ma=a;this.Sb=c;this.i=d;this.m=31850572;this.B=0}g=ch.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.M=function(){return this.A};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return wd(Nc,this.A)};g.ka=function(){return B(this.Ma)};
g.oa=function(){var b=C(this.Ma);return b?new ch(this.A,b,this.Sb,null):null==this.Sb?ab(this):new ch(this.A,this.Sb,null,null)};g.K=function(){return this};g.N=function(b,a){return new ch(a,this.Ma,this.Sb,this.i)};g.P=function(b,a){return td(a,this)};ch.prototype[Sa]=function(){return Qc(this)};function dh(b,a,c,d,e){this.A=b;this.count=a;this.Ma=c;this.Sb=d;this.i=e;this.m=31858766;this.B=8192}g=dh.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};
g.M=function(){return this.A};g.O=function(){return this.count};g.Lb=function(){return B(this.Ma)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return wd(eh,this.A)};g.ka=function(){return B(this.Ma)};g.oa=function(){return Mc(q(this))};g.K=function(){var b=q(this.Sb),a=this.Ma;return r(r(a)?a:b)?new ch(null,this.Ma,q(b),null):null};g.N=function(b,a){return new dh(a,this.count,this.Ma,this.Sb,this.i)};
g.P=function(b,a){var c;r(this.Ma)?(c=this.Sb,c=new dh(this.A,this.count+1,this.Ma,Dd.b(r(c)?c:Ed,a),null)):c=new dh(this.A,this.count+1,Dd.b(this.Ma,a),Ed,null);return c};var eh=new dh(null,0,null,Ed,Uc);dh.prototype[Sa]=function(){return Qc(this)};function fh(){this.m=2097152;this.B=0}fh.prototype.equiv=function(b){return this.u(null,b)};fh.prototype.u=function(){return!1};var gh=new fh;
function hh(b,a){return fe(Yd(a)?G(b)===G(a)?Gf(ve,dg.b(function(b){return E.b(Jd(a,B(b),gh),Ad(b))},b)):null:null)}function ih(b){this.Y=b}ih.prototype.next=function(){if(null!=this.Y){var b=B(this.Y),a=H(b,0),b=H(b,1);this.Y=C(this.Y);return{value:[a,b],done:!1}}return{value:null,done:!0}};function jh(b){return new ih(q(b))}function kh(b){this.Y=b}kh.prototype.next=function(){if(null!=this.Y){var b=B(this.Y);this.Y=C(this.Y);return{value:[b,b],done:!1}}return{value:null,done:!0}};
function lh(b){return new kh(q(b))}
function mh(b,a){var c;if(a instanceof K)a:{c=b.length;for(var d=a.U,e=0;;){if(c<=e){c=-1;break a}var f=b[e];if(f instanceof K&&d===f.U){c=e;break a}e+=2}}else if(c="string"==typeof a,r(r(c)?c:"number"===typeof a))a:for(c=b.length,d=0;;){if(c<=d){c=-1;break a}if(a===b[d]){c=d;break a}d+=2}else if(a instanceof A)a:for(c=b.length,d=a.hb,e=0;;){if(c<=e){c=-1;break a}f=b[e];if(f instanceof A&&d===f.hb){c=e;break a}e+=2}else if(null==a)a:for(c=b.length,d=0;;){if(c<=d){c=-1;break a}if(null==b[d]){c=d;break a}d+=
2}else a:for(c=b.length,d=0;;){if(c<=d){c=-1;break a}if(E.b(a,b[d])){c=d;break a}d+=2}return c}function nh(b,a,c){this.l=b;this.L=a;this.xa=c;this.m=32374990;this.B=0}g=nh.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.M=function(){return this.xa};g.sa=function(){return this.L<this.l.length-2?new nh(this.l,this.L+2,this.xa):null};g.O=function(){return(this.l.length-this.L)/2};g.J=function(){return Sc(this)};g.u=function(b,a){return sd(this,a)};
g.ea=function(){return wd(Nc,this.xa)};g.la=function(b,a){return xd(a,this)};g.ma=function(b,a,c){return zd(a,c,this)};g.ka=function(){return new R(null,2,5,S,[this.l[this.L],this.l[this.L+1]],null)};g.oa=function(){return this.L<this.l.length-2?new nh(this.l,this.L+2,this.xa):Nc};g.K=function(){return this};g.N=function(b,a){return new nh(this.l,this.L,a)};g.P=function(b,a){return td(a,this)};nh.prototype[Sa]=function(){return Qc(this)};function oh(b,a,c){this.l=b;this.L=a;this.s=c}
oh.prototype.Rc=function(){return this.L<this.s};oh.prototype.next=function(){var b=new R(null,2,5,S,[this.l[this.L],this.l[this.L+1]],null);this.L+=2;return b};function m(b,a,c,d){this.A=b;this.s=a;this.l=c;this.i=d;this.m=16647951;this.B=8196}g=m.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.keys=function(){return Qc(ph.c?ph.c(this):ph.call(null,this))};g.entries=function(){return jh(q(this))};
g.values=function(){return Qc(qh.c?qh.c(this):qh.call(null,this))};g.has=function(b){return ge(this,b)};g.get=function(b,a){return this.C(null,b,a)};g.forEach=function(b){for(var a=q(this),c=null,d=0,e=0;;)if(e<d){var f=c.R(null,e),h=H(f,0),f=H(f,1);b.b?b.b(f,h):b.call(null,f,h);e+=1}else if(a=q(a))$d(a)?(c=hc(a),a=ic(a),h=c,d=G(c),c=h):(c=B(a),h=H(c,0),c=f=H(c,1),b.b?b.b(c,h):b.call(null,c,h),a=C(a),c=null,d=0),e=0;else return null};g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){b=mh(this.l,a);return-1===b?c:this.l[b+1]};g.jc=function(b,a,c){b=this.l.length;for(var d=0;;)if(d<b){var e=this.l[d],f=this.l[d+1];c=a.g?a.g(c,e,f):a.call(null,c,e,f);if(Zc(c))return a=c,$c.c?$c.c(a):$c.call(null,a);d+=2}else return c};g.qc=function(){return new oh(this.l,0,2*this.s)};g.M=function(){return this.A};g.O=function(){return this.s};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Vc(this)};
g.u=function(b,a){if(a&&(a.m&1024||a.Vd)){var c=this.l.length;if(this.s===a.O(null))for(var d=0;;)if(d<c){var e=a.C(null,this.l[d],ce);if(e!==ce)if(E.b(this.l[d+1],e))d+=2;else return!1;else return!1}else return!0;else return!1}else return hh(this,a)};g.ic=function(){return new rh({},this.l.length,Va(this.l))};g.ea=function(){return Ib(je,this.A)};g.la=function(b,a){return xd(a,this)};g.ma=function(b,a,c){return zd(a,c,this)};
g.V=function(b,a){if(0<=mh(this.l,a)){var c=this.l.length,d=c-2;if(0===d)return ab(this);for(var d=Array(d),e=0,f=0;;){if(e>=c)return new m(this.A,this.s-1,d,null);E.b(a,this.l[e])||(d[f]=this.l[e],d[f+1]=this.l[e+1],f+=2);e+=2}}else return this};
g.T=function(b,a,c){b=mh(this.l,a);if(-1===b){if(this.s<ie){b=this.l;for(var d=b.length,e=Array(d+2),f=0;;)if(f<d)e[f]=b[f],f+=1;else break;e[d]=a;e[d+1]=c;return new m(this.A,this.s+1,e,null)}return Ib(qb(O.b(sh,this),a,c),this.A)}if(c===this.l[b+1])return this;a=Va(this.l);a[b+1]=c;return new m(this.A,this.s,a,null)};g.Vb=function(b,a){return-1!==mh(this.l,a)};g.K=function(){var b=this.l;return 0<=b.length-2?new nh(b,0,null):null};g.N=function(b,a){return new m(a,this.s,this.l,this.i)};
g.P=function(b,a){if(Zd(a))return qb(this,x.b(a,0),x.b(a,1));for(var c=this,d=q(a);;){if(null==d)return c;var e=B(d);if(Zd(e))c=qb(c,x.b(e,0),x.b(e,1)),d=C(d);else throw Error("conj on a map takes map entries or seqables of map entries");}};
g.call=function(){var b=null,b=function(a,b,d){switch(arguments.length){case 2:return this.D(null,b);case 3:return this.C(null,b,d)}throw Error("Invalid arity: "+arguments.length);};b.b=function(a,b){return this.D(null,b)};b.g=function(a,b,d){return this.C(null,b,d)};return b}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return this.D(null,b)};g.b=function(b,a){return this.C(null,b,a)};var je=new m(null,0,[],Wc),ie=8;
function th(b){for(var a=[],c=0;;)if(c<b.length){var d=b[c],e=b[c+1];-1===mh(a,d)&&(a.push(d),a.push(e));c+=2}else break;return new m(null,a.length/2,a,null)}m.prototype[Sa]=function(){return Qc(this)};function rh(b,a,c){this.lc=b;this.mc=a;this.l=c;this.m=258;this.B=56}g=rh.prototype;g.O=function(){if(r(this.lc))return Je(this.mc,2);throw Error("count after persistent!");};g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){if(r(this.lc))return b=mh(this.l,a),-1===b?c:this.l[b+1];throw Error("lookup after persistent!");};
g.Xb=function(b,a){if(r(this.lc)){if(a?a.m&2048||a.Wd||(a.m?0:La(tb,a)):La(tb,a))return cc(this,Qe.c?Qe.c(a):Qe.call(null,a),Re.c?Re.c(a):Re.call(null,a));for(var c=q(a),d=this;;){var e=B(c);if(r(e))var f=e,c=C(c),d=cc(d,function(){var a=f;return Qe.c?Qe.c(a):Qe.call(null,a)}(),function(){var a=f;return Re.c?Re.c(a):Re.call(null,a)}());else return d}}else throw Error("conj! after persistent!");};
g.kc=function(){if(r(this.lc))return this.lc=!1,new m(null,Je(this.mc,2),this.l,null);throw Error("persistent! called twice");};g.uc=function(b,a,c){var d=this;if(r(d.lc)){b=mh(this.l,a);if(-1===b)return d.mc+2<=2*ie?(d.mc+=2,d.l.push(a),d.l.push(c),this):vf.g(function(){var a=d.mc,b=d.l;return uh.b?uh.b(a,b):uh.call(null,a,b)}(),a,c);c!==d.l[b+1]&&(d.l[b+1]=c);return this}throw Error("assoc! after persistent!");};
function uh(b,a){for(var c=$b(sh),d=0;;)if(d<b)c=vf.g(c,a[d],a[d+1]),d+=2;else return c}function vh(){this.F=!1}function wh(b,a){return b===a?!0:M(b,a)?!0:E.b(b,a)}function xh(b,a,c){b=Va(b);b[a]=c;return b}function yh(b,a){var c=Array(b.length-2);be(b,0,c,0,2*a);be(b,2*(a+1),c,2*a,c.length-2*a);return c}function zh(b,a,c,d){b=b.Zb(a);b.l[c]=d;return b}
function Ah(b,a,c){for(var d=b.length,e=0,f=c;;)if(e<d){c=b[e];if(null!=c){var h=b[e+1];c=a.g?a.g(f,c,h):a.call(null,f,c,h)}else c=b[e+1],c=null!=c?c.bc(a,f):f;if(Zc(c))return b=c,$c.c?$c.c(b):$c.call(null,b);e+=2;f=c}else return f}function Bh(b,a,c){this.fa=b;this.ja=a;this.l=c}g=Bh.prototype;g.Zb=function(b){if(b===this.fa)return this;var a=Ke(this.ja),c=Array(0>a?4:2*(a+1));be(this.l,0,c,0,2*a);return new Bh(b,this.ja,c)};g.Ac=function(){var b=this.l;return Ch?Ch(b):Dh.call(null,b)};
g.bc=function(b,a){return Ah(this.l,b,a)};g.Ob=function(b,a,c,d){var e=1<<(a>>>b&31);if(0===(this.ja&e))return d;var f=Ke(this.ja&e-1),e=this.l[2*f],f=this.l[2*f+1];return null==e?f.Ob(b+5,a,c,d):wh(c,e)?f:d};
g.Ua=function(b,a,c,d,e,f){var h=1<<(c>>>a&31),k=Ke(this.ja&h-1);if(0===(this.ja&h)){var l=Ke(this.ja);if(2*l<this.l.length){b=this.Zb(b);a=b.l;f.F=!0;a:for(c=2*(l-k),f=2*k+(c-1),l=2*(k+1)+(c-1);;){if(0===c)break a;a[l]=a[f];--l;--c;--f}a[2*k]=d;a[2*k+1]=e;b.ja|=h;return b}if(16<=l){k=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];k[c>>>a&31]=Eh.Ua(b,a+5,c,d,e,f);for(e=d=0;;)if(32>d)0!==
(this.ja>>>d&1)&&(k[d]=null!=this.l[e]?Eh.Ua(b,a+5,Cc(this.l[e]),this.l[e],this.l[e+1],f):this.l[e+1],e+=2),d+=1;else break;return new Fh(b,l+1,k)}a=Array(2*(l+4));be(this.l,0,a,0,2*k);a[2*k]=d;a[2*k+1]=e;be(this.l,2*k,a,2*(k+1),2*(l-k));f.F=!0;b=this.Zb(b);b.l=a;b.ja|=h;return b}l=this.l[2*k];h=this.l[2*k+1];if(null==l)return l=h.Ua(b,a+5,c,d,e,f),l===h?this:zh(this,b,2*k+1,l);if(wh(d,l))return e===h?this:zh(this,b,2*k+1,e);f.F=!0;f=a+5;d=Kh?Kh(b,f,l,h,c,d,e):Lh.call(null,b,f,l,h,c,d,e);e=2*k;k=
2*k+1;b=this.Zb(b);b.l[e]=null;b.l[k]=d;return b};
g.Ta=function(b,a,c,d,e){var f=1<<(a>>>b&31),h=Ke(this.ja&f-1);if(0===(this.ja&f)){var k=Ke(this.ja);if(16<=k){h=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];h[a>>>b&31]=Eh.Ta(b+5,a,c,d,e);for(d=c=0;;)if(32>c)0!==(this.ja>>>c&1)&&(h[c]=null!=this.l[d]?Eh.Ta(b+5,Cc(this.l[d]),this.l[d],this.l[d+1],e):this.l[d+1],d+=2),c+=1;else break;return new Fh(null,k+1,h)}b=Array(2*(k+1));be(this.l,
0,b,0,2*h);b[2*h]=c;b[2*h+1]=d;be(this.l,2*h,b,2*(h+1),2*(k-h));e.F=!0;return new Bh(null,this.ja|f,b)}var l=this.l[2*h],f=this.l[2*h+1];if(null==l)return k=f.Ta(b+5,a,c,d,e),k===f?this:new Bh(null,this.ja,xh(this.l,2*h+1,k));if(wh(c,l))return d===f?this:new Bh(null,this.ja,xh(this.l,2*h+1,d));e.F=!0;e=this.ja;k=this.l;b+=5;b=Mh?Mh(b,l,f,a,c,d):Lh.call(null,b,l,f,a,c,d);c=2*h;h=2*h+1;d=Va(k);d[c]=null;d[h]=b;return new Bh(null,e,d)};
g.Bc=function(b,a,c){var d=1<<(a>>>b&31);if(0===(this.ja&d))return this;var e=Ke(this.ja&d-1),f=this.l[2*e],h=this.l[2*e+1];return null==f?(b=h.Bc(b+5,a,c),b===h?this:null!=b?new Bh(null,this.ja,xh(this.l,2*e+1,b)):this.ja===d?null:new Bh(null,this.ja^d,yh(this.l,e))):wh(c,f)?new Bh(null,this.ja^d,yh(this.l,e)):this};var Eh=new Bh(null,0,[]);function Fh(b,a,c){this.fa=b;this.s=a;this.l=c}g=Fh.prototype;g.Zb=function(b){return b===this.fa?this:new Fh(b,this.s,Va(this.l))};
g.Ac=function(){var b=this.l;return Nh?Nh(b):Oh.call(null,b)};g.bc=function(b,a){for(var c=this.l.length,d=0,e=a;;)if(d<c){var f=this.l[d];if(null!=f&&(e=f.bc(b,e),Zc(e)))return c=e,$c.c?$c.c(c):$c.call(null,c);d+=1}else return e};g.Ob=function(b,a,c,d){var e=this.l[a>>>b&31];return null!=e?e.Ob(b+5,a,c,d):d};g.Ua=function(b,a,c,d,e,f){var h=c>>>a&31,k=this.l[h];if(null==k)return b=zh(this,b,h,Eh.Ua(b,a+5,c,d,e,f)),b.s+=1,b;a=k.Ua(b,a+5,c,d,e,f);return a===k?this:zh(this,b,h,a)};
g.Ta=function(b,a,c,d,e){var f=a>>>b&31,h=this.l[f];if(null==h)return new Fh(null,this.s+1,xh(this.l,f,Eh.Ta(b+5,a,c,d,e)));b=h.Ta(b+5,a,c,d,e);return b===h?this:new Fh(null,this.s,xh(this.l,f,b))};
g.Bc=function(b,a,c){var d=a>>>b&31,e=this.l[d];if(null!=e){b=e.Bc(b+5,a,c);if(b===e)d=this;else if(null==b)if(8>=this.s)a:{e=this.l;b=e.length;a=Array(2*(this.s-1));c=0;for(var f=1,h=0;;)if(c<b)c!==d&&null!=e[c]&&(a[f]=e[c],f+=2,h|=1<<c),c+=1;else{d=new Bh(null,h,a);break a}}else d=new Fh(null,this.s-1,xh(this.l,d,b));else d=new Fh(null,this.s,xh(this.l,d,b));return d}return this};function Ph(b,a,c){a*=2;for(var d=0;;)if(d<a){if(wh(c,b[d]))return d;d+=2}else return-1}
function Qh(b,a,c,d){this.fa=b;this.Cb=a;this.s=c;this.l=d}g=Qh.prototype;g.Zb=function(b){if(b===this.fa)return this;var a=Array(2*(this.s+1));be(this.l,0,a,0,2*this.s);return new Qh(b,this.Cb,this.s,a)};g.Ac=function(){var b=this.l;return Ch?Ch(b):Dh.call(null,b)};g.bc=function(b,a){return Ah(this.l,b,a)};g.Ob=function(b,a,c,d){b=Ph(this.l,this.s,c);return 0>b?d:wh(c,this.l[b])?this.l[b+1]:d};
g.Ua=function(b,a,c,d,e,f){if(c===this.Cb){a=Ph(this.l,this.s,d);if(-1===a){if(this.l.length>2*this.s)return a=2*this.s,c=2*this.s+1,b=this.Zb(b),b.l[a]=d,b.l[c]=e,f.F=!0,b.s+=1,b;c=this.l.length;a=Array(c+2);be(this.l,0,a,0,c);a[c]=d;a[c+1]=e;f.F=!0;d=this.s+1;b===this.fa?(this.l=a,this.s=d,b=this):b=new Qh(this.fa,this.Cb,d,a);return b}return this.l[a+1]===e?this:zh(this,b,a+1,e)}return(new Bh(b,1<<(this.Cb>>>a&31),[null,this,null,null])).Ua(b,a,c,d,e,f)};
g.Ta=function(b,a,c,d,e){return a===this.Cb?(b=Ph(this.l,this.s,c),-1===b?(b=2*this.s,a=Array(b+2),be(this.l,0,a,0,b),a[b]=c,a[b+1]=d,e.F=!0,new Qh(null,this.Cb,this.s+1,a)):E.b(this.l[b],d)?this:new Qh(null,this.Cb,this.s,xh(this.l,b+1,d))):(new Bh(null,1<<(this.Cb>>>b&31),[null,this])).Ta(b,a,c,d,e)};g.Bc=function(b,a,c){b=Ph(this.l,this.s,c);return-1===b?this:1===this.s?null:new Qh(null,this.Cb,this.s-1,yh(this.l,Je(b,2)))};
function Lh(){switch(arguments.length){case 6:return Mh(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4],arguments[5]);case 7:return Kh(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4],arguments[5],arguments[6]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}function Mh(b,a,c,d,e,f){var h=Cc(a);if(h===d)return new Qh(null,h,2,[a,c,e,f]);var k=new vh;return Eh.Ta(b,h,a,c,k).Ta(b,d,e,f,k)}
function Kh(b,a,c,d,e,f,h){var k=Cc(c);if(k===e)return new Qh(null,k,2,[c,d,f,h]);var l=new vh;return Eh.Ua(b,a,k,c,d,l).Ua(b,a,e,f,h,l)}function Rh(b,a,c,d,e){this.A=b;this.Pb=a;this.L=c;this.Y=d;this.i=e;this.m=32374860;this.B=0}g=Rh.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.M=function(){return this.A};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return wd(Nc,this.A)};
g.la=function(b,a){return xd(a,this)};g.ma=function(b,a,c){return zd(a,c,this)};g.ka=function(){return null==this.Y?new R(null,2,5,S,[this.Pb[this.L],this.Pb[this.L+1]],null):B(this.Y)};g.oa=function(){if(null==this.Y){var b=this.Pb,a=this.L+2;return Sh?Sh(b,a,null):Dh.call(null,b,a,null)}var b=this.Pb,a=this.L,c=C(this.Y);return Sh?Sh(b,a,c):Dh.call(null,b,a,c)};g.K=function(){return this};g.N=function(b,a){return new Rh(a,this.Pb,this.L,this.Y,this.i)};g.P=function(b,a){return td(a,this)};
Rh.prototype[Sa]=function(){return Qc(this)};function Dh(){switch(arguments.length){case 1:return Ch(arguments[0]);case 3:return Sh(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}function Ch(b){return Sh(b,0,null)}
function Sh(b,a,c){if(null==c)for(c=b.length;;)if(a<c){if(null!=b[a])return new Rh(null,b,a,null,null);var d=b[a+1];if(r(d)&&(d=d.Ac(),r(d)))return new Rh(null,b,a+2,d,null);a+=2}else return null;else return new Rh(null,b,a,c,null)}function Th(b,a,c,d,e){this.A=b;this.Pb=a;this.L=c;this.Y=d;this.i=e;this.m=32374860;this.B=0}g=Th.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.M=function(){return this.A};
g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return wd(Nc,this.A)};g.la=function(b,a){return xd(a,this)};g.ma=function(b,a,c){return zd(a,c,this)};g.ka=function(){return B(this.Y)};g.oa=function(){var b=this.Pb,a=this.L,c=C(this.Y);return Uh?Uh(null,b,a,c):Oh.call(null,null,b,a,c)};g.K=function(){return this};g.N=function(b,a){return new Th(a,this.Pb,this.L,this.Y,this.i)};g.P=function(b,a){return td(a,this)};
Th.prototype[Sa]=function(){return Qc(this)};function Oh(){switch(arguments.length){case 1:return Nh(arguments[0]);case 4:return Uh(arguments[0],arguments[1],arguments[2],arguments[3]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}function Nh(b){return Uh(null,b,0,null)}function Uh(b,a,c,d){if(null==d)for(d=a.length;;)if(c<d){var e=a[c];if(r(e)&&(e=e.Ac(),r(e)))return new Th(b,a,c+1,e,null);c+=1}else return null;else return new Th(b,a,c,d,null)}
function Vh(b,a,c,d,e,f){this.A=b;this.s=a;this.root=c;this.ua=d;this.Da=e;this.i=f;this.m=16123663;this.B=8196}g=Vh.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.keys=function(){return Qc(ph.c?ph.c(this):ph.call(null,this))};g.entries=function(){return jh(q(this))};g.values=function(){return Qc(qh.c?qh.c(this):qh.call(null,this))};g.has=function(b){return ge(this,b)};g.get=function(b,a){return this.C(null,b,a)};
g.forEach=function(b){for(var a=q(this),c=null,d=0,e=0;;)if(e<d){var f=c.R(null,e),h=H(f,0),f=H(f,1);b.b?b.b(f,h):b.call(null,f,h);e+=1}else if(a=q(a))$d(a)?(c=hc(a),a=ic(a),h=c,d=G(c),c=h):(c=B(a),h=H(c,0),c=f=H(c,1),b.b?b.b(c,h):b.call(null,c,h),a=C(a),c=null,d=0),e=0;else return null};g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){return null==a?this.ua?this.Da:c:null==this.root?c:this.root.Ob(0,Cc(a),a,c)};
g.jc=function(b,a,c){this.ua&&(b=this.Da,c=a.g?a.g(c,null,b):a.call(null,c,null,b));return Zc(c)?$c.c?$c.c(c):$c.call(null,c):null!=this.root?this.root.bc(a,c):c};g.M=function(){return this.A};g.O=function(){return this.s};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Vc(this)};g.u=function(b,a){return hh(this,a)};g.ic=function(){return new Wh({},this.root,this.s,this.ua,this.Da)};g.ea=function(){return Ib(sh,this.A)};
g.V=function(b,a){if(null==a)return this.ua?new Vh(this.A,this.s-1,this.root,!1,null,null):this;if(null==this.root)return this;var c=this.root.Bc(0,Cc(a),a);return c===this.root?this:new Vh(this.A,this.s-1,c,this.ua,this.Da,null)};g.T=function(b,a,c){if(null==a)return this.ua&&c===this.Da?this:new Vh(this.A,this.ua?this.s:this.s+1,this.root,!0,c,null);b=new vh;a=(null==this.root?Eh:this.root).Ta(0,Cc(a),a,c,b);return a===this.root?this:new Vh(this.A,b.F?this.s+1:this.s,a,this.ua,this.Da,null)};
g.Vb=function(b,a){return null==a?this.ua:null==this.root?!1:this.root.Ob(0,Cc(a),a,ce)!==ce};g.K=function(){if(0<this.s){var b=null!=this.root?this.root.Ac():null;return this.ua?td(new R(null,2,5,S,[null,this.Da],null),b):b}return null};g.N=function(b,a){return new Vh(a,this.s,this.root,this.ua,this.Da,this.i)};
g.P=function(b,a){if(Zd(a))return qb(this,x.b(a,0),x.b(a,1));for(var c=this,d=q(a);;){if(null==d)return c;var e=B(d);if(Zd(e))c=qb(c,x.b(e,0),x.b(e,1)),d=C(d);else throw Error("conj on a map takes map entries or seqables of map entries");}};
g.call=function(){var b=null,b=function(a,b,d){switch(arguments.length){case 2:return this.D(null,b);case 3:return this.C(null,b,d)}throw Error("Invalid arity: "+arguments.length);};b.b=function(a,b){return this.D(null,b)};b.g=function(a,b,d){return this.C(null,b,d)};return b}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return this.D(null,b)};g.b=function(b,a){return this.C(null,b,a)};var sh=new Vh(null,0,null,!1,null,Wc);
function Md(b,a){for(var c=b.length,d=0,e=$b(sh);;)if(d<c)var f=d+1,e=e.uc(null,b[d],a[d]),d=f;else return bc(e)}Vh.prototype[Sa]=function(){return Qc(this)};function Wh(b,a,c,d,e){this.fa=b;this.root=a;this.count=c;this.ua=d;this.Da=e;this.m=258;this.B=56}
function Xh(b,a){if(b.fa){if(a?a.m&2048||a.Wd||(a.m?0:La(tb,a)):La(tb,a))return Yh(b,Qe.c?Qe.c(a):Qe.call(null,a),Re.c?Re.c(a):Re.call(null,a));for(var c=q(a),d=b;;){var e=B(c);if(r(e))var f=e,c=C(c),d=Yh(d,function(){var a=f;return Qe.c?Qe.c(a):Qe.call(null,a)}(),function(){var a=f;return Re.c?Re.c(a):Re.call(null,a)}());else return d}}else throw Error("conj! after persistent");}
function Yh(b,a,c){if(b.fa){if(null==a)b.Da!==c&&(b.Da=c),b.ua||(b.count+=1,b.ua=!0);else{var d=new vh;a=(null==b.root?Eh:b.root).Ua(b.fa,0,Cc(a),a,c,d);a!==b.root&&(b.root=a);d.F&&(b.count+=1)}return b}throw Error("assoc! after persistent!");}g=Wh.prototype;g.O=function(){if(this.fa)return this.count;throw Error("count after persistent!");};g.D=function(b,a){return null==a?this.ua?this.Da:null:null==this.root?null:this.root.Ob(0,Cc(a),a)};
g.C=function(b,a,c){return null==a?this.ua?this.Da:c:null==this.root?c:this.root.Ob(0,Cc(a),a,c)};g.Xb=function(b,a){return Xh(this,a)};g.kc=function(){var b;if(this.fa)this.fa=null,b=new Vh(null,this.count,this.root,this.ua,this.Da,null);else throw Error("persistent! called twice");return b};g.uc=function(b,a,c){return Yh(this,a,c)};function Zh(b,a,c){for(var d=a;;)if(null!=b)a=c?b.left:b.right,d=Dd.b(d,b),b=a;else return d}
function $h(b,a,c,d,e){this.A=b;this.stack=a;this.Dc=c;this.s=d;this.i=e;this.m=32374862;this.B=0}g=$h.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.M=function(){return this.A};g.O=function(){return 0>this.s?G(C(this))+1:this.s};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return wd(Nc,this.A)};g.la=function(b,a){return xd(a,this)};g.ma=function(b,a,c){return zd(a,c,this)};
g.ka=function(){var b=this.stack;return null==b?null:yb(b)};g.oa=function(){var b=B(this.stack),b=Zh(this.Dc?b.right:b.left,C(this.stack),this.Dc);return null!=b?new $h(null,b,this.Dc,this.s-1,null):Nc};g.K=function(){return this};g.N=function(b,a){return new $h(a,this.stack,this.Dc,this.s,this.i)};g.P=function(b,a){return td(a,this)};$h.prototype[Sa]=function(){return Qc(this)};function ai(b,a,c){return new $h(null,Zh(b,null,a),a,c,null)}
function bi(b,a,c,d){return c instanceof ci?c.left instanceof ci?new ci(c.key,c.F,c.left.mb(),new di(b,a,c.right,d,null),null):c.right instanceof ci?new ci(c.right.key,c.right.F,new di(c.key,c.F,c.left,c.right.left,null),new di(b,a,c.right.right,d,null),null):new di(b,a,c,d,null):new di(b,a,c,d,null)}
function ei(b,a,c,d){return d instanceof ci?d.right instanceof ci?new ci(d.key,d.F,new di(b,a,c,d.left,null),d.right.mb(),null):d.left instanceof ci?new ci(d.left.key,d.left.F,new di(b,a,c,d.left.left,null),new di(d.key,d.F,d.left.right,d.right,null),null):new di(b,a,c,d,null):new di(b,a,c,d,null)}
function fi(b,a,c,d){if(c instanceof ci)return new ci(b,a,c.mb(),d,null);if(d instanceof di)return ei(b,a,c,d.Cc());if(d instanceof ci&&d.left instanceof di)return new ci(d.left.key,d.left.F,new di(b,a,c,d.left.left,null),ei(d.key,d.F,d.left.right,d.right.Cc()),null);throw Error("red-black tree invariant violation");}
var gi=function gi(a,c,d){d=null!=a.left?gi(a.left,c,d):d;if(Zc(d))return $c.c?$c.c(d):$c.call(null,d);var e=a.key,f=a.F;d=c.g?c.g(d,e,f):c.call(null,d,e,f);if(Zc(d))return $c.c?$c.c(d):$c.call(null,d);a=null!=a.right?gi(a.right,c,d):d;return Zc(a)?$c.c?$c.c(a):$c.call(null,a):a};function di(b,a,c,d,e){this.key=b;this.F=a;this.left=c;this.right=d;this.i=e;this.m=32402207;this.B=0}g=di.prototype;g.pd=function(b){return b.rd(this)};
g.Cc=function(){return new ci(this.key,this.F,this.left,this.right,null)};g.mb=function(){return this};g.od=function(b){return b.qd(this)};g.replace=function(b,a,c,d){return new di(b,a,c,d,null)};g.qd=function(b){return new di(b.key,b.F,this,b.right,null)};g.rd=function(b){return new di(b.key,b.F,b.left,this,null)};g.bc=function(b,a){return gi(this,b,a)};g.D=function(b,a){return x.g(this,a,null)};g.C=function(b,a,c){return x.g(this,a,c)};g.R=function(b,a){return 0===a?this.key:1===a?this.F:null};
g.za=function(b,a,c){return 0===a?this.key:1===a?this.F:c};g.Yb=function(b,a,c){return(new R(null,2,5,S,[this.key,this.F],null)).Yb(null,a,c)};g.M=function(){return null};g.O=function(){return 2};g.rc=function(){return this.key};g.sc=function(){return this.F};g.Lb=function(){return this.F};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return Ed};g.la=function(b,a){return ad(this,a)};g.ma=function(b,a,c){return ed(this,a,c)};
g.T=function(b,a,c){return I.g(new R(null,2,5,S,[this.key,this.F],null),a,c)};g.K=function(){return cb(cb(Nc,this.F),this.key)};g.N=function(b,a){return wd(new R(null,2,5,S,[this.key,this.F],null),a)};g.P=function(b,a){return new R(null,3,5,S,[this.key,this.F,a],null)};
g.call=function(){var b=null,b=function(a,b,d){switch(arguments.length){case 2:return this.D(null,b);case 3:return this.C(null,b,d)}throw Error("Invalid arity: "+arguments.length);};b.b=function(a,b){return this.D(null,b)};b.g=function(a,b,d){return this.C(null,b,d)};return b}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return this.D(null,b)};g.b=function(b,a){return this.C(null,b,a)};di.prototype[Sa]=function(){return Qc(this)};
function ci(b,a,c,d,e){this.key=b;this.F=a;this.left=c;this.right=d;this.i=e;this.m=32402207;this.B=0}g=ci.prototype;g.pd=function(b){return new ci(this.key,this.F,this.left,b,null)};g.Cc=function(){throw Error("red-black tree invariant violation");};g.mb=function(){return new di(this.key,this.F,this.left,this.right,null)};g.od=function(b){return new ci(this.key,this.F,b,this.right,null)};g.replace=function(b,a,c,d){return new ci(b,a,c,d,null)};
g.qd=function(b){return this.left instanceof ci?new ci(this.key,this.F,this.left.mb(),new di(b.key,b.F,this.right,b.right,null),null):this.right instanceof ci?new ci(this.right.key,this.right.F,new di(this.key,this.F,this.left,this.right.left,null),new di(b.key,b.F,this.right.right,b.right,null),null):new di(b.key,b.F,this,b.right,null)};
g.rd=function(b){return this.right instanceof ci?new ci(this.key,this.F,new di(b.key,b.F,b.left,this.left,null),this.right.mb(),null):this.left instanceof ci?new ci(this.left.key,this.left.F,new di(b.key,b.F,b.left,this.left.left,null),new di(this.key,this.F,this.left.right,this.right,null),null):new di(b.key,b.F,b.left,this,null)};g.bc=function(b,a){return gi(this,b,a)};g.D=function(b,a){return x.g(this,a,null)};g.C=function(b,a,c){return x.g(this,a,c)};
g.R=function(b,a){return 0===a?this.key:1===a?this.F:null};g.za=function(b,a,c){return 0===a?this.key:1===a?this.F:c};g.Yb=function(b,a,c){return(new R(null,2,5,S,[this.key,this.F],null)).Yb(null,a,c)};g.M=function(){return null};g.O=function(){return 2};g.rc=function(){return this.key};g.sc=function(){return this.F};g.Lb=function(){return this.F};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return Ed};
g.la=function(b,a){return ad(this,a)};g.ma=function(b,a,c){return ed(this,a,c)};g.T=function(b,a,c){return I.g(new R(null,2,5,S,[this.key,this.F],null),a,c)};g.K=function(){return cb(cb(Nc,this.F),this.key)};g.N=function(b,a){return wd(new R(null,2,5,S,[this.key,this.F],null),a)};g.P=function(b,a){return new R(null,3,5,S,[this.key,this.F,a],null)};
g.call=function(){var b=null,b=function(a,b,d){switch(arguments.length){case 2:return this.D(null,b);case 3:return this.C(null,b,d)}throw Error("Invalid arity: "+arguments.length);};b.b=function(a,b){return this.D(null,b)};b.g=function(a,b,d){return this.C(null,b,d)};return b}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return this.D(null,b)};g.b=function(b,a){return this.C(null,b,a)};ci.prototype[Sa]=function(){return Qc(this)};
var hi=function hi(a,c,d,e,f){if(null==c)return new ci(d,e,null,null,null);var h;h=c.key;h=a.b?a.b(d,h):a.call(null,d,h);if(0===h)return f[0]=c,null;if(0>h)return a=hi(a,c.left,d,e,f),null!=a?c.od(a):null;a=hi(a,c.right,d,e,f);return null!=a?c.pd(a):null},ii=function ii(a,c){if(null==a)return c;if(null==c)return a;if(a instanceof ci){if(c instanceof ci){var d=ii(a.right,c.left);return d instanceof ci?new ci(d.key,d.F,new ci(a.key,a.F,a.left,d.left,null),new ci(c.key,c.F,d.right,c.right,null),null):
new ci(a.key,a.F,a.left,new ci(c.key,c.F,d,c.right,null),null)}return new ci(a.key,a.F,a.left,ii(a.right,c),null)}if(c instanceof ci)return new ci(c.key,c.F,ii(a,c.left),c.right,null);d=ii(a.right,c.left);return d instanceof ci?new ci(d.key,d.F,new di(a.key,a.F,a.left,d.left,null),new di(c.key,c.F,d.right,c.right,null),null):fi(a.key,a.F,a.left,new di(c.key,c.F,d,c.right,null))},ji=function ji(a,c,d,e){if(null!=c){var f;f=c.key;f=a.b?a.b(d,f):a.call(null,d,f);if(0===f)return e[0]=c,ii(c.left,c.right);
if(0>f)return a=ji(a,c.left,d,e),null!=a||null!=e[0]?c.left instanceof di?fi(c.key,c.F,a,c.right):new ci(c.key,c.F,a,c.right,null):null;a=ji(a,c.right,d,e);if(null!=a||null!=e[0])if(c.right instanceof di)if(e=c.key,d=c.F,c=c.left,a instanceof ci)c=new ci(e,d,c,a.mb(),null);else if(c instanceof di)c=bi(e,d,c.Cc(),a);else if(c instanceof ci&&c.right instanceof di)c=new ci(c.right.key,c.right.F,bi(c.key,c.F,c.left.Cc(),c.right.left),new di(e,d,c.right.right,a,null),null);else throw Error("red-black tree invariant violation");
else c=new ci(c.key,c.F,c.left,a,null);else c=null;return c}return null},ki=function ki(a,c,d,e){var f=c.key,h=a.b?a.b(d,f):a.call(null,d,f);return 0===h?c.replace(f,e,c.left,c.right):0>h?c.replace(f,c.F,ki(a,c.left,d,e),c.right):c.replace(f,c.F,c.left,ki(a,c.right,d,e))};function li(b,a,c,d,e){this.Ka=b;this.Gb=a;this.s=c;this.A=d;this.i=e;this.m=418776847;this.B=8192}g=li.prototype;
g.forEach=function(b){for(var a=q(this),c=null,d=0,e=0;;)if(e<d){var f=c.R(null,e),h=H(f,0),f=H(f,1);b.b?b.b(f,h):b.call(null,f,h);e+=1}else if(a=q(a))$d(a)?(c=hc(a),a=ic(a),h=c,d=G(c),c=h):(c=B(a),h=H(c,0),c=f=H(c,1),b.b?b.b(c,h):b.call(null,c,h),a=C(a),c=null,d=0),e=0;else return null};g.get=function(b,a){return this.C(null,b,a)};g.entries=function(){return jh(q(this))};g.toString=function(){return pc(this)};g.keys=function(){return Qc(ph.c?ph.c(this):ph.call(null,this))};
g.values=function(){return Qc(qh.c?qh.c(this):qh.call(null,this))};g.equiv=function(b){return this.u(null,b)};function mi(b,a){for(var c=b.Gb;;)if(null!=c){var d;d=c.key;d=b.Ka.b?b.Ka.b(a,d):b.Ka.call(null,a,d);if(0===d)return c;c=0>d?c.left:c.right}else return null}g.has=function(b){return ge(this,b)};g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){b=mi(this,a);return null!=b?b.F:c};g.jc=function(b,a,c){return null!=this.Gb?gi(this.Gb,a,c):c};g.M=function(){return this.A};g.O=function(){return this.s};
g.Za=function(){return 0<this.s?ai(this.Gb,!1,this.s):null};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Vc(this)};g.u=function(b,a){return hh(this,a)};g.ea=function(){return new li(this.Ka,null,0,this.A,0)};g.V=function(b,a){var c=[null],d=ji(this.Ka,this.Gb,a,c);return null==d?null==Hd(c,0)?this:new li(this.Ka,null,0,this.A,null):new li(this.Ka,d.mb(),this.s-1,this.A,null)};
g.T=function(b,a,c){b=[null];var d=hi(this.Ka,this.Gb,a,c,b);return null==d?(b=Hd(b,0),E.b(c,b.F)?this:new li(this.Ka,ki(this.Ka,this.Gb,a,c),this.s,this.A,null)):new li(this.Ka,d.mb(),this.s+1,this.A,null)};g.Vb=function(b,a){return null!=mi(this,a)};g.K=function(){return 0<this.s?ai(this.Gb,!0,this.s):null};g.N=function(b,a){return new li(this.Ka,this.Gb,this.s,a,this.i)};
g.P=function(b,a){if(Zd(a))return qb(this,x.b(a,0),x.b(a,1));for(var c=this,d=q(a);;){if(null==d)return c;var e=B(d);if(Zd(e))c=qb(c,x.b(e,0),x.b(e,1)),d=C(d);else throw Error("conj on a map takes map entries or seqables of map entries");}};
g.call=function(){var b=null,b=function(a,b,d){switch(arguments.length){case 2:return this.D(null,b);case 3:return this.C(null,b,d)}throw Error("Invalid arity: "+arguments.length);};b.b=function(a,b){return this.D(null,b)};b.g=function(a,b,d){return this.C(null,b,d)};return b}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return this.D(null,b)};g.b=function(b,a){return this.C(null,b,a)};var ni=new li(me,null,0,null,Wc);li.prototype[Sa]=function(){return Qc(this)};
var Sf=function Sf(){return Sf.j(0<arguments.length?new Da(Array.prototype.slice.call(arguments,0),0):null)};Sf.j=function(b){b=q(b);for(var a=$b(sh);;)if(b){var c=C(C(b)),a=vf.g(a,B(b),Ad(b));b=c}else return bc(a)};Sf.G=0;Sf.I=function(b){return Sf.j(q(b))};var qi=function qi(){return qi.j(0<arguments.length?new Da(Array.prototype.slice.call(arguments,0),0):null)};qi.j=function(b){b=b instanceof Da&&0===b.L?b.l:Ga(b);return th(b)};qi.G=0;qi.I=function(b){return qi.j(q(b))};
function ri(b,a){this.va=b;this.xa=a;this.m=32374988;this.B=0}g=ri.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.M=function(){return this.xa};g.sa=function(){var b=this.va,b=(b?b.m&128||b.Jc||(b.m?0:La(kb,b)):La(kb,b))?this.va.sa(null):C(this.va);return null==b?null:new ri(b,this.xa)};g.J=function(){return Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return wd(Nc,this.xa)};g.la=function(b,a){return xd(a,this)};
g.ma=function(b,a,c){return zd(a,c,this)};g.ka=function(){return this.va.ka(null).rc(null)};g.oa=function(){var b=this.va,b=(b?b.m&128||b.Jc||(b.m?0:La(kb,b)):La(kb,b))?this.va.sa(null):C(this.va);return null!=b?new ri(b,this.xa):Nc};g.K=function(){return this};g.N=function(b,a){return new ri(this.va,a)};g.P=function(b,a){return td(a,this)};ri.prototype[Sa]=function(){return Qc(this)};function ph(b){return(b=q(b))?new ri(b,null):null}function Qe(b){return ub(b)}
function si(b,a){this.va=b;this.xa=a;this.m=32374988;this.B=0}g=si.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.M=function(){return this.xa};g.sa=function(){var b=this.va,b=(b?b.m&128||b.Jc||(b.m?0:La(kb,b)):La(kb,b))?this.va.sa(null):C(this.va);return null==b?null:new si(b,this.xa)};g.J=function(){return Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return wd(Nc,this.xa)};g.la=function(b,a){return xd(a,this)};
g.ma=function(b,a,c){return zd(a,c,this)};g.ka=function(){return this.va.ka(null).sc(null)};g.oa=function(){var b=this.va,b=(b?b.m&128||b.Jc||(b.m?0:La(kb,b)):La(kb,b))?this.va.sa(null):C(this.va);return null!=b?new si(b,this.xa):Nc};g.K=function(){return this};g.N=function(b,a){return new si(this.va,a)};g.P=function(b,a){return td(a,this)};si.prototype[Sa]=function(){return Qc(this)};function qh(b){return(b=q(b))?new si(b,null):null}function Re(b){return vb(b)}
var ti=function ti(){return ti.j(0<arguments.length?new Da(Array.prototype.slice.call(arguments,0),0):null)};ti.j=function(b){return r(Hf(ve,b))?te(function(a,b){return Dd.b(r(a)?a:je,b)},b):null};ti.G=0;ti.I=function(b){return ti.j(q(b))};function ui(b,a){for(var c=je,d=q(a);;)if(d)var e=B(d),f=Jd(b,e,vi),c=Ef.b(f,vi)?I.g(c,e,f):c,d=C(d);else return wd(c,Rd(b))}function ke(b,a,c){this.A=b;this.$b=a;this.i=c;this.m=15077647;this.B=8196}g=ke.prototype;g.toString=function(){return pc(this)};
g.equiv=function(b){return this.u(null,b)};g.keys=function(){return Qc(q(this))};g.entries=function(){return lh(q(this))};g.values=function(){return Qc(q(this))};g.has=function(b){return ge(this,b)};g.forEach=function(b){for(var a=q(this),c=null,d=0,e=0;;)if(e<d){var f=c.R(null,e),h=H(f,0),f=H(f,1);b.b?b.b(f,h):b.call(null,f,h);e+=1}else if(a=q(a))$d(a)?(c=hc(a),a=ic(a),h=c,d=G(c),c=h):(c=B(a),h=H(c,0),c=f=H(c,1),b.b?b.b(c,h):b.call(null,c,h),a=C(a),c=null,d=0),e=0;else return null};
g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){return pb(this.$b,a)?a:c};g.M=function(){return this.A};g.O=function(){return Za(this.$b)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Vc(this)};g.u=function(b,a){return Vd(a)&&G(this)===G(a)&&Gf(function(a){return function(b){return ge(a,b)}}(this),a)};g.ic=function(){return new wi($b(this.$b))};g.ea=function(){return wd(le,this.A)};g.Kc=function(b,a){return new ke(this.A,sb(this.$b,a),null)};g.K=function(){return ph(this.$b)};
g.N=function(b,a){return new ke(a,this.$b,this.i)};g.P=function(b,a){return new ke(this.A,I.g(this.$b,a,null),null)};g.call=function(){var b=null,b=function(a,b,d){switch(arguments.length){case 2:return this.D(null,b);case 3:return this.C(null,b,d)}throw Error("Invalid arity: "+arguments.length);};b.b=function(a,b){return this.D(null,b)};b.g=function(a,b,d){return this.C(null,b,d)};return b}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};
g.c=function(b){return this.D(null,b)};g.b=function(b,a){return this.C(null,b,a)};var le=new ke(null,je,Wc);ke.prototype[Sa]=function(){return Qc(this)};function wi(b){this.Fb=b;this.B=136;this.m=259}g=wi.prototype;g.Xb=function(b,a){this.Fb=vf.g(this.Fb,a,null);return this};g.kc=function(){return new ke(null,bc(this.Fb),null)};g.O=function(){return G(this.Fb)};g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){return nb.g(this.Fb,a,ce)===ce?c:a};
g.call=function(){function b(a,b,c){return nb.g(this.Fb,b,ce)===ce?c:b}function a(a,b){return nb.g(this.Fb,b,ce)===ce?null:b}var c=null,c=function(c,e,f){switch(arguments.length){case 2:return a.call(this,c,e);case 3:return b.call(this,c,e,f)}throw Error("Invalid arity: "+arguments.length);};c.b=a;c.g=b;return c}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return nb.g(this.Fb,b,ce)===ce?null:b};g.b=function(b,a){return nb.g(this.Fb,b,ce)===ce?a:b};
function xi(b,a,c){this.A=b;this.Hb=a;this.i=c;this.m=417730831;this.B=8192}g=xi.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};g.keys=function(){return Qc(q(this))};g.entries=function(){return lh(q(this))};g.values=function(){return Qc(q(this))};g.has=function(b){return ge(this,b)};
g.forEach=function(b){for(var a=q(this),c=null,d=0,e=0;;)if(e<d){var f=c.R(null,e),h=H(f,0),f=H(f,1);b.b?b.b(f,h):b.call(null,f,h);e+=1}else if(a=q(a))$d(a)?(c=hc(a),a=ic(a),h=c,d=G(c),c=h):(c=B(a),h=H(c,0),c=f=H(c,1),b.b?b.b(c,h):b.call(null,c,h),a=C(a),c=null,d=0),e=0;else return null};g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){b=mi(this.Hb,a);return null!=b?b.key:c};g.M=function(){return this.A};g.O=function(){return G(this.Hb)};
g.Za=function(){return 0<G(this.Hb)?dg.b(Qe,Ub(this.Hb)):null};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Vc(this)};g.u=function(b,a){return Vd(a)&&G(this)===G(a)&&Gf(function(a){return function(b){return ge(a,b)}}(this),a)};g.ea=function(){return new xi(this.A,ab(this.Hb),0)};g.Kc=function(b,a){return new xi(this.A,Nd.b(this.Hb,a),null)};g.K=function(){return ph(this.Hb)};g.N=function(b,a){return new xi(a,this.Hb,this.i)};g.P=function(b,a){return new xi(this.A,I.g(this.Hb,a,null),null)};
g.call=function(){var b=null,b=function(a,b,d){switch(arguments.length){case 2:return this.D(null,b);case 3:return this.C(null,b,d)}throw Error("Invalid arity: "+arguments.length);};b.b=function(a,b){return this.D(null,b)};b.g=function(a,b,d){return this.C(null,b,d)};return b}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return this.D(null,b)};g.b=function(b,a){return this.C(null,b,a)};var yi=new xi(null,ni,Wc);xi.prototype[Sa]=function(){return Qc(this)};
function zi(b){b=q(b);if(null==b)return le;if(b instanceof Da&&0===b.L){b=b.l;a:for(var a=0,c=$b(le);;)if(a<b.length)var d=a+1,c=c.Xb(null,b[a]),a=d;else break a;return c.kc(null)}for(d=$b(le);;)if(null!=b)a=C(b),d=d.Xb(null,b.ka(null)),b=a;else return bc(d)}function Ai(){return w(cb,yi,0<arguments.length?new Da(Array.prototype.slice.call(arguments,0),0):null)}
var Bi=function Bi(){switch(arguments.length){case 0:return Bi.w();case 1:return Bi.c(arguments[0]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};
Bi.w=function(){return function(b){return function(a){return function(){function c(c,d){if(ge($c.c?$c.c(a):$c.call(null,a),d))return c;mc(a,Dd.b(Cb(a),d));return b.b?b.b(c,d):b.call(null,c,d)}function d(a){return b.c?b.c(a):b.call(null,a)}function e(){return b.w?b.w():b.call(null)}var f=null,f=function(a,b){switch(arguments.length){case 0:return e.call(this);case 1:return d.call(this,a);case 2:return c.call(this,a,b)}throw Error("Invalid arity: "+arguments.length);};f.w=e;f.c=d;f.b=c;return f}()}(Zf(le))}};
Bi.c=function(b){return function c(b,e){return new af(null,function(){return function(b,d){for(;;){var e=b,l=H(e,0);if(e=q(e))if(ge(d,l))l=Mc(e),e=d,b=l,d=e;else return td(l,c(Mc(e),Dd.b(d,l)));else return null}}.call(null,b,e)},null,null)}(b,le)};Bi.G=1;function Ci(b){for(var a=Ed;;)if(C(b))a=Dd.b(a,B(b)),b=C(b);else return q(a)}function $e(b){if(b&&(b.B&4096||b.Yd))return b.name;if("string"===typeof b)return b;throw Error([u("Doesn't support name: "),u(b)].join(""));}
function Di(b,a){for(var c=$b(je),d=q(b),e=q(a);;)if(d&&e)c=vf.g(c,B(d),B(e)),d=C(d),e=C(e);else return bc(c)}var Ei=function Ei(){switch(arguments.length){case 2:return Ei.b(arguments[0],arguments[1]);case 3:return Ei.g(arguments[0],arguments[1],arguments[2]);default:return Ei.j(arguments[0],arguments[1],arguments[2],new Da(Array.prototype.slice.call(arguments,3),0))}};Ei.b=function(b,a){return a};Ei.g=function(b,a,c){return(b.c?b.c(a):b.call(null,a))>(b.c?b.c(c):b.call(null,c))?a:c};
Ei.j=function(b,a,c,d){return w(function(a,c){return Ei.g(b,a,c)},Ei.g(b,a,c),d)};Ei.I=function(b){var a=B(b),c=C(b);b=B(c);var d=C(c),c=B(d),d=C(d);return Ei.j(a,b,c,d)};Ei.G=3;function Fi(b,a,c){return new af(null,function(){var d=q(c);return d?td(fg(b,d),Fi(b,a,gg(a,d))):null},null,null)}function Gi(b,a){return new af(null,function(){var c=q(a);if(c){var d;d=B(c);d=b.c?b.c(d):b.call(null,d);c=r(d)?td(B(c),Gi(b,Mc(c))):null}else c=null;return c},null,null)}
function Hi(b,a,c){this.L=b;this.end=a;this.step=c}Hi.prototype.Rc=function(){return 0<this.step?this.L<this.end:this.L>this.end};Hi.prototype.next=function(){var b=this.L;this.L+=this.step;return b};function Ii(b,a,c,d,e){this.A=b;this.start=a;this.end=c;this.step=d;this.i=e;this.m=32375006;this.B=8192}g=Ii.prototype;g.toString=function(){return pc(this)};g.equiv=function(b){return this.u(null,b)};
g.R=function(b,a){if(a<Za(this))return this.start+a*this.step;if(this.start>this.end&&0===this.step)return this.start;throw Error("Index out of bounds");};g.za=function(b,a,c){return a<Za(this)?this.start+a*this.step:this.start>this.end&&0===this.step?this.start:c};g.qc=function(){return new Hi(this.start,this.end,this.step)};g.M=function(){return this.A};
g.sa=function(){return 0<this.step?this.start+this.step<this.end?new Ii(this.A,this.start+this.step,this.end,this.step,null):null:this.start+this.step>this.end?new Ii(this.A,this.start+this.step,this.end,this.step,null):null};g.O=function(){return Ka(Qb(this))?0:Math.ceil((this.end-this.start)/this.step)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Sc(this)};g.u=function(b,a){return sd(this,a)};g.ea=function(){return wd(Nc,this.A)};g.la=function(b,a){return ad(this,a)};
g.ma=function(b,a,c){for(b=this.start;;)if(0<this.step?b<this.end:b>this.end){var d=b;c=a.b?a.b(c,d):a.call(null,c,d);if(Zc(c))return a=c,$c.c?$c.c(a):$c.call(null,a);b+=this.step}else return c};g.ka=function(){return null==Qb(this)?null:this.start};g.oa=function(){return null!=Qb(this)?new Ii(this.A,this.start+this.step,this.end,this.step,null):Nc};g.K=function(){return 0<this.step?this.start<this.end?this:null:this.start>this.end?this:null};
g.N=function(b,a){return new Ii(a,this.start,this.end,this.step,this.i)};g.P=function(b,a){return td(a,this)};Ii.prototype[Sa]=function(){return Qc(this)};function tg(){return new Ii(null,0,Number.MAX_VALUE,1,null)}function Ji(b){return new Ii(null,0,b,1,null)}
function Ki(b,a){return new af(null,function(){var c=q(a);if(c){var d=B(c),e=b.c?b.c(d):b.call(null,d),d=td(d,Gi(function(a,c){return function(a){return E.b(c,b.c?b.c(a):b.call(null,a))}}(d,e,c,c),C(c)));return td(d,Ki(b,q(gg(G(d),c))))}return null},null,null)}function Li(b){a:for(var a=b;;)if(q(a))a=C(a);else break a;return b}function Mi(b,a){if("string"===typeof a){var c=b.exec(a);return E.b(B(c),a)?1===G(c)?B(c):se(c):null}throw new TypeError("re-matches must match against a string.");}
function Ni(b,a){if("string"===typeof a){var c=b.exec(a);return null==c?null:1===G(c)?B(c):se(c)}throw new TypeError("re-find must match against a string.");}function Oi(b){if(b instanceof RegExp)return b;var a=Ni(/^\(\?([idmsux]*)\)/,b),c=H(a,0),a=H(a,1);b=Oe(b,G(c));return new RegExp(b,r(a)?a:"")}
function T(b,a,c,d,e,f,h){var k=ua;ua=null==ua?null:ua-1;try{if(null!=ua&&0>ua)return Vb(b,"#");Vb(b,c);if(0===Ba.c(f))q(h)&&Vb(b,function(){var a=Pi.c(f);return r(a)?a:"..."}());else{if(q(h)){var l=B(h);a.g?a.g(l,b,f):a.call(null,l,b,f)}for(var p=C(h),n=Ba.c(f)-1;;)if(!p||null!=n&&0===n){q(p)&&0===n&&(Vb(b,d),Vb(b,function(){var a=Pi.c(f);return r(a)?a:"..."}()));break}else{Vb(b,d);var t=B(p);c=b;h=f;a.g?a.g(t,c,h):a.call(null,t,c,h);var y=C(p);c=n-1;p=y;n=c}}return Vb(b,e)}finally{ua=k}}
function Qi(b,a){for(var c=q(a),d=null,e=0,f=0;;)if(f<e){var h=d.R(null,f);Vb(b,h);f+=1}else if(c=q(c))d=c,$d(d)?(c=hc(d),e=ic(d),d=c,h=G(c),c=e,e=h):(h=B(d),Vb(b,h),c=C(d),d=null,e=0),f=0;else return null}var Ri={'"':'\\"',"\\":"\\\\","\b":"\\b","\f":"\\f","\n":"\\n","\r":"\\r","\t":"\\t"};function Si(b){return[u('"'),u(b.replace(RegExp('[\\\\"\b\f\n\r\t]',"g"),function(a){return Ri[a]})),u('"')].join("")}
function Ti(b,a,c){if(null==b)return Vb(a,"nil");if(void 0===b)return Vb(a,"#\x3cundefined\x3e");if(r(function(){var a=Id(c,za);return r(a)?(a=b?b.m&131072||b.Xd?!0:b.m?!1:La(Db,b):La(Db,b))?Rd(b):a:a}())){Vb(a,"^");var d=Rd(b);Ui.g?Ui.g(d,a,c):Ui.call(null,d,a,c);Vb(a," ")}return null==b?Vb(a,"nil"):b.Nc?b.Yc(b,a,c):b&&(b.m&2147483648||b.ba)?b.H(null,a,c):Pa(b)===Boolean||"number"===typeof b?Vb(a,""+u(b)):null!=b&&b.constructor===Object?(Vb(a,"#js "),d=dg.b(function(a){return new R(null,2,5,S,[Ze.c(a),
b[a]],null)},ae(b)),Vi.S?Vi.S(d,Ui,a,c):Vi.call(null,d,Ui,a,c)):Ja(b)?T(a,Ui,"#js ["," ","]",c,b):r("string"==typeof b)?r(ya.c(c))?Vb(a,Si(b)):Vb(a,b):Od(b)?Qi(a,F(["#\x3c",""+u(b),"\x3e"],0)):b instanceof Date?(d=function(a,b){for(var c=""+u(a);;)if(G(c)<b)c=[u("0"),u(c)].join("");else return c},Qi(a,F(['#inst "',""+u(b.getUTCFullYear()),"-",d(b.getUTCMonth()+1,2),"-",d(b.getUTCDate(),2),"T",d(b.getUTCHours(),2),":",d(b.getUTCMinutes(),2),":",d(b.getUTCSeconds(),2),".",d(b.getUTCMilliseconds(),3),
"-",'00:00"'],0))):r(b instanceof RegExp)?Qi(a,F(['#"',b.source,'"'],0)):(b?b.m&2147483648||b.ba||(b.m?0:La(Wb,b)):La(Wb,b))?Yb(b,a,c):Qi(a,F(["#\x3c",""+u(b),"\x3e"],0))}function Ui(b,a,c){var d=Wi.c(c);return r(d)?(c=I.g(c,Xi,Ti),d.g?d.g(b,a,c):d.call(null,b,a,c)):Ti(b,a,c)}
function Yi(b,a){var c;if(Td(b))c="";else{c=u;var d=new la;a:{var e=new oc(d);Ui(B(b),e,a);for(var f=q(C(b)),h=null,k=0,l=0;;)if(l<k){var p=h.R(null,l);Vb(e," ");Ui(p,e,a);l+=1}else if(f=q(f))h=f,$d(h)?(f=hc(h),k=ic(h),h=f,p=G(f),f=k,k=p):(p=B(h),Vb(e," "),Ui(p,e,a),f=C(h),h=null,k=0),l=0;else break a}c=""+c(d)}return c}function U(b){return Yi(b,wa())}
function Zi(b){var a=I.g(wa(),ya,!1);b=Yi(b,a);ra.c?ra.c(b):ra.call(null,b);r(sa)?(b=wa(),ra.c?ra.c("\n"):ra.call(null,"\n"),b=(Id(b,xa),null)):b=null;return b}function Vi(b,a,c,d){return T(c,function(b,c,d){var k=ub(b);a.g?a.g(k,c,d):a.call(null,k,c,d);Vb(c," ");b=vb(b);return a.g?a.g(b,c,d):a.call(null,b,c,d)},"{",", ","}",d,q(b))}Wf.prototype.ba=!0;Wf.prototype.H=function(b,a,c){Vb(a,"#\x3cVolatile: ");Ui(this.state,a,c);return Vb(a,"\x3e")};Da.prototype.ba=!0;
Da.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};af.prototype.ba=!0;af.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};$h.prototype.ba=!0;$h.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};Rh.prototype.ba=!0;Rh.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};di.prototype.ba=!0;di.prototype.H=function(b,a,c){return T(a,Ui,"["," ","]",c,this)};nh.prototype.ba=!0;nh.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};
xi.prototype.ba=!0;xi.prototype.H=function(b,a,c){return T(a,Ui,"#{"," ","}",c,this)};Ug.prototype.ba=!0;Ug.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};We.prototype.ba=!0;We.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};md.prototype.ba=!0;md.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};Vh.prototype.ba=!0;Vh.prototype.H=function(b,a,c){return Vi(this,Ui,a,c)};Th.prototype.ba=!0;Th.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};
Yg.prototype.ba=!0;Yg.prototype.H=function(b,a,c){return T(a,Ui,"["," ","]",c,this)};li.prototype.ba=!0;li.prototype.H=function(b,a,c){return Vi(this,Ui,a,c)};ke.prototype.ba=!0;ke.prototype.H=function(b,a,c){return T(a,Ui,"#{"," ","}",c,this)};ff.prototype.ba=!0;ff.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};Pf.prototype.ba=!0;Pf.prototype.H=function(b,a,c){Vb(a,"#\x3cAtom: ");Ui(this.state,a,c);return Vb(a,"\x3e")};si.prototype.ba=!0;
si.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};ci.prototype.ba=!0;ci.prototype.H=function(b,a,c){return T(a,Ui,"["," ","]",c,this)};R.prototype.ba=!0;R.prototype.H=function(b,a,c){return T(a,Ui,"["," ","]",c,this)};ch.prototype.ba=!0;ch.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};Te.prototype.ba=!0;Te.prototype.H=function(b,a){return Vb(a,"()")};dh.prototype.ba=!0;dh.prototype.H=function(b,a,c){return T(a,Ui,"#queue ["," ","]",c,q(this))};m.prototype.ba=!0;
m.prototype.H=function(b,a,c){return Vi(this,Ui,a,c)};Ii.prototype.ba=!0;Ii.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};ri.prototype.ba=!0;ri.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};Se.prototype.ba=!0;Se.prototype.H=function(b,a,c){return T(a,Ui,"("," ",")",c,this)};A.prototype.oc=!0;A.prototype.Wb=function(b,a){if(a instanceof A)return Hc(this,a);throw Error([u("Cannot compare "),u(this),u(" to "),u(a)].join(""));};K.prototype.oc=!0;
K.prototype.Wb=function(b,a){if(a instanceof K)return Xe(this,a);throw Error([u("Cannot compare "),u(this),u(" to "),u(a)].join(""));};Yg.prototype.oc=!0;Yg.prototype.Wb=function(b,a){if(Zd(a))return ne(this,a);throw Error([u("Cannot compare "),u(this),u(" to "),u(a)].join(""));};R.prototype.oc=!0;R.prototype.Wb=function(b,a){if(Zd(a))return ne(this,a);throw Error([u("Cannot compare "),u(this),u(" to "),u(a)].join(""));};
function $i(b){return function(a,c){var d=b.b?b.b(a,c):b.call(null,a,c);return Zc(d)?new Yc(d):d}}function aj(b){return function(a){return function(){function c(b,c){return w(a,b,c)}function d(a){return b.c?b.c(a):b.call(null,a)}function e(){return b.w?b.w():b.call(null)}var f=null,f=function(a,b){switch(arguments.length){case 0:return e.call(this);case 1:return d.call(this,a);case 2:return c.call(this,a,b)}throw Error("Invalid arity: "+arguments.length);};f.w=e;f.c=d;f.b=c;return f}()}($i(b))}
var bj={},cj=function cj(a){if(a?a.Td:a)return a.Td(a);var c;c=cj[ba(null==a?null:a)];if(!c&&(c=cj._,!c))throw Qa("IEncodeJS.-clj-\x3ejs",a);return c.call(null,a)};function dj(b){return(b?r(r(null)?null:b.Sd)||(b.Mb?0:La(bj,b)):La(bj,b))?cj(b):"string"===typeof b||"number"===typeof b||b instanceof K||b instanceof A?ej.c?ej.c(b):ej.call(null,b):U(F([b],0))}
var ej=function ej(a){if(null==a)return null;if(a?r(r(null)?null:a.Sd)||(a.Mb?0:La(bj,a)):La(bj,a))return cj(a);if(a instanceof K)return $e(a);if(a instanceof A)return""+u(a);if(Yd(a)){var c={};a=q(a);for(var d=null,e=0,f=0;;)if(f<e){var h=d.R(null,f),k=H(h,0),h=H(h,1);c[dj(k)]=ej(h);f+=1}else if(a=q(a))$d(a)?(e=hc(a),a=ic(a),d=e,e=G(e)):(e=B(a),d=H(e,0),e=H(e,1),c[dj(d)]=ej(e),a=C(a),d=null,e=0),f=0;else break;return c}if(Ud(a)){c=[];a=q(dg.b(ej,a));d=null;for(f=e=0;;)if(f<e)k=d.R(null,f),c.push(k),
f+=1;else if(a=q(a))d=a,$d(d)?(a=hc(d),f=ic(d),d=a,e=G(a),a=f):(a=B(d),c.push(a),a=C(d),d=null,e=0),f=0;else break;return c}return a},fj={},gj=function gj(a,c){if(a?a.Rd:a)return a.Rd(a,c);var d;d=gj[ba(null==a?null:a)];if(!d&&(d=gj._,!d))throw Qa("IEncodeClojure.-js-\x3eclj",a);return d.call(null,a,c)};
function nj(b){var a=F([new m(null,1,[oj,!1],null)],0),c=de(a)?xf(Sf,a):a,d=Id(c,oj);return function(b,c,d,k){return function p(n){return(n?r(r(null)?null:n.oe)||(n.Mb?0:La(fj,n)):La(fj,n))?gj(n,xf(qi,a)):de(n)?Li(dg.b(p,n)):Ud(n)?O.b(null==n?null:ab(n),dg.b(p,n)):Ja(n)?se(dg.b(p,n)):Pa(n)===Object?O.b(je,function(){return function(a,b,c,d){return function L(e){return new af(null,function(a,b,c,d){return function(){for(;;){var a=q(e);if(a){if($d(a)){var b=hc(a),c=G(b),f=ef(c);return function(){for(var a=
0;;)if(a<c){var e=x.b(b,a),k=f,h=S,t;t=e;t=d.c?d.c(t):d.call(null,t);e=new R(null,2,5,h,[t,p(n[e])],null);k.add(e);a+=1}else return!0}()?gf(jf(f),L(ic(a))):gf(jf(f),null)}var k=B(a);return td(new R(null,2,5,S,[function(){var a=k;return d.c?d.c(a):d.call(null,a)}(),p(n[k])],null),L(Mc(a)))}return null}}}(a,b,c,d),null,null)}}(b,c,d,k)(ae(n))}()):n}}(a,c,d,r(d)?Ze:u)(b)}function pj(b){return Math.floor(Math.random()*b)}function qj(b){return Hd(b,pj(G(b)))}
function rj(b,a){return of(w(function(a,d){var e=b.c?b.c(d):b.call(null,d);return vf.g(a,e,Dd.b(Jd(a,e,Ed),d))},$b(je),a))}function sj(b,a){this.fc=b;this.i=a;this.m=2153775104;this.B=2048}g=sj.prototype;g.toString=function(){return this.fc};g.equiv=function(b){return this.u(null,b)};g.u=function(b,a){return a instanceof sj&&this.fc===a.fc};g.H=function(b,a){return Vb(a,[u('#uuid "'),u(this.fc),u('"')].join(""))};
g.J=function(){if(null==this.i){for(var b=this.fc,a=0,c=0;c<b.length;++c)a=31*a+b.charCodeAt(c),a%=4294967296;this.i=a}return this.i};g.Wb=function(b,a){return oa(this.fc,a.fc)};function tj(b,a,c){var d=Error();this.message=b;this.data=a;this.sd=c;this.name=d.name;this.description=d.description;this.je=d.je;this.fileName=d.fileName;this.lineNumber=d.lineNumber;this.columnNumber=d.columnNumber;this.stack=d.stack;return this}tj.prototype.__proto__=Error.prototype;tj.prototype.ba=!0;
tj.prototype.H=function(b,a,c){Vb(a,"#ExceptionInfo{:message ");Ui(this.message,a,c);r(this.data)&&(Vb(a,", :data "),Ui(this.data,a,c));r(this.sd)&&(Vb(a,", :cause "),Ui(this.sd,a,c));return Vb(a,"}")};tj.prototype.toString=function(){return pc(this)};function uj(b,a){return new tj(b,a,null)};var vj=new K("transact","unique","transact/unique",-940992320),wj=new K(null,"used-args","used-args",23596256),xj=new K(null,"args","args",1315556576),yj=new K("parser","in","parser/in",1617442048),zj=new K(null,"find","find",496279456),Aj=new K(null,"tempids","tempids",1767509089),Bj=new K(null,"schema","schema",-1582001791),Cj=new K(null,"female","female",1810186049),Dj=new K(null,"tuples","tuples",-676032639),Ej=new K("parser","find","parser/find",-801023103),Fj=new K(null,"attribute","attribute",
-2074029119),Gj=new K(null,"min","min",444991522),Hj=new K("transact","cas","transact/cas",816687170),Ij=new K("lookup-ref","unique","lookup-ref/unique",-960647710),Jj=new K(null,"expand-kvps","expand-kvps",44141154),Kj=new K("db.unique","identity","db.unique/identity",1675950722),Lj=new K(null,"last-name","last-name",-1695738974),Mj=new K(null,"*","*",-1294732318),Nj=new K("datascript.pull-api","expand-rev","datascript.pull-api/expand-rev",2143627459),Oj=new K(null,"max-tx","max-tx",1119558339),
Pj=new K(null,"multi?","multi?",-749311069),Qj=new K(null,"where","where",-2044795965),Rj=new K(null,"v","v",21465059),Sj=new K(null,"fn","fn",-1175266204),Tj=new K("db","unique","db/unique",329396388),Uj=new K(null,"wildcard","wildcard",-622473020),Vj=new K(null,"done","done",-889844188),za=new K(null,"meta","meta",1499536964),Wj=new K(null,"variable","variable",-281346492),Xj=new K(null,"age","age",-604307804),Yj=new K(null,"sex","sex",-2056008571),Aa=new K(null,"dup","dup",556298533),Zj=new K(null,
"aevt","aevt",-585148059),ak=new K(null,"pred","pred",1927423397),bk=new K(null,"rattr","rattr",-1122345563),ck=new K(null,"key","key",-1516042587),dk=new K(null,"element","element",1974019749),ek=new K(null,"limit","limit",-1355822363),fk=new K("parser","where","parser/where",-966053850),gk=new K(null,"datom","datom",-371556090),hk=new K(null,"male","male",-560253338),ik=new K(null,"db-after","db-after",-571884666),jk=new K("parser","rule-vars","parser/rule-vars",-1493174969),Tf=new K(null,"validator",
"validator",-1966190681),kk=new K(null,"fragment","fragment",826775688),lk=new K(null,"raw","raw",1604651272),mk=new K(null,"default","default",-1987822328),nk=new K(null,"rule-vars","rule-vars",1665972520),ok=new K(null,"free","free",801364328),pk=new K(null,"finally-block","finally-block",832982472),qk=new K(null,"added","added",2057651688),rk=new K(null,"new","new",-2085437848),sk=new K(null,"other","other",995793544),tk=new K(null,"bindings","bindings",1271397192),uk=new K("db","valueType","db/valueType",
1827971944),vk=new K(null,"symbol","symbol",-1038572696),wk=new K(null,"avet","avet",1383857032),xk=new K(null,"sources","sources",-321166424),yk=new K(null,"name","name",1843675177),zk=new K("query","binding","query/binding",698240489),Ak=new K("db.type","ref","db.type/ref",-1728373079),Bk=new K(null,"value","value",305978217),Ck=new K(null,"prefix-context","prefix-context",-1269613591),Mk=new K("datascript.pull-api","recursion","datascript.pull-api/recursion",-1897884534),Nk=new K(null,"expand-rev",
"expand-rev",1249112650),Ok=new K(null,"operation","operation",-1267664310),Pk=new K(null,"max-eid","max-eid",2134868075),Qk=new K(null,"follows","follows",-757192277),X=new K(null,"recur","recur",-437573268),Rk=new K(null,"eids","eids",1546550700),Sk=new K(null,"catch-block","catch-block",1175212748),Tk=new K(null,"state","state",-1988618099),Uk=new K(null,"entity-id","entity-id",1485898093),Xi=new K(null,"fallback-impl","fallback-impl",-1501286995),Vk=new K(null,"source","source",-433931539),Wk=
new K("transaction","filtered","transaction/filtered",1699706605),xa=new K(null,"flush-on-newline","flush-on-newline",-151457939),Yk=new K("db","isComponent","db/isComponent",423352398),Zk=new K("db.fn","call","db.fn/call",-151594418),$k=new K("transact","upsert","transact/upsert",412688078),al=new K(null,"e","e",1381269198),bl=new K(null,"rules","rules",1198912366),cl=new K(null,"elements","elements",657646735),dl=new K(null,"size","size",1098693007),el=new K(null,"eavt","eavt",-666437073),fl=new K("db.fn",
"retractEntity","db.fn/retractEntity",-1423535441),gl=new K(null,"batch","batch",-662921200),hl=new K("db.unique","value","db.unique/value",276903088),il=new K(null,"ts","ts",1617209904),jl=new K(null,"db-before","db-before",-553691536),ya=new K(null,"readably","readably",1129599760),Pi=new K(null,"more-marker","more-marker",-14717935),kl=new K(null,"tx-data","tx-data",934159761),ll=new K(null,"rels","rels",1770187185),ml=new K("db","retract","db/retract",-1549825231),nl=new K(null,"binding","binding",
539932593),ol=new K(null,"tx","tx",466630418),pl=new K(null,"porrl","porrl",-1693905102),ql=new K("parser","with","parser/with",-386255821),rl=new K(null,"recursion","recursion",-749738765),sl=new K(null,"seen","seen",-518999789),tl=new K(null,"median","median",569566131),ul=new K(null,"with","with",-1536296876),vl=new K(null,"pending-guards","pending-guards",-1255527308),wl=new K("db","current-tx","db/current-tx",1600722132),Ba=new K(null,"print-length","print-length",1931866356),xl=new K(null,"max",
"max",61366548),yl=new K("db.fn","retractAttribute","db.fn/retractAttribute",937402164),zl=new K("lookup-ref","syntax","lookup-ref/syntax",-317304012),Al=new K("db.fn","cas","db.fn/cas",-379352172),Bl=new K(null,"catch-exception","catch-exception",-1997306795),Cl=new K("entity-id","syntax","entity-id/syntax",1921317045),Dl=new K(null,"specs","specs",1426570741),El=new K("db","cardinality","db/cardinality",-104975659),Fl=new K(null,"expected","expected",1583670997),Gl=new K(null,"prev","prev",-1597069226),
Hl=new K("db","id","db/id",-1388397098),Il=new K(null,"continue-block","continue-block",-1852047850),Jl=new K("entity-id","missing","entity-id/missing",1234588374),Kl=new K(null,"attrs","attrs",-2090668713),Ll=new K(null,"context","context",-830191113),Ml=new K("datascript.impl.entity","nf","datascript.impl.entity/nf",-953741353),Nl=new K(null,"subpattern","subpattern",45002743),Ol=new K(null,"error","error",-978969032),Pl=new K(null,"depth","depth",1768663640),Ql=new K("parser","binding","parser/binding",
-346395752),Rl=new K("schema","validation","schema/validation",1178447161),Sl=new K("db","add","db/add",235286841),Tl=new K(null,"clauses","clauses",1454841241),Ul=new K(null,"form","form",-1624062471),Vl=new K(null,"tag","tag",-1290361223),Wl=new K(null,"unfiltered-db","unfiltered-db",-1363720391),Xl=new K(null,"target","target",253001721),Yl=new K(null,"eid","eid",559519930),Zl=new K(null,"rschema","rschema",-1196134054),$l=new K(null,"tx-meta","tx-meta",1159283194),am=new K("db.cardinality","many",
"db.cardinality/many",772806234),bm=new K("transact","syntax","transact/syntax",-299207078),cm=new K(null,"wildcard?","wildcard?",-686044101),Wi=new K(null,"alt-impl","alt-impl",670969595),dm=new K("parser","pull","parser/pull",-2147427204),em=new K(null,"entity","entity",-450970276),fm=new K(null,"prefix-clauses","prefix-clauses",1294180028),oj=new K(null,"keywordize-keys","keywordize-keys",1310784252),gm=new K(null,"expand","expand",595248157),hm=new K(null,"listeners","listeners",394544445),im=
new K(null,"map","map",1371690461),jm=new K(null,"kvps","kvps",65308317),km=new K(null,"test","test",577538877),lm=new K("db.cardinality","one","db.cardinality/one",1428352190),mm=new K(null,"required","required",1807647006),nm=new K(null,"a","a",-2123407586),om=new K(null,"datoms","datoms",-290874434),pm=new K(null,"old","old",-1825222690),qm=new K(null,"in","in",-1531184865),rm=new K(null,"vars","vars",-2046957217),Mm=new K(null,"pattern","pattern",242135423),vi=new K("cljs.core","not-found","cljs.core/not-found",
-1572889185),Nm=new K(null,"salary","salary",1283904063),Om=new K("parser","query","parser/query",1877320671),Pm=new K(null,"attr","attr",-604132353),Qm=new K(null,"results","results",-1134170113);var Rm=function(b,a){return function(){function c(c,d,e){return fe(function(){var f=b.c?b.c(c):b.call(null,c);return r(f)&&(f=b.c?b.c(d):b.call(null,d),r(f)&&(f=b.c?b.c(e):b.call(null,e),r(f)&&(f=a.c?a.c(c):a.call(null,c),r(f))))?(f=a.c?a.c(d):a.call(null,d),r(f)?a.c?a.c(e):a.call(null,e):f):f}())}function d(c,d){return fe(function(){var e=b.c?b.c(c):b.call(null,c);return r(e)&&(e=b.c?b.c(d):b.call(null,d),r(e))?(e=a.c?a.c(c):a.call(null,c),r(e)?a.c?a.c(d):a.call(null,d):e):e}())}function e(c){var d=
b.c?b.c(c):b.call(null,c);c=r(d)?a.c?a.c(c):a.call(null,c):d;return fe(c)}var f=null,h=function(){function c(a,b,e,f){var k=null;if(3<arguments.length){for(var k=0,h=Array(arguments.length-3);k<h.length;)h[k]=arguments[k+3],++k;k=new Da(h,0)}return d.call(this,a,b,e,k)}function d(c,e,k,h){return fe(function(){var d=f.g(c,e,k);return r(d)?Gf(function(){return function(c){var d=b.c?b.c(c):b.call(null,c);return r(d)?a.c?a.c(c):a.call(null,c):d}}(d),h):d}())}c.G=3;c.I=function(a){var b=B(a);a=C(a);var c=
B(a);a=C(a);var e=B(a);a=Mc(a);return d(b,c,e,a)};c.j=d;return c}(),f=function(a,b,f,n){switch(arguments.length){case 0:return!0;case 1:return e.call(this,a);case 2:return d.call(this,a,b);case 3:return c.call(this,a,b,f);default:var t=null;if(3<arguments.length){for(var t=0,y=Array(arguments.length-3);t<y.length;)y[t]=arguments[t+3],++t;t=new Da(y,0)}return h.j(a,b,f,t)}throw Error("Invalid arity: "+arguments.length);};f.G=3;f.I=h.I;f.w=function(){return!0};f.c=e;f.b=d;f.g=c;f.j=h.j;return f}()}(function(b){return"number"===
typeof b},Me);var Sm,Tm=function Tm(a,c,d){if(a?a.Xc:a)return a.Xc(0,c,d);var e;e=Tm[ba(null==a?null:a)];if(!e&&(e=Tm._,!e))throw Qa("WritePort.put!",a);return e.call(null,a,c,d)},Um=function Um(a){if(a?a.Lc:a)return a.Lc();var c;c=Um[ba(null==a?null:a)];if(!c&&(c=Um._,!c))throw Qa("Channel.close!",a);return c.call(null,a)},Vm=function Vm(a){if(a?a.Dd:a)return!0;var c;c=Vm[ba(null==a?null:a)];if(!c&&(c=Vm._,!c))throw Qa("Handler.active?",a);return c.call(null,a)},Wm=function Wm(a){if(a?a.Ed:a)return a.La;var c;
c=Wm[ba(null==a?null:a)];if(!c&&(c=Wm._,!c))throw Qa("Handler.commit",a);return c.call(null,a)},Xm=function Xm(a,c){if(a?a.Cd:a)return a.Cd(0,c);var d;d=Xm[ba(null==a?null:a)];if(!d&&(d=Xm._,!d))throw Qa("Buffer.add!*",a);return d.call(null,a,c)},Ym=function Ym(){switch(arguments.length){case 1:return Ym.c(arguments[0]);case 2:return Ym.b(arguments[0],arguments[1]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};Ym.c=function(b){return b};
Ym.b=function(b,a){return Xm(b,a)};Ym.G=2;function Zm(b,a,c,d,e){for(var f=0;;)if(f<e)c[d+f]=b[a+f],f+=1;else break}function $m(b,a,c,d){this.head=b;this.ca=a;this.length=c;this.l=d}$m.prototype.pop=function(){if(0===this.length)return null;var b=this.l[this.ca];this.l[this.ca]=null;this.ca=(this.ca+1)%this.l.length;--this.length;return b};$m.prototype.unshift=function(b){this.l[this.head]=b;this.head=(this.head+1)%this.l.length;this.length+=1;return null};function an(b,a){b.length+1===b.l.length&&b.resize();b.unshift(a)}
$m.prototype.resize=function(){var b=Array(2*this.l.length);return this.ca<this.head?(Zm(this.l,this.ca,b,0,this.length),this.ca=0,this.head=this.length,this.l=b):this.ca>this.head?(Zm(this.l,this.ca,b,0,this.l.length-this.ca),Zm(this.l,0,b,this.l.length-this.ca,this.head),this.ca=0,this.head=this.length,this.l=b):this.ca===this.head?(this.head=this.ca=0,this.l=b):null};
function bn(b,a){for(var c=b.length,d=0;;)if(d<c){var e=b.pop(),f;f=e;f=a.c?a.c(f):a.call(null,f);r(f)&&b.unshift(e);d+=1}else break}function dn(b){return new $m(0,0,0,Array(b))}function en(b,a){this.aa=b;this.n=a;this.m=2;this.B=0}function fn(b){return b.aa.length===b.n}en.prototype.Cd=function(b,a){an(this.aa,a);return this};en.prototype.O=function(){return this.aa.length};var gn;a:{var hn=aa.navigator;if(hn){var on=hn.userAgent;if(on){gn=on;break a}}gn=""};var pn;
function qn(){var b=aa.MessageChannel;"undefined"===typeof b&&"undefined"!==typeof window&&window.postMessage&&window.addEventListener&&-1==gn.indexOf("Presto")&&(b=function(){var a=document.createElement("IFRAME");a.style.display="none";a.src="";document.documentElement.appendChild(a);var b=a.contentWindow,a=b.document;a.open();a.write("");a.close();var c="callImmediate"+Math.random(),d="file:"==b.location.protocol?"*":b.location.protocol+"//"+b.location.host,a=ha(function(a){if(("*"==d||a.origin==
d)&&a.data==c)this.port1.onmessage()},this);b.addEventListener("message",a,!1);this.port1={};this.port2={postMessage:function(){b.postMessage(c,d)}}});if("undefined"!==typeof b&&-1==gn.indexOf("Edge")&&-1==gn.indexOf("Trident")&&-1==gn.indexOf("MSIE")){var a=new b,c={},d=c;a.port1.onmessage=function(){if(void 0!==c.next){c=c.next;var a=c.td;c.td=null;a()}};return function(b){d.next={td:b};d=d.next;a.port2.postMessage(0)}}return"undefined"!==typeof document&&"onreadystatechange"in document.createElement("SCRIPT")?
function(a){var b=document.createElement("SCRIPT");b.onreadystatechange=function(){b.onreadystatechange=null;b.parentNode.removeChild(b);b=null;a();a=null};document.documentElement.appendChild(b)}:function(a){aa.setTimeout(a,0)}};var rn=dn(32),sn=!1,tn=!1;function un(){sn=!0;tn=!1;for(var b=0;;){var a=rn.pop();if(null!=a&&(a.w?a.w():a.call(null),1024>b)){b+=1;continue}break}sn=!1;return 0<rn.length?vn.w?vn.w():vn.call(null):null}function vn(){var b=tn;if(r(r(b)?sn:b))return null;tn=!0;"function"!=ba(aa.setImmediate)||aa.Window&&aa.Window.prototype&&aa.Window.prototype.setImmediate==aa.setImmediate?(pn||(pn=qn()),pn(un)):aa.setImmediate(un)}function wn(b){an(rn,b);vn()};var xn,yn=function yn(a){"undefined"===typeof xn&&(xn=function(a,d,e){this.Od=a;this.F=d;this.ie=e;this.m=425984;this.B=0},xn.prototype.N=function(a,d){return new xn(this.Od,this.F,d)},xn.prototype.M=function(){return this.ie},xn.prototype.pc=function(){return this.F},xn.Ld=function(){return new R(null,3,5,S,[new A(null,"box","box",-1123515375,null),new A(null,"val","val",1769233139,null),new A(null,"meta37520","meta37520",-1340503353,null)],null)},xn.Nc=!0,xn.Mc="cljs.core.async.impl.channels/t37519",
xn.Yc=function(a,d){return Vb(d,"cljs.core.async.impl.channels/t37519")});return new xn(yn,a,je)};function zn(b,a){this.zc=b;this.F=a}function An(b){return Vm(b.zc)}var Bn=function Bn(a){if(a?a.Bd:a)return a.Bd();var c;c=Bn[ba(null==a?null:a)];if(!c&&(c=Bn._,!c))throw Qa("MMC.abort",a);return c.call(null,a)};function Cn(b,a,c,d,e,f,h){this.nc=b;this.Qc=a;this.cc=c;this.Pc=d;this.aa=e;this.closed=f;this.Ja=h}
Cn.prototype.Bd=function(){for(;;){var b=this.cc.pop();if(null!=b){var a=b.zc;wn(function(a){return function(){return a.c?a.c(!0):a.call(null,!0)}}(a.La,a,b.F,b,this))}break}bn(this.cc,Lf());return Um(this)};
Cn.prototype.Xc=function(b,a,c){var d=this;if(b=d.closed)return yn(!b);if(r(function(){var a=d.aa;return r(a)?Ka(fn(d.aa)):a}())){for(c=Zc(function(){var b=d.aa;return d.Ja.b?d.Ja.b(b,a):d.Ja.call(null,b,a)}());;){if(0<d.nc.length&&0<G(d.aa)){var e=d.nc.pop(),f=e.La,h=d.aa.aa.pop();wn(function(a,b){return function(){return a.c?a.c(b):a.call(null,b)}}(f,h,e,c,b,this))}break}c&&Bn(this);return yn(!0)}e=function(){for(;;){var a=d.nc.pop();if(r(a)){if(r(!0))return a}else return null}}();if(r(e))return c=
Wm(e),wn(function(b){return function(){return b.c?b.c(a):b.call(null,a)}}(c,e,b,this)),yn(!0);64<d.Pc?(d.Pc=0,bn(d.cc,An)):d.Pc+=1;an(d.cc,new zn(c,a));return null};
function Dn(b,a){if(null!=b.aa&&0<G(b.aa)){for(var c=a.La,d=yn(b.aa.aa.pop());;){if(!r(fn(b.aa))){var e=b.cc.pop();if(null!=e){var f=e.zc,h=e.F;wn(function(a){return function(){return a.c?a.c(!0):a.call(null,!0)}}(f.La,f,h,e,c,d,b));Zc(function(){var a=b.aa,c=h;return b.Ja.b?b.Ja.b(a,c):b.Ja.call(null,a,c)}())&&Bn(b);continue}}break}return d}c=function(){for(;;){var a=b.cc.pop();if(r(a)){if(Vm(a.zc))return a}else return null}}();if(r(c))return d=Wm(c.zc),wn(function(a){return function(){return a.c?
a.c(!0):a.call(null,!0)}}(d,c,b)),yn(c.F);if(r(b.closed))return r(b.aa)&&(c=b.aa,b.Ja.c?b.Ja.c(c):b.Ja.call(null,c)),r(r(!0)?a.La:!0)?(c=function(){var a=b.aa;return r(a)?0<G(b.aa):a}(),c=r(c)?b.aa.aa.pop():null,yn(c)):null;64<b.Qc?(b.Qc=0,bn(b.nc,Vm)):b.Qc+=1;an(b.nc,a);return null}
Cn.prototype.Lc=function(){var b=this;if(!b.closed){b.closed=!0;if(r(function(){var a=b.aa;return r(a)?0===b.cc.length:a}())){var a=b.aa;b.Ja.c?b.Ja.c(a):b.Ja.call(null,a)}for(;a=b.nc.pop(),null!=a;){var c=a.La,d=r(function(){var a=b.aa;return r(a)?0<G(b.aa):a}())?b.aa.aa.pop():null;wn(function(a,b){return function(){return a.c?a.c(b):a.call(null,b)}}(c,d,a,this))}}return null};function En(b){console.log(b);return null}
function Fn(b,a){var c=(r(null)?null:En).call(null,a);return null==c?b:Ym.b(b,c)}
function Gn(b){return new Cn(dn(32),0,dn(32),0,b,!1,function(){return function(a){return function(){function b(c,d){try{return a.b?a.b(c,d):a.call(null,c,d)}catch(e){return Fn(c,e)}}function d(b){try{return a.c?a.c(b):a.call(null,b)}catch(c){return Fn(b,c)}}var e=null,e=function(a,e){switch(arguments.length){case 1:return d.call(this,a);case 2:return b.call(this,a,e)}throw Error("Invalid arity: "+arguments.length);};e.c=d;e.b=b;return e}()}(r(null)?null.c?null.c(Ym):null.call(null,Ym):Ym)}())};var Hn,In=function In(a){"undefined"===typeof Hn&&(Hn=function(a,d,e){this.md=a;this.La=d;this.he=e;this.m=393216;this.B=0},Hn.prototype.N=function(a,d){return new Hn(this.md,this.La,d)},Hn.prototype.M=function(){return this.he},Hn.prototype.Dd=function(){return!0},Hn.prototype.Ed=function(){return this.La},Hn.Ld=function(){return new R(null,3,5,S,[new A(null,"fn-handler","fn-handler",648785851,null),new A(null,"f","f",43394975,null),new A(null,"meta37392","meta37392",-156812351,null)],null)},Hn.Nc=
!0,Hn.Mc="cljs.core.async.impl.ioc-helpers/t37391",Hn.Yc=function(a,d){return Vb(d,"cljs.core.async.impl.ioc-helpers/t37391")});return new Hn(In,a,je)};function Jn(b){try{return b[0].call(null,b)}catch(a){throw a instanceof Object&&b[6].Lc(),a;}}function Kn(b,a,c){c=Dn(c,In(function(c){b[2]=c;b[1]=a;return Jn(b)}));return r(c)?(b[2]=$c.c?$c.c(c):$c.call(null,c),b[1]=a,X):null}function Ln(b,a){var c=b[6];null!=a&&c.Xc(0,a,In(function(){return function(){return null}}(c)));c.Lc();return c}
function Mn(b,a,c,d,e,f,h,k){this.Xa=b;this.Ya=a;this.cb=c;this.$a=d;this.fb=e;this.h=f;this.f=h;this.i=k;this.m=2229667594;this.B=8192}g=Mn.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "catch-block":return this.Xa;case "catch-exception":return this.Ya;case "finally-block":return this.cb;case "continue-block":return this.$a;case "prev":return this.fb;default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#cljs.core.async.impl.ioc-helpers.ExceptionFrame{",", ","}",c,N.b(new R(null,5,5,S,[new R(null,2,5,S,[Sk,this.Xa],null),new R(null,2,5,S,[Bl,this.Ya],null),new R(null,2,5,S,[pk,this.cb],null),new R(null,2,5,S,[Il,this.$a],null),new R(null,2,5,S,[Gl,this.fb],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 5+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,5,[pk,null,Sk,null,Bl,null,Gl,null,Il,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Mn(this.Xa,this.Ya,this.cb,this.$a,this.fb,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Sk,a):M.call(null,Sk,a))?new Mn(c,this.Ya,this.cb,this.$a,this.fb,this.h,this.f,null):r(M.b?M.b(Bl,a):M.call(null,Bl,a))?new Mn(this.Xa,c,this.cb,this.$a,this.fb,this.h,this.f,null):r(M.b?M.b(pk,a):M.call(null,pk,a))?new Mn(this.Xa,this.Ya,c,this.$a,this.fb,this.h,this.f,null):r(M.b?M.b(Il,a):M.call(null,Il,a))?new Mn(this.Xa,this.Ya,this.cb,c,this.fb,this.h,this.f,null):r(M.b?M.b(Gl,a):M.call(null,Gl,a))?new Mn(this.Xa,this.Ya,this.cb,this.$a,c,this.h,this.f,
null):new Mn(this.Xa,this.Ya,this.cb,this.$a,this.fb,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,5,5,S,[new R(null,2,5,S,[Sk,this.Xa],null),new R(null,2,5,S,[Bl,this.Ya],null),new R(null,2,5,S,[pk,this.cb],null),new R(null,2,5,S,[Il,this.$a],null),new R(null,2,5,S,[Gl,this.fb],null)],null),this.f))};g.N=function(b,a){return new Mn(this.Xa,this.Ya,this.cb,this.$a,this.fb,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};
function Nn(b){for(;;){var a=b[4],c=Sk.c(a),d=Bl.c(a),e=b[5];if(r(function(){var b=e;return r(b)?Ka(a):b}()))throw e;if(r(function(){var a=e;return r(a)?(a=c,r(a)?e instanceof d:a):a}())){b[1]=c;b[2]=e;b[5]=null;b[4]=I.j(a,Sk,null,F([Bl,null],0));break}if(r(function(){var b=e;return r(b)?Ka(c)&&Ka(pk.c(a)):b}()))b[4]=Gl.c(a);else{if(r(function(){var b=e;return r(b)?(b=Ka(c))?pk.c(a):b:b}())){b[1]=pk.c(a);b[4]=I.g(a,pk,null);break}if(r(function(){var b=Ka(e);return b?pk.c(a):b}())){b[1]=pk.c(a);b[4]=
I.g(a,pk,null);break}if(Ka(e)&&Ka(pk.c(a))){b[1]=Il.c(a);b[4]=Gl.c(a);break}throw Error("No matching clause");}}};for(var On=Array(1),Pn=0;;)if(Pn<On.length)On[Pn]=null,Pn+=1;else break;function Qn(b){b=E.b(b,0)?null:b;return Gn("number"===typeof b?new en(dn(b),b):b)}
var Sn=function Rn(a){"undefined"===typeof Sm&&(Sm=function(a,d,e){this.md=a;this.La=d;this.ge=e;this.m=393216;this.B=0},Sm.prototype.N=function(a,d){return new Sm(this.md,this.La,d)},Sm.prototype.M=function(){return this.ge},Sm.prototype.Dd=function(){return!0},Sm.prototype.Ed=function(){return this.La},Sm.Ld=function(){return new R(null,3,5,S,[new A(null,"fn-handler","fn-handler",648785851,null),new A(null,"f","f",43394975,null),new A(null,"meta34687","meta34687",797384247,null)],null)},Sm.Nc=!0,
Sm.Mc="cljs.core.async/t34686",Sm.Yc=function(a,d){return Vb(d,"cljs.core.async/t34686")});return new Sm(Rn,a,je)}(function(){return null});function Tn(b,a){var c=Tm(b,a,Sn);return r(c)?$c.c?$c.c(c):$c.call(null,c):!0};var Un={},Vn=B(og(function(b){return 0!=(32&1<<b)},new Ii(null,31,-1,-1,null)))+1,Wn=(1<<Vn)-1;function Xn(b,a,c,d){for(var e=0,f=He(c);;)if(e<=f){c=e+f>>>1;var h=a[c];0>(b.b?b.b(h,d):b.call(null,h,d))?e=c+1:f=c-1}else return e}function Yn(b,a,c,d){for(var e=0,f=He(c);;)if(e<=f){c=e+f>>>1;var h=a[c];0<(b.b?b.b(h,d):b.call(null,h,d))?f=c-1:e=c+1}else return e}function Zn(b,a,c){var d=a.length,e=Xn(b,a,d-1,c);if(d=e<d)a=a[e],d=0===(b.b?b.b(a,c):b.call(null,a,c));return d?e:-1}
function $n(b,a,c){var d=a.length;b=Xn(b,a,d-1,c);return b===d?-1:b}function ao(b){return b[b.length-1]}function bo(b,a,c,d,e,f){var h=f.length,k=d-a,l=k+h,p;p=k+h+(c-e);p=Ua?Array(p):Ta.call(null,p);d-=a;for(var n=0;;)if(n<d)p[n+0]=b[n+a],n+=1;else break;a=h-0;for(h=0;;)if(h<a)p[h+k]=f[h+0],h+=1;else break;c-=e;for(f=0;;)if(f<c)p[f+l]=b[f+e],f+=1;else break;return p}function co(b,a,c,d){return bo(b,0,b.length,a,c,d)}
function eo(b,a){var c=b.length,d=a.length,e=c+d,f=e>>>1,h=e-f,e=Ua?Array(f):Ta.call(null,f),h=Ua?Array(h):Ta.call(null,h);if(c<=f){for(var k=c-0,l=0;;)if(l<k)e[l+0]=b[l+0],l+=1;else break;k=f-c-0;for(l=0;;)if(l<k)e[l+c]=a[l+0],l+=1;else break;d-=f-c;for(k=0;;)if(k<d)h[k+0]=a[k+(f-c)],k+=1;else break}else{k=f-0;for(l=0;;)if(l<k)e[l+0]=b[l+0],l+=1;else break;k=c-f;for(l=0;;)if(l<k)h[l+0]=b[l+f],l+=1;else break;d-=0;for(k=0;;)if(k<d)h[k+(c-f)]=a[k+0],k+=1;else break}return[e,h]}
function fo(b,a,c,d,e,f){d-=c;if(f=d===f-0)for(f=0;;){if(f===d)return!0;var h=a[f+c],k=e[f+0];if(0!==(b.b?b.b(h,k):b.call(null,h,k)))return!1;f+=1}else return f}function go(b,a){for(var c=a.length,d=0;;)if(d<c){var e=d,f;f=a[d];f=b.c?b.c(f):b.call(null,f);a[e]=f;d+=1}else break;return a}function ho(b){var a=b.length,c=$b(Ed);if(0<a)for(var d=0;;){var e=a-d;if(32>=e){pf.b(c,b.slice(d));break}else 40<=e?(pf.b(c,b.slice(d,d+24)),d+=24):(e>>>=1,pf.b(c,b.slice(d,d+e)),d+=e)}return qe(bc(c))}
function io(b,a){return r(b)?r(a)?[b,a]:[b]:[a]}function jo(b,a,c){return r(b)?r(a)?r(c)?[b,a,c]:[b,a]:r(c)?[b,c]:[b]:r(a)?r(c)?[a,c]:[a]:[c]}
var ko=function ko(a){if(a?a.ad:a)return a.ad(a);var c;c=ko[ba(null==a?null:a)];if(!c&&(c=ko._,!c))throw Qa("INode.node-lim-key",a);return c.call(null,a)},lo=function lo(a){if(a?a.Hd:a)return a.keys.length;var c;c=lo[ba(null==a?null:a)];if(!c&&(c=lo._,!c))throw Qa("INode.node-len",a);return c.call(null,a)},mo=function mo(a,c){if(a?a.cd:a)return a.cd(a,c);var d;d=mo[ba(null==a?null:a)];if(!d&&(d=mo._,!d))throw Qa("INode.node-merge",a);return d.call(null,a,c)},no=function no(a,c){if(a?a.dd:a)return a.dd(a,
c);var d;d=no[ba(null==a?null:a)];if(!d&&(d=no._,!d))throw Qa("INode.node-merge-n-split",a);return d.call(null,a,c)},oo=function oo(a,c,d){if(a?a.bd:a)return a.bd(a,c,d);var e;e=oo[ba(null==a?null:a)];if(!e&&(e=oo._,!e))throw Qa("INode.node-lookup",a);return e.call(null,a,c,d)},po=function po(a,c,d){if(a?a.Zc:a)return a.Zc(a,c,d);var e;e=po[ba(null==a?null:a)];if(!e&&(e=po._,!e))throw Qa("INode.node-conj",a);return e.call(null,a,c,d)},qo=function qo(a,c,d,e,f,h){if(a?a.$c:a)return a.$c(a,c,d,e,f,
h);var k;k=qo[ba(null==a?null:a)];if(!k&&(k=qo._,!k))throw Qa("INode.node-disj",a);return k.call(null,a,c,d,e,f,h)};function ro(b,a,c,d){if(r(a))return[b];if(16<lo(b))return jo(c,b,d);if(r(r(c)?16>=lo(c):c))return io(mo(c,b),d);if(r(r(d)?16>=lo(d):d))return io(c,mo(b,d));if(r(r(c)?null==d||lo(c)<lo(d):c))return b=no(c,b),jo(b[0],b[1],d);b=no(b,d);return jo(c,b[0],b[1])}function so(b,a){this.keys=b;this.na=a}g=so.prototype;g.ad=function(){return ao(this.keys)};g.Hd=function(){return this.keys.length};
g.cd=function(b,a){return new so(this.keys.concat(a.keys),this.na.concat(a.na))};g.dd=function(b,a){var c=eo(this.keys,a.keys),d=eo(this.na,a.na);return io(new so(c[0],d[0]),new so(c[1],d[1]))};g.bd=function(b,a,c){b=$n(a,this.keys,c);return-1===b?null:oo(this.na[b],a,c)};
g.Zc=function(b,a,c){b=Xn(a,this.keys,this.keys.length-2,c);c=po(this.na[b],a,c);if(r(c)){var d=this.keys,e=b+1,f=c.map(ko);a=fo(a,d,b,e,f,f.length)?d:co(d,b,e,f);b=co(this.na,b,b+1,c);if(32>=b.length)return[new so(a,b)];c=b.length>>>1;return[new so(a.slice(0,c),b.slice(0,c)),new so(a.slice(c),b.slice(c))]}return null};
g.$c=function(b,a,c,d,e,f){var h=$n(a,this.keys,c);if(-1===h)return null;b=0<=h-1?this.na[h-1]:null;var k=h+1<this.na.length?this.na[h+1]:null;c=qo(this.na[h],a,c,!1,b,k);if(r(c)){b=r(b)?h-1:h;var h=r(k)?2+h:1+h,k=this.keys,l=c.map(ko);a=fo(a,k,b,h,l,l.length)?k:co(k,b,h,l);c=co(this.na,b,h,c);return ro(new so(a,c),d,e,f)}return null};function to(b){this.keys=b}g=to.prototype;g.ad=function(){return ao(this.keys)};g.Hd=function(){return this.keys.length};g.cd=function(b,a){return new to(this.keys.concat(a.keys))};
g.dd=function(b,a){var c=eo(this.keys,a.keys);return io(new to(c[0]),new to(c[1]))};g.bd=function(b,a,c){b=Zn(a,this.keys,c);return-1===b?null:this.keys[b]};g.Zc=function(b,a,c){b=Xn(a,this.keys,this.keys.length-1,c);var d=this.keys.length,e;if(e=b<d)e=this.keys[b],e=0===(a.b?a.b(c,e):a.call(null,c,e));return e?null:32===d?(a=d+1>>>1,b>a?[new to(this.keys.slice(0,a)),new to(bo(this.keys,a,d,b,b,[c]))]:[new to(bo(this.keys,0,a,b,b,[c])),new to(this.keys.slice(a,d))]):[new to(co(this.keys,b,b,[c]))]};
g.$c=function(b,a,c,d,e,f){b=Zn(a,this.keys,c);if(-1===b)return null;b=co(this.keys,b,b+1,[]);return ro(new to(b),d,e,f)};function uo(b,a,c,d,e,f){this.root=b;this.shift=a;this.s=c;this.Ra=d;this.A=e;this.i=f;this.m=2297303311;this.B=8192}g=uo.prototype;g.toString=function(){return pc(this)};g.D=function(b,a){return oo(this.root,this.Ra,a)};g.C=function(b,a,c){b=oo(this.root,this.Ra,a);return r(b)?b:c};g.H=function(b,a,c){return T(a,Ui,"#{"," ","}",c,q(this))};g.M=function(){return this.A};g.O=function(){return this.s};
g.Za=function(){var b=vo.c?vo.c(this):vo.call(null,this);return Ub(b)};g.J=function(){var b=this.i;if(null!=b)return b;a:for(var b=0,a=q(this);;)if(a)var c=B(a),b=(b+Cc(c))%4503599627370496,a=C(a);else break a;return this.i=b};g.u=function(b,a){return Vd(a)&&this.s===G(a)&&Gf(function(a){return function(b){return ge(a,b)}}(this),a)};g.ea=function(){return new uo(new to([]),0,0,this.Ra,this.A,Un.Sc)};g.Kc=function(b,a){var c=this.Ra;return wo.g?wo.g(this,a,c):wo.call(null,this,a,c)};
g.la=function(b,a){var c=vo.c?vo.c(this):vo.call(null,this);return r(c)?Kb.b(c,a):a.w?a.w():a.call(null)};g.ma=function(b,a,c){b=vo.c?vo.c(this):vo.call(null,this);return r(b)?Kb.g(b,a,c):c};g.K=function(){return vo.c?vo.c(this):vo.call(null,this)};g.N=function(b,a){return new uo(this.root,this.shift,this.s,this.Ra,a,this.i)};g.P=function(b,a){var c=this.Ra;return xo.g?xo.g(this,a,c):xo.call(null,this,a,c)};
g.call=function(){var b=null,b=function(a,b,d){switch(arguments.length){case 2:return this.D(null,b);case 3:return this.C(null,b,d)}throw Error("Invalid arity: "+arguments.length);};b.b=function(a,b){return this.D(null,b)};b.g=function(a,b,d){return this.C(null,b,d)};return b}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return this.D(null,b)};g.b=function(b,a){return this.C(null,b,a)};function yo(b,a,c,d){return new uo(a,c,d,b.Ra,b.A,Un.Sc)}
function zo(b,a){for(var c=b.shift,d=b.root;;)if(0<c)d=d.na[Wn&a>>>c],c-=Vn;else return d.keys}function xo(b,a,c){a=po(b.root,c,a);return null==a?b:1===a.length?yo(b,a[0],b.shift,b.s+1):yo(b,new so(a.map(ko),a),b.shift+Vn,b.s+1)}function wo(b,a,c){a=qo(b.root,c,a,!0,null,null);if(null==a)return b;a=a[0];return a instanceof so&&1===a.na.length?yo(b,a.na[0],b.shift-Vn,b.s-1):yo(b,a,b.shift,b.s-1)}
var Ao=function Ao(a,c,d){var e=Wn&c>>>d;return 0<d?(c=Ao(a.na[e],c,d-Vn),-1===c?e+1<a.na.length?0|e+1<<d:-1:c|e<<d):e+1<a.keys.length?0|e+1<<0:-1};function Bo(b,a){for(var c=b,d=0,e=a;;)if(0<e)d|=c.na.length-1<<e,e-=Vn,c=ao(c.na);else return d|c.keys.length-1<<0}var Co=function Co(a,c,d){var e=Wn&c>>>d;if(0<d){var f=d-Vn;c=Co(a.na[e],c,f);return-1===c?0<=e-1?(--e,Bo(a.na[e],f)|e<<d):-1:c|e<<d}return 0<=e-1?0|e-1<<0:-1};
function vo(b){if(0<lo(b.root)){var a=Bo(b.root,b.shift)+1;return Do.g?Do.g(b,0,a):Do.call(null,b,0,a)}return null}function Eo(b,a,c,d,e){this.set=b;this.left=a;this.right=c;this.keys=d;this.Na=e;this.m=143130816;this.B=1536}g=Eo.prototype;g.K=function(){return r(this.keys)?this:null};g.ka=function(){return Fo.c?Fo.c(this):Fo.call(null,this)};g.oa=function(){var b=Go.c?Go.c(this):Go.call(null,this);return r(b)?b:Nc};g.sa=function(){return Go.c?Go.c(this):Go.call(null,this)};
g.Gc=function(){return Ho.c?Ho.c(this):Ho.call(null,this)};g.Hc=function(){var b=jc(this);return r(b)?b:Nc};g.Fc=function(){return Io.c?Io.c(this):Io.call(null,this)};g.la=function(b,a){return Jo?Jo(this,a):Ko.call(null,this,a)};g.ma=function(b,a,c){return Lo?Lo(this,a,c):Ko.call(null,this,a,c)};g.Za=function(){return Mo.c?Mo.c(this):Mo.call(null,this)};function Do(b,a,c){return new Eo(b,a,c,zo(b,a),Wn&a>>>0)}function Fo(b){return r(b.keys)?b.keys[b.Na]:null}
function Go(b){var a=b.set,c=b.left,d=b.right,e=b.keys;b=b.Na;if(r(e)){if(b+1<e.length)return c+1<d?new Eo(a,c+1,d,e,b+1):null;c=Ao(a.root,c,a.shift);return Ef.b(-1,c)&&c<d?Do(a,c,d):null}return null}function Ho(b){var a=b.right,c=b.keys,d=b.Na;b=E.b(b.left|Wn,a|Wn)?a&Wn:c.length;return new df(c,d,b)}function Io(b){var a=b.set,c=b.right;b=Ao(a.root,b.left+(b.keys.length-b.Na-1),a.shift);return Ef.b(-1,b)&&b<c?Do(a,b,c):null}
function Mo(b){var a=b.set,c=b.left,d=b.right;return r(b.keys)?(b=Co(a.root,c,a.shift),d=Co(a.root,d,a.shift),No.g?No.g(a,b,d):No.call(null,a,b,d)):null}function Ko(){switch(arguments.length){case 2:return Jo(arguments[0],arguments[1]);case 3:return Lo(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}function Jo(b,a){if(null==b.keys)return a.w?a.w():a.call(null);var c=Fo(b),d=Go(b);return r(d)?Lo(d,a,c):c}
function Lo(b,a,c){var d=b.set,e=b.right,f=b.left,h=b.keys;for(b=b.Na;;){if(Zc(c))return a=c,$c.c?$c.c(a):$c.call(null,a);if(null==h)return c;var k=h[b];c=a.b?a.b(c,k):a.call(null,c,k);if(b+1<h.length)if(f+1<e)b+=1,f+=1;else return c;else if(f=Ao(d.root,f,d.shift),-1!==f&&f<e)h=zo(d,f),b=Wn&f>>>0;else return c}}function Oo(b,a,c,d,e){this.set=b;this.left=a;this.right=c;this.keys=d;this.Na=e;this.m=142606528;this.B=0}g=Oo.prototype;g.K=function(){return r(this.keys)?this:null};
g.ka=function(){return Po.c?Po.c(this):Po.call(null,this)};g.oa=function(){var b=Qo.c?Qo.c(this):Qo.call(null,this);return r(b)?b:Nc};g.sa=function(){return Qo.c?Qo.c(this):Qo.call(null,this)};g.Za=function(){return Ro.c?Ro.c(this):Ro.call(null,this)};function No(b,a,c){return new Oo(b,a,c,zo(b,c),Wn&c>>>0)}function Po(b){return r(b.keys)?b.keys[b.Na]:null}
function Qo(b){var a=b.set,c=b.left,d=b.right,e=b.keys;b=b.Na;if(r(e)){if(0<=b-1)return d-1>c?new Oo(a,c,d-1,e,b-1):null;d=Co(a.root,d,a.shift);return Ef.b(-1,d)&&d>c?No(a,c,d):null}return null}function Ro(b){var a=b.set,c=b.left;b=b.right;if(r(ph)){var d=Ao(a.root,b,a.shift);return Do(a,-1===c?0:Ao(a.root,c,a.shift),-1===d?b+1:d)}return null}
function So(b,a,c){a:for(var d=b.root,e=0,f=b.shift;;){var h=lo(d);if(0===f){var k=d.keys,k=Xn(b.Ra,k,h-1,a);a=h===k?-1:e|k<<0;break a}k=d.keys;k=Xn(b.Ra,k,h-2,a);e|=k<<f;f-=Vn;d=d.na[k]}if(0>a)return null;a:for(d=b.root,e=0,f=b.shift;;){k=lo(d);if(0===f){h=d.keys;k=Yn(b.Ra,h,k-1,c);c=e|k<<0;break a}h=d.keys;k=Yn(b.Ra,h,k-2,c);e|=k<<f;f-=Vn;d=d.na[k]}return c>a?new Eo(b,a,c,zo(b,a),Wn&a>>>0):null}
function To(b,a){for(var c=go(function(a){return new to(a)},ho(b)),d=c,e=0;;){var f=G(d);switch(f){case 0:return new uo(new to([]),0,0,a,null,Un.Sc);case 1:return new uo(B(d),e,b.length,a,null,Un.Sc);default:d=go(function(){return function(a){return new so(a.map(ko),a)}}(d,e,f,c),ho(d)),e+=Vn}}}function Uo(b){return new uo(new to([]),0,0,b,null,Un.Sc)};var Vo=function Vo(a,c){var d;d=Nf(Vo,a);de(c)?(d=Li(dg.b(d,c)),d=a.c?a.c(d):a.call(null,d)):Ud(c)?(d=O.b(null==c?null:ab(c),dg.b(d,c)),d=a.c?a.c(d):a.call(null,d)):d=a.c?a.c(c):a.call(null,c);return d};var Wo=Error;function Xo(b,a,c,d,e){this.e=b;this.a=a;this.v=c;this.tx=d;this.added=e;this.m=2162164480;this.B=0}g=Xo.prototype;g.J=function(){var b=this.i;return r(b)?b:this.i=Yo.c?Yo.c(this):Yo.call(null,this)};g.u=function(b,a){var c=a instanceof Xo;return c?Zo.b?Zo.b(this,a):Zo.call(null,this,a):c};g.K=function(){return $o.c?$o.c(this):$o.call(null,this)};g.D=function(b,a){return ap.g?ap.g(this,a,null):ap.call(null,this,a,null)};
g.C=function(b,a,c){return ap.g?ap.g(this,a,c):ap.call(null,this,a,c)};g.T=function(b,a){return bp.c?bp.c(a):bp.call(null,a)};g.H=function(b,a,c){return T(a,Ui,"#datascript/Datom ["," ","]",c,new R(null,5,5,S,[this.e,this.a,this.v,this.tx,this.added],null))};
var cp=function cp(){switch(arguments.length){case 3:return cp.g(arguments[0],arguments[1],arguments[2]);case 4:return cp.S(arguments[0],arguments[1],arguments[2],arguments[3]);case 5:return cp.Z(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};cp.g=function(b,a,c){return new Xo(b,a,c,536870912,!0)};cp.S=function(b,a,c,d){return new Xo(b,a,c,d,!0)};cp.Z=function(b,a,c,d,e){return new Xo(b,a,c,d,e)};cp.G=5;
function Yo(b){return Fc(Fc(Cc(b.e),Cc(b.a)),Cc(b.v))}function Zo(b,a){return E.b(b.e,a.e)&&E.b(b.a,a.a)&&E.b(b.v,a.v)}function $o(b){return cb(cb(cb(cb(cb(Nc,b.added),b.tx),b.v),b.a),b.e)}function ap(b,a,c){return E.b(Rj,a)?b.v:E.b("e",a)?b.e:E.b(qk,a)?b.added:E.b("v",a)?b.v:E.b(al,a)?b.e:E.b("a",a)?b.a:E.b(ol,a)?b.tx:E.b("added",a)?b.added:E.b("tx",a)?b.tx:E.b(nm,a)?b.a:c}
function bp(b,a,c){switch(a instanceof K?a.U:null){case "e":return new Xo(c,b.a,b.v,b.tx,b.added);case "a":return new Xo(b.e,c,b.v,b.tx,b.added);case "v":return new Xo(b.e,b.a,c,b.tx,b.added);case "tx":return new Xo(b.e,b.a,b.v,c,b.added);case "added":return new Xo(b.e,b.a,b.v,b.tx,c);default:throw new Wo([u("invalid key for #datascript/Datom: "),u(a)].join(""));}}function dp(b,a){return r(r(b)?a:b)?me(b,a):0}function ep(b,a){return r(r(b)?a:b)?b-a:0}
function fp(b,a){if(null!=b&&null!=a){var c=Pa(b),d=Pa(a);return c===d?me(b,a):oa(c,d)}return 0}function gp(b,a){var c=ep(b.e,a.e);return 0===c&&(c=dp(b.a,a.a),0===c&&(c=fp(b.v,a.v),0===c))?(c=ep(b.tx,a.tx),0===c?0:c):c}function pp(b,a){var c=dp(b.a,a.a);return 0===c&&(c=ep(b.e,a.e),0===c&&(c=fp(b.v,a.v),0===c))?(c=ep(b.tx,a.tx),0===c?0:c):c}function qp(b,a){var c=dp(b.a,a.a);return 0===c&&(c=fp(b.v,a.v),0===c&&(c=ep(b.e,a.e),0===c))?(c=ep(b.tx,a.tx),0===c?0:c):c}
function rp(b,a){return b instanceof K?fc(b,a):oa(b,a)}function sp(b,a){var c=Pa(b),d=Pa(a);return c===d?me(b,a):oa(c,d)}function tp(b,a){var c=b.e-a.e;return 0===c&&(c=rp(b.a,a.a),0===c&&(c=sp(b.v,a.v),0===c))?(c=b.tx-a.tx,0===c?0:c):c}function up(b,a){var c=rp(b.a,a.a);return 0===c&&(c=b.e-a.e,0===c&&(c=sp(b.v,a.v),0===c))?(c=b.tx-a.tx,0===c?0:c):c}function vp(b,a){var c=rp(b.a,a.a);return 0===c&&(c=sp(b.v,a.v),0===c&&(c=b.e-a.e,0===c))?(c=b.tx-a.tx,0===c?0:c):c}
var wp={},xp=function xp(a,c){if(a?a.ld:a)return a.ld(a,c);var d;d=xp[ba(null==a?null:a)];if(!d&&(d=xp._,!d))throw Qa("ISearch.-search",a);return d.call(null,a,c)},yp=function yp(a,c,d){if(a?a.hd:a)return a.hd(a,c,d);var e;e=yp[ba(null==a?null:a)];if(!e&&(e=yp._,!e))throw Qa("IIndexAccess.-datoms",a);return e.call(null,a,c,d)},zp=function zp(a,c,d){if(a?a.kd:a)return a.kd(a,c,d);var e;e=zp[ba(null==a?null:a)];if(!e&&(e=zp._,!e))throw Qa("IIndexAccess.-seek-datoms",a);return e.call(null,a,c,d)},Ap=
function Ap(a,c,d,e){if(a?a.jd:a)return a.jd(a,c,d,e);var f;f=Ap[ba(null==a?null:a)];if(!f&&(f=Ap._,!f))throw Qa("IIndexAccess.-index-range",a);return f.call(null,a,c,d,e)},Bp={},Cp=function Cp(a){if(a?a.gd:a)return a.gd(a);var c;c=Cp[ba(null==a?null:a)];if(!c&&(c=Cp._,!c))throw Qa("IDB.-schema",a);return c.call(null,a)},Dp=function Dp(a,c){if(a?a.fd:a)return a.fd(a,c);var d;d=Dp[ba(null==a?null:a)];if(!d&&(d=Dp._,!d))throw Qa("IDB.-attrs-by",a);return d.call(null,a,c)};
function Ep(b,a,c,d,e,f,h,k,l,p){this.Ea=b;this.Aa=a;this.Ga=c;this.Ca=d;this.Oa=e;this.Pa=f;this.Ha=h;this.h=k;this.f=l;this.i=p;this.m=2229667594;this.B=8192}g=Ep.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "schema":return this.Ea;case "eavt":return this.Aa;case "aevt":return this.Ga;case "avet":return this.Ca;case "max-eid":return this.Oa;case "max-tx":return this.Pa;case "rschema":return this.Ha;default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.core.DB{",", ","}",c,N.b(new R(null,7,5,S,[new R(null,2,5,S,[Bj,this.Ea],null),new R(null,2,5,S,[el,this.Aa],null),new R(null,2,5,S,[Zj,this.Ga],null),new R(null,2,5,S,[wk,this.Ca],null),new R(null,2,5,S,[Pk,this.Oa],null),new R(null,2,5,S,[Oj,this.Pa],null),new R(null,2,5,S,[Zl,this.Ha],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 7+G(this.f)};
g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,7,[Bj,null,Oj,null,Zj,null,wk,null,Pk,null,el,null,Zl,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Ep(this.Ea,this.Aa,this.Ga,this.Ca,this.Oa,this.Pa,this.Ha,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Bj,a):M.call(null,Bj,a))?new Ep(c,this.Aa,this.Ga,this.Ca,this.Oa,this.Pa,this.Ha,this.h,this.f,null):r(M.b?M.b(el,a):M.call(null,el,a))?new Ep(this.Ea,c,this.Ga,this.Ca,this.Oa,this.Pa,this.Ha,this.h,this.f,null):r(M.b?M.b(Zj,a):M.call(null,Zj,a))?new Ep(this.Ea,this.Aa,c,this.Ca,this.Oa,this.Pa,this.Ha,this.h,this.f,null):r(M.b?M.b(wk,a):M.call(null,wk,a))?new Ep(this.Ea,this.Aa,this.Ga,c,this.Oa,this.Pa,this.Ha,this.h,this.f,null):r(M.b?M.b(Pk,a):M.call(null,
Pk,a))?new Ep(this.Ea,this.Aa,this.Ga,this.Ca,c,this.Pa,this.Ha,this.h,this.f,null):r(M.b?M.b(Oj,a):M.call(null,Oj,a))?new Ep(this.Ea,this.Aa,this.Ga,this.Ca,this.Oa,c,this.Ha,this.h,this.f,null):r(M.b?M.b(Zl,a):M.call(null,Zl,a))?new Ep(this.Ea,this.Aa,this.Ga,this.Ca,this.Oa,this.Pa,c,this.h,this.f,null):new Ep(this.Ea,this.Aa,this.Ga,this.Ca,this.Oa,this.Pa,this.Ha,this.h,I.g(this.f,a,c),null)};
g.K=function(){return q(N.b(new R(null,7,5,S,[new R(null,2,5,S,[Bj,this.Ea],null),new R(null,2,5,S,[el,this.Aa],null),new R(null,2,5,S,[Zj,this.Ga],null),new R(null,2,5,S,[wk,this.Ca],null),new R(null,2,5,S,[Pk,this.Oa],null),new R(null,2,5,S,[Oj,this.Pa],null),new R(null,2,5,S,[Zl,this.Ha],null)],null),this.f))};g.N=function(b,a){return new Ep(this.Ea,this.Aa,this.Ga,this.Ca,this.Oa,this.Pa,this.Ha,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};
function Fp(b){return new Ep(Bj.c(b),el.c(b),Zj.c(b),wk.c(b),Pk.c(b),Oj.c(b),Zl.c(b),null,Nd.j(b,Bj,F([el,Zj,wk,Pk,Oj,Zl],0)),null)}g.ba=!0;g.H=function(b,a,c){return Gp.g?Gp.g(this,a,c):Gp.call(null,this,a,c)};g.Uc=!0;g.O=function(){return G(this.Aa)};g.ae=!0;g.Za=function(){return Ub(this.Aa)};g.vd=!0;g.J=function(){return Hp.c?Hp.c(this):Hp.call(null,this)};g.u=function(b,a){return Ip.b?Ip.b(this,a):Ip.call(null,this,a)};g.ea=function(){var b=this.Ea;return Jp?Jp(b):Kp.call(null,b)};g.Wc=!0;
g.K=function(){return Qb(this.Aa)};g.hd=function(b,a,c){b=Id(this,a);a=Lp.g?Lp.g(this,a,c):Lp.call(null,this,a,c);return So(b,a,a)};g.kd=function(b,a,c){b=Id(this,a);a=Lp.g?Lp.g(this,a,c):Lp.call(null,this,a,c);return So(b,a,new Xo(null,null,null,null,null))};
g.jd=function(b,a,c,d){b=cb(cb(cb(cb(cb(Nc,d),c),a),new A(null,"db","db",-1661185010,null)),new A(null,"-index-range","-index-range",898114142,null));Mp.b?Mp.b(a,b):Mp.call(null,a,b);c=Np.Z?Np.Z(this,null,a,c,null):Np.call(null,this,null,a,c,null);a=Np.Z?Np.Z(this,null,a,d,null):Np.call(null,this,null,a,d,null);return So(this.Ca,c,a)};g.ed=!0;g.gd=function(){return this.Ea};g.fd=function(b,a){return this.Ha.call(null,a)};g.Id=!0;
g.ld=function(b,a){var c=Qn(1);wn(function(b,c){return function(){var f=function(){return function(a){return function(){function b(c){for(;;){var d;a:try{for(;;){var e=a(c);if(!M(e,X)){d=e;break a}}}catch(f){if(f instanceof Object)c[5]=f,Nn(c),d=X;else throw f;}if(!M(d,X))return d}}function c(){var a=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];a[0]=d;a[1]=1;return a}var d=null,d=function(a){switch(arguments.length){case 0:return c.call(this);
case 1:return b.call(this,a)}throw Error("Invalid arity: "+arguments.length);};d.w=c;d.c=b;return d}()}(function(b,c){return function(d){var e=d[1];if(7===e){var f=d,h=f;h[2]=d[2];h[1]=4;return X}if(59===e){var v=d[2],D=f=d;D[2]=v;D[1]=58;return X}if(20===e){var z=d[2],L=f=d;L[2]=z;L[1]=18;return X}if(58===e){var V=d[2],ta=f=d;ta[2]=V;ta[1]=52;return X}if(27===e){var Na=d[7],Ma=og(Na,d[2]),Fa=f=d;Fa[2]=Ma;Fa[1]=26;return X}if(1===e){var J=d[8],ib=H(a,0),W=H(a,1),Q=H(a,2),P=H(a,3),ea=c.Aa,pa=c.Ga,
na=c.Ca;d[9]=na;d[10]=W;d[11]=P;d[8]=ib;d[12]=pa;d[13]=Q;d[14]=ea;f=d;f[1]=r(ib)?2:3;return X}if(24===e){var na=d[9],W=d[10],P=d[11],J=d[8],pa=d[12],Q=d[13],ea=d[14],Na=function(){return function(a,b,c,d,e){return function(a){return E.b(d,a.v)&&E.b(e,a.tx)}}(a,J,W,Q,P,ea,pa,na,na,W,P,J,pa,Q,ea,e,b,c)}(),$a=new Xo(J,null,null,null,null),lb=ea.c?ea.c($a):ea.call(null,$a);d[7]=Na;f=d;return Kn(f,27,lb)}if(55===e){var jb=d[2],gb=f=d;gb[2]=jb;gb[1]=52;return X}if(39===e){var zb=d[2],ob=f=d;ob[2]=zb;ob[1]=
36;return X}if(46===e){var na=d[9],W=d[10],Eb=new Xo(null,W,null,null,null),Lb=na.c?na.c(Eb):na.call(null,Eb),f=d;return Kn(f,49,Lb)}if(4===e){var Xb=d[2],f=d;return Ln(f,Xb)}if(54===e){var na=d[9],W=d[10],P=d[11],J=d[8],pa=d[12],Q=d[13],ea=d[14],Dc=og(function(){return function(a,b,c,d){return function(a){return E.b(d,a.v)}}(a,J,W,Q,P,ea,pa,na,na,W,P,J,pa,Q,ea,e,b,c)}(),ea),Lc=f=d;Lc[2]=Dc;Lc[1]=55;return X}if(15===e){var Ec=d[2],Tc=f=d;Tc[2]=Ec;Tc[1]=13;return X}if(48===e){var vd=d[15],id=og(vd,
d[2]),bd=f=d;bd[2]=id;bd[1]=47;return X}if(50===e)return P=d[11],f=d,f[1]=r(P)?53:54,X;if(21===e)return P=d[11],f=d,f[1]=r(P)?24:25,X;if(31===e){var Oc=d[2],nd=f=d;nd[2]=Oc;nd[1]=23;return X}if(32===e){var qf=d[16],Lg=og(qf,d[2]),Xf=f=d;Xf[2]=Lg;Xf[1]=31;return X}if(40===e){var na=d[9],W=d[10],P=d[11],J=d[8],pa=d[12],Q=d[13],ea=d[14],Tb=function(){return function(a,b,c,d,e){return function(a){return E.b(e,a.tx)}}(a,J,W,Q,P,ea,pa,na,na,W,P,J,pa,Q,ea,e,b,c)}(),xc=new Xo(null,W,Q,null,null),yc=na.c?
na.c(xc):na.call(null,xc);d[17]=Tb;f=d;return Kn(f,43,yc)}if(56===e){var na=d[9],W=d[10],P=d[11],J=d[8],pa=d[12],Q=d[13],ea=d[14],cd=og(function(){return function(a,b,c,d,e){return function(a){return E.b(e,a.tx)}}(a,J,W,Q,P,ea,pa,na,na,W,P,J,pa,Q,ea,e,b,c)}(),ea),rf=f=d;rf[2]=cd;rf[1]=58;return X}if(33===e){var hp=d[2],sf=f=d;sf[2]=hp;sf[1]=31;return X}if(13===e){var Gh=d[2],Dk=f=d;Dk[2]=Gh;Dk[1]=10;return X}if(22===e)return P=d[11],f=d,f[1]=r(P)?29:30,X;if(36===e){var tf=d[2],tm=f=d;tm[2]=tf;tm[1]=
4;return X}if(41===e){var na=d[9],W=d[10],Q=d[13],Hh=new Xo(null,W,Q,null,null),hj=na.c?na.c(Hh):na.call(null,Hh),f=d;return Kn(f,44,hj)}if(43===e){var Tb=d[17],um=og(Tb,d[2]),Ek=f=d;Ek[2]=um;Ek[1]=42;return X}if(29===e){var na=d[9],W=d[10],P=d[11],J=d[8],pa=d[12],Q=d[13],ea=d[14],qf=function(){return function(a,b,c,d,e){return function(a){return E.b(e,a.tx)}}(a,J,W,Q,P,ea,pa,na,na,W,P,J,pa,Q,ea,e,b,c)}(),Fk=new Xo(J,null,null,null,null),ip=ea.c?ea.c(Fk):ea.call(null,Fk);d[16]=qf;f=d;return Kn(f,
32,ip)}if(44===e){var jp=d[2],Ih=f=d;Ih[2]=jp;Ih[1]=42;return X}if(6===e){var Q=d[13],vm=null!=Q,f=d;f[1]=vm?21:22;return X}if(28===e){var ij=d[18],wm=og(ij,d[2]),xm=f=d;xm[2]=wm;xm[1]=26;return X}if(51===e)return P=d[11],f=d,f[1]=r(P)?56:57,X;if(25===e){var na=d[9],W=d[10],P=d[11],J=d[8],pa=d[12],Q=d[13],ea=d[14],ij=function(){return function(a,b,c,d){return function(a){return E.b(d,a.v)}}(a,J,W,Q,P,ea,pa,na,na,W,P,J,pa,Q,ea,e,b,c)}(),ym=new Xo(J,null,null,null,null),jj=ea.c?ea.c(ym):ea.call(null,
ym);d[18]=ij;f=d;return Kn(f,28,jj)}if(34===e){var Q=d[13],zm=null!=Q,f=d;f[1]=zm?37:38;return X}if(17===e){var W=d[10],J=d[8],ea=d[14],Gk=new Xo(J,W,null,null,null),Am=ea.c?ea.c(Gk):ea.call(null,Gk),f=d;return Kn(f,20,Am)}if(3===e)return W=d[10],f=d,f[1]=r(W)?34:35,X;if(12===e){var W=d[10],J=d[8],Q=d[13],ea=d[14],Bm=new Xo(J,W,Q,null,null),kp=ea.c?ea.c(Bm):ea.call(null,Bm),f=d;return Kn(f,15,kp)}if(2===e)return W=d[10],f=d,f[1]=r(W)?5:6,X;if(23===e){var kj=d[2],Hk=f=d;Hk[2]=kj;Hk[1]=7;return X}if(47===
e){var Cm=d[2],Ik=f=d;Ik[2]=Cm;Ik[1]=39;return X}if(35===e){var Q=d[13],Gd=null!=Q,f=d;f[1]=Gd?50:51;return X}if(19===e){var zc=d[19],Dm=og(zc,d[2]),Em=f=d;Em[2]=Dm;Em[1]=18;return X}if(57===e){var ea=d[14],Fm=new Xo(null,null,null,null,null),lp=ea.c?ea.c(Fm):ea.call(null,Fm),f=d;return Kn(f,59,lp)}if(11===e){var W=d[10],P=d[11],J=d[8],Q=d[13],ea=d[14],od=new Xo(J,W,Q,P,null),pd=ea.c?ea.c(od):ea.call(null,od),f=d;return Kn(f,14,pd)}if(9===e)return P=d[11],f=d,f[1]=r(P)?16:17,X;if(5===e){var Q=d[13],
qd=null!=Q,f=d;f[1]=qd?8:9;return X}if(14===e){var rd=d[2],Jc=f=d;Jc[2]=rd;Jc[1]=13;return X}if(45===e){var na=d[9],W=d[10],P=d[11],J=d[8],pa=d[12],Q=d[13],ea=d[14],vd=function(){return function(a,b,c,d,e){return function(a){return E.b(e,a.tx)}}(a,J,W,Q,P,ea,pa,na,na,W,P,J,pa,Q,ea,e,b,c)}(),Ac=new Xo(null,W,null,null,null),uf=na.c?na.c(Ac):na.call(null,Ac);d[15]=vd;f=d;return Kn(f,48,uf)}if(53===e){var na=d[9],W=d[10],P=d[11],J=d[8],pa=d[12],Q=d[13],ea=d[14],Yf=og(function(){return function(a,b,c,
d,e){return function(a){return E.b(d,a.v)&&E.b(e,a.tx)}}(a,J,W,Q,P,ea,pa,na,na,W,P,J,pa,Q,ea,e,b,c)}(),ea),Xd=f=d;Xd[2]=Yf;Xd[1]=55;return X}if(26===e){var mp=d[2],Gm=f=d;Gm[2]=mp;Gm[1]=23;return X}if(16===e){var na=d[9],W=d[10],P=d[11],J=d[8],pa=d[12],Q=d[13],ea=d[14],zc=function(){return function(a,b,c,d,e){return function(a){return E.b(e,a.tx)}}(a,J,W,Q,P,ea,pa,na,na,W,P,J,pa,Q,ea,e,b,c)}(),Jh=new Xo(J,W,null,null,null),Hm=ea.c?ea.c(Jh):ea.call(null,Jh);d[19]=zc;f=d;return Kn(f,19,Hm)}if(38===
e)return P=d[11],f=d,f[1]=r(P)?45:46,X;if(30===e){var J=d[8],ea=d[14],Jk=new Xo(J,null,null,null,null),Im=ea.c?ea.c(Jk):ea.call(null,Jk),f=d;return Kn(f,33,Im)}if(10===e){var np=d[2],Jm=f=d;Jm[2]=np;Jm[1]=7;return X}if(18===e){var lj=d[2],Mg=f=d;Mg[2]=lj;Mg[1]=10;return X}if(52===e){var Km=d[2],Kk=f=d;Kk[2]=Km;Kk[1]=36;return X}if(42===e){var op=d[2],Lm=f=d;Lm[2]=op;Lm[1]=39;return X}if(37===e)return P=d[11],f=d,f[1]=r(P)?40:41,X;if(8===e)return P=d[11],f=d,f[1]=r(P)?11:12,X;if(49===e){var mj=d[2],
Lk=f=d;Lk[2]=mj;Lk[1]=47;return X}return null}}(b,c),b,c)}(),h=function(){var a=f.w?f.w():f.call(null);a[6]=b;return a}();return Jn(h)}}(c,this));return c};function Op(b,a,c,d,e){this.Fa=b;this.Qa=a;this.h=c;this.f=d;this.i=e;this.m=2229667594;this.B=8192}g=Op.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "unfiltered-db":return this.Fa;case "pred":return this.Qa;default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.core.FilteredDB{",", ","}",c,N.b(new R(null,2,5,S,[new R(null,2,5,S,[Wl,this.Fa],null),new R(null,2,5,S,[ak,this.Qa],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 2+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};
g.V=function(b,a){return ge(new ke(null,new m(null,2,[ak,null,Wl,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Op(this.Fa,this.Qa,this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return r(M.b?M.b(Wl,a):M.call(null,Wl,a))?new Op(c,this.Qa,this.h,this.f,null):r(M.b?M.b(ak,a):M.call(null,ak,a))?new Op(this.Fa,c,this.h,this.f,null):new Op(this.Fa,this.Qa,this.h,I.g(this.f,a,c),null)};
g.K=function(){return q(N.b(new R(null,2,5,S,[new R(null,2,5,S,[Wl,this.Fa],null),new R(null,2,5,S,[ak,this.Qa],null)],null),this.f))};g.N=function(b,a){return new Op(this.Fa,this.Qa,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.Vc=!0;g.D=function(){throw Error("-lookup is not supported on FilteredDB");};g.C=function(){throw Error("-lookup is not supported on FilteredDB");};g.ba=!0;g.H=function(b,a,c){return Gp.g?Gp.g(this,a,c):Gp.call(null,this,a,c)};
g.Uc=!0;g.O=function(){return G(yp(this,el,Ed))};g.vd=!0;g.J=function(){return Pp.c?Pp.c(this):Pp.call(null,this)};g.u=function(b,a){return Ip.b?Ip.b(this,a):Ip.call(null,this,a)};g.ea=function(){throw Error("-empty is not supported on FilteredDB");};g.Vb=function(){throw Error("-contains-key? is not supported on FilteredDB");};g.T=function(){throw Error("-assoc is not supported on FilteredDB");};g.Wc=!0;g.K=function(){return yp(this,el,Ed)};g.hd=function(b,a,c){return og(this.Qa,yp(this.Fa,a,c))};
g.kd=function(b,a,c){return og(this.Qa,zp(this.Fa,a,c))};g.jd=function(b,a,c,d){return og(this.Qa,Ap(this.Fa,a,c,d))};g.ed=!0;g.gd=function(){return Cp(this.Fa)};g.fd=function(b,a){return Dp(this.Fa,a)};g.Id=!0;g.ld=function(b,a){return og(this.Qa,xp(this.Fa,a))};
function Qp(b,a){return E.b(new R(null,2,5,S,[b,a],null),new R(null,2,5,S,[Yk,!0],null))?new R(null,1,5,S,[Yk],null):E.b(a,Ak)?new R(null,1,5,S,[Ak],null):E.b(a,am)?new R(null,1,5,S,[am],null):E.b(a,Kj)?new R(null,2,5,S,[Tj,Kj],null):E.b(a,hl)?new R(null,2,5,S,[Tj,hl],null):null}function Rp(b){var a=le;return w(function(b,d){var e=H(d,0),f=H(d,1);return xg.S(b,new R(null,1,5,S,[e],null),Of(Dd,a),f)},je,b)}
function Sp(b){return Rp(function(){return function c(b){return new af(null,function(){for(var e=b;;){var f=q(e);if(f){var h=f,k=B(h),l=H(k,0),p=H(k,1);if(f=q(function(b,c,d,e,f,k){return function V(h){return new af(null,function(b,c,d,e,f,k){return function(){for(var l=h;;){var p=q(l);if(p){var n=p,t=B(n),v=H(t,0),y=H(t,1);if(p=q(function(b,c,d,e,f,k,h,l,p,n,t,v){return function id(y){return new af(null,function(b,c,d,e,f,k,h,l,p){return function(){for(;;){var b=q(y);if(b){if($d(b)){var c=hc(b),
d=G(c),e=ef(d);a:for(var f=0;;)if(f<d){var k=x.b(c,f);e.add(new R(null,2,5,S,[k,p],null));f+=1}else{c=!0;break a}return c?gf(jf(e),id(ic(b))):gf(jf(e),null)}e=B(b);return td(new R(null,2,5,S,[e,p],null),id(Mc(b)))}return null}}}(b,c,d,e,f,k,h,l,p,n,t,v),null,null)}}(l,b,t,v,y,n,p,c,d,e,f,k)(Qp(v,y))))return N.b(p,V(Mc(l)));l=Mc(l)}else return null}}}(b,c,d,e,f,k),null,null)}}(e,k,l,p,h,f)(p)))return N.b(f,c(Mc(e)));e=Mc(e)}else return null}},null,null)}(b)}())}
function Tp(b,a,c,d){if(null!=c&&!ge(d,c))throw uj([u("Bad attribute specification for "),u(U(F([new th([b,new th([a,c])])],0))),u(", expected one of "),u(d)].join(""),new m(null,4,[Ol,Rl,Fj,b,ck,a,Bk,c],null));}
function Up(b){for(var a=q(b),c=null,d=0,e=0;;)if(e<d){var f=c.R(null,e),h=H(f,0),k=H(f,1),l=Yk.b(k,!1);Tp(h,Yk,Yk.c(k),new ke(null,new m(null,2,[!0,null,!1,null],null),null));if(r(function(){var a=l;return r(a)?Ef.b(uk.c(k),Ak):a}()))throw uj([u("Bad attribute specification for "),u(h),u(": {:db/isComponent true} should also have {:db/valueType :db.type/ref}")].join(""),new m(null,3,[Ol,Rl,Fj,h,ck,Yk],null));Tp(h,Tj,Tj.c(k),new ke(null,new m(null,2,[Kj,null,hl,null],null),null));Tp(h,uk,uk.c(k),
new ke(null,new m(null,1,[Ak,null],null),null));Tp(h,El,El.c(k),new ke(null,new m(null,2,[am,null,lm,null],null),null));e+=1}else if(a=q(a)){if($d(a))d=hc(a),a=ic(a),c=d,d=G(d);else{var c=B(a),d=H(c,0),p=H(c,1),n=Yk.b(p,!1);Tp(d,Yk,Yk.c(p),new ke(null,new m(null,2,[!0,null,!1,null],null),null));if(r(function(){var a=n;return r(a)?Ef.b(uk.c(p),Ak):a}()))throw uj([u("Bad attribute specification for "),u(d),u(": {:db/isComponent true} should also have {:db/valueType :db.type/ref}")].join(""),new m(null,
3,[Ol,Rl,Fj,d,ck,Yk],null));Tp(d,Tj,Tj.c(p),new ke(null,new m(null,2,[Kj,null,hl,null],null),null));Tp(d,uk,uk.c(p),new ke(null,new m(null,1,[Ak,null],null),null));Tp(d,El,El.c(p),new ke(null,new m(null,2,[am,null,lm,null],null),null));a=C(a);c=null;d=0}e=0}else break;return b}function Kp(){switch(arguments.length){case 0:return Vp();case 1:return Jp(arguments[0]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}function Vp(){return Jp(null)}
function Jp(b){return Fp(new m(null,7,[Bj,Up(b),el,Uo(gp),Zj,Uo(pp),wk,Uo(qp),Pk,0,Oj,536870912,Zl,Sp(b)],null))}function Wp(){switch(arguments.length){case 1:return Xp(arguments[0]);case 2:return Yp(arguments[0],arguments[1]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}function Xp(b){return Yp(b,null)}
function Yp(b,a){if(Td(b))return Jp(a);var c=Up(a),d=Ea?Ga(b):Ha.call(null,b),e=To(d.sort(tp),gp),f=To(d.sort(up),pp),h=To(d.sort(vp),qp),k=al.c(B(Ub(e))),c=we(dg.c(function(){return function(a){return a.tx}}(c,d,e,f,h,k)),Fe,536870912,e);return Fp(new m(null,7,[Bj,a,el,e,Zj,f,wk,h,Pk,k,Oj,c,Zl,Sp(a)],null))}function Hp(b){var a=b.i;return r(a)?a:b.i=Sc(yp(b,el,Ed))}function Pp(b){var a=b.i;return r(a)?a:b.i=Sc(yp(b,el,Ed))}
function Ip(b,a){var c=a instanceof Ep||a instanceof Op;if(c&&(c=E.b(Cp(b),Cp(a))))a:{var d=yp(b,el,Ed),c=yp(a,el,Ed),e=E.b(G(d),G(c));if(e)for(d=q(d),c=q(c);;){if(null==d){c=!0;break a}if(E.b(B(d),B(c)))d=C(d),c=C(c);else{c=!1;break a}}else c=e}return c}function Gp(b,a,c){Vb(a,"#datascript/DB {");Vb(a,":schema ");Ui(Cp(b),a,c);Vb(a,", :datoms ");T(a,function(a,b,c){return T(b,Ui,"["," ","]",c,new R(null,4,5,S,[a.e,a.a,a.v,a.tx],null))},"["," ","]",c,yp(b,el,Ed));return Vb(a,"}")}
function Np(b,a,c,d,e){if(r(c)){var f=cb(cb(cb(cb(cb(cb(Nc,e),d),c),a),new A(null,"db","db",-1661185010,null)),new A(null,"resolve-datom","resolve-datom",-294110827,null));Mp.b?Mp.b(c,f):Mp.call(null,c,f)}a=Zp.b?Zp.b(b,a):Zp.call(null,b,a);f=(f=null!=d)?$p.b?$p.b(b,c):$p.call(null,b,c):f;return new Xo(a,c,r(f)?aq.b?aq.b(b,d):aq.call(null,b,d):d,Zp.b?Zp.b(b,e):Zp.call(null,b,e),null)}
function Lp(b,a,c){var d=H(c,0),e=H(c,1),f=H(c,2);c=H(c,3);switch(a instanceof K?a.U:null){case "eavt":return Np(b,d,e,f,c);case "aevt":return Np(b,e,d,f,c);case "avet":return Np(b,f,d,e,c);default:throw Error([u("No matching clause: "),u(a)].join(""));}}function bq(b,a,c,d,e,f,h,k){this.bb=b;this.ab=a;this.jb=c;this.ib=d;this.kb=e;this.h=f;this.f=h;this.i=k;this.m=2229667594;this.B=8192}g=bq.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "db-before":return this.bb;case "db-after":return this.ab;case "tx-data":return this.jb;case "tempids":return this.ib;case "tx-meta":return this.kb;default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.core.TxReport{",", ","}",c,N.b(new R(null,5,5,S,[new R(null,2,5,S,[jl,this.bb],null),new R(null,2,5,S,[ik,this.ab],null),new R(null,2,5,S,[kl,this.jb],null),new R(null,2,5,S,[Aj,this.ib],null),new R(null,2,5,S,[$l,this.kb],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 5+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,5,[Aj,null,ik,null,jl,null,kl,null,$l,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new bq(this.bb,this.ab,this.jb,this.ib,this.kb,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(jl,a):M.call(null,jl,a))?new bq(c,this.ab,this.jb,this.ib,this.kb,this.h,this.f,null):r(M.b?M.b(ik,a):M.call(null,ik,a))?new bq(this.bb,c,this.jb,this.ib,this.kb,this.h,this.f,null):r(M.b?M.b(kl,a):M.call(null,kl,a))?new bq(this.bb,this.ab,c,this.ib,this.kb,this.h,this.f,null):r(M.b?M.b(Aj,a):M.call(null,Aj,a))?new bq(this.bb,this.ab,this.jb,c,this.kb,this.h,this.f,null):r(M.b?M.b($l,a):M.call(null,$l,a))?new bq(this.bb,this.ab,this.jb,this.ib,c,this.h,this.f,
null):new bq(this.bb,this.ab,this.jb,this.ib,this.kb,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,5,5,S,[new R(null,2,5,S,[jl,this.bb],null),new R(null,2,5,S,[ik,this.ab],null),new R(null,2,5,S,[kl,this.jb],null),new R(null,2,5,S,[Aj,this.ib],null),new R(null,2,5,S,[$l,this.kb],null)],null),this.f))};g.N=function(b,a){return new bq(this.bb,this.ab,this.jb,this.ib,this.kb,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};
function cq(b,a,c){return ge(Dp(b,c),a)}function $p(b,a){return cq(b,a,Ak)}
function dq(b,a){if("string"===typeof a||"number"===typeof a)return a;if(Wd(a)){if(Ef.b(G(a),2))throw uj([u("Lookup ref should contain 2 elements: "),u(U(F([a],0)))].join(""),new m(null,2,[Ol,zl,Uk,a],null));if(cq(b,B(a),Kj))return al.c(B(yp(b,wk,a)));throw uj([u("Lookup ref attribute should be marked as :db.unique/identity: "),u(U(F([a],0)))].join(""),new m(null,2,[Ol,Ij,Uk,a],null));}throw uj([u("Expected number or lookup ref for entity id, got "),u(U(F([a],0)))].join(""),new m(null,2,[Ol,Cl,Uk,
a],null));}function aq(b,a){var c=dq(b,a);if(r(c))return c;throw uj([u("Nothing found for entity id "),u(U(F([a],0)))].join(""),new m(null,2,[Ol,Jl,Uk,a],null));}function Zp(b,a){return r(a)?aq(b,a):null}function Mp(b,a){if(b instanceof K||"string"===typeof b)return null;throw uj([u("Bad entity attribute "),u(U(F([b],0))),u(" at "),u(U(F([a],0))),u(", expected keyword or string")].join(""),new m(null,3,[Ol,bm,Fj,b,Ll,a],null));}
function eq(b,a){if(null==b)throw uj([u("Cannot store nil as a value at "),u(U(F([a],0)))].join(""),new m(null,3,[Ol,bm,Bk,b,Ll,a],null));return null}function fq(b){return ug(b,new R(null,2,5,S,[jl,Oj],null))+1}function gq(b,a){return a>Pk.c(b)&&536870912>a?I.g(b,Pk,a):b}function hq(b,a,c){return xg.S(wg(b,new R(null,2,5,S,[Aj,a],null),c),new R(null,1,5,S,[ik],null),gq,c)}function iq(b){return E.b(b,wl)||E.b(b,":db/current-tx")}
function jq(b,a){var c;c=a.added;c=r(c)?cq(b,a.a,Tj):c;if(r(c)&&(c=Ff(yp(b,wk,new R(null,2,5,S,[a.a,a.v],null))),r(c)))throw uj([u("Cannot add "),u(U(F([a],0))),u(" because of unique constraint: "),u(U(F([c],0)))].join(""),new m(null,3,[Ol,vj,Fj,a.a,gk,a],null));if(r(a.added))return gq(xg.Z(xg.Z(xg.Z(b,new R(null,1,5,S,[el],null),xo,a,tp),new R(null,1,5,S,[Zj],null),xo,a,up),new R(null,1,5,S,[wk],null),xo,a,vp),a.e);c=B(xp(b,new R(null,3,5,S,[a.e,a.a,a.v],null)));return xg.Z(xg.Z(xg.Z(b,new R(null,
1,5,S,[el],null),wo,c,tp),new R(null,1,5,S,[Zj],null),wo,c,up),new R(null,1,5,S,[wk],null),wo,c,vp)}function kq(b,a){return xg.S(xg.S(b,new R(null,1,5,S,[ik],null),jq,a),new R(null,1,5,S,[kl],null),Dd,a)}function lq(b){if(b instanceof K)return E.b("_",Hd($e(b),0));if("string"===typeof b)return fe(Mi(/(?:([^\/]+)\/)?_([^\/]+)/,b));throw uj([u("Bad attribute type: "),u(U(F([b],0))),u(", expected keyword or string")].join(""),new m(null,2,[Ol,bm,Fj,b],null));}
function mq(b){if(b instanceof K)return lq(b)?Ze.b(Ye(b),Oe($e(b),1)):Ze.b(Ye(b),[u("_"),u($e(b))].join(""));if("string"===typeof b){var a=Mi(/(?:([^\/]+)\/)?([^\/]+)/,b);H(a,0);b=H(a,1);a=H(a,2);return E.b("_",Hd(a,0))?r(b)?[u(b),u("/"),u(a.substring(1))].join(""):a.substring(1):r(b)?[u(b),u("/_"),u(a)].join(""):[u("_"),u(a)].join("")}throw uj([u("Bad attribute type: "),u(U(F([b],0))),u(", expected keyword or string")].join(""),new m(null,2,[Ol,bm,Fj,b],null));}
function nq(b,a){var c=Ff(Dp(b,Kj));return r(c)?ue(function(){return function(c,e,f){var h=B(yp(b,wk,new R(null,2,5,S,[e,f],null)));if(r(h)){var k=Hl.c(c),l=h.e;if(null==k)return I.g(Nd.b(c,e),Hl,l);if(E.b(k,l))return Nd.b(c,e);throw uj([u("Cannot resolve upsert for "),u(U(F([a],0))),u(": "),u(U(F([new th([Hl,k,e,f])],0))),u(" conflicts with existing "),u(U(F([h],0)))].join(""),new m(null,4,[Ol,$k,Fj,e,em,a,gk,h],null));}return c}}(c,c),a,ui(a,c)):a}
function oq(b,a,c){lq(a)||cq(b,a,am)?(a=Ja.c?Ja.c(c):Ja.call(null,c),a=r(a)?a:Ud(c)&&!Yd(c),b=Ka(a)?new R(null,1,5,S,[c],null):E.b(G(c),2)&&cq(b,B(c),Kj)?new R(null,1,5,S,[c],null):c):b=new R(null,1,5,S,[c],null);return b}
function pq(b,a){return function(a){return function e(f){return new af(null,function(a){return function(){for(var c=f;;){var l=q(c);if(l){var p=l,n=B(p),t=H(n,0),y=H(n,1);if(Ef.b(t,Hl)){var v=Mp(t,new th([Hl,a,t,y])),D=lq(t),z=D?mq(t):t;if(D&&!$p(b,z))throw uj([u("Bad attribute "),u(U(F([t],0))),u(": reverse attribute name requires {:db/valueType :db.type/ref} in schema")].join(""),new m(null,3,[Ol,bm,Fj,t,Ll,new th([Hl,a,t,y])],null));if(l=q(function(a,c,e,f,k,h,l,p,n,t,v){return function pa(y){return new af(null,
function(a,c,e,f,k,h,l,p,n,t,v){return function(){for(;;){var a=q(y);if(a){if($d(a)){var c=hc(a),k=G(c),h=ef(k);a:for(var p=0;;)if(p<k){var n=x.b(c,p),n=$p(b,f)&&Yd(n)?I.g(n,mq(l),v):e?new R(null,4,5,S,[Sl,n,f,v],null):new R(null,4,5,S,[Sl,v,f,n],null);h.add(n);p+=1}else{c=!0;break a}return c?gf(jf(h),pa(ic(a))):gf(jf(h),null)}h=B(a);return td($p(b,f)&&Yd(h)?I.g(h,mq(l),v):e?new R(null,4,5,S,[Sl,h,f,v],null):new R(null,4,5,S,[Sl,v,f,h],null),pa(Mc(a)))}return null}}}(a,c,e,f,k,h,l,p,n,t,v),null,null)}}(c,
v,D,z,null,n,t,y,p,l,a)(oq(b,t,y))))return N.b(l,e(Mc(c)))}c=Mc(c)}else return null}}}(a),null,null)}}(Hl.c(a))(a)}function qq(b,a){H(a,0);var c=H(a,1),d=H(a,2),e=H(a,3);Mp(d,a);eq(e,a);var f=fq(b),h=ik.c(b),c=aq(h,c),e=$p(h,d)?aq(h,e):e,k=new Xo(c,d,e,f,!0);if(cq(h,d,am))return Td(xp(h,new R(null,3,5,S,[c,d,e],null)))?kq(b,k):b;h=B(xp(h,new R(null,2,5,S,[c,d],null)));return r(h)?E.b(h.v,e)?b:kq(kq(b,new Xo(c,d,h.v,f,!1)),k):kq(b,k)}
function rq(b,a){var c=fq(b);return kq(b,new Xo(a.e,a.a,a.v,c,!1))}function sq(b,a){return O.g(le,Mf.b(ng(function(a){return cq(b,a.a,Yk)}),dg.c(function(a){return new R(null,2,5,S,[fl,a.v],null)})),a)}
function tq(b,a){for(;;){if(null!=a&&!Wd(a))throw uj([u("Bad transaction data "),u(U(F([a],0))),u(", expected sequential collection")].join(""),new m(null,2,[Ol,bm,kl,a],null));var c=a,d=H(c,0),e=Ne(c,1),f=ik.c(b);if(null==d)return xg.g(wg(b,new R(null,2,5,S,[Aj,wl],null),fq(b)),new R(null,2,5,S,[ik,Oj],null),Xc);if(Yd(d)){var h=Hl.c(d),k=Zp(f,r(function(){var a=h;return Rm.c?Rm.c(a):Rm.call(null,a)}())?ug(b,new R(null,2,5,S,[Aj,h],null)):iq(h)?fq(b):h),l=nq(f,I.g(d,Hl,k)),d=function(){var a=Hl.c(l);
return r(a)?a:Pk.c(f)+1}(),k=I.g(l,Hl,d),d=null==h?xg.S(b,new R(null,1,5,S,[ik],null),gq,d):r(function(){var a=h;return Rm.c?Rm.c(a):Rm.call(null,a)}())?hq(b,h,d):"number"===typeof h&&h>Pk.c(f)?xg.S(b,new R(null,1,5,S,[ik],null),gq,h):b,e=N.b(pq(f,k),e);b=d;a=e}else if(Wd(d)){var p=d,k=H(p,0),n=H(p,1),t=H(p,2),y=H(p,3);if(E.b(k,Zk)){var v=H(d,0),k=H(d,1),D=Ne(d,2),d=b,e=N.b(yf(k,f,D),e);b=d;a=e}else if(E.b(k,Al)){var z=d,v=H(z,0),D=H(z,1),L=H(z,2),V=H(z,3),ta=H(z,4),Na=aq(f,D),Ma=Mp(L,d),Fa=$p(f,
L)?aq(f,V):V,J=$p(f,L)?aq(f,ta):ta,ib=eq(Fa,d),W=eq(J,d),Q=xp(f,new R(null,2,5,S,[Na,L],null));if(cq(f,L,am))if(r(Hf(function(a,b,c,d,e,f,k,h,l,p,n){return function(a){return E.b(a.v,n)}}(b,a,z,v,D,L,V,ta,Na,Ma,Fa,J,ib,W,Q,p,k,n,t,y,c,d,e,f),Q)))b=k=qq(b,new R(null,4,5,S,[Sl,Na,L,J],null)),a=e;else throw uj([u(":db.fn/cas failed on datom ["),u(U(F([Na],0))),u(" "),u(U(F([L],0))),u(" "),u(U(F([dg.b(Rj,Q)],0))),u("], expected "),u(U(F([Fa],0)))].join(""),new m(null,4,[Ol,Hj,pm,Q,Fl,Fa,rk,J],null));
else if(k=Rj.c(B(Q)),E.b(k,Fa))b=k=qq(b,new R(null,4,5,S,[Sl,Na,L,J],null)),a=e;else throw uj([u(":db.fn/cas failed on datom ["),u(U(F([Na],0))),u(" "),u(U(F([L],0))),u(" "),u(U(F([k],0))),u("], expected "),u(U(F([Fa],0)))].join(""),new m(null,4,[Ol,Hj,pm,B(Q),Fl,Fa,rk,J],null));}else if(iq(n))d=b,e=N.b(new R(null,1,5,S,[new R(null,4,5,S,[k,fq(b),t,y],null)],null),e),b=d,a=e;else if($p(f,t)&&iq(y))d=b,e=N.b(new R(null,1,5,S,[new R(null,4,5,S,[k,n,t,fq(b)],null)],null),e),b=d,a=e;else if(r(function(){var a=
n;return Rm.c?Rm.c(a):Rm.call(null,a)}()))d=ug(b,new R(null,2,5,S,[Aj,n],null)),r(d)?(D=b,e=N.b(new R(null,1,5,S,[new R(null,4,5,S,[k,d,t,y],null)],null),e),b=D,a=e):(e=hq(b,n,Pk.c(f)+1),k=a,b=e,a=k);else if(r(function(){var a=$p(f,t);return a?(a=y,Rm.c?Rm.c(a):Rm.call(null,a)):a}()))d=ug(b,new R(null,2,5,S,[Aj,y],null)),r(d)?(D=b,e=N.b(new R(null,1,5,S,[new R(null,4,5,S,[k,n,t,d],null)],null),e),b=D,a=e):(e=hq(b,y,Pk.c(f)+1),k=a,b=e,a=k);else if(E.b(k,Sl))b=k=qq(b,d),a=e;else if(E.b(k,ml))D=aq(f,
n),k=$p(f,t)?aq(f,y):y,Mp(t,d),eq(k,d),d=B(xp(f,new R(null,3,5,S,[D,t,k],null))),r(d)&&(b=k=rq(b,d)),a=e;else if(E.b(k,yl))D=aq(f,n),Mp(t,d),Q=xp(f,new R(null,2,5,S,[D,t],null)),k=w(rq,b,Q),e=N.b(sq(f,Q),e),b=k,a=e;else if(E.b(k,fl))D=aq(f,n),Q=xp(f,new R(null,1,5,S,[D],null)),k=mg(function(a,b,c,d,e,f,k,h,l,p,n,t,v){return function(a){return xp(v,new R(null,3,5,S,[null,a,c],null))}}(b,a,D,Q,p,k,n,t,y,c,d,e,f),F([Dp(f,Ak)],0)),k=w(rq,b,N.b(Q,k)),e=N.b(sq(f,Q),e),b=k,a=e;else throw uj([u("Unknown operation at "),
u(U(F([d],0))),u(", expected :db/add, :db/retract, :db.fn/call, :db.fn/retractAttribute or :db.fn/retractEntity")].join(""),new m(null,3,[Ol,bm,Ok,k,kl,d],null));}else throw uj([u("Bad entity type at "),u(U(F([d],0))),u(", expected map or vector")].join(""),new m(null,2,[Ol,bm,kl,d],null));}};function uq(b,a){var c=yf(Ei,b,a);return td(c,pg(function(a){return function(b){return a===b}}(c),a))}var vq=function vq(){switch(arguments.length){case 0:return vq.w();case 1:return vq.c(arguments[0]);case 2:return vq.b(arguments[0],arguments[1]);default:return vq.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};vq.w=function(){return le};vq.c=function(b){return b};vq.b=function(b,a){return G(b)<G(a)?w(Dd,a,b):w(Dd,b,a)};
vq.j=function(b,a,c){b=uq(G,Dd.j(c,a,F([b],0)));return w(O,B(b),Mc(b))};vq.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return vq.j(a,b,c)};vq.G=2;var wq=function wq(){switch(arguments.length){case 1:return wq.c(arguments[0]);case 2:return wq.b(arguments[0],arguments[1]);default:return wq.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};wq.c=function(b){return b};
wq.b=function(b,a){for(;;)if(G(a)<G(b)){var c=b;b=a;a=c}else return w(function(a,b){return function(a,c){return ge(b,c)?a:Sd.b(a,c)}}(b,a),b,b)};wq.j=function(b,a,c){b=uq(function(a){return-G(a)},Dd.j(c,a,F([b],0)));return w(wq,B(b),Mc(b))};wq.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return wq.j(a,b,c)};wq.G=2;
var xq=function xq(){switch(arguments.length){case 1:return xq.c(arguments[0]);case 2:return xq.b(arguments[0],arguments[1]);default:return xq.j(arguments[0],arguments[1],new Da(Array.prototype.slice.call(arguments,2),0))}};xq.c=function(b){return b};xq.b=function(b,a){return G(b)<G(a)?w(function(b,d){return ge(a,d)?Sd.b(b,d):b},b,b):w(Sd,b,a)};xq.j=function(b,a,c){return w(xq,b,Dd.b(c,a))};xq.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return xq.j(a,b,c)};xq.G=2;var yq={},zq=function zq(a,c,d){if(a?a.ha:a)return a.ha(a,c,d);var e;e=zq[ba(null==a?null:a)];if(!e&&(e=zq._,!e))throw Qa("ITraversable.-collect",a);return e.call(null,a,c,d)},Aq=function Aq(a,c){if(a?a.ia:a)return a.ia(a,c);var d;d=Aq[ba(null==a?null:a)];if(!d&&(d=Aq._,!d))throw Qa("ITraversable.-collect-vars",a);return d.call(null,a,c)};function Bq(b,a){return Wd(b)&&E.b(G(b),a)}
function Cq(b,a){return Wd(a)?w(function(a,d){var e=b.c?b.c(d):b.call(null,d);return r(e)?Dd.b(a,e):new Yc(null)},Ed,a):null}function Dq(){return Eq(arguments[0],arguments[1],2<arguments.length?new Da(Array.prototype.slice.call(arguments,2),0):null)}
function Eq(b,a,c){var d=H(c,0),e=r(d)?d:Ed;return r(b.c?b.c(a):b.call(null,a))?Dd.b(e,a):(a?r(r(null)?null:a.ga)||(a.Mb?0:La(yq,a)):La(yq,a))?zq(a,b,e):r(ee.c?ee.c(a):ee.call(null,a))?w(function(){return function(a,c){return Eq(b,c,F([a],0))}}(e,c,d),e,a):e}function Fq(b){var a=Td(b);return a?a:xf(he,b)}function Gq(b,a){return wd(b,new m(null,1,[Vk,a],null))}function Hq(b){var a=Vk.c(Rd(b));return r(a)?a:b}function Iq(b,a,c){this.h=b;this.f=a;this.i=c;this.m=2229667594;this.B=8192}g=Iq.prototype;
g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a){default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.Placeholder{",", ","}",c,N.b(Ed,this.f))};g.M=function(){return this.h};g.O=function(){return 0+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};
g.V=function(b,a){return ge(le,a)?Nd.b(wd(O.b(je,this),this.h),a):new Iq(this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return new Iq(this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(Ed,this.f))};g.N=function(b,a){return new Iq(a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return c};g.ia=function(b,a){return a};function Jq(b,a,c,d){this.symbol=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=Jq.prototype;
g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "symbol":return this.symbol;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.Variable{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[vk,this.symbol],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,1,[vk,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Jq(this.symbol,this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return r(M.b?M.b(vk,a):M.call(null,vk,a))?new Jq(c,this.h,this.f,null):new Jq(this.symbol,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[vk,this.symbol],null)],null),this.f))};
g.N=function(b,a){return new Jq(this.symbol,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.symbol,F([c],0))};g.ia=function(b,a){var c=this.symbol;return Y.b?Y.b(a,c):Y.call(null,a,c)};function Kq(b,a,c,d){this.symbol=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=Kq.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "symbol":return this.symbol;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.SrcVar{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[vk,this.symbol],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,1,[vk,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Kq(this.symbol,this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return r(M.b?M.b(vk,a):M.call(null,vk,a))?new Kq(c,this.h,this.f,null):new Kq(this.symbol,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[vk,this.symbol],null)],null),this.f))};
g.N=function(b,a){return new Kq(this.symbol,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.symbol,F([c],0))};g.ia=function(b,a){var c=this.symbol;return Y.b?Y.b(a,c):Y.call(null,a,c)};function Lq(b,a,c){this.h=b;this.f=a;this.i=c;this.m=2229667594;this.B=8192}g=Lq.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a){default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.DefaultSrc{",", ","}",c,N.b(Ed,this.f))};g.M=function(){return this.h};g.O=function(){return 0+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(le,a)?Nd.b(wd(O.b(je,this),this.h),a):new Lq(this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return new Lq(this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(Ed,this.f))};g.N=function(b,a){return new Lq(a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return c};g.ia=function(b,a){return a};function Mq(b,a,c){this.h=b;this.f=a;this.i=c;this.m=2229667594;this.B=8192}g=Mq.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a){default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.RulesVar{",", ","}",c,N.b(Ed,this.f))};g.M=function(){return this.h};g.O=function(){return 0+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(le,a)?Nd.b(wd(O.b(je,this),this.h),a):new Mq(this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return new Mq(this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(Ed,this.f))};g.N=function(b,a){return new Mq(a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return c};g.ia=function(b,a){return a};function Nq(b,a,c,d){this.value=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=Nq.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "value":return this.value;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.Constant{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[Bk,this.value],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,1,[Bk,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Nq(this.value,this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return r(M.b?M.b(Bk,a):M.call(null,Bk,a))?new Nq(c,this.h,this.f,null):new Nq(this.value,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[Bk,this.value],null)],null),this.f))};
g.N=function(b,a){return new Nq(this.value,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.value,F([c],0))};g.ia=function(b,a){var c=this.value;return Y.b?Y.b(a,c):Y.call(null,a,c)};function Oq(b,a,c,d){this.symbol=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=Oq.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "symbol":return this.symbol;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.PlainSymbol{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[vk,this.symbol],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,1,[vk,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Oq(this.symbol,this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return r(M.b?M.b(vk,a):M.call(null,vk,a))?new Oq(c,this.h,this.f,null):new Oq(this.symbol,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[vk,this.symbol],null)],null),this.f))};
g.N=function(b,a){return new Oq(this.symbol,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.symbol,F([c],0))};g.ia=function(b,a){var c=this.symbol;return Y.b?Y.b(a,c):Y.call(null,a,c)};function Pq(b){return E.b(new A(null,"_","_",-1201019570,null),b)?new Iq(null,null,null):null}function Qq(b){return b instanceof A&&E.b(B($e(b)),"?")?new Jq(b,null,null,null):null}
function Rq(b){return b instanceof A&&E.b(B($e(b)),"$")?new Kq(b,null,null,null):null}function Sq(b){return b instanceof A?null:new Nq(b,null,null,null)}function Tq(b){return b instanceof A&&Ka(Qq(b))&&Ka(Rq(b))&&Ka(Pq(b))?new Oq(b,null,null,null):null}function Uq(b){var a=Qq(b);if(r(a))return a;a=Sq(b);return r(a)?a:Rq(b)}function Vq(b,a,c,d,e){this.required=b;this.Db=a;this.h=c;this.f=d;this.i=e;this.m=2229667594;this.B=8192}g=Vq.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "required":return this.required;case "free":return this.Db;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.RuleVars{",", ","}",c,N.b(new R(null,2,5,S,[new R(null,2,5,S,[mm,this.required],null),new R(null,2,5,S,[ok,this.Db],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 2+G(this.f)};
g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,2,[ok,null,mm,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Vq(this.required,this.Db,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(mm,a):M.call(null,mm,a))?new Vq(c,this.Db,this.h,this.f,null):r(M.b?M.b(ok,a):M.call(null,ok,a))?new Vq(this.required,c,this.h,this.f,null):new Vq(this.required,this.Db,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,2,5,S,[new R(null,2,5,S,[mm,this.required],null),new R(null,2,5,S,[ok,this.Db],null)],null),this.f))};g.N=function(b,a){return new Vq(this.required,this.Db,a,this.f,this.i)};
g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.Db,F([Eq(a,this.required,F([c],0))],0))};g.ia=function(b,a){var c;c=this.required;c=Y.b?Y.b(a,c):Y.call(null,a,c);var d=this.Db;return Y.b?Y.b(c,d):Y.call(null,c,d)};function Wq(b,a,c){this.h=b;this.f=a;this.i=c;this.m=2229667594;this.B=8192}g=Wq.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a){default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.BindIgnore{",", ","}",c,N.b(Ed,this.f))};g.M=function(){return this.h};g.O=function(){return 0+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(le,a)?Nd.b(wd(O.b(je,this),this.h),a):new Wq(this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return new Wq(this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(Ed,this.f))};g.N=function(b,a){return new Wq(a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return c};g.ia=function(b,a){return a};function Xq(b,a,c,d){this.qa=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=Xq.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "variable":return this.qa;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.BindScalar{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[Wj,this.qa],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,1,[Wj,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Xq(this.qa,this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return r(M.b?M.b(Wj,a):M.call(null,Wj,a))?new Xq(c,this.h,this.f,null):new Xq(this.qa,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[Wj,this.qa],null)],null),this.f))};
g.N=function(b,a){return new Xq(this.qa,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.qa,F([c],0))};g.ia=function(b,a){var c=this.qa;return Y.b?Y.b(a,c):Y.call(null,a,c)};function Yq(b,a,c,d){this.Ib=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=Yq.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "bindings":return this.Ib;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.BindTuple{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[tk,this.Ib],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,1,[tk,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Yq(this.Ib,this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return r(M.b?M.b(tk,a):M.call(null,tk,a))?new Yq(c,this.h,this.f,null):new Yq(this.Ib,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[tk,this.Ib],null)],null),this.f))};
g.N=function(b,a){return new Yq(this.Ib,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.Ib,F([c],0))};g.ia=function(b,a){var c=this.Ib;return Y.b?Y.b(a,c):Y.call(null,a,c)};function Zq(b,a,c,d){this.ra=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=Zq.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "binding":return this.ra;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.BindColl{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[nl,this.ra],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,1,[nl,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Zq(this.ra,this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return r(M.b?M.b(nl,a):M.call(null,nl,a))?new Zq(c,this.h,this.f,null):new Zq(this.ra,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[nl,this.ra],null)],null),this.f))};
g.N=function(b,a){return new Zq(this.ra,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.ra,F([c],0))};g.ia=function(b,a){var c=this.ra;return Y.b?Y.b(a,c):Y.call(null,a,c)};function $q(b){return E.b(new A(null,"_","_",-1201019570,null),b)?Gq(new Wq(null,null,null),b):null}
function ar(b){if(r(function(){var a=Bq(b,2);return r(a)?E.b(Ad(b),new A(null,"...","...",-1926939749,null)):a}())){var a=function(){var a=B(b);return br.c?br.c(a):br.call(null,a)}();if(r(a))return Gq(new Zq(a,null,null,null),b);throw uj(""+u("Cannot parse collection binding"),new m(null,2,[Ol,Ql,Ul,b],null));}return null}function cr(b){var a=$q(b);return r(a)?a:br.c?br.c(b):br.call(null,b)}
function dr(b){var a=Cq(cr,b);if(r(a)){if(Td(a))throw uj(""+u("Tuple binding cannot be empty"),new m(null,2,[Ol,Ql,Ul,b],null));return Gq(new Yq(a,null,null,null),b)}return null}
function br(b){var a=ar(b);if(r(a))return a;a=Bq(b,1);a=r(a)?Wd(B(b)):a;a=r(a)?Gq(new Zq(dr(B(b)),null,null,null),b):null;if(r(a))return a;a=dr(b);if(r(a))return a;a=$q(b);if(r(a))return a;a=Qq(b);a=r(a)?Gq(new Xq(a,null,null,null),b):null;if(r(a))return a;throw uj(""+u("Cannot parse binding, expected (bind-scalar | bind-tuple | bind-coll | bind-rel)"),new m(null,2,[Ol,Ql,Ul,b],null));}
var er=function er(a){if(a?a.Oc:a)return a.Oc(a);var c;c=er[ba(null==a?null:a)];if(!c&&(c=er._,!c))throw Qa("IFindVars.-find-vars",a);return c.call(null,a)};Jq.prototype.Oc=function(){return new R(null,1,5,S,[this.symbol],null)};function fr(b,a,c,d,e){this.$=b;this.X=a;this.h=c;this.f=d;this.i=e;this.m=2229667594;this.B=8192}g=fr.prototype;g.Oc=function(){return er(Cd(this.X))};g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "fn":return this.$;case "args":return this.X;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.Aggregate{",", ","}",c,N.b(new R(null,2,5,S,[new R(null,2,5,S,[Sj,this.$],null),new R(null,2,5,S,[xj,this.X],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 2+G(this.f)};
g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,2,[xj,null,Sj,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new fr(this.$,this.X,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Sj,a):M.call(null,Sj,a))?new fr(c,this.X,this.h,this.f,null):r(M.b?M.b(xj,a):M.call(null,xj,a))?new fr(this.$,c,this.h,this.f,null):new fr(this.$,this.X,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,2,5,S,[new R(null,2,5,S,[Sj,this.$],null),new R(null,2,5,S,[xj,this.X],null)],null),this.f))};g.N=function(b,a){return new fr(this.$,this.X,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;
g.ha=function(b,a,c){return Eq(a,this.X,F([Eq(a,this.$,F([c],0))],0))};g.ia=function(b,a){var c;c=this.$;c=Y.b?Y.b(a,c):Y.call(null,a,c);var d=this.X;return Y.b?Y.b(c,d):Y.call(null,c,d)};function gr(b,a,c,d,e,f){this.source=b;this.qa=a;this.pattern=c;this.h=d;this.f=e;this.i=f;this.m=2229667594;this.B=8192}g=gr.prototype;g.Oc=function(){return er(this.qa)};g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "source":return this.source;case "variable":return this.qa;case "pattern":return this.pattern;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.Pull{",", ","}",c,N.b(new R(null,3,5,S,[new R(null,2,5,S,[Vk,this.source],null),new R(null,2,5,S,[Wj,this.qa],null),new R(null,2,5,S,[Mm,this.pattern],null)],null),this.f))};g.M=function(){return this.h};
g.O=function(){return 3+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,3,[Wj,null,Vk,null,Mm,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new gr(this.source,this.qa,this.pattern,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Vk,a):M.call(null,Vk,a))?new gr(c,this.qa,this.pattern,this.h,this.f,null):r(M.b?M.b(Wj,a):M.call(null,Wj,a))?new gr(this.source,c,this.pattern,this.h,this.f,null):r(M.b?M.b(Mm,a):M.call(null,Mm,a))?new gr(this.source,this.qa,c,this.h,this.f,null):new gr(this.source,this.qa,this.pattern,this.h,I.g(this.f,a,c),null)};
g.K=function(){return q(N.b(new R(null,3,5,S,[new R(null,2,5,S,[Vk,this.source],null),new R(null,2,5,S,[Wj,this.qa],null),new R(null,2,5,S,[Mm,this.pattern],null)],null),this.f))};g.N=function(b,a){return new gr(this.source,this.qa,this.pattern,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.pattern,F([Eq(a,this.qa,F([Eq(a,this.source,F([c],0))],0))],0))};
g.ia=function(b,a){var c;c=this.source;c=Y.b?Y.b(a,c):Y.call(null,a,c);var d=this.qa;c=Y.b?Y.b(c,d):Y.call(null,c,d);d=this.pattern;return Y.b?Y.b(c,d):Y.call(null,c,d)};var hr=function hr(a){if(a?a.vc:a)return a.vc(a);var c;c=hr[ba(null==a?null:a)];if(!c&&(c=hr._,!c))throw Qa("IFindElements.find-elements",a);return c.call(null,a)};function ir(b,a,c,d){this.elements=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=ir.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "elements":return this.elements;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.FindRel{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[cl,this.elements],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,1,[cl,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new ir(this.elements,this.h,Ff(Nd.b(this.f,a)),null)};g.vc=function(){return this.elements};g.T=function(b,a,c){return r(M.b?M.b(cl,a):M.call(null,cl,a))?new ir(c,this.h,this.f,null):new ir(this.elements,this.h,I.g(this.f,a,c),null)};
g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[cl,this.elements],null)],null),this.f))};g.N=function(b,a){return new ir(this.elements,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.elements,F([c],0))};g.ia=function(b,a){var c=this.elements;return Y.b?Y.b(a,c):Y.call(null,a,c)};function jr(b,a,c,d){this.element=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=jr.prototype;
g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "element":return this.element;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.FindColl{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[dk,this.element],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 1+G(this.f)};
g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,1,[dk,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new jr(this.element,this.h,Ff(Nd.b(this.f,a)),null)};g.vc=function(){return new R(null,1,5,S,[this.element],null)};
g.T=function(b,a,c){return r(M.b?M.b(dk,a):M.call(null,dk,a))?new jr(c,this.h,this.f,null):new jr(this.element,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[dk,this.element],null)],null),this.f))};g.N=function(b,a){return new jr(this.element,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.element,F([c],0))};
g.ia=function(b,a){var c=this.element;return Y.b?Y.b(a,c):Y.call(null,a,c)};function kr(b,a,c,d){this.element=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=kr.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "element":return this.element;default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.FindScalar{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[dk,this.element],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};
g.V=function(b,a){return ge(new ke(null,new m(null,1,[dk,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new kr(this.element,this.h,Ff(Nd.b(this.f,a)),null)};g.vc=function(){return new R(null,1,5,S,[this.element],null)};g.T=function(b,a,c){return r(M.b?M.b(dk,a):M.call(null,dk,a))?new kr(c,this.h,this.f,null):new kr(this.element,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[dk,this.element],null)],null),this.f))};
g.N=function(b,a){return new kr(this.element,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.element,F([c],0))};g.ia=function(b,a){var c=this.element;return Y.b?Y.b(a,c):Y.call(null,a,c)};function lr(b,a,c,d){this.elements=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=lr.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "elements":return this.elements;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.FindTuple{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[cl,this.elements],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,1,[cl,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new lr(this.elements,this.h,Ff(Nd.b(this.f,a)),null)};g.vc=function(){return this.elements};g.T=function(b,a,c){return r(M.b?M.b(cl,a):M.call(null,cl,a))?new lr(c,this.h,this.f,null):new lr(this.elements,this.h,I.g(this.f,a,c),null)};
g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[cl,this.elements],null)],null),this.f))};g.N=function(b,a){return new lr(this.elements,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.elements,F([c],0))};g.ia=function(b,a){var c=this.elements;return Y.b?Y.b(a,c):Y.call(null,a,c)};function mr(b){return b instanceof fr}function nr(b){return b instanceof gr}
function or(b){var a=Qq(b);if(r(a))return a;a:{if(Wd(b)&&E.b(B(b),new A(null,"pull","pull",779986722,null))){if(3<=G(b)&&4>=G(b)){var c=(a=E.b(G(b),4))?Hd(b,1):new A(null,"$","$",-1580747756,null),a=a?C(C(b)):C(b),d=H(a,0),a=H(a,1),c=Rq(c),d=Qq(d),e=Qq(a),a=r(e)?e:Sq(a);if(r(r(c)?r(d)?a:d:c)){a=new gr(c,d,a,null,null,null);break a}}throw uj(""+u("Cannot parse pull expression, expect ['pull' src-var? variable (constant | variable)]"),new m(null,2,[Ol,Ej,kk,b],null));}a=null}if(r(a))return a;a:{if(Wd(b)&&
E.b(B(b),new A(null,"aggregate","aggregate",-1142967327,null))){if(3<=G(b)&&(H(b,0),c=H(b,1),a=Ne(b,2),c=Qq(c),a=Cq(Uq,a),r(r(c)?a:c))){a=new fr(c,a,null,null,null);break a}throw uj(""+u("Cannot parse custom aggregate call, expect ['aggregate' variable fn-arg+]"),new m(null,2,[Ol,Ej,kk,b],null));}a=null}r(a)?b=a:Wd(b)&&2<=G(b)?(a=H(b,0),b=Ne(b,1),a=Tq(a),b=Cq(Uq,b),b=r(r(a)?b:a)?new fr(a,b,null,null,null):null):b=null;return b}
function pr(b){var a;a=Cq(or,b);a=null==a?null:new ir(a,null,null,null);if(r(a))return a;a:{if(Wd(b)&&E.b(G(b),1)&&(a=B(b),Wd(a)&&E.b(G(a),2)&&E.b(Ad(a),new A(null,"...","...",-1926939749,null)))){a=or(B(a));a=null==a?null:new jr(a,null,null,null);break a}a=null}if(r(a))return a;Wd(b)&&E.b(G(b),2)&&E.b(Ad(b),new A(null,".",".",1975675962,null))?(a=or(B(b)),a=null==a?null:new kr(a,null,null,null)):a=null;if(r(a))return a;Wd(b)&&E.b(G(b),1)?(a=B(b),a=Cq(or,a),a=null==a?null:new lr(a,null,null,null)):
a=null;if(r(a))return a;throw uj(""+u("Cannot parse :find, expected: (find-rel | find-coll | find-tuple | find-scalar)"),new m(null,2,[Ol,Ej,kk,b],null));}function qr(b){var a;a=Rq(b);a=r(a)?a:E.b(new A(null,"%","%",-950237169,null),b)?new Mq(null,null,null):null;return r(a)?Gq(new Xq(a,null,null,null),b):br(b)}function rr(b,a,c,d,e){this.source=b;this.pattern=a;this.h=c;this.f=d;this.i=e;this.m=2229667594;this.B=8192}g=rr.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "source":return this.source;case "pattern":return this.pattern;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.Pattern{",", ","}",c,N.b(new R(null,2,5,S,[new R(null,2,5,S,[Vk,this.source],null),new R(null,2,5,S,[Mm,this.pattern],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 2+G(this.f)};
g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,2,[Vk,null,Mm,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new rr(this.source,this.pattern,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Vk,a):M.call(null,Vk,a))?new rr(c,this.pattern,this.h,this.f,null):r(M.b?M.b(Mm,a):M.call(null,Mm,a))?new rr(this.source,c,this.h,this.f,null):new rr(this.source,this.pattern,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,2,5,S,[new R(null,2,5,S,[Vk,this.source],null),new R(null,2,5,S,[Mm,this.pattern],null)],null),this.f))};g.N=function(b,a){return new rr(this.source,this.pattern,a,this.f,this.i)};
g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.pattern,F([Eq(a,this.source,F([c],0))],0))};g.ia=function(b,a){var c;c=this.source;c=Y.b?Y.b(a,c):Y.call(null,a,c);var d=this.pattern;return Y.b?Y.b(c,d):Y.call(null,c,d)};function sr(b,a,c,d,e){this.$=b;this.X=a;this.h=c;this.f=d;this.i=e;this.m=2229667594;this.B=8192}g=sr.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "fn":return this.$;case "args":return this.X;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.Predicate{",", ","}",c,N.b(new R(null,2,5,S,[new R(null,2,5,S,[Sj,this.$],null),new R(null,2,5,S,[xj,this.X],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 2+G(this.f)};
g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,2,[xj,null,Sj,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new sr(this.$,this.X,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Sj,a):M.call(null,Sj,a))?new sr(c,this.X,this.h,this.f,null):r(M.b?M.b(xj,a):M.call(null,xj,a))?new sr(this.$,c,this.h,this.f,null):new sr(this.$,this.X,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,2,5,S,[new R(null,2,5,S,[Sj,this.$],null),new R(null,2,5,S,[xj,this.X],null)],null),this.f))};g.N=function(b,a){return new sr(this.$,this.X,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;
g.ha=function(b,a,c){return Eq(a,this.X,F([Eq(a,this.$,F([c],0))],0))};g.ia=function(b,a){var c;c=this.$;c=Y.b?Y.b(a,c):Y.call(null,a,c);var d=this.X;return Y.b?Y.b(c,d):Y.call(null,c,d)};function tr(b,a,c,d,e,f){this.$=b;this.X=a;this.ra=c;this.h=d;this.f=e;this.i=f;this.m=2229667594;this.B=8192}g=tr.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "fn":return this.$;case "args":return this.X;case "binding":return this.ra;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.Function{",", ","}",c,N.b(new R(null,3,5,S,[new R(null,2,5,S,[Sj,this.$],null),new R(null,2,5,S,[xj,this.X],null),new R(null,2,5,S,[nl,this.ra],null)],null),this.f))};g.M=function(){return this.h};
g.O=function(){return 3+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,3,[xj,null,Sj,null,nl,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new tr(this.$,this.X,this.ra,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Sj,a):M.call(null,Sj,a))?new tr(c,this.X,this.ra,this.h,this.f,null):r(M.b?M.b(xj,a):M.call(null,xj,a))?new tr(this.$,c,this.ra,this.h,this.f,null):r(M.b?M.b(nl,a):M.call(null,nl,a))?new tr(this.$,this.X,c,this.h,this.f,null):new tr(this.$,this.X,this.ra,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,3,5,S,[new R(null,2,5,S,[Sj,this.$],null),new R(null,2,5,S,[xj,this.X],null),new R(null,2,5,S,[nl,this.ra],null)],null),this.f))};
g.N=function(b,a){return new tr(this.$,this.X,this.ra,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.ra,F([Eq(a,this.X,F([Eq(a,this.$,F([c],0))],0))],0))};g.ia=function(b,a){var c;c=this.$;c=Y.b?Y.b(a,c):Y.call(null,a,c);var d=this.X;c=Y.b?Y.b(c,d):Y.call(null,c,d);d=this.ra;return Y.b?Y.b(c,d):Y.call(null,c,d)};
function ur(b,a,c,d,e,f){this.source=b;this.name=a;this.X=c;this.h=d;this.f=e;this.i=f;this.m=2229667594;this.B=8192}g=ur.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "source":return this.source;case "name":return this.name;case "args":return this.X;default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.RuleExpr{",", ","}",c,N.b(new R(null,3,5,S,[new R(null,2,5,S,[Vk,this.source],null),new R(null,2,5,S,[yk,this.name],null),new R(null,2,5,S,[xj,this.X],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 3+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,3,[xj,null,yk,null,Vk,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new ur(this.source,this.name,this.X,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Vk,a):M.call(null,Vk,a))?new ur(c,this.name,this.X,this.h,this.f,null):r(M.b?M.b(yk,a):M.call(null,yk,a))?new ur(this.source,c,this.X,this.h,this.f,null):r(M.b?M.b(xj,a):M.call(null,xj,a))?new ur(this.source,this.name,c,this.h,this.f,null):new ur(this.source,this.name,this.X,this.h,I.g(this.f,a,c),null)};
g.K=function(){return q(N.b(new R(null,3,5,S,[new R(null,2,5,S,[Vk,this.source],null),new R(null,2,5,S,[yk,this.name],null),new R(null,2,5,S,[xj,this.X],null)],null),this.f))};g.N=function(b,a){return new ur(this.source,this.name,this.X,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.X,F([Eq(a,this.name,F([Eq(a,this.source,F([c],0))],0))],0))};
g.ia=function(b,a){var c;c=this.source;c=Y.b?Y.b(a,c):Y.call(null,a,c);var d=this.name;c=Y.b?Y.b(c,d):Y.call(null,c,d);d=this.X;return Y.b?Y.b(c,d):Y.call(null,c,d)};function vr(b,a,c,d,e,f){this.source=b;this.lb=a;this.da=c;this.h=d;this.f=e;this.i=f;this.m=2229667594;this.B=8192}g=vr.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "source":return this.source;case "vars":return this.lb;case "clauses":return this.da;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.Not{",", ","}",c,N.b(new R(null,3,5,S,[new R(null,2,5,S,[Vk,this.source],null),new R(null,2,5,S,[rm,this.lb],null),new R(null,2,5,S,[Tl,this.da],null)],null),this.f))};g.M=function(){return this.h};
g.O=function(){return 3+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,3,[Vk,null,Tl,null,rm,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new vr(this.source,this.lb,this.da,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Vk,a):M.call(null,Vk,a))?new vr(c,this.lb,this.da,this.h,this.f,null):r(M.b?M.b(rm,a):M.call(null,rm,a))?new vr(this.source,c,this.da,this.h,this.f,null):r(M.b?M.b(Tl,a):M.call(null,Tl,a))?new vr(this.source,this.lb,c,this.h,this.f,null):new vr(this.source,this.lb,this.da,this.h,I.g(this.f,a,c),null)};
g.K=function(){return q(N.b(new R(null,3,5,S,[new R(null,2,5,S,[Vk,this.source],null),new R(null,2,5,S,[rm,this.lb],null),new R(null,2,5,S,[Tl,this.da],null)],null),this.f))};g.N=function(b,a){return new vr(this.source,this.lb,this.da,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.da,F([Eq(a,this.lb,F([Eq(a,this.source,F([c],0))],0))],0))};
g.ia=function(b,a){var c;c=this.source;c=Y.b?Y.b(a,c):Y.call(null,a,c);var d=this.lb;c=Y.b?Y.b(c,d):Y.call(null,c,d);d=this.da;return Y.b?Y.b(c,d):Y.call(null,c,d)};function wr(b,a,c,d,e,f){this.source=b;this.gb=a;this.da=c;this.h=d;this.f=e;this.i=f;this.m=2229667594;this.B=8192}g=wr.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "source":return this.source;case "rule-vars":return this.gb;case "clauses":return this.da;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.Or{",", ","}",c,N.b(new R(null,3,5,S,[new R(null,2,5,S,[Vk,this.source],null),new R(null,2,5,S,[nk,this.gb],null),new R(null,2,5,S,[Tl,this.da],null)],null),this.f))};g.M=function(){return this.h};
g.O=function(){return 3+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,3,[nk,null,Vk,null,Tl,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new wr(this.source,this.gb,this.da,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Vk,a):M.call(null,Vk,a))?new wr(c,this.gb,this.da,this.h,this.f,null):r(M.b?M.b(nk,a):M.call(null,nk,a))?new wr(this.source,c,this.da,this.h,this.f,null):r(M.b?M.b(Tl,a):M.call(null,Tl,a))?new wr(this.source,this.gb,c,this.h,this.f,null):new wr(this.source,this.gb,this.da,this.h,I.g(this.f,a,c),null)};
g.K=function(){return q(N.b(new R(null,3,5,S,[new R(null,2,5,S,[Vk,this.source],null),new R(null,2,5,S,[nk,this.gb],null),new R(null,2,5,S,[Tl,this.da],null)],null),this.f))};g.N=function(b,a){return new wr(this.source,this.gb,this.da,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.da,F([Eq(a,this.gb,F([Eq(a,this.source,F([c],0))],0))],0))};
g.ia=function(b,a){var c;c=this.source;c=Y.b?Y.b(a,c):Y.call(null,a,c);var d=this.gb;c=Y.b?Y.b(c,d):Y.call(null,c,d);d=this.da;return Y.b?Y.b(c,d):Y.call(null,c,d)};function xr(b,a,c,d){this.da=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=xr.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "clauses":return this.da;default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.And{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[Tl,this.da],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};
g.V=function(b,a){return ge(new ke(null,new m(null,1,[Tl,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new xr(this.da,this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return r(M.b?M.b(Tl,a):M.call(null,Tl,a))?new xr(c,this.h,this.f,null):new xr(this.da,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[Tl,this.da],null)],null),this.f))};g.N=function(b,a){return new xr(this.da,a,this.f,this.i)};
g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.da,F([c],0))};g.ia=function(b,a){var c=this.da;return Y.b?Y.b(a,c):Y.call(null,a,c)};function yr(b){var a=Pq(b);if(r(a))return a;a=Qq(b);return r(a)?a:Sq(b)}function zr(b){if(Wd(b)){var a=Rq(B(b));return r(a)?new R(null,2,5,S,[a,C(b)],null):new R(null,2,5,S,[new Lq(null,null,null),b],null)}return null}
function Ar(b){if(Wd(b)){var a=H(b,0);b=Ne(b,1);b=null==b?Ed:b;var c=Tq(a),a=r(c)?c:Qq(a);b=Cq(Uq,b);return r(r(a)?b:a)?new R(null,2,5,S,[a,b],null):null}return null}var Y=function Y(a,c){return c instanceof Jq?Dd.b(a,c):c instanceof vr?O.b(a,rm.c(c)):c instanceof wr?Y(a,nk.c(c)):(c?r(r(null)?null:c.ga)||(c.Mb?0:La(yq,c)):La(yq,c))?Aq(c,a):Wd(c)?w(Y,a,c):a};function Br(b){return Y(Ed,b)}
function Cr(b,a,c){a=xq.b(zi(b),zi(Br(a)));if(!Td(a))throw uj([u("Join variable not declared inside clauses: "),u(U(F([qg(vk,a)],0)))].join(""),new m(null,2,[Ol,fk,Ul,c],null));if(Td(b))throw uj(""+u("Join variables should not be empty"),new m(null,2,[Ol,fk,Ul,c],null));}function Dr(b,a){Cr(rm.c(b),Tl.c(b),a);return b}
function Er(b,a){for(var c=de(b)?xf(Sf,b):b,d=Id(c,nk),e=de(d)?xf(Sf,d):d,d=Id(e,mm),e=Id(e,ok),f=Id(c,Tl),c=N.b(d,e),d=q(f),e=null,h=f=0;;)if(h<f){var k=e.R(null,h);Cr(c,new R(null,1,5,S,[k],null),a);h+=1}else if(d=q(d))e=d,$d(e)?(d=hc(e),h=ic(e),e=d,f=G(d),d=h):(d=B(e),Cr(c,new R(null,1,5,S,[d],null),a),d=C(e),e=null,f=0),h=0;else break;return b}
function bg(b){if(Wd(b)&&E.b(new A(null,"and","and",668631710,null),B(b))){var a=Cq(cg,C(b));if(r(Ff(a)))return new xr(a,null,null,null);throw uj(""+u("Cannot parse 'and' clause, expected [ 'and' clause+ ]"),new m(null,2,[Ol,fk,Ul,b],null));}return null}
function cg(b){var a;a:{var c=zr(b);if(r(c)){a=H(c,0);var d=H(c,1),c=H(d,0),d=Ne(d,1);if(E.b(new A(null,"not","not",1044554643,null),c)){c=Cq(cg,d);if(r(c)){a=Dr(new vr(a,se(Bi.c(Br(c))),c,null,null,null),b);break a}throw uj(""+u("Cannot parse 'not' clause, expected [ src-var? 'not' clause+ ]"),new m(null,2,[Ol,fk,Ul,b],null));}}a=null}if(r(a))return a;a:{c=zr(b);if(r(c)){a=H(c,0);var e=H(c,1),c=H(e,0),d=H(e,1),e=Ne(e,2);if(E.b(new A(null,"not-join","not-join",-645515756,null),c)){c=Cq(Qq,d);d=Cq(cg,
e);if(r(r(c)?d:c)){a=Dr(new vr(a,c,d,null,null,null),b);break a}throw uj(""+u("Cannot parse 'not-join' clause, expected [ src-var? 'not-join' [variable+] clause+ ]"),new m(null,2,[Ol,fk,Ul,b],null));}}a=null}if(r(a))return a;a:{c=zr(b);if(r(c)&&(a=H(c,0),d=H(c,1),c=H(d,0),d=Ne(d,1),E.b(new A(null,"or","or",1876275696,null),c))){c=Cq(ag(),d);if(r(c)){a=Er(new wr(a,new Vq(null,se(Bi.c(Br(c))),null,null,null),c,null,null,null),b);break a}throw uj(""+u("Cannot parse 'or' clause, expected [ src-var? 'or' clause+ ]"),
new m(null,2,[Ol,fk,Ul,b],null));}a=null}if(r(a))return a;a:{c=zr(b);if(r(c)&&(a=H(c,0),d=H(c,1),e=H(d,0),c=H(d,1),d=Ne(d,2),E.b(new A(null,"or-join","or-join",591375469,null),e))){if(Wd(c)){var f=Wd(B(c))?new R(null,2,5,S,[B(c),C(c)],null):new R(null,2,5,S,[null,c],null),e=H(f,0),f=H(f,1),e=Cq(Qq,e),f=Cq(Qq,f);if(Td(e)&&Td(f))throw uj(""+u("Cannot parse rule-vars, expected [ variable+ | ([ variable+ ] variable*) ]"),new m(null,2,[Ol,jk,Ul,c],null));if(!r(Fq(N.b(e,f))))throw uj(""+u("Rule variables should be distinct"),
new m(null,2,[Ol,jk,Ul,c],null));c=new Vq(e,f,null,null,null)}else throw uj(""+u("Cannot parse rule-vars, expected [ variable+ | ([ variable+ ] variable*) ]"),new m(null,2,[Ol,jk,Ul,c],null));d=Cq(cg,d);if(r(r(c)?d:c)){a=Er(new wr(a,c,d,null,null,null),b);break a}throw uj(""+u("Cannot parse 'or-join' clause, expected [ src-var? 'or-join' [variable+] clause+ ]"),new m(null,2,[Ol,fk,Ul,b],null));}a=null}if(r(a))return a;a:{if(r(Bq(b,1))&&(c=Ar(B(b)),r(c))){a=H(c,0);c=H(c,1);a=new sr(a,c,null,null,null);
break a}a=null}if(r(a))return a;a:{if(r(Bq(b,2))&&(c=H(b,0),a=H(b,1),d=Ar(c),r(d))){c=H(d,0);d=H(d,1);a=br(a);a=r(a)?new tr(c,d,a,null,null,null):null;break a}a=null}if(r(a))return a;a:{c=zr(b);if(r(c)&&(a=H(c,0),c=H(c,1),d=H(c,0),c=Ne(c,1),d=Tq(d),e=Cq(yr,c),r(d))){if(Td(c))throw uj(""+u("rule-expr requieres at least one argument"),new m(null,2,[Ol,fk,Ul,b],null));if(null==e)throw uj(""+u("Cannot parse rule-expr arguments, expected [ (variable | constant | '_')+ ]"),new m(null,2,[Ol,fk,Ul,b],null));
a=new ur(a,d,e,null,null,null);break a}a=null}if(r(a))return a;a:{c=zr(b);if(r(c)&&(a=H(c,0),c=H(c,1),c=Cq(yr,c),r(c))){if(Td(c))throw uj(""+u("Pattern could not be empty"),new m(null,2,[Ol,fk,Ul,b],null));a=Gq(new rr(a,c,null,null,null),b);break a}a=null}if(r(a))return a;throw uj(""+u("Cannot parse clause, expected (data-pattern | pred-expr | fn-expr | rule-expr | not-clause | not-join-clause | or-clause | or-join-clause)"),new m(null,2,[Ol,fk,Ul,b],null));}
function Fr(b,a,c,d,e,f,h){this.find=b;this.Wa=a;this.Sa=c;this.Va=d;this.h=e;this.f=f;this.i=h;this.m=2229667594;this.B=8192}g=Fr.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "find":return this.find;case "with":return this.Wa;case "in":return this.Sa;case "where":return this.Va;default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.parser.Query{",", ","}",c,N.b(new R(null,4,5,S,[new R(null,2,5,S,[zj,this.find],null),new R(null,2,5,S,[ul,this.Wa],null),new R(null,2,5,S,[qm,this.Sa],null),new R(null,2,5,S,[Qj,this.Va],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 4+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,4,[zj,null,Qj,null,ul,null,qm,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Fr(this.find,this.Wa,this.Sa,this.Va,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(zj,a):M.call(null,zj,a))?new Fr(c,this.Wa,this.Sa,this.Va,this.h,this.f,null):r(M.b?M.b(ul,a):M.call(null,ul,a))?new Fr(this.find,c,this.Sa,this.Va,this.h,this.f,null):r(M.b?M.b(qm,a):M.call(null,qm,a))?new Fr(this.find,this.Wa,c,this.Va,this.h,this.f,null):r(M.b?M.b(Qj,a):M.call(null,Qj,a))?new Fr(this.find,this.Wa,this.Sa,c,this.h,this.f,null):new Fr(this.find,this.Wa,this.Sa,this.Va,this.h,I.g(this.f,a,c),null)};
g.K=function(){return q(N.b(new R(null,4,5,S,[new R(null,2,5,S,[zj,this.find],null),new R(null,2,5,S,[ul,this.Wa],null),new R(null,2,5,S,[qm,this.Sa],null),new R(null,2,5,S,[Qj,this.Va],null)],null),this.f))};g.N=function(b,a){return new Fr(this.find,this.Wa,this.Sa,this.Va,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};g.ga=!0;g.ha=function(b,a,c){return Eq(a,this.Va,F([Eq(a,this.Sa,F([Eq(a,this.Wa,F([Eq(a,this.find,F([c],0))],0))],0))],0))};
g.ia=function(b,a){return Y(Y(Y(Y(a,this.find),this.Wa),this.Sa),this.Va)};function Gr(b){for(var a=je,c=null;;){var d=B(b);if(r(d))d instanceof K?c=d:a=xg.S(a,new R(null,1,5,S,[c],null),Of(Dd,Ed),d),b=C(b);else return a}}
function Hr(b,a){var c=zi(Br(zj.c(b))),d=zi(ul.c(b)),e=zi(Br(qm.c(b))),f=zi(Br(Qj.c(b))),e=xq.b(vq.b(c,d),vq.b(f,e)),c=wq.b(c,d);if(!Td(e))throw uj([u("Query for unknown vars: "),u(U(F([qg(vk,e)],0)))].join(""),new m(null,3,[Ol,Om,rm,e,Ul,a],null));if(!Td(c))throw uj([u(":in and :with should not use same variables: "),u(U(F([qg(vk,c)],0)))].join(""),new m(null,3,[Ol,Om,rm,c,Ul,a],null));var h=Br(qm.c(b)),k=Dq(function(){return function(a){return a instanceof Kq}}(h),qm.c(b)),l=Dq(function(){return function(a){return a instanceof
Mq}}(h,k),qm.c(b));if(!r(function(){var a=Fq(h);return r(a)?(a=Fq(k),r(a)?Fq(l):a):a}()))throw uj(""+u("Vars used in :in should be distinct"),new m(null,2,[Ol,Om,Ul,a],null));c=Br(ul.c(b));if(!r(Fq(c)))throw uj(""+u("Vars used in :with should be distinct"),new m(null,2,[Ol,Om,Ul,a],null));c=Eq(function(a){return a instanceof Kq},qm.c(b),F([le],0));d=Eq(function(){return function(a){return a instanceof Kq}}(c),Qj.c(b),F([le],0));c=xq.b(d,c);if(!Td(c))throw uj([u("Where uses unknown source vars: "),
u(U(F([qg(vk,c)],0)))].join(""),new m(null,3,[Ol,Om,rm,c,Ul,a],null));c=Dq(function(a){return a instanceof ur},Qj.c(b));d=Dq(function(){return function(a){return a instanceof Mq}}(c),qm.c(b));if(!Td(c)&&Td(d))throw uj(""+u("Missing rules var '%' in :in"),new m(null,2,[Ol,Om,Ul,a],null));};function Ir(b,a,c,d,e){this.ac=b;this.Kd=a;this.Md=c;this.Jd=d;this.pa=e;this.m=2147484416;this.B=0}g=Ir.prototype;g.T=function(b,a,c){return Jr.g?Jr.g(this,a,c):Jr.call(null,this,a,c)};g.Vb=function(b,a){return pb(this.ac,a)};g.D=function(b,a){return nb.g(this.ac,a,null)};g.C=function(b,a,c){return nb.g(this.ac,a,c)};g.H=function(b,a,c){return Yb(bc(this.ac),a,c)};function Kr(b,a,c,d,e){return new Ir(b,a,c,d,e)}
function Jr(b,a,c){var d=b.ac,e=b.Kd,f=b.Md,h=b.Jd;b=b.pa;var k=f.b?f.b(a,null):f.call(null,a,null);if(r(k))return Kr(d,I.g(Nd.b(e,k),h,a),I.g(f,a,h),h+1,b);a=Kr(I.g(d,a,c),I.g(e,h,a),I.g(f,a,h),h+1,b);return Lr.c?Lr.c(a):Lr.call(null,a)}function Lr(b){if(G(b.ac)>b.pa){var a=b.ac,c=b.Kd,d=b.Md,e=b.Jd;b=b.pa;var f=B(c),h=H(f,0),f=H(f,1);return Kr(Nd.b(a,f),Nd.b(c,h),Nd.b(d,f),e,b)}return b};function Mr(b,a,c,d,e){this.gc=b;this.Ba=a;this.h=c;this.f=d;this.i=e;this.m=2229667594;this.B=8192}g=Mr.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "wildcard?":return this.gc;case "attrs":return this.Ba;default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.pull-parser.PullSpec{",", ","}",c,N.b(new R(null,2,5,S,[new R(null,2,5,S,[cm,this.gc],null),new R(null,2,5,S,[Kl,this.Ba],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 2+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};
g.V=function(b,a){return ge(new ke(null,new m(null,2,[Kl,null,cm,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Mr(this.gc,this.Ba,this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return r(M.b?M.b(cm,a):M.call(null,cm,a))?new Mr(c,this.Ba,this.h,this.f,null):r(M.b?M.b(Kl,a):M.call(null,Kl,a))?new Mr(this.gc,c,this.h,this.f,null):new Mr(this.gc,this.Ba,this.h,I.g(this.f,a,c),null)};
g.K=function(){return q(N.b(new R(null,2,5,S,[new R(null,2,5,S,[cm,this.gc],null),new R(null,2,5,S,[Kl,this.Ba],null)],null),this.f))};g.N=function(b,a){return new Mr(this.gc,this.Ba,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};var Nr=function Nr(a){if(a?a.Nb:a)return a.Nb(a);var c;c=Nr[ba(null==a?null:a)];if(!c&&(c=Nr._,!c))throw Qa("IPullSpecComponent.-as-spec",a);return c.call(null,a)};
function Or(b,a,c,d){this.W=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=Or.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "attr":return this.W;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.pull-parser.PullAttrName{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[Pm,this.W],null)],null),this.f))};g.M=function(){return this.h};
g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.Nb=function(){return new R(null,2,5,S,[this.W,new m(null,1,[Pm,this.W],null)],null)};g.V=function(b,a){return ge(new ke(null,new m(null,1,[Pm,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Or(this.W,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Pm,a):M.call(null,Pm,a))?new Or(c,this.h,this.f,null):new Or(this.W,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[Pm,this.W],null)],null),this.f))};g.N=function(b,a){return new Or(this.W,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};function Pr(b,a,c,d,e){this.W=b;this.Rb=a;this.h=c;this.f=d;this.i=e;this.m=2229667594;this.B=8192}g=Pr.prototype;
g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "attr":return this.W;case "rattr":return this.Rb;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.pull-parser.PullReverseAttrName{",", ","}",c,N.b(new R(null,2,5,S,[new R(null,2,5,S,[Pm,this.W],null),new R(null,2,5,S,[bk,this.Rb],null)],null),this.f))};g.M=function(){return this.h};
g.O=function(){return 2+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.Nb=function(){return new R(null,2,5,S,[this.Rb,new m(null,1,[Pm,this.W],null)],null)};g.V=function(b,a){return ge(new ke(null,new m(null,2,[bk,null,Pm,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Pr(this.W,this.Rb,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Pm,a):M.call(null,Pm,a))?new Pr(c,this.Rb,this.h,this.f,null):r(M.b?M.b(bk,a):M.call(null,bk,a))?new Pr(this.W,c,this.h,this.f,null):new Pr(this.W,this.Rb,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,2,5,S,[new R(null,2,5,S,[Pm,this.W],null),new R(null,2,5,S,[bk,this.Rb],null)],null),this.f))};g.N=function(b,a){return new Pr(this.W,this.Rb,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};
function Qr(b,a,c,d,e){this.W=b;this.pa=a;this.h=c;this.f=d;this.i=e;this.m=2229667594;this.B=8192}g=Qr.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "attr":return this.W;case "limit":return this.pa;default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.pull-parser.PullLimitExpr{",", ","}",c,N.b(new R(null,2,5,S,[new R(null,2,5,S,[Pm,this.W],null),new R(null,2,5,S,[ek,this.pa],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 2+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};
g.Nb=function(){return wg(Nr(this.W),new R(null,2,5,S,[1,ek],null),this.pa)};g.V=function(b,a){return ge(new ke(null,new m(null,2,[ek,null,Pm,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Qr(this.W,this.pa,this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return r(M.b?M.b(Pm,a):M.call(null,Pm,a))?new Qr(c,this.pa,this.h,this.f,null):r(M.b?M.b(ek,a):M.call(null,ek,a))?new Qr(this.W,c,this.h,this.f,null):new Qr(this.W,this.pa,this.h,I.g(this.f,a,c),null)};
g.K=function(){return q(N.b(new R(null,2,5,S,[new R(null,2,5,S,[Pm,this.W],null),new R(null,2,5,S,[ek,this.pa],null)],null),this.f))};g.N=function(b,a){return new Qr(this.W,this.pa,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};function Rr(b,a,c,d,e){this.W=b;this.value=a;this.h=c;this.f=d;this.i=e;this.m=2229667594;this.B=8192}g=Rr.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "attr":return this.W;case "value":return this.value;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.pull-parser.PullDefaultExpr{",", ","}",c,N.b(new R(null,2,5,S,[new R(null,2,5,S,[Pm,this.W],null),new R(null,2,5,S,[Bk,this.value],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 2+G(this.f)};
g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.Nb=function(){return wg(Nr(this.W),new R(null,2,5,S,[1,mk],null),this.value)};g.V=function(b,a){return ge(new ke(null,new m(null,2,[Bk,null,Pm,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Rr(this.W,this.value,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Pm,a):M.call(null,Pm,a))?new Rr(c,this.value,this.h,this.f,null):r(M.b?M.b(Bk,a):M.call(null,Bk,a))?new Rr(this.W,c,this.h,this.f,null):new Rr(this.W,this.value,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,2,5,S,[new R(null,2,5,S,[Pm,this.W],null),new R(null,2,5,S,[Bk,this.value],null)],null),this.f))};g.N=function(b,a){return new Rr(this.W,this.value,a,this.f,this.i)};
g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};function Sr(b,a,c){this.h=b;this.f=a;this.i=c;this.m=2229667594;this.B=8192}g=Sr.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a){default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.pull-parser.PullWildcard{",", ","}",c,N.b(Ed,this.f))};g.M=function(){return this.h};g.O=function(){return 0+G(this.f)};
g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(le,a)?Nd.b(wd(O.b(je,this),this.h),a):new Sr(this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return new Sr(this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(Ed,this.f))};g.N=function(b,a){return new Sr(a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};
function Tr(b,a,c,d){this.pa=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=Tr.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "limit":return this.pa;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.pull-parser.PullRecursionLimit{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[ek,this.pa],null)],null),this.f))};g.M=function(){return this.h};
g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.Nb=function(){return new R(null,2,5,S,[rl,this.pa],null)};g.V=function(b,a){return ge(new ke(null,new m(null,1,[ek,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Tr(this.pa,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(ek,a):M.call(null,ek,a))?new Tr(c,this.h,this.f,null):new Tr(this.pa,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[ek,this.pa],null)],null),this.f))};g.N=function(b,a){return new Tr(this.pa,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};function Ur(b,a,c,d,e){this.W=b;this.Qb=a;this.h=c;this.f=d;this.i=e;this.m=2229667594;this.B=8192}g=Ur.prototype;
g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "attr":return this.W;case "porrl":return this.Qb;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.pull-parser.PullMapSpecEntry{",", ","}",c,N.b(new R(null,2,5,S,[new R(null,2,5,S,[Pm,this.W],null),new R(null,2,5,S,[pl,this.Qb],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 2+G(this.f)};
g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.Nb=function(){return zg(Nr(this.W),1,Dd,Nr(this.Qb))};g.V=function(b,a){return ge(new ke(null,new m(null,2,[pl,null,Pm,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Ur(this.W,this.Qb,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Pm,a):M.call(null,Pm,a))?new Ur(c,this.Qb,this.h,this.f,null):r(M.b?M.b(pl,a):M.call(null,pl,a))?new Ur(this.W,c,this.h,this.f,null):new Ur(this.W,this.Qb,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,2,5,S,[new R(null,2,5,S,[Pm,this.W],null),new R(null,2,5,S,[pl,this.Qb],null)],null),this.f))};g.N=function(b,a){return new Ur(this.W,this.Qb,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};
function Vr(b,a){return a instanceof Sr?I.g(b,cm,!0):zg(b,Kl,pf,Nr(a))}function Wr(b,a,c,d){this.dc=b;this.h=a;this.f=c;this.i=d;this.m=2229667594;this.B=8192}g=Wr.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "specs":return this.dc;default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.pull-parser.PullPattern{",", ","}",c,N.b(new R(null,1,5,S,[new R(null,2,5,S,[Dl,this.dc],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 1+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};
g.Nb=function(){var b=new Mr(!1,$b(je),null,null,null),b=w(Vr,b,this.dc);return new R(null,2,5,S,[Nl,yg(b,Kl,of)],null)};g.V=function(b,a){return ge(new ke(null,new m(null,1,[Dl,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new Wr(this.dc,this.h,Ff(Nd.b(this.f,a)),null)};g.T=function(b,a,c){return r(M.b?M.b(Dl,a):M.call(null,Dl,a))?new Wr(c,this.h,this.f,null):new Wr(this.dc,this.h,I.g(this.f,a,c),null)};
g.K=function(){return q(N.b(new R(null,1,5,S,[new R(null,2,5,S,[Dl,this.dc],null)],null),this.f))};g.N=function(b,a){return new Wr(this.dc,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};var Xr=new ke(null,new m(null,3,[Mj,null,"*",null,new A(null,"*","*",345799209,null),null],null),null);function Yr(b){return b instanceof K||"string"===typeof b?lq(b)?new Pr(mq(b),b,null,null,null):new Or(b,null,null,null):null}
var bs=new ke(null,new m(null,2,["...",null,new A(null,"...","...",-1926939749,null),null],null),null);function cs(b){return Wd(b)&&E.b(3,G(b))}var ds=new ke(null,new m(null,3,[new A(null,"limit","limit",284709164,null),null,ek,null,"limit",null],null),null);
function es(b){var a=H(b,0),c=H(b,1),d=H(b,2);if(r(ds.c?ds.c(a):ds.call(null,a))){c=(a=null==d||"number"===typeof d&&0<d)?Yr(c):a;if(r(c))return new Qr(c,d,null,null,null);throw uj(""+u('Expected ["limit" attr-name (positive-number | nil)]'),new m(null,2,[Ol,dm,kk,b],null));}return null}var fs=new ke(null,new m(null,3,[new A(null,"default","default",-347290801,null),null,mk,null,"default",null],null),null);
function gs(b){var a=H(b,0),c=H(b,1);b=function(){var b=Yr(a);return r(b)?b:r(cs(a))?es(a):null}();if(r(b)){var d=function(){var a;a=r(bs.c?bs.c(c):bs.call(null,c))?new Tr(null,null,null,null):"number"===typeof c&&0<c?new Tr(c,null,null,null):null;return r(a)?a:hs.c?hs.c(c):hs.call(null,c)}();if(r(d))return new Ur(b,d,null,null,null);throw uj(""+u("Expected (pattern | recursion-limit)"),new m(null,2,[Ol,dm,kk,new R(null,2,5,S,[a,c],null)],null));}throw uj(""+u("Expected (attr-name | limit-expr)"),
new m(null,2,[Ol,dm,kk,new R(null,2,5,S,[a,c],null)],null));}
function is(b){var a=Yr(b);if(r(a))return a;a=r(Xr.c?Xr.c(b):Xr.call(null,b))?new Sr(null,null,null):null;if(r(a))return a;a=Yd(b)?gs(B(b)):null;if(r(a))return a;if(r(cs(b))){if(a=es(b),!r(a))b:{var c=H(b,0),d=H(b,1),a=H(b,2);if(r(fs.c?fs.c(c):fs.call(null,c))){c=fs.c?fs.c(c):fs.call(null,c);d=r(c)?Yr(d):c;if(r(d)){a=new Rr(d,a,null,null,null);break b}throw uj(""+u('Expected ["default" attr-name any-value]'),new m(null,2,[Ol,dm,kk,b],null));}a=null}}else a=null;if(r(a))return a;throw uj(""+u("Cannot parse attr-spec, expected: (attr-name | wildcard | map-spec | attr-expr)"),
new m(null,2,[Ol,dm,kk,b],null));}function js(b){return Yd(b)?im:r(Xr.c?Xr.c(b):Xr.call(null,b))?Uj:sk}function ks(b){return O.g(Ed,dg.c(function(a){return Dd.b(je,a)}),b)}function ls(b){b=rj(js,b);var a=r(Ff(Id(b,Uj)))?new R(null,1,5,S,[new A(null,"*","*",345799209,null)],null):Ed;return O.g(O.b(a,Id(b,sk)),Mf.b(dg.c(ks),aj),Id(b,im))}function hs(b){return Wd(b)?new Wr(O.g(Ed,dg.c(is),ls(b)),null,null,null):null}
function ms(b){var a;a=null==b?null:hs(b);a=null==a?null:Hd(Nr(a),1);if(r(a))return a;throw uj(""+u("Cannot parse pull pattern, expected: [attr-spec+]"),new m(null,2,[Ol,dm,kk,b],null));};function ns(b,a){return w(pf,b,a)}function os(b,a,c){return Md([Pj,Rk,Tk,rl,Dl,cm,jm,Mm,Qm],[c,a,Mm,new m(null,2,[Pl,je,sl,le],null),q(Kl.c(b)),cm.c(b),$b(je),b,$b(Ed)])}function ps(b,a,c,d){return I.g(os(b,a,c),Pm,d)}function qs(b,a,c){var d=Mm.c(b);return I.j(b,Rk,a,F([Dl,q(Kl.c(d)),cm,cm.c(d),jm,$b(je),Qm,function(){var a=Qm.c(b);return q(c)?pf.b(a,c):a}()],0))}function rs(b,a,c){var d=de(b)?xf(Sf,b):b,e=Id(d,Pl),d=Id(d,sl);return I.j(b,Pl,yg(e,a,Of(Xc,0)),F([sl,Dd.b(d,c)],0))}
function ss(b,a,c){var d;d=ge(vg(b,new R(null,2,5,S,[rl,sl],null),le),c);return r(d)?Dd.b(a,zg(b,Qm,pf,new m(null,1,[Hl,c],null))):null}function ts(b,a){var c=jm.c(a),c=null==c?null:bc(c);return null==c?null:Id(c,b)}var us=Nf(ts,Mk);function vs(b,a){var c=Pm.c(b),c=rs(rl.c(b),c,a);return I.g(ps(Mm.c(b),new R(null,1,5,S,[a],null),!1,Mk),rl,c)}
function ws(b){var a=H(b,0);b=Ne(b,1);var c=q(Rk.c(a));if(c){var a=qs(a,Mc(c),us.c?us.c(a):us.call(null,a)),c=B(c),d=ss(a,b,c);return r(d)?d:Dd.j(b,a,F([vs(a,c)],0))}c=us.c?us.c(a):us.call(null,a);d=Qm.c(a);c=q(c)?pf.b(d,c):d;return Dd.b(b,I.j(a,Tk,Vj,F([Qm,c],0)))}function xs(b,a,c,d,e){var f=de(d)?xf(Sf,d):d,h=Id(f,rl),f=Id(f,Mm),k=Jd(Id(h,Pl),b,0);return E.b(rl.c(Id(Kl.c(f),b)),k)?Dd.b(e,d):ws(Dd.j(e,d,F([new m(null,7,[Tk,rl,Mm,f,Pm,b,Pj,a,Rk,c,rl,h,Qm,$b(Ed)],null)],0)))}
var ys=function(b){return function(a,c,d,e,f){a=rs(rl.c(a),d,c);return I.g(ps(b,f,e,d),rl,a)}}(new Mr(!0,je,null,null,null));
function zs(b,a,c,d,e,f,h,k){var l=H(k,0),p=Ne(k,1),n=Jd(h,ek,1E3),t=Ff(r(n)?O.g(Ed,eg(n),f):f);if(r(t)){var y=$p(b,c),v=y&&cq(b,c,Yk),D=r(e)?cq(b,c,am):!v,z=r(e)?function(){return function(a){return a.v}}(y,v,D,n,t,k,l,p):function(){return function(a){return a.e}}(y,v,D,n,t,k,l,p);if(ge(h,Nl))return Dd.j(p,l,F([ps(Nl.c(h),qg(z,t),D,a)],0));if(ge(h,rl))return xs(a,D,qg(z,t),l,p);if(r(v?e:v))return Dd.j(p,l,F([ys(l,d,a,D,qg(z,t))],0));var L=function(){return y?Mf.b(function(){return function(a){return Md([Hl],
[a])}}(z,y,v,D,z,n,t,k,l,p),z):z}(),V=!D;return Dd.b(p,Ag(l,jm,vf,a,function(){var a=O.g(Ed,dg.c(L),t);return V?B(a):a}()))}return Dd.b(p,ge(h,mk)?Ag(l,jm,vf,a,mk.c(h)):l)}var As=ng(function(b){var a=H(b,0);b=H(b,1);return Ef.b(a,Pm.c(b))});function Bs(b,a,c){return ps(I.j(Mm.c(b),Kl,c,F([cm,!1],0)),new R(null,1,5,S,[a],null),!1,Nj)}function Cs(b,a){return Dd.b(Mc(b),zg(B(b),jm,ns,bc(a)))}function Ds(b){var a=H(b,0);b=Ne(b,1);var c=Jj.c(a),a=ts(Nj,a);return Cs(b,ns(c,r(a)?a:je))}
function Es(b,a){var c=H(a,0),d=Ne(a,1),e=q(om.c(c));if(e){var f=B(e),e=H(f,0),f=H(f,1),h=Jd(ug(c,new R(null,2,5,S,[Mm,Kl],null)),e,je);return zs(b,e,e,Yl.c(c),!0,f,h,Dd.b(d,yg(c,om,Mc)))}e=Ff(O.g(je,As,ug(c,new R(null,2,5,S,[Mm,Kl],null))));return r(e)?(c=I.j(c,Tk,Nk,F([Jj,jm.c(c),jm,$b(je)],0)),Dd.j(d,c,F([Bs(c,Yl.c(c),e)],0))):Cs(d,jm.c(c))}
function Fs(b,a,c,d,e){var f=rj(function(a){return a.a},yp(b,el,new R(null,1,5,S,[d],null))),h=de(a)?xf(Sf,a):a,k=Id(h,Pm),h=Id(h,rl),k=null!=k?rs(h,k,d):h;return Es(b,Dd.j(c,a,F([new m(null,6,[Tk,gm,jm,nf(new m(null,1,[Hl,d],null)),Yl,d,Mm,e,om,q(f),rl,k],null)],0)))}
function Gs(b,a){for(;;){var c=a,d=H(c,0),e=Ne(c,1);if(c=q(Rk.c(d))){if(r(cm.c(d))){var f=b,d=I.j(d,Dl,Ed,F([Yl,B(c),cm,!1],0)),c=e,h=de(d)?xf(Sf,d):d,e=Id(h,Yl),h=Id(h,Mm),k=ss(d,c,e);return r(k)?k:Fs(f,d,c,e,h)}if(f=q(Dl.c(d))){h=f;f=B(h);Mm.c(d);e=Dd.b(e,I.g(d,Dl,Mc(h)));d=b;h=f;c=B(c);f=H(h,0);h=H(h,1);if(E.b(Hl,f))d=r(Ff(yp(d,el,new R(null,1,5,S,[c],null))))?Dd.b(Mc(e),Ag(B(e),jm,vf,Hl,c)):e;else var k=Pm.c(h),l=E.b(f,k),p=l?yp(d,el,new R(null,2,5,S,[c,k],null)):yp(d,wk,new R(null,2,5,S,[k,c],
null)),d=zs(d,f,k,c,l,p,h,e);return d}f=b;d=Dd.b(e,qs(d,Mc(c),Ff(of(jm.c(d)))));b=f;a=d}else return Dd.b(e,I.g(d,Tk,Vj))}}
function Hs(b,a){for(;;)switch(Tk.c(B(a))instanceof K?Tk.c(B(a)).U:null){case "expand":var c=b,d=Es(b,a);b=c;a=d;continue;case "expand-rev":c=b;d=Ds(a);b=c;a=d;continue;case "pattern":c=b;d=Gs(b,a);b=c;a=d;continue;case "recursion":c=b;d=ws(a);b=c;a=d;continue;case "done":var c=a,e=H(c,0),f=Ne(c,1),h=function(){var a=of(Qm.c(e));return Ka(Pj.c(e))?B(a):a}();if(q(f)){c=b;d=Dd.b(Mc(f),function(){var a=B(f);return r(h)?Ag(a,jm,vf,Pm.c(e),h):a}());b=c;a=d;continue}else return h;default:throw Error([u("No matching clause: "),
u(Tk.c(B(a)))].join(""));}}function Is(b,a,c,d){c=O.g(Ed,dg.c(function(a){return aq(b,a)}),c);return Hs(b,cb(Nc,os(a,c,d)))}function Js(b,a,c){return Is(b,ms(a),new R(null,1,5,S,[c],null),!1)}function Ks(b,a,c){return Is(b,ms(a),c,!0)};var Ls=function Ls(a){if(a?a.Fd:a)return a.Fd();var c;c=Ls[ba(null==a?null:a)];if(!c&&(c=Ls._,!c))throw Qa("PushbackReader.read-char",a);return c.call(null,a)},Ms=function Ms(a,c){if(a?a.Gd:a)return a.Gd(0,c);var d;d=Ms[ba(null==a?null:a)];if(!d&&(d=Ms._,!d))throw Qa("PushbackReader.unread",a);return d.call(null,a,c)};function Ns(b,a,c){this.Y=b;this.buffer=a;this.Na=c}Ns.prototype.Fd=function(){return 0===this.buffer.length?(this.Na+=1,this.Y[this.Na]):this.buffer.pop()};
Ns.prototype.Gd=function(b,a){return this.buffer.push(a)};function Os(b){var a=!/[^\t\n\r ]/.test(b);return r(a)?a:","===b}function Ps(b,a){var c;!(c=!/[^0-9]/.test(a))&&(c="+"===a||"-"===a)&&(c=Ls(b),Ms(b,c),c=!/[^0-9]/.test(c));return c}function Qs(b){throw Error(xf(u,b));}function Rs(b,a){for(var c=new la(a),d=Ls(b);;){var e;if(!(e=null==d||Os(d))){e=d;var f="#"!==e;e=f?(f="'"!==e)?(f=":"!==e)?Ss.c?Ss.c(e):Ss.call(null,e):f:f:f}if(e)return Ms(b,d),c.toString();c.append(d);d=Ls(b)}}
function Ts(b){for(;;){var a=Ls(b);if("\n"===a||"\r"===a||null==a)return b}}var Us=Oi("^([-+]?)(?:(0)|([1-9][0-9]*)|0[xX]([0-9A-Fa-f]+)|0([0-7]+)|([1-9][0-9]?)[rR]([0-9A-Za-z]+))(N)?$"),Vs=Oi("^([-+]?[0-9]+)/([0-9]+)$"),Ws=Oi("^([-+]?[0-9]+(\\.[0-9]*)?([eE][-+]?[0-9]+)?)(M)?$"),Xs=Oi("^[:]?([^0-9/].*/)?([^0-9/][^/]*)$");function Ys(b,a){var c=b.exec(a);return null!=c&&c[0]===a?1===c.length?c[0]:c:null}
function Zs(b){if(r(Ys(Us,b))){b=Ys(Us,b);var a=b[2];if(null!=(E.b(a,"")?null:a))b=0;else{var a=r(b[3])?[b[3],10]:r(b[4])?[b[4],16]:r(b[5])?[b[5],8]:r(b[6])?[b[7],parseInt(b[6],10)]:[null,null],c=a[0];null==c?b=null:(a=parseInt(c,a[1]),b="-"===b[1]?-a:a)}}else r(Ys(Vs,b))?(b=Ys(Vs,b),b=parseInt(b[1],10)/parseInt(b[2],10)):b=r(Ys(Ws,b))?parseFloat(b):null;return b}var $s=Oi("^[0-9A-Fa-f]{2}$"),ft=Oi("^[0-9A-Fa-f]{4}$");
function gt(b,a,c){return r(Mi(b,c))?c:Qs(F(["Unexpected unicode escape \\",a,c],0))}function ht(b){return String.fromCharCode(parseInt(b,16))}
function it(b){var a=Ls(b),c="t"===a?"\t":"r"===a?"\r":"n"===a?"\n":"\\"===a?"\\":'"'===a?'"':"b"===a?"\b":"f"===a?"\f":null;r(c)?a=c:"x"===a?(b=(new la(Ls(b),Ls(b))).toString(),a=ht(gt($s,a,b))):"u"===a?(b=(new la(Ls(b),Ls(b),Ls(b),Ls(b))).toString(),a=ht(gt(ft,a,b))):a=/[^0-9]/.test(a)?Qs(F(["Unexpected unicode escape \\",a],0)):String.fromCharCode(a);return a}function jt(b){for(var a=Ls(b);;){var c;c=a;c=Os.c?Os.c(c):Os.call(null,c);if(r(c))a=Ls(b);else return a}}
function kt(b,a){for(var c=$b(Ed);;){var d=jt(a);r(d)||Qs(F(["EOF while reading"],0));if(b===d)return bc(c);var e=function(){var a=d;return Ss.c?Ss.c(a):Ss.call(null,a)}();if(r(e))var f=e,e=function(){var b=d;return f.b?f.b(a,b):f.call(null,a,b)}();else Ms(a,d),e=lt.S?lt.S(a,!0,null,!0):lt.call(null,a,!0,null);c=e===a?c:pf.b(c,e)}}function mt(b,a){return Qs(F(["Reader for ",a," not implemented yet"],0))}
function nt(b,a){var c=Ls(b),d=ot.c?ot.c(c):ot.call(null,c);if(r(d))return d.b?d.b(b,a):d.call(null,b,a);d=pt.b?pt.b(b,c):pt.call(null,b,c);return r(d)?d:Qs(F(["No dispatch macro for ",c],0))}function qt(b,a){return Qs(F(["Unmatched delimiter ",a],0))}function rt(b){return xf(Ve,kt(")",b))}function st(b){return kt("]",b)}function tt(b){b=kt("}",b);Jf(G(b))&&Qs(F(["Map literal must contain an even number of forms"],0));return xf(Sf,b)}
function Kt(b,a){for(var c=new la(a),d=Ls(b);;){if(r(function(){var a=null==d;if(a||(a=Os(d)))return a;a=d;return Ss.c?Ss.c(a):Ss.call(null,a)}())){Ms(b,d);var e=c.toString(),c=Zs(e);return r(c)?c:Qs(F(["Invalid number format [",e,"]"],0))}c.append(d);d=e=Ls(b)}}function Lt(b){for(var a=new la,c=Ls(b);;){if(null==c)return Qs(F(["EOF while reading"],0));if("\\"===c)a.append(it(b));else{if('"'===c)return a.toString();a.append(c)}c=Ls(b)}}
function Mt(b){for(var a=new la,c=Ls(b);;){if(null==c)return Qs(F(["EOF while reading"],0));if("\\"===c){a.append(c);var d=Ls(b);if(null==d)return Qs(F(["EOF while reading"],0));var e=function(){var b=a;b.append(d);return b}(),f=Ls(b)}else{if('"'===c)return a.toString();e=function(){var b=a;b.append(c);return b}();f=Ls(b)}a=e;c=f}}
function Nt(b,a){var c=Rs(b,a),d=-1!=c.indexOf("/");r(r(d)?1!==c.length:d)?c=Kc(c.substring(0,c.indexOf("/")),c.substring(c.indexOf("/")+1,c.length)):(d=Ic(c),c="nil"===c?null:"true"===c?!0:"false"===c?!1:"/"===c?new A(null,"/","/",-1371932971,null):d);return c}
function Ot(b){b=Rs(b,Ls(b));var a=Ys(Xs,b);b=a[0];var c=a[1],a=a[2];return void 0!==c&&":/"===c.substring(c.length-2,c.length)||":"===a[a.length-1]||-1!==b.indexOf("::",1)?Qs(F(["Invalid token: ",b],0)):null!=c&&0<c.length?Ze.b(c.substring(0,c.indexOf("/")),a):Ze.c(b)}function Pt(b){return function(a){return cb(cb(Nc,lt.S?lt.S(a,!0,null,!0):lt.call(null,a,!0,null)),b)}}function Qt(){return function(){return Qs(F(["Unreadable form"],0))}}
function Rt(b){var a;a=lt.S?lt.S(b,!0,null,!0):lt.call(null,b,!0,null);a=a instanceof A?new m(null,1,[Vl,a],null):"string"===typeof a?new m(null,1,[Vl,a],null):a instanceof K?new th([a,!0]):a;Yd(a)||Qs(F(["Metadata must be Symbol,Keyword,String or Map"],0));return((b=lt.S?lt.S(b,!0,null,!0):lt.call(null,b,!0,null))?b.m&262144||b.fe||(b.m?0:La(Hb,b)):La(Hb,b))?wd(b,ti.j(F([Rd(b),a],0))):Qs(F(["Metadata can only be applied to IWithMetas"],0))}function St(b){return zi(kt("}",b))}
function Tt(b){return Oi(Mt(b))}function Ut(b){lt.S?lt.S(b,!0,null,!0):lt.call(null,b,!0,null);return b}function Ss(b){return'"'===b?Lt:":"===b?Ot:";"===b?Ts:"'"===b?Pt(new A(null,"quote","quote",1377916282,null)):"@"===b?Pt(new A(null,"deref","deref",1494944732,null)):"^"===b?Rt:"`"===b?mt:"~"===b?mt:"("===b?rt:")"===b?qt:"["===b?st:"]"===b?qt:"{"===b?tt:"}"===b?qt:"\\"===b?Ls:"#"===b?nt:null}function ot(b){return"{"===b?St:"\x3c"===b?Qt():'"'===b?Tt:"!"===b?Ts:"_"===b?Ut:null}
function lt(b,a,c){for(;;){var d=Ls(b);if(null==d)return r(a)?Qs(F(["EOF while reading"],0)):c;if(!Os(d))if(";"===d){var e=function(){var a=b,c=d;return Ts.b?Ts.b(a,c):Ts.call(null,a)}();b=e}else{var f=Ss(d),e=r(f)?function(){var a=b,c=d;return f.b?f.b(a,c):f.call(null,a,c)}():Ps(b,d)?Kt(b,d):Nt(b,d);if(e!==b)return e}}}
var Vt=function(b,a){return function(c,d){return Id(r(d)?a:b,c)}}(new R(null,13,5,S,[null,31,28,31,30,31,30,31,31,30,31,30,31],null),new R(null,13,5,S,[null,31,29,31,30,31,30,31,31,30,31,30,31],null)),Wt=/(\d\d\d\d)(?:-(\d\d)(?:-(\d\d)(?:[T](\d\d)(?::(\d\d)(?::(\d\d)(?:[.](\d+))?)?)?)?)?)?(?:[Z]|([-+])(\d\d):(\d\d))?/;function Xt(b){b=parseInt(b,10);return Ka(isNaN(b))?b:null}
function Yt(b,a,c,d){b<=a&&a<=c||Qs(F([[u(d),u(" Failed:  "),u(b),u("\x3c\x3d"),u(a),u("\x3c\x3d"),u(c)].join("")],0));return a}
function Zt(b){var a=Mi(Wt,b);H(a,0);var c=H(a,1),d=H(a,2),e=H(a,3),f=H(a,4),h=H(a,5),k=H(a,6),l=H(a,7),p=H(a,8),n=H(a,9),t=H(a,10);if(Ka(a))return Qs(F([[u("Unrecognized date/time syntax: "),u(b)].join("")],0));var y=Xt(c),v=function(){var a=Xt(d);return r(a)?a:1}();b=function(){var a=Xt(e);return r(a)?a:1}();var a=function(){var a=Xt(f);return r(a)?a:0}(),c=function(){var a=Xt(h);return r(a)?a:0}(),D=function(){var a=Xt(k);return r(a)?a:0}(),z=function(){var a;a:if(E.b(3,G(l)))a=l;else if(3<G(l))a=
l.substring(0,3);else for(a=new la(l);;)if(3>a.Jb.length)a=a.append("0");else{a=a.toString();break a}a=Xt(a);return r(a)?a:0}(),p=(E.b(p,"-")?-1:1)*(60*function(){var a=Xt(n);return r(a)?a:0}()+function(){var a=Xt(t);return r(a)?a:0}());return new R(null,8,5,S,[y,Yt(1,v,12,"timestamp month field must be in range 1..12"),Yt(1,b,function(){var a;a=0===Ie(y,4);r(a)&&(a=Ka(0===Ie(y,100)),a=r(a)?a:0===Ie(y,400));return Vt.b?Vt.b(v,a):Vt.call(null,v,a)}(),"timestamp day field must be in range 1..last day in month"),
Yt(0,a,23,"timestamp hour field must be in range 0..23"),Yt(0,c,59,"timestamp minute field must be in range 0..59"),Yt(0,D,E.b(c,59)?60:59,"timestamp second field must be in range 0..60"),Yt(0,z,999,"timestamp millisecond field must be in range 0..999"),p],null)}
var $t,au=new m(null,4,["inst",function(b){var a;if("string"===typeof b)if(a=Zt(b),r(a)){b=H(a,0);var c=H(a,1),d=H(a,2),e=H(a,3),f=H(a,4),h=H(a,5),k=H(a,6);a=H(a,7);a=new Date(Date.UTC(b,c-1,d,e,f,h,k)-6E4*a)}else a=Qs(F([[u("Unrecognized date/time syntax: "),u(b)].join("")],0));else a=Qs(F(["Instance literal expects a string for its timestamp."],0));return a},"uuid",function(b){return"string"===typeof b?new sj(b,null):Qs(F(["UUID literal expects a string as its representation."],0))},"queue",function(b){return Zd(b)?
O.b(eh,b):Qs(F(["Queue literal expects a vector for its elements."],0))},"js",function(b){if(Zd(b)){var a=[];b=q(b);for(var c=null,d=0,e=0;;)if(e<d){var f=c.R(null,e);a.push(f);e+=1}else if(b=q(b))c=b,$d(c)?(b=hc(c),e=ic(c),c=b,d=G(b),b=e):(b=B(c),a.push(b),b=C(c),c=null,d=0),e=0;else break;return a}if(Yd(b)){a={};b=q(b);c=null;for(e=d=0;;)if(e<d){var h=c.R(null,e),f=H(h,0),h=H(h,1);a[$e(f)]=h;e+=1}else if(b=q(b))$d(b)?(d=hc(b),b=ic(b),c=d,d=G(d)):(d=B(b),c=H(d,0),d=H(d,1),a[$e(c)]=d,b=C(b),c=null,
d=0),e=0;else break;return a}return Qs(F([[u("JS literal expects a vector or map containing "),u("only string or unqualified keyword keys")].join("")],0))}],null);$t=Rf?Rf(au):Qf.call(null,au);var bu=Rf?Rf(null):Qf.call(null,null);
function pt(b,a){var c=Nt(b,a),d=Id($c.c?$c.c($t):$c.call(null,$t),""+u(c)),e=$c.c?$c.c(bu):$c.call(null,bu);return r(d)?(c=lt(b,!0,null),d.c?d.c(c):d.call(null,c)):r(e)?(d=lt(b,!0,null),e.b?e.b(c,d):e.call(null,c,d)):Qs(F(["Could not find tag parser for ",""+u(c)," in ",U(F([ph($c.c?$c.c($t):$c.call(null,$t))],0))],0))}function cu(b,a){var c=""+u(b);Id($c.c?$c.c($t):$c.call(null,$t),c);Vf.S($t,I,c,a)};function du(b,a){var c;c="number"===typeof a||Wd(a)?dq(b,a):null;if(r(c)){var d=Zf(!1),e=Zf(je);return eu.S?eu.S(b,c,d,e):eu.call(null,b,c,d,e)}return null}function fu(b,a,c){return cq(b,a,am)?$p(b,a)?w(function(a,c){return Dd.b(a,du(b,Rj.c(c)))},le,c):w(function(a,b){return Dd.b(a,Rj.c(b))},le,c):$p(b,a)?du(b,Rj.c(B(c))):Rj.c(B(c))}
function gu(b,a,c,d){a=Ff(xp(b,new R(null,3,5,S,[null,c,a],null)));return r(a)?cq(b,c,Yk)?du(b,al.c(B(a))):w(function(){return function(a,c){return Dd.b(a,du(b,al.c(c)))}}(a,a),le,a):d}function hu(b){return r(b)?qe(b):null}
function iu(b){ju.c?ju.c(b):ju.call(null,b);return function c(d){return new af(null,function(){for(;;){var e=q(d);if(e){if($d(e)){var f=hc(e),h=G(f),k=ef(h);a:for(var l=0;;)if(l<h){var p=x.b(f,l),n=H(p,0),p=H(p,1),n=cq(b.db,n,am)?new R(null,2,5,S,[n,hu(p)],null):new R(null,2,5,S,[n,p],null);k.add(n);l+=1}else{f=!0;break a}return f?gf(jf(k),c(ic(e))):gf(jf(k),null)}f=B(e);k=H(f,0);f=H(f,1);return td(cq(b.db,k,am)?new R(null,2,5,S,[k,hu(f)],null):new R(null,2,5,S,[k,f],null),c(Mc(e)))}return null}},
null,null)}(function(){var c=b.Kb;return $c.c?$c.c(c):$c.call(null,c)}())}function ku(b,a,c,d){this.db=b;this.eid=a;this.nd=c;this.Kb=d;this.m=2162164483;this.B=0}g=ku.prototype;g.entry_set=function(){return qe(dg.b(qe,iu(this)))};
g.forEach=function(){function b(a,b){for(var c=q(iu(this)),h=null,k=0,l=0;;)if(l<k){var p=h.R(null,l),n=H(p,0),p=H(p,1);a.call(b,p,n,this);l+=1}else if(c=q(c))$d(c)?(h=hc(c),c=ic(c),n=h,k=G(h),h=n):(h=B(c),n=H(h,0),p=H(h,1),a.call(b,p,n,this),c=C(c),h=null,k=0),l=0;else return null}function a(a){for(var b=q(iu(this)),c=null,h=0,k=0;;)if(k<h){var l=c.R(null,k),p=H(l,0),l=H(l,1);a.g?a.g(l,p,this):a.call(null,l,p,this);k+=1}else if(b=q(b))$d(b)?(c=hc(b),b=ic(b),p=c,h=G(c),c=p):(c=B(b),p=H(c,0),c=l=H(c,
1),a.g?a.g(c,p,this):a.call(null,c,p,this),b=C(b),c=null,h=0),k=0;else return null}var c=null,c=function(c,e){switch(arguments.length){case 1:return a.call(this,c);case 2:return b.call(this,c,e)}throw Error("Invalid arity: "+arguments.length);};c.c=a;c.b=b;return c}();g.get=function(b){if(E.b(b,":db/id"))return this.eid;if(lq(b))return hu(gu(this.db,this.eid,mq(b),null));var a=lu?lu(this,b):mu.call(null,this,b);return cq(this.db,b,am)?hu(a):a};g.key_set=function(){return qe(ph(this))};g.entries=function(){return jh(iu(this))};
g.value_set=function(){return qe(dg.b(Ad,iu(this)))};g.toString=function(){return pc(this)};g.keys=function(){return Qc(ph(this))};g.values=function(){return Qc(dg.b(Ad,iu(this)))};g.equiv=function(b){return nu.b?nu.b(this,b):nu.call(null,this,b)};g.has=function(b){return null!=this.get(b)};g.u=function(b,a){return nu.b?nu.b(this,a):nu.call(null,this,a)};g.J=function(){return Cc(this.eid)};g.K=function(){ju.c?ju.c(this):ju.call(null,this);var b=q,a;a=this.Kb;a=$c.c?$c.c(a):$c.call(null,a);return b(a)};
g.O=function(){ju.c?ju.c(this):ju.call(null,this);var b;b=this.Kb;b=$c.c?$c.c(b):$c.call(null,b);return G(b)};g.D=function(b,a){return ou?ou(this,a,null):mu.call(null,this,a,null)};g.C=function(b,a,c){return ou?ou(this,a,c):mu.call(null,this,a,c)};g.Vb=function(b,a){return Ef.b(Ml,ou?ou(this,a,Ml):mu.call(null,this,a,Ml))};
g.call=function(){function b(a,b,c){return ou?ou(this,b,c):mu.call(null,this,b,c)}function a(a,b){return lu?lu(this,b):mu.call(null,this,b)}var c=null,c=function(c,e,f){switch(arguments.length){case 2:return a.call(this,0,e);case 3:return b.call(this,0,e,f)}throw Error("Invalid arity: "+arguments.length);};c.b=a;c.g=b;return c}();g.apply=function(b,a){return this.call.apply(this,[this].concat(Va(a)))};g.c=function(b){return lu?lu(this,b):mu.call(null,this,b)};
g.b=function(b,a){return ou?ou(this,b,a):mu.call(null,this,b,a)};g.H=function(b,a,c){var d=this;return Yb(I.g(function(){var a=d.Kb;return $c.c?$c.c(a):$c.call(null,a)}(),Hl,d.eid),a,c)};function eu(b,a,c,d){return new ku(b,a,c,d)}function nu(b,a){return a instanceof ku&&E.b(b.eid,a.eid)}
function mu(){switch(arguments.length){case 2:return lu(arguments[0],arguments[1]);case 3:return ou(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}function lu(b,a){return ou(b,a,null)}
function ou(b,a,c){if(E.b(a,Hl))return b.eid;if(lq(a))return gu(b.db,b.eid,mq(a),c);var d=function(){var a=b.Kb;return $c.c?$c.c(a):$c.call(null,a)}().call(null,a);if(r(d))return d;if(r(function(){var a=b.nd;return $c.c?$c.c(a):$c.call(null,a)}()))return c;d=Ff(xp(b.db,new R(null,2,5,S,[b.eid,a],null)));r(d)&&(c=fu(b.db,a,d),$f(b.Kb,I.g(function(){var a=b.Kb;return $c.c?$c.c(a):$c.call(null,a)}(),a,c)));return c}
function pu(b,a){return ue(function(a,d,e){return I.g(a,d,cq(b,d,Yk)?cq(b,d,am)?zi(dg.b(ju,e)):ju.c?ju.c(e):ju.call(null,e):e)},je,a)}function qu(b,a){return w(function(a,d){var e=nm.c(B(d));return I.g(a,e,fu(b,e,d))},je,Ki(nm,a))}function ju(b){var a;a=b.nd;a=$c.c?$c.c(a):$c.call(null,a);r(a)||(a=Ff(xp(b.db,new R(null,1,5,S,[b.eid],null))),r(a)&&(a=pu(b.db,qu(b.db,a)),mc(b.Kb,a),mc(b.nd,!0)));return b}ia("datascript.impl.entity.Entity.prototype.get",ku.prototype.get);
ia("datascript.impl.entity.Entity.prototype.has",ku.prototype.has);ia("datascript.impl.entity.Entity.prototype.forEach",ku.prototype.forEach);ia("datascript.impl.entity.Entity.prototype.key_set",ku.prototype.key_set);ia("datascript.impl.entity.Entity.prototype.value_set",ku.prototype.value_set);ia("datascript.impl.entity.Entity.prototype.entry_set",ku.prototype.entry_set);ia("datascript.impl.entity.Entity.prototype.keys",ku.prototype.keys);ia("datascript.impl.entity.Entity.prototype.values",ku.prototype.values);
ia("datascript.impl.entity.Entity.prototype.entries",ku.prototype.entries);ia("cljs.core.ES6Iterator.prototype.next",Pc.prototype.next);ia("cljs.core.ES6EntriesIterator.prototype.next",ih.prototype.next);function ru(b,a,c,d,e,f){this.Tb=b;this.Ub=a;this.rules=c;this.h=d;this.f=e;this.i=f;this.m=2229667594;this.B=8192}g=ru.prototype;g.D=function(b,a){return nb.g(this,a,null)};g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "rels":return this.Tb;case "sources":return this.Ub;case "rules":return this.rules;default:return Jd(this.f,a,c)}};
g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.query.Context{",", ","}",c,N.b(new R(null,3,5,S,[new R(null,2,5,S,[ll,this.Tb],null),new R(null,2,5,S,[xk,this.Ub],null),new R(null,2,5,S,[bl,this.rules],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 3+G(this.f)};g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};
g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,3,[xk,null,bl,null,ll,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new ru(this.Tb,this.Ub,this.rules,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(ll,a):M.call(null,ll,a))?new ru(c,this.Ub,this.rules,this.h,this.f,null):r(M.b?M.b(xk,a):M.call(null,xk,a))?new ru(this.Tb,c,this.rules,this.h,this.f,null):r(M.b?M.b(bl,a):M.call(null,bl,a))?new ru(this.Tb,this.Ub,c,this.h,this.f,null):new ru(this.Tb,this.Ub,this.rules,this.h,I.g(this.f,a,c),null)};
g.K=function(){return q(N.b(new R(null,3,5,S,[new R(null,2,5,S,[ll,this.Tb],null),new R(null,2,5,S,[xk,this.Ub],null),new R(null,2,5,S,[bl,this.rules],null)],null),this.f))};g.N=function(b,a){return new ru(this.Tb,this.Ub,this.rules,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};function su(b,a,c,d,e){this.Ba=b;this.ec=a;this.h=c;this.f=d;this.i=e;this.m=2229667594;this.B=8192}g=su.prototype;g.D=function(b,a){return nb.g(this,a,null)};
g.C=function(b,a,c){switch(a instanceof K?a.U:null){case "attrs":return this.Ba;case "tuples":return this.ec;default:return Jd(this.f,a,c)}};g.H=function(b,a,c){return T(a,function(){return function(b){return T(a,Ui,""," ","",c,b)}}(this),"#datascript.query.Relation{",", ","}",c,N.b(new R(null,2,5,S,[new R(null,2,5,S,[Kl,this.Ba],null),new R(null,2,5,S,[Dj,this.ec],null)],null),this.f))};g.M=function(){return this.h};g.O=function(){return 2+G(this.f)};
g.J=function(){var b=this.i;return null!=b?b:this.i=b=Pe(this)};g.u=function(b,a){var c;c=r(a)?(c=this.constructor===a.constructor)?hh(this,a):c:a;return r(c)?!0:!1};g.V=function(b,a){return ge(new ke(null,new m(null,2,[Dj,null,Kl,null],null),null),a)?Nd.b(wd(O.b(je,this),this.h),a):new su(this.Ba,this.ec,this.h,Ff(Nd.b(this.f,a)),null)};
g.T=function(b,a,c){return r(M.b?M.b(Kl,a):M.call(null,Kl,a))?new su(c,this.ec,this.h,this.f,null):r(M.b?M.b(Dj,a):M.call(null,Dj,a))?new su(this.Ba,c,this.h,this.f,null):new su(this.Ba,this.ec,this.h,I.g(this.f,a,c),null)};g.K=function(){return q(N.b(new R(null,2,5,S,[new R(null,2,5,S,[Kl,this.Ba],null),new R(null,2,5,S,[Dj,this.ec],null)],null),this.f))};g.N=function(b,a){return new su(this.Ba,this.ec,a,this.f,this.i)};g.P=function(b,a){return Zd(a)?qb(this,x.b(a,0),x.b(a,1)):w(cb,this,a)};
function tu(b,a){return wq.b(zi(ph(b)),zi(ph(a)))}function uu(b){return O.g(Ed,aj,b)}
var vu=function vu(a,c){return E.b(new A(null,"_","_",-1201019570,null),a)?!0:E.b(new R(null,1,5,S,[new A(null,"*","*",345799209,null)],null),a)?Wd(c):a instanceof A?E.b(c,a):Wd(a)?E.b(Cd(a),new A(null,"*","*",345799209,null))?Wd(c)&&Gf(function(a){var c=H(a,0);a=H(a,1);return vu(c,a)},dg.g(Tg,Ci(a),c)):Wd(c)&&E.b(G(c),G(a))&&Gf(function(a){var c=H(a,0);a=H(a,1);return vu(c,a)},dg.g(Tg,a,c)):a.c?a.c(c):a.call(null,c)};function wu(b){return b instanceof A&&E.b("$",B($e(b)))}
function xu(b){return b instanceof A&&E.b("?",B($e(b)))}function yu(b){return b instanceof K||"string"===typeof b}function zu(b){return vu(new R(null,2,5,S,[yu,new A(null,"_","_",-1201019570,null)],null),b)}
function Au(b,a,c){var d=Qn(1);wn(function(d){return function(){var f=function(){return function(a){return function(){function b(c){for(;;){var d;a:try{for(;;){var e=a(c);if(!M(e,X)){d=e;break a}}}catch(f){if(f instanceof Object)c[5]=f,Nn(c),d=X;else throw f;}if(!M(d,X))return d}}function c(){var a=[null,null,null,null,null,null,null,null,null,null];a[0]=d;a[1]=1;return a}var d=null,d=function(a){switch(arguments.length){case 0:return c.call(this);case 1:return b.call(this,a)}throw Error("Invalid arity: "+
arguments.length);};d.w=c;d.c=b;return d}()}(function(){return function(d){var e=d[1];if(1===e){var e=a,f=c;d[7]=f;d[8]=e;d[2]=null;d[1]=2;return X}return 2===e?(f=d[9],f=d[7],e=B(f),d[9]=e,d[1]=r(null==e)?4:5,X):3===e?(e=d[2],Ln(d,e)):4===e?(e=d[8],d[2]=e,d[1]=6,X):5===e?(f=d[9],e=d[8],e=b.b?b.b(e,f):b.call(null,e,f),Kn(d,7,e)):6===e?(e=d[2],d[2]=e,d[1]=3,X):7===e?(f=d[7],e=d[2],f=Mc(f),d[7]=f,d[8]=e,d[2]=null,d[1]=2,X):null}}(d),d)}(),h=function(){var a=f.w?f.w():f.call(null);a[6]=d;return a}();
return Jn(h)}}(d));return d}function Bu(b,a,c,d){var e=a.length,f=d.length,h;h=e+f;h=Ua?Array(h):Ta.call(null,h);for(var k=0;;)if(k<e)h[k]=b[a[k]],k+=1;else break;for(b=0;;)if(b<f)h[e+b]=c[d[b]],b+=1;else break;return h}function Cu(b,a){return new su(Kl.c(b),N.b(Dj.c(b),Dj.c(a)),null,null,null)}var Du=function Du(){switch(arguments.length){case 0:return Du.w();case 2:return Du.b(arguments[0],arguments[1]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};
Du.w=function(){return new su(je,new R(null,1,5,S,[Ua?[]:Ta.call(null,0)],null),null,null,null)};Du.b=function(b,a){var c=ph(Kl.c(b)),d=ph(Kl.c(a)),e=qe(dg.b(Kl.c(b),c)),f=qe(dg.b(Kl.c(a),d));return new su(Di(N.b(c,d),tg()),of(w(function(b,c,d,e){return function(f,t){return w(function(a,b,c,d){return function(a,b){return pf.b(a,Bu(t,c,b,d))}}(b,c,d,e),f,Dj.c(a))}}(c,d,e,f),$b(Ed),Dj.c(b))),null,null,null)};Du.G=2;
var Eu=function Eu(){return Eu.j(0<arguments.length?new Da(Array.prototype.slice.call(arguments,0),0):null)};Eu.j=function(b){var a=G(b);return Ef.b(fg(a/2,b),gg(a/2,b))};Eu.G=0;Eu.I=function(b){return Eu.j(q(b))};var Fu=function Fu(){return Fu.j(arguments[0],arguments[1],2<arguments.length?new Da(Array.prototype.slice.call(arguments,2),0):null)};Fu.j=function(b,a,c){return w(function(c,e){var f=B(xp(b,new R(null,2,5,S,[a,e],null)));r(f)?(f=Rj.c(f),f=new Yc(f)):f=null;return f},null,c)};Fu.G=2;
Fu.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return Fu.j(a,b,c)};
var Gu=Md([new A(null,"true?","true?",-1600332395,null),new A(null,"odd?","odd?",-1458588199,null),new A(null,"get-else","get-else",1312024065,null),new A(null,"\x3e\x3d","\x3e\x3d",1016916022,null),new A(null,"\x3e","\x3e",1085014381,null),new A(null,"get-some","get-some",409442058,null),new A(null,"nil?","nil?",1612038930,null),new A(null,"inc","inc",324505433,null),new A(null,"/","/",-1371932971,null),new A(null,"quot","quot",-1125214196,null),new A(null,"false?","false?",-1522377573,null),new A(null,
"identity","identity",-1007039734,null),new A(null,"-differ?","-differ?",1465687357,null),new A(null,"\x3c\x3d","\x3c\x3d",1244895369,null),new A(null,"\x3d","\x3d",-1501502141,null),new A(null,"min","min",2085523049,null),new A(null,"+","+",-740910886,null),new A(null,"missing?","missing?",-1710383910,null),new A(null,"ground","ground",-1460862835,null),new A(null,"\x3d\x3d","\x3d\x3d",-234118149,null),new A(null,"max","max",1701898075,null),new A(null,"*","*",345799209,null),new A(null,"zero?",
"zero?",325758897,null),new A(null,"!\x3d","!\x3d",-201205829,null),new A(null,"dec","dec",-766002333,null),new A(null,"vector","vector",-751469611,null),new A(null,"not\x3d","not\x3d",1466536204,null),new A(null,"str","str",-1564826950,null),new A(null,"\x3c","\x3c",993667236,null),new A(null,"-","-",-471816912,null),new A(null,"pos?","pos?",-244377722,null),new A(null,"mod","mod",1510044207,null),new A(null,"rem","rem",664046770,null),new A(null,"even?","even?",-1827825394,null),new A(null,"neg?",
"neg?",-1902175577,null)],[function(b){return!0===b},Jf,function(b,a,c,d){b=B(xp(b,new R(null,2,5,S,[a,c],null)));return r(b)?Rj.c(b):d},Ee,De,Fu,Ia,Xc,Ae,Je,function(b){return!1===b},ve,Eu,Ce,E,Ge,xe,function(b,a,c){return null==Id(du(b,a),c)},ve,Le,Fe,ze,function(b){return 0===b},Ef,function(b){return b-1},Tg,Ef,u,Be,ye,function(b){return 0<b},Ie,function(b,a){return b-a*Je(b,a)},If,Me]),Hu=function(){function b(b){var e=a(b);return c(function(){return function(a){return function k(b){return new af(null,
function(a){return function(){for(;;){var c=q(b);if(c){if($d(c)){var d=hc(c),e=G(d),f=ef(e);a:for(var D=0;;)if(D<e){var z=x.b(d,D)-a;f.add(z*z);D+=1}else{d=!0;break a}return d?gf(jf(f),k(ic(c))):gf(jf(f),null)}f=B(c)-a;return td(f*f,k(Mc(c)))}return null}}}(a),null,null)}}(e)(b)}())/G(b)}function a(a){return c(a)/G(a)}function c(a){return w(xe,0,a)}return Md([new A(null,"variance","variance",-1522424942,null),new A(null,"count","count",-514511684,null),new A(null,"median","median",-2084869638,null),
new A(null,"sum","sum",1777518341,null),new A(null,"min","min",2085523049,null),new A(null,"max","max",1701898075,null),new A(null,"count-distinct","count-distinct",-1566572514,null),new A(null,"distinct","distinct",-148347594,null),new A(null,"avg","avg",1837937727,null),new A(null,"stddev","stddev",775056588,null),new A(null,"rand","rand",-1745930995,null),new A(null,"sample","sample",1719555128,null)],[b,G,function(a){var b=pe(me,a);a=G(a);var c=a>>1,h=Hd(b,c);return If(a)?(h+Hd(b,c-1))/2:h},c,
function(){function a(b,c){return se(w(function(a,c){return G(a)<b?pe(fp,Dd.b(a,c)):0>fp(c,Cd(a))?pe(fp,Dd.b(Ci(a),c)):a},Ed,c))}function b(a){return w(function(a,b){return 0>fp(b,a)?b:a},B(a),C(a))}var c=null,c=function(c,f){switch(arguments.length){case 1:return b.call(this,c);case 2:return a.call(this,c,f)}throw Error("Invalid arity: "+arguments.length);};c.c=b;c.b=a;return c}(),function(){function a(b,c){return se(w(function(a,c){return G(a)<b?pe(fp,Dd.b(a,c)):0<fp(c,B(a))?pe(fp,Dd.b(C(a),c)):
a},Ed,c))}function b(a){return w(function(a,b){return 0<fp(b,a)?b:a},B(a),C(a))}var c=null,c=function(c,f){switch(arguments.length){case 1:return b.call(this,c);case 2:return a.call(this,c,f)}throw Error("Invalid arity: "+arguments.length);};c.c=b;c.b=a;return c}(),function(a){return G(Bi.c(a))},Mf.b(se,Bi),a,function(a){a=b(a);return Math.sqrt(a)},function(){function a(b,c){return se(lg(b,function(){return qj(c)}))}var b=null,b=function(b,c){switch(arguments.length){case 1:return qj(b);case 2:return a.call(this,
b,c)}throw Error("Invalid arity: "+arguments.length);};b.c=function(a){return qj(a)};b.b=a;return b}(),function(a,b){return se(fg(a,re(b)))}])}();function Iu(b){b="string"===typeof b?lt(new Ns(b,[],-1),!1,null):b;return rj(Bd,b)}function Ju(b){var a=ee.c?ee.c(b):ee.call(null,b);return r(a)?a:Ja.c?Ja.c(b):Ja.call(null,b)}function Ku(b){b=dg.b(vk,se(Bi.c(Br(b))));return new su(Di(b,tg()),Ed,null,null,null)}
var Lu=function Lu(a,c){if(a?a.wc:a)return a.wc(a,c);var d;d=Lu[ba(null==a?null:a)];if(!d&&(d=Lu._,!d))throw Qa("IBinding.in-\x3erel",a);return d.call(null,a,c)};Wq.prototype.wc=function(){return Du.w()};Xq.prototype.wc=function(b,a){return new su(new th([ug(this,new R(null,2,5,S,[Wj,vk],null)),0]),new R(null,1,5,S,[Ea(new R(null,1,5,S,[a],null))],null),null,null,null)};
Zq.prototype.wc=function(b,a){if(Ka(Ju(a)))throw uj([u("Cannot bind value "),u(U(F([a],0))),u(" to collection "),u(U(F([Hq(this)],0)))].join(""),new m(null,3,[Ol,zk,Bk,a,nl,Hq(this)],null));return Td(a)?Ku(this):te(Cu,dg.b(function(a){return function(b){return Lu(nl.c(a),b)}}(this),a))};
Yq.prototype.wc=function(b,a){if(Ka(Ju(a)))throw uj([u("Cannot bind value "),u(U(F([a],0))),u(" to tuple "),u(U(F([Hq(this)],0)))].join(""),new m(null,3,[Ol,zk,Bk,a,nl,Hq(this)],null));if(G(a)<G(tk.c(this)))throw uj([u("Not enough elements in a collection "),u(U(F([a],0))),u(" to bind tuple "),u(U(F([Hq(this)],0)))].join(""),new m(null,3,[Ol,zk,Bk,a,nl,Hq(this)],null));return te(Du,dg.g(function(){return function(a,b){return Lu(a,b)}}(this),tk.c(this),a))};
function Mu(b,a){var c=H(a,0),d=H(a,1);return c instanceof Xq&&Wj.c(c)instanceof Kq?xg.Z(b,new R(null,1,5,S,[xk],null),I,ug(c,new R(null,2,5,S,[Wj,vk],null)),d):c instanceof Xq&&Wj.c(c)instanceof Mq?I.g(b,bl,Iu(d)):xg.S(b,new R(null,1,5,S,[ll],null),Dd,Lu(c,d))}var Nu=null,Ou=null;function Pu(b,a){var c=b.c?b.c(a):b.call(null,a);return null!=Nu&&ge(Nu,a)?function(a){return function(b){b=b[a];return"number"===typeof b?b:dq(Ou,b)}}(c):function(a){return function(b){return b[a]}}(c)}
function Qu(b){return 1===G(b)?B(b):function(a){return function(b){return mf(a.map(function(){return function(a){return a.c?a.c(b):a.call(null,b)}}(a)))}}(qe(b))}function Ru(b,a){for(var c=a,d=$b(je);;){var e=B(c);if(r(e)){var f;f=e;f=b.c?b.c(f):b.call(null,f);c=C(c);d=vf.g(d,f,Dd.b(Jd(d,f,Nc),e))}else return bc(d)}}
function Su(b,a){var c=Dj.c(b),d=Dj.c(a),e=Kl.c(b),f=Kl.c(a),h=se(tu(Kl.c(b),Kl.c(a))),k=dg.b(function(a,b,c){return function(a){return Pu(c,a)}}(c,d,e,f,h),h),l=dg.b(function(a,b,c,d){return function(a){return Pu(d,a)}}(c,d,e,f,h,k),h),p=ph(e),n=se(xq.b(zi(ph(f)),zi(ph(e)))),t=qe(dg.b(e,p)),y=qe(dg.b(f,n)),v=Qu(k),D=Ru(v,c),z=Qu(l),c=of(w(function(a,b,c,d,e,f,k,h,l,p,n,t,v,y){return function(z,D){var jb=y.c?y.c(D):y.call(null,D),gb=Id(v,jb);return r(gb)?w(function(a,b,c,d,e,f,k,h,l,p,n,t,v,y){return function(a,
b){return pf.b(a,Bu(b,v,D,y))}}(gb,gb,jb,a,b,c,d,e,f,k,h,l,p,n,t,v,y),z,gb):z}}(c,d,e,f,h,k,l,p,n,t,y,v,D,z),$b(Ed),d));return new su(Di(N.b(p,n),tg()),c,null,null,null)}
function Vu(b,a){var c=Qn(1);wn(function(c){return function(){var e=function(){return function(a){return function(){function b(c){for(;;){var d;a:try{for(;;){var e=a(c);if(!M(e,X)){d=e;break a}}}catch(f){if(f instanceof Object)c[5]=f,Nn(c),d=X;else throw f;}if(!M(d,X))return d}}function c(){var a=[null,null,null,null,null,null,null,null];a[0]=d;a[1]=1;return a}var d=null,d=function(a){switch(arguments.length){case 0:return c.call(this);case 1:return b.call(this,a)}throw Error("Invalid arity: "+arguments.length);
};d.w=c;d.c=b;return d}()}(function(c){return function(d){var e=d[1];if(1===e){var f=d[7],n=qg(function(){return function(){return function(a){return a instanceof A?null:a}}(f,e,c)}(),a),t=xp(b,n);d[7]=n;return Kn(d,2,t)}if(2===e){var f=d[7],y=d[2],n=function(){return function(){return function(a){var b=H(a,0);H(a,1);return xu(b)}}(f,y,f,y,sh,e,c)}(),t=dg.g(Tg,a,new R(null,4,5,S,["e","a","v","tx"],null)),n=O.b(sh,og(n,t)),n=new su(n,y,null,null,null);return Ln(d,n)}return null}}(c),c)}(),f=function(){var a=
e.w?e.w():e.call(null);a[6]=c;return a}();return Jn(f)}}(c));return c}function Wu(b,a){var c=og(function(b){a:for(var c=a;;){var d=b;if(r(r(d)?c:d)){var d=B(b),k=B(c);if(k instanceof A||E.b(d,k))b=C(b),c=C(c);else{b=!1;break a}}else{b=!0;break a}}return b},b),d=O.b(je,og(function(){return function(a){var b=H(a,0);H(a,1);return xu(b)}}(c),dg.g(Tg,a,tg())));return new su(d,dg.b(qe,c),null,null,null)}
function Xu(b,a){var c=Qn(1);wn(function(c){return function(){var e=function(){return function(a){return function(){function b(c){for(;;){var d;a:try{for(;;){var e=a(c);if(!M(e,X)){d=e;break a}}}catch(f){if(f instanceof Object)c[5]=f,Nn(c),d=X;else throw f;}if(!M(d,X))return d}}function c(){var a=[null,null,null,null,null,null,null];a[0]=d;a[1]=1;return a}var d=null,d=function(a){switch(arguments.length){case 0:return c.call(this);case 1:return b.call(this,a)}throw Error("Invalid arity: "+arguments.length);
};d.w=c;d.c=b;return d}()}(function(){return function(c){var d=c[1];return 7===d?(c[1]=r(c[2])?8:9,X):20===d?(d=c[2],c[2]=d,c[1]=16,X):1===d?(c[1]=r(b)?2:3,X):4===d?(d=c[2],c[1]=r(d)?14:15,X):15===d?(c[1]=18,X):13===d?(d=c[2],c[2]=d,c[1]=10,X):6===d?(d=b.Id,c[2]=d,c[1]=7,X):17===d?(d=c[2],c[2]=d,c[1]=16,X):3===d?(d=La(wp,b),c[2]=d,c[1]=4,X):12===d?(c[2]=!1,c[1]=13,X):2===d?(c[1]=6,X):19===d?(c[2]=null,c[1]=20,X):11===d?(d=La(wp,b),c[2]=d,c[1]=13,X):9===d?(d=!b.Mb,c[1]=r(d)?11:12,X):5===d?(c[2]=null,
c[1]=7,X):14===d?(d=Vu(b,a),Kn(c,17,d)):16===d?(d=c[2],Ln(c,d)):10===d?(d=c[2],c[2]=d,c[1]=4,X):18===d?(d=Wu(b,a),c[2]=d,c[1]=20,X):8===d?(c[2]=!0,c[1]=10,X):null}}(c),c)}(),f=function(){var a=e.w?e.w():e.call(null);a[6]=c;return a}();return Jn(f)}}(c));return c}function Yu(b,a){for(var c=b,d=a,e=Ed;;){var f=B(c);if(r(f))r(Ff(tu(Kl.c(d),Kl.c(f))))?(c=C(c),d=Su(f,d)):(c=C(c),e=Dd.b(e,f));else return Dd.b(e,d)}}
function Zu(b,a){var c=Hf(function(b){return ge(Kl.c(b),a)?b:null},ll.c(b));if(r(c)){var d=B(Dj.c(c));return r(d)?d[Kl.c(c).call(null,a)]:null}return null}function $u(b,a){var c=og(function(b){return!Td(wq.b(zi(a),zi(ph(Kl.c(b)))))},ll.c(b)),d=te(Du,c);return new R(null,2,5,S,[xg.g(b,new R(null,1,5,S,[ll],null),function(a){return function(b){return pg(zi(a),b)}}(c,d)),d],null)}
function av(b,a,c,d){return function(e){var f=dg.b(function(c){if(c instanceof A){var d=Id(xk.c(b),c);return r(d)?d:e[Id(Kl.c(a),c)]}return c},d);return xf(c,f)}}
function bv(b,a){var c=H(a,0),d=H(c,0),e=Ne(c,1),f=function(){var a=Id(Gu,d);return r(a)?a:Zu(b,d)}(),h=$u(b,og(Gc,e)),k=H(h,0),l=H(h,1),p=r(f)?function(){return xg.g(l,new R(null,1,5,S,[Dj],null),function(a){return function(b){return og(a,b)}}(av(k,l,f,e),a,c,d,e,f,h,k,l))}():I.g(l,new R(null,1,5,S,[Dj],null),Ed);return xg.S(k,new R(null,1,5,S,[ll],null),Dd,p)}
function cv(b,a){var c=H(a,0),d=H(c,0),e=Ne(c,1),f=H(a,1),h=br(f),k=function(){var a=Id(Gu,d);return r(a)?a:Zu(b,d)}(),l=$u(b,og(Gc,e)),p=H(l,0),n=H(l,1),t=r(k)?function(){var b=av(p,n,k,e),t=Ff(Dj.c(n));return r(t)?te(Cu,dg.b(function(a,b,c,d,e,f,k,h,l,p,n,t,v){return function(a){var b=c.c?c.c(a):c.call(null,a),b=Lu(l,b);return Du.b(new su(Kl.c(v),new R(null,1,5,S,[a],null),null,null,null),b)}}(t,t,b,a,c,d,e,f,h,k,l,p,n),t)):Du.b(n,Ku(h))}():Du.b(I.g(n,new R(null,1,5,S,[Dj],null),Ed),Ku(h));return xg.S(p,
new R(null,1,5,S,[ll],null),Dd,t)}function dv(b,a){return Wd(a)&&ge(bl.c(b),r(wu(B(a)))?Ad(a):B(a))}var ev=Rf?Rf(0):Qf.call(null,0);
function fv(b,a){var c=H(b,0),d=Ne(b,1),e=Vf.b(ev,Xc),f=Id(bl.c(a),c);return function(a,b,c,d,e){return function y(f){return new af(null,function(a,b,c,d,e){return function(){for(;;){var k=q(f);if(k){var h=k;if($d(h)){var l=hc(h),p=G(l),n=ef(p);return function(){for(var f=0;;)if(f<p){var v=x.b(l,f),y=v,P=H(y,0),W=H(P,0),Q=Ne(P,1),ea=Ne(y,1),na=Di(Q,c);hf(n,Vo(function(a,b,c,d,e,f,k,h,l,p,n,v,y,z,D,J,L){return function(a){if(r(xu(a))){var b=k.c?k.c(a):k.call(null,a);return r(b)?b:Ic([u($e(a)),u("__auto__"),
u(L)].join(""))}return a}}(f,y,P,W,Q,ea,na,v,l,p,n,h,k,a,b,c,d,e),ea));f+=1}else return!0}()?gf(jf(n),y(ic(h))):gf(jf(n),null)}var W=B(h),Q=W,P=H(Q,0),ea=H(P,0),pa=Ne(P,1),na=Ne(Q,1),$a=Di(pa,c);return td(Vo(function(a,b,c,d,e,f,k,h,l,p,n,v,y){return function(a){if(r(xu(a))){var b=f.c?f.c(a):f.call(null,a);return r(b)?b:Ic([u($e(a)),u("__auto__"),u(y)].join(""))}return a}}(Q,P,ea,pa,na,$a,W,h,k,a,b,c,d,e),na),y(Mc(h)))}return null}}}(a,b,c,d,e),null,null)}}(b,c,d,e,f)(f)}
function gv(b,a){var c=pg(function(a){var b=H(a,0);a=H(a,1);return E.b(b,a)},dg.g(Tg,b,a));return new R(null,2,5,S,[dg.b(B,c),dg.b(Ad,c)],null)}
function hv(b,a){var c=H(b,0),d=Ne(b,1),e=Id(a,c);return function(a,b,c,d){return function n(e){return new af(null,function(a,b,c){return function(){for(;;){var a=q(e);if(a){if($d(a)){var b=hc(a),d=G(b),f=ef(d);a:for(var k=0;;)if(k<d){var h=x.b(b,k),l=gv(c,h),h=H(l,0),l=H(l,1),h=new R(null,1,5,S,[N.j(new R(null,1,5,S,[new A(null,"-differ?","-differ?",1465687357,null)],null),h,F([l],0))],null);f.add(h);k+=1}else{b=!0;break a}return b?gf(jf(f),n(ic(a))):gf(jf(f),null)}f=B(a);b=gv(c,f);f=H(b,0);b=H(b,
1);return td(new R(null,1,5,S,[N.j(new R(null,1,5,S,[new A(null,"-differ?","-differ?",1465687357,null)],null),f,F([b],0))],null),n(Mc(a)))}return null}}}(a,b,c,d),null,null)}}(b,c,d,e)(e)}function iv(b){var a=Rf?Rf(Ed):Qf.call(null,Ed);Vo(function(a){return function(b){r(xu.c?xu.c(b):xu.call(null,b))&&Vf.g(a,Dd,b);return b}}(a),b);return $c.c?$c.c(a):$c.call(null,a)}
function jv(b,a){var c=function(a){return function(b){b=H(b,0);H(b,0);b=Ne(b,1);return Gf(a,b)}}(zi(iv(b)));return new R(null,2,5,S,[og(c,a),pg(c,a)],null)}
function kv(b,a){var c=Qn(1);wn(function(c){return function(){var e=function(){return function(a){return function(){function b(c){for(;;){var d;a:try{for(;;){var e=a(c);if(!M(e,X)){d=e;break a}}}catch(f){if(f instanceof Object)c[5]=f,Nn(c),d=X;else throw f;}if(!M(d,X))return d}}function c(){var a=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];a[0]=d;a[1]=1;return a}var d=null,d=function(a){switch(arguments.length){case 0:return c.call(this);
case 1:return b.call(this,a)}throw Error("Invalid arity: "+arguments.length);};d.w=c;d.c=b;return d}()}(function(c){return function(d){var e=d[1];if(7===e){var f=d[7],n=d[8],t=d[9],y=Ck.c(f),v=function(){var a=n;return t.b?t.b(y,a):t.call(null,y,a)}();return Kn(d,10,v)}if(1===e){var D=d[10],z=d[11],t=d[9],L=og(xu,a),V=tg(),ta=Di(L,V),Na=function(){return function(a,b,c,d,e,f,h,k,l,p){return function(n,t){var v=Qn(1);wn(function(a,b,c,d,e,f,h,k,l,p,v){return function(){var y=function(){return function(a){return function(){function b(c){for(;;){var d;
a:try{for(;;){var e=a(c);if(!M(e,X)){d=e;break a}}}catch(f){if(f instanceof Object)c[5]=f,Nn(c),d=X;else throw f;}if(!M(d,X))return d}}function c(){var a=[null,null,null,null,null,null,null];a[0]=d;a[1]=1;return a}var d=null,d=function(a){switch(arguments.length){case 0:return c.call(this);case 1:return b.call(this,a)}throw Error("Invalid arity: "+arguments.length);};d.w=c;d.c=b;return d}()}(function(){return function(a){var b=a[1];return 1===b?(b=Au(lv,n,t),Kn(a,2,b)):2===b?(b=a[2],Ln(a,b)):null}}(a,
b,c,d,e,f,h,k,l,p,v),a,b,c,d,e,f,h,k,l,p,v)}(),z=function(){var b=y.w?y.w():y.call(null);b[6]=a;return b}();return Jn(z)}}(v,a,b,c,d,e,f,h,k,l,p));return v}}(L,ta,D,z,t,L,V,ta,e,c)}(),Ma=function(){return function(a,b,c,d,e,f,h,k,l,p,n,t){return function(v){return Hf(function(){return function(a){return Td(Dj.c(a))}}(a,b,c,d,e,f,h,k,l,p,n,t),ll.c(v))}}(L,ta,Na,D,z,t,L,V,ta,Na,e,c)}(),v=Md([fm,Ck,Tl,wj,vl],[Ed,b,new R(null,1,5,S,[a],null),sh,sh]),Fa=cb(Nc,v),J=new su(ta,Ed,null,null,null);d[12]=Ma;
d[10]=L;d[11]=ta;d[13]=Fa;d[9]=Na;d[14]=J;d[2]=null;d[1]=2;return X}if(4===e){var f=d[7],ib=d[15],Ma=d[12],D=d[10],z=d[11],Fa=d[13],t=d[9],W=d[16],J=d[14],Q=d[17],v=function(){return function(){return function(a){return Ka(dv(b,a))}}(D,z,t,Ma,Fa,J,f,f,f,ib,Ma,D,z,Fa,t,W,J,Q,e,c)}(),P=Tl.c(f),v=new R(null,2,5,S,[Gi(v,P),hg(v,P)],null),n=H(v,0),P=H(v,1),ea=H(P,0),pa=Ne(P,1);d[15]=ea;d[8]=n;d[18]=pa;d[16]=v;d[17]=P;d[1]=r(null==ea)?7:8;return X}if(15===e)return Fa=d[13],J=d[14],v=C(Fa),d[13]=v,d[14]=
J,d[2]=null,d[1]=2,X;if(13===e)return v=d[2],d[2]=v,d[1]=9,X;if(6===e)return v=d[2],d[2]=v,d[1]=3,X;if(17===e)return v=d[2],d[2]=v,d[1]=13,X;if(3===e)return v=d[2],Ln(d,v);if(12===e){var f=d[7],na=d[19],n=d[8],$a=d[20],t=d[9],v=N.b(n,na),P=Ck.c(f),P=t.b?t.b(P,v):t.call(null,P,v);d[20]=v;return Kn(d,14,P)}if(2===e)return f=d[7],Fa=d[13],v=B(Fa),d[7]=v,d[1]=r(v)?4:5,X;if(11===e)return Fa=d[13],J=d[14],P=C(Fa),v=J,d[13]=P,d[14]=v,d[2]=null,d[1]=2,X;if(9===e)return v=d[2],d[2]=v,d[1]=6,X;if(5===e)return J=
d[14],d[2]=J,d[1]=6,X;if(14===e){var Ma=d[12],lb=d[21],v=d[2],P=Ma.c?Ma.c(v):Ma.call(null,v);d[21]=v;d[1]=r(P)?15:16;return X}if(16===e){var f=d[7],ib=d[15],Ma=d[12],D=d[10],jb=d[22],na=d[19],n=d[8],gb=d[23],pa=d[18],$a=d[20],z=d[11],Fa=d[13],zb=d[24],t=d[9],ob=d[25],W=d[16],J=d[14],lb=d[21],Eb=d[26],Q=d[17],Lb=wj.c(f),Xb=wj.c(f),Dc=Jd(Xb,gb,Ed),Lc=Dd.b(Dc,jb),Ec=I.g(Lb,gb,Lc),Tc=fv(ib,b),v=function(){return function(a,b,c,d,e,f,h,k,l,p,n,t,v,y,z,D,J,L,P,V,W,Q,ea,ta,Fa,na,Tc,pa,Ma,bd,Na,id,Ec,vd,
Oc,nd,Dc,ib,$a,Tb,Lc,lb,qf,gb,ob,jb,zb,Lb,Eb,Xf,yc,Lg,Xb){return function Mg(xc){return new af(null,function(a,b,c,d,e,f,h,k,l,p,n,t,v){return function(){for(;;){var a=q(xc);if(a){if($d(a)){var b=hc(a),f=G(b),h=ef(f);a:for(var k=0;;)if(k<f){var l=x.b(b,k),l=new m(null,5,[fm,d,Ck,v,Tl,uu(F([l,c],0)),wj,e,vl,n],null);h.add(l);k+=1}else{b=!0;break a}return b?gf(jf(h),Mg(ic(a))):gf(jf(h),null)}h=B(a);return td(new m(null,5,[fm,d,Ck,v,Tl,uu(F([h,c],0)),wj,e,vl,n],null),Mg(Mc(a)))}return null}}}(a,b,c,
d,e,f,h,k,l,p,n,t,v,y,z,D,J,L,P,V,W,Q,ea,ta,Fa,na,Tc,pa,Ma,bd,Na,id,Ec,vd,Oc,nd,Dc,ib,$a,Tb,Lc,lb,qf,gb,ob,jb,zb,Lb,Eb,Xf,yc,Lg,Xb),null,null)}}(n,D,pa,$a,Ec,J,z,f,f,Ma,Eb,gb,lb,ib,Tc,t,jb,zb,ib,Q,na,Fa,W,ob,f,ib,Ma,D,jb,na,n,gb,pa,$a,z,Fa,zb,t,ob,W,J,lb,Eb,Q,Lb,Xb,Ed,Dc,Lc,Ec,Tc,e,c)}(),v=v.c?v.c(Tc):v.call(null,Tc),P=C(Fa),P=N.b(v,P),v=J;d[13]=P;d[14]=v;d[2]=null;d[1]=2;return X}if(10===e){var D=d[10],z=d[11],Fa=d[13],J=d[14],vd=d[2],v=function(){var a=D;return mv?mv(vd,a):nv.call(null,vd,a)}(),
P=new su(z,v,null,null,null),v=C(Fa),P=Cu(J,P);d[13]=v;d[14]=P;d[2]=null;d[1]=2;return X}if(8===e){var f=d[7],ib=d[15],Ma=d[12],D=d[10],jb=d[22],na=d[19],n=d[8],gb=d[23],pa=d[18],z=d[11],Fa=d[13],zb=d[24],t=d[9],ob=d[25],W=d[16],J=d[14],Eb=d[26],Q=d[17],id=H(ib,0),bd=Ne(ib,1),Oc=wj.c(f),nd=hv(ib,Oc),qf=fm.c(f),Lg=N.b(qf,n),Xf=vl.c(f),Tb=N.b(nd,Xf),xc=jv(Lg,Tb),yc=H(xc,0),cd=H(xc,1),v=Hf(function(){return function(){return function(a){return E.b(a,new R(null,1,5,S,[Ve(new A(null,"-differ?","-differ?",
1465687357,null))],null))}}(n,D,pa,J,z,f,f,Ma,cd,id,ib,t,bd,nd,ib,Q,yc,Fa,W,xc,f,ib,Ma,D,jb,na,n,gb,pa,z,Fa,zb,t,ob,W,J,Eb,Q,id,bd,Oc,nd,qf,Lg,Xf,Tb,xc,yc,cd,e,c)}(),yc);d[22]=bd;d[19]=yc;d[23]=id;d[24]=nd;d[25]=xc;d[26]=cd;d[1]=r(v)?11:12;return X}return null}}(c),c)}(),f=function(){var a=e.w?e.w():e.call(null);a[6]=c;return a}();return Jn(f)}}(c));return c}
function ov(b,a){if(b?r(r(null)?null:b.ed)||(b.Mb?0:La(Bp,b)):La(Bp,b)){var c=H(a,0),d=H(a,1),e=H(a,2),f=H(a,3);return Vg(new R(null,4,5,S,[r(zu(c))?aq(b,c):c,d,r(function(){if(r(e)){var a=yu(d);return r(a)?(a=$p(b,d))?zu(e):a:a}return e}())?aq(b,e):e,r(zu(f))?aq(b,f):f],null),0,G(a))}return a}
function lv(b,a){var c=Qn(1);wn(function(c){return function(){var e=function(){return function(a){return function(){function b(c){for(;;){var d;a:try{for(;;){var e=a(c);if(!M(e,X)){d=e;break a}}}catch(f){if(f instanceof Object)c[5]=f,Nn(c),d=X;else throw f;}if(!M(d,X))return d}}function c(){var a=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];a[0]=d;a[1]=1;return a}var d=null,d=function(a){switch(arguments.length){case 0:return c.call(this);case 1:return b.call(this,
a)}throw Error("Invalid arity: "+arguments.length);};d.w=c;d.c=b;return d}()}(function(){return function(c){var d=c[1];if(7===d)return d=c,d[2]=c[2],d[1]=4,X;if(20===d)return d=c[2],c[2]=d,c[1]=14,X;if(27===d){var e=d=c[8],f=c[7],n=H(f,0),t=H(f,1),d=H(f,2),f=H(f,3),n=r(xu(n))?Dd.b(le,n):le,n=r(xu(f))?Dd.b(n,f):n,f=xu(d),e=r(f)?Ka(xu(t))&&$p(e,t):f,d=r(e)?Dd.b(n,d):n;c[2]=d;c[1]=29;return X}if(1===d)return d=vu(new R(null,1,5,S,[new R(null,2,5,S,[Gc,new A(null,"*","*",345799209,null)],null)],null),
a),c[1]=r(d)?2:3,X;if(24===d)return d=c[8],c[2]=d,c[1]=26,X;if(4===d)return d=c[2],Ln(c,d);if(15===d)return c[2]=null,c[1]=17,X;if(21===d)return d=c[8],d=La(Bp,d),c[2]=d,c[1]=23,X;if(31===d)return d=Nu,e=Ou,c[9]=c[2],c[10]=e,c[11]=d,Nn(c),X;if(32===d)return e=c[12],c[4]=new Mn(null,null,31,30,c[4],null,null,null),d=xg.S(b,new R(null,1,5,S,[ll],null),Yu,e),c[2]=d,Nn(c),X;if(13===d)return d=c[8],d=La(Bp,d),c[2]=d,c[1]=14,X;if(22===d)return c[2]=!1,c[1]=23,X;if(29===d)return d=Nu=c[2],c[13]=d,c[2]=null,
c[1]=32,X;if(6===d)return d=vu(new R(null,1,5,S,[new A(null,"*","*",345799209,null)],null),a),c[1]=r(d)?8:9,X;if(28===d)return c[2]=null,c[1]=29,X;if(25===d)return c[2]=null,c[1]=26,X;if(17===d)return d=c[2],c[1]=r(d)?18:19,X;if(3===d)return d=vu(new R(null,2,5,S,[new R(null,2,5,S,[Gc,new A(null,"*","*",345799209,null)],null),new A(null,"_","_",-1201019570,null)],null),a),c[1]=r(d)?5:6,X;if(12===d)return c[1]=16,X;if(2===d)return d=bv(b,a),c[2]=d,c[1]=4,X;if(23===d)return d=c[2],c[2]=d,c[1]=20,X;
if(19===d)return d=c[8],d=!d.Mb,c[1]=r(d)?21:22,X;if(11===d)return d=c[8],e=c[2],c[12]=e,c[1]=r(d)?12:13,X;if(9===d)throw c=[u("No matching clause: "),u(a)].join(""),Error(c);return 5===d?(d=cv(b,a),c[2]=d,c[1]=7,X):14===d?(d=c[14],d=c[2],c[14]=d,c[1]=r(d)?24:25,X):26===d?(d=c[14],e=Ou=c[2],c[15]=e,c[1]=r(d)?27:28,X):16===d?(d=c[8],d=d.ed,c[2]=d,c[1]=17,X):30===d?(d=c[2],c[2]=d,c[1]=10,X):10===d?(d=c[2],c[2]=d,c[1]=7,X):18===d?(c[2]=!0,c[1]=20,X):8===d?(e=r(wu(B(a)))?a:N.b(new R(null,1,5,S,[new A(null,
"$","$",-1580747756,null)],null),a),d=H(e,0),e=Ne(e,1),t=xk.c(b),d=Id(t,d),e=ov(d,e),t=Xu(d,e),c[7]=e,c[8]=d,Kn(c,11,t)):null}}(c),c)}(),f=function(){var a=e.w?e.w():e.call(null);a[6]=c;return a}();return Jn(f)}}(c));return c}
function pv(b,a){var c=Qn(1);wn(function(c){return function(){var e=function(){return function(a){return function(){function b(c){for(;;){var d;a:try{for(;;){var e=a(c);if(!M(e,X)){d=e;break a}}}catch(f){if(f instanceof Object)c[5]=f,Nn(c),d=X;else throw f;}if(!M(d,X))return d}}function c(){var a=[null,null,null,null,null,null,null];a[0]=d;a[1]=1;return a}var d=null,d=function(a){switch(arguments.length){case 0:return c.call(this);case 1:return b.call(this,a)}throw Error("Invalid arity: "+arguments.length);
};d.w=c;d.c=b;return d}()}(function(){return function(c){var d=c[1];if(1===d)return d=dv(b,a),c[1]=r(d)?2:3,X;if(2===d)return d=B(a),d=wu(d),c[1]=r(d)?5:6,X;if(3===d)return d=lv(b,a),Kn(c,9,d);if(4===d)return d=c[2],Ln(c,d);if(5===d){var d=B(a),e=C(a),d=new R(null,2,5,S,[d,e],null);c[2]=d;c[1]=7;return X}return 6===d?(d=new R(null,2,5,S,[new A(null,"$","$",-1580747756,null),a],null),c[2]=d,c[1]=7,X):7===d?(d=c[2],e=H(d,0),d=H(d,1),e=ug(b,new R(null,2,5,S,[xk,e],null)),e=Md([new A(null,"$","$",-1580747756,
null)],[e]),e=I.g(b,xk,e),d=kv(e,d),Kn(c,8,d)):8===d?(d=xg.S(b,new R(null,1,5,S,[ll],null),Yu,c[2]),c[2]=d,c[1]=4,X):9===d?(d=c[2],c[2]=d,c[1]=4,X):null}}(c),c)}(),f=function(){var a=e.w?e.w():e.call(null);a[6]=c;return a}();return Jn(f)}}(c));return c}function nv(){switch(arguments.length){case 2:return mv(arguments[0],arguments[1]);case 3:return qv(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}}
function mv(b,a){var c=ll.c(b),d=qv,e;e=G(a);e=Ua?Array(e):Ta.call(null,e);return d(new R(null,1,5,S,[e],null),c,a)}
function qv(b,a,c){for(;;){var d=B(a);if(r(d)){var e=d,f=ui(Kl.c(e),c);if(Td(f))var h=b,k=C(a),l=c;else var p=qe(dg.b(function(a,b,c,d){return function(a){return Id(d,a)}}(b,a,c,f,e,d),c)),n=G(c),h=function(){return function(a,b,c,d,e,f,h,k){return function Ma(l){return new af(null,function(a,b,c,d,e,f,h,k){return function(){for(var p=l;;){var n=q(p);if(n){var t=n,v=B(t);if(n=q(function(a,b,c,d,e,f,h,k,l,p,n,t){return function nd(v){return new af(null,function(a,b,c,d,e,f,h,k,l){return function(){for(;;){var a=
q(v);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){for(var f=x.b(b,a),h=d,p=Va(e),n=0;;)if(n<l){var t=k[n];r(t)&&(p[n]=f[t]);n+=1}else break;h.add(p);a+=1}else return!0}()?gf(jf(d),nd(ic(a))):gf(jf(d),null)}var f=B(a);return td(function(){for(var a=Va(e),b=0;;)if(b<l){var c=k[b];r(c)&&(a[b]=f[c]);b+=1}else break;return a}(),nd(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,p,n,t),null,null)}}(p,a,b,c,v,t,n,d,e,f,h,k)(Dj.c(h))))return N.b(n,Ma(Mc(p)));p=Mc(p)}else return null}}}(a,
b,c,d,e,f,h,k),null,null)}}(b,a,c,p,n,f,e,d)(b)}(),k=C(a),l=c;b=h;a=k;c=l}else return b}}var rv=function rv(a,c){if(a?a.xc:a)return a.xc(a,c);var d;d=rv[ba(null==a?null:a)];if(!d&&(d=rv._,!d))throw Qa("IContextResolve.-context-resolve",a);return d.call(null,a,c)};Jq.prototype.xc=function(b,a){return Zu(a,this.symbol)};Kq.prototype.xc=function(b,a){return ug(a,new R(null,2,5,S,[xk,this.symbol],null))};Oq.prototype.xc=function(){return Id(Hu,this.symbol)};Nq.prototype.xc=function(){return this.value};
function sv(b,a,c){return sg(function(b,e,f){if(r(mr(b))){e=rv(Sj.c(b),a);b=dg.b(function(){return function(b){return rv(b,a)}}(e),Ci(xj.c(b)));var h=dg.b(function(){return function(a){return Hd(a,f)}}(e,b),c);return xf(e,N.b(b,new R(null,1,5,S,[h],null)))}return e},b,B(c))}function tv(b){var a=Kf(mr);return pg(Ia,dg.g(function(b,d){return r(a.c?a.c(b):a.call(null,b))?d:null},b,tg()))}
function uv(b,a,c){var d=tv(b),e=function(a){return function(b){return dg.b(function(){return function(a){return Hd(b,a)}}(a),a)}}(d);c=rj(e,c);return function(c,d,e){return function p(n){return new af(null,function(){return function(){for(;;){var c=q(n);if(c){if($d(c)){var d=hc(c),e=G(d),f=ef(e);a:for(var h=0;;)if(h<e){var k=x.b(d,h);H(k,0);k=H(k,1);k=sv(b,a,k);f.add(k);h+=1}else{d=!0;break a}return d?gf(jf(f),p(ic(c))):gf(jf(f),null)}f=B(c);H(f,0);f=H(f,1);return td(sv(b,a,f),p(Mc(c)))}return null}}}(c,
d,e),null,null)}}(d,e,c)(c)}var vv=function vv(a,c){if(a?a.yc:a)return a.yc(a,c);var d;d=vv[ba(null==a?null:a)];if(!d&&(d=vv._,!d))throw Qa("IPostProcess.-post-process",a);return d.call(null,a,c)};ir.prototype.yc=function(b,a){return a};jr.prototype.yc=function(b,a){return O.g(Ed,dg.c(B),a)};kr.prototype.yc=function(b,a){return Bd(a)};lr.prototype.yc=function(b,a){return B(a)};
function wv(b,a,c){return function(a){return function f(b){return new af(null,function(a){return function(){for(;;){var c=q(b);if(c){var d=c;if($d(d)){var n=hc(d),t=G(n),y=ef(t);return function(){for(var b=0;;)if(b<t){var f=x.b(n,b);hf(y,rg(function(){return function(a,b){if(r(a)){var c=H(a,0),d=H(a,1);return Is(c,d,new R(null,1,5,S,[b],null),!1)}return b}}(b,f,n,t,y,d,c,a),a,f));b+=1}else return!0}()?gf(jf(y),f(ic(d))):gf(jf(y),null)}var v=B(d);return td(rg(function(){return function(a,b){if(r(a)){var c=
H(a,0),d=H(a,1);return Is(c,d,new R(null,1,5,S,[b],null),!1)}return b}}(v,d,c,a),a,v),f(Mc(d)))}return null}}}(a),null,null)}}(function(){return function e(b){return new af(null,function(){for(;;){var c=q(b);if(c){if($d(c)){var k=hc(c),l=G(k),p=ef(l);a:for(var n=0;;)if(n<l){var t=x.b(k,n),t=r(nr(t))?new R(null,2,5,S,[rv(Vk.c(t),a),ms(rv(Mm.c(t),a))],null):null;p.add(t);n+=1}else{k=!0;break a}return k?gf(jf(p),e(ic(c))):gf(jf(p),null)}p=B(c);return td(r(nr(p))?new R(null,2,5,S,[rv(Vk.c(p),a),ms(rv(Mm.c(p),
a))],null):null,e(Mc(c)))}return null}},null,null)}(b)}())(c)}var xv=Zf(Kr(je,function(){a:for(var b=q(0<arguments.length?new Da(Array.prototype.slice.call(arguments,0),0):null),a=ni;;)if(b)var c=C(C(b)),a=I.g(a,B(b),Ad(b)),b=c;else break a;return a}(),je,0,100));
function yv(b){var a=Jd($c.c?$c.c(xv):$c.call(null,xv),b,null);if(r(a))return a;if(Yd(b))a=b;else if(Wd(b))a=Gr(b);else throw uj(""+u("Query should be a vector or a map"),new m(null,2,[Ol,Om,Ul,b],null));var c=a,a=pr(zj.c(c)),d=ul.c(c);if(r(d)){var e=Cq(Qq,d);if(r(e))d=e;else throw uj(""+u("Cannot parse :with clause, expected [ variable+ ]"),new m(null,2,[Ol,ql,Ul,d],null));}else d=null;var e=qm.b(c,new R(null,1,5,S,[new A(null,"$","$",-1580747756,null)],null)),f=Cq(qr,e);if(!r(f))throw uj(""+u("Cannot parse :in clause, expected (src-var | % | bind-scalar | bind-tuple | bind-coll | bind-rel)"),
new m(null,2,[Ol,yj,Ul,e],null));e=f;c=Qj.b(c,Ed);f=Cq(cg,c);if(!r(f))throw uj(""+u("Cannot parse :where clause, expected [clause+]"),new m(null,2,[Ol,fk,Ul,c],null));a=new m(null,4,[zj,a,ul,d,qm,e,Qj,f],null);a=new Fr(zj.c(a),ul.c(a),qm.c(a),Qj.c(a),null,Nd.j(a,zj,F([ul,qm,Qj],0)),null);Hr(a,b);mc(xv,I.g(Cb(xv),b,a));return a}var zv=function zv(){return zv.j(arguments[0],1<arguments.length?new Da(Array.prototype.slice.call(arguments,1),0):null)};
zv.j=function(b,a){var c=Qn(1);wn(function(c){return function(){var e=function(){return function(a){return function(){function b(c){for(;;){var d;a:try{for(;;){var e=a(c);if(!M(e,X)){d=e;break a}}}catch(f){if(f instanceof Object)c[5]=f,Nn(c),d=X;else throw f;}if(!M(d,X))return d}}function c(){var a=[null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];a[0]=d;a[1]=1;return a}var d=null,d=function(a){switch(arguments.length){case 0:return c.call(this);
case 1:return b.call(this,a)}throw Error("Invalid arity: "+arguments.length);};d.w=c;d.c=b;return d}()}(function(c){return function(d){var e=d[1];if(7===e){var f=d[7];d[2]=f;d[1]=8;return X}if(1===e){var n=d[8],t=d[9],y=d[10],v=d[11],D=d[12],z=yv(b),L=zj.c(z),V=hr(L),ta=mg(er,F([hr(L)],0)),Na=G(V),Ma=ul.c(z),Fa=dg.b(vk,Ma),J=N.b(ta,Fa),Fa=Wd(b);d[8]=ta;d[9]=Ma;d[10]=L;d[11]=z;d[13]=J;d[12]=V;d[14]=Na;d[1]=Fa?2:3;return X}if(4===e){var ib=d[15],W=d[16],v=d[11],Q=d[17],z=d[2],L=Qj.c(z),V=new ru(Ed,
sh,sh,null,null,null),ta=qm.c(v),V=w(Mu,V,Di(ta,a)),ta=Au(pv,V,L);d[15]=L;d[16]=V;d[17]=z;return Kn(d,5,ta)}return 15===e?(y=d[10],z=d[18],z=vv(y,z),d[2]=z,d[1]=17,X):13===e?(z=d[19],d[2]=z,d[1]=14,X):6===e?(ib=d[15],W=d[16],n=d[8],t=d[9],y=d[10],v=d[11],J=d[13],D=d[12],Na=d[14],Q=d[17],f=d[7],z=qg(function(){return function(a,b,c,d,e,f,h,k){return function(a){return se(Vg(a,0,k))}}(y,Q,D,f,f,v,n,Na,J,ib,t,W,ib,W,n,t,y,v,J,D,Na,Q,f,e,c)}(),f),d[2]=z,d[1]=8,X):17===e?(z=d[2],Ln(d,z)):3===e?(d[2]=b,
d[1]=4,X):12===e?(W=d[16],D=d[12],z=d[19],z=wv(D,W,z),d[2]=z,d[1]=14,X):2===e?(z=Gr(b),d[2]=z,d[1]=4,X):11===e?(D=d[12],z=d[2],L=Hf(nr,D),d[19]=z,d[1]=r(L)?12:13,X):9===e?(W=d[16],D=d[12],z=d[20],z=uv(D,W,z),d[2]=z,d[1]=11,X):5===e?(J=d[13],Q=d[17],f=zi(dg.b(se,mv(d[2],J))),z=ul.c(Q),d[7]=f,d[1]=r(z)?6:7,X):14===e?(z=d[2],d[18]=z,d[1]=15,X):16===e?(z=d[18],d[2]=z,d[1]=17,X):10===e?(z=d[20],d[2]=z,d[1]=11,X):8===e?(D=d[12],z=d[2],L=Hf(mr,D),d[20]=z,d[1]=r(L)?9:10,X):null}}(c),c)}(),f=function(){var a=
e.w?e.w():e.call(null);a[6]=c;return a}();return Jn(f)}}(c));return c};zv.G=1;zv.I=function(b){var a=B(b);b=C(b);return zv.j(a,b)};function Av(b){return b instanceof Op}function Bv(b,a,c){if(r(Av(b)))throw uj("Filtered DB cannot be modified",new m(null,1,[Ol,Wk],null));b=new m(null,5,[jl,b,ik,b,kl,Ed,Aj,je,$l,c],null);b=new bq(jl.c(b),ik.c(b),kl.c(b),Aj.c(b),$l.c(b),null,Nd.j(b,jl,F([ik,kl,Aj,$l],0)),null);return tq(b,a)}function Cv(b,a){return ik.c(Bv(b,a,null))}
var Dv=function Dv(){switch(arguments.length){case 2:return Dv.b(arguments[0],arguments[1]);case 3:return Dv.g(arguments[0],arguments[1],arguments[2]);case 4:return Dv.S(arguments[0],arguments[1],arguments[2],arguments[3]);case 5:return Dv.Z(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]);case 6:return Dv.ya(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4],arguments[5]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};
Dv.b=function(b,a){return yp(b,a,Ed)};Dv.g=function(b,a,c){return yp(b,a,new R(null,1,5,S,[c],null))};Dv.S=function(b,a,c,d){return yp(b,a,new R(null,2,5,S,[c,d],null))};Dv.Z=function(b,a,c,d,e){return yp(b,a,new R(null,3,5,S,[c,d,e],null))};Dv.ya=function(b,a,c,d,e,f){return yp(b,a,new R(null,4,5,S,[c,d,e,f],null))};Dv.G=6;
var Ev=function Ev(){switch(arguments.length){case 2:return Ev.b(arguments[0],arguments[1]);case 3:return Ev.g(arguments[0],arguments[1],arguments[2]);case 4:return Ev.S(arguments[0],arguments[1],arguments[2],arguments[3]);case 5:return Ev.Z(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]);case 6:return Ev.ya(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4],arguments[5]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};
Ev.b=function(b,a){return zp(b,a,Ed)};Ev.g=function(b,a,c){return zp(b,a,new R(null,1,5,S,[c],null))};Ev.S=function(b,a,c,d){return zp(b,a,new R(null,2,5,S,[c,d],null))};Ev.Z=function(b,a,c,d,e){return zp(b,a,new R(null,3,5,S,[c,d,e],null))};Ev.ya=function(b,a,c,d,e,f){return zp(b,a,new R(null,4,5,S,[c,d,e,f],null))};Ev.G=6;
function Fv(b,a,c){var d=Rf?Rf(null):Qf.call(null,null);Vf.b(b,function(b){return function(d){d=Bv(d,a,c);Uf.b?Uf.b(b,d):Uf.call(null,b,d);return ik.c(d)}}(d));return $c.c?$c.c(d):$c.call(null,d)}var Gv=function Gv(){switch(arguments.length){case 2:return Gv.b(arguments[0],arguments[1]);case 3:return Gv.g(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};Gv.b=function(b,a){return Gv.g(b,1*Math.random(),a)};
Gv.g=function(b,a,c){Vf.S(hm.c(Rd(b)),I,a,c);return a};Gv.G=3;
for(var Hv=q(new m(null,2,[new A("datascript","Datom","datascript/Datom",-901340080,null),function(b){return xf(cp,b)},new A("datascript","DB","datascript/DB",-487332776,null),function(b){var a=de(b)?xf(Sf,b):b,c=Id(a,Bj),d=Id(a,om);return Yp(dg.b(function(){return function(a){var b=H(a,0),c=H(a,1),d=H(a,2);a=H(a,3);return new Xo(b,c,d,a,!0)}}(b,a,c,d),d),c)}],null)),Iv=null,Jv=0,Kv=0;;)if(Kv<Jv){var Lv=Iv.R(null,Kv),Mv=H(Lv,0),Nv=H(Lv,1);cu(Mv,Nv);Kv+=1}else{var Ov=q(Hv);if(Ov){var Pv=Ov;if($d(Pv))var Qv=
hc(Pv),Rv=ic(Pv),Sv=Qv,Tv=G(Qv),Hv=Rv,Iv=Sv,Jv=Tv;else{var Uv=B(Pv),Vv=H(Uv,0),Wv=H(Uv,1);cu(Vv,Wv);Hv=C(Pv);Iv=null;Jv=0}Kv=0}else break}Rf||Qf.call(null,-1E6);function Xv(b,a){var c=b.toString(16),d=G(c);return d>a?c.substring(0,a):d<a?[u(xf(u,jg(a-d,"0"))),u(c)].join(""):c};function Yv(b){return"string"===typeof b&&E.b(b.substring(0,1),":")?Ze.c(b.substring(1)):b}
function Zv(b){if(Yd(b))return I.g(Nd.b(b,":db/id"),Hl,b.c?b.c(":db/id"):b.call(null,":db/id"));if(E.b(B(b),":db.fn/call")){var a=H(b,0),c=H(b,1),d=Ne(b,2);return N.b(new R(null,2,5,S,[Zk,function(a,b,c){return function(){function a(c){var d=null;if(0<arguments.length){for(var d=0,e=Array(arguments.length-0);d<e.length;)e[d]=arguments[d+0],++d;d=new Da(e,0)}return b.call(this,d)}function b(a){a=xf(c,a);return $v.c?$v.c(a):$v.call(null,a)}a.G=0;a.I=function(a){a=q(a);return b(a)};a.j=b;return a}()}(b,
a,c,d)],null),d)}return Wd(b)?(a=H(b,0),b=Ne(b,1),N.b(new R(null,1,5,S,[Yv(a)],null),b)):null}function $v(b){return dg.b(Zv,nj(b))}function aw(b){return Ja(b)?new Xo(b[0],b[1],b[2],function(){var a=b[3];return r(a)?a:536870912}(),function(){var a=b[4];return r(a)?a:!0}()):new Xo(b.e,b.a,b.v,function(){var a=b.tx;return r(a)?a:536870912}(),function(){var a=b.added;return r(a)?a:!0}())}function bw(b){return ej(Vo(function(a){return a instanceof K?""+u(a):a},b))}
var cw=function cw(){return cw.j(0<arguments.length?new Da(Array.prototype.slice.call(arguments,0),0):null)};ia("datascript.js.empty_db",cw);cw.j=function(b){b=H(b,0);b=Vo(Yv,nj(b));return Jp?Jp(b):Kp.call(null,b)};cw.G=0;cw.I=function(b){return cw.j(q(b))};var dw=function dw(){return dw.j(arguments[0],1<arguments.length?new Da(Array.prototype.slice.call(arguments,1),0):null)};ia("datascript.js.init_db",dw);
dw.j=function(b,a){var c=H(a,0),d=dg.b(aw,b),c=Vo(Yv,nj(c));return Yp?Yp(d,c):Wp.call(null,d,c)};dw.G=1;dw.I=function(b){var a=B(b);b=C(b);return dw.j(a,b)};var ew=function ew(){return ew.j(arguments[0],arguments[1],2<arguments.length?new Da(Array.prototype.slice.call(arguments,2),0):null)};ia("datascript.js.q",ew);
ew.j=function(b,a,c){var d=Qn(1);wn(function(d){return function(){var f=function(){return function(a){return function(){function b(c){for(;;){var d;a:try{for(;;){var e=a(c);if(!M(e,X)){d=e;break a}}}catch(f){if(f instanceof Object)c[5]=f,Nn(c),d=X;else throw f;}if(!M(d,X))return d}}function c(){var a=[null,null,null,null,null,null,null];a[0]=d;a[1]=1;return a}var d=null,d=function(a){switch(arguments.length){case 0:return c.call(this);case 1:return b.call(this,a)}throw Error("Invalid arity: "+arguments.length);
};d.w=c;d.c=b;return d}()}(function(){return function(d){var e=d[1];return 1===e?(e=lt(new Ns(a,[],-1),!1,null),e=yf(zv,e,c),Kn(d,2,e)):2===e?(e=ej(d[2]),e=b.b?b.b(null,e):b.call(null,null,e),Ln(d,e)):null}}(d),d)}(),h=function(){var a=f.w?f.w():f.call(null);a[6]=d;return a}();return Jn(h)}}(d));return d};ew.G=2;ew.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return ew.j(a,b,c)};ia("datascript.js.pull",function(b,a,c){a=lt(new Ns(a,[],-1),!1,null);c=nj(c);b=Js.g?Js.g(b,a,c):Js.call(null,b,a,c);return bw(b)});
ia("datascript.js.pull_many",function(b,a,c){a=lt(new Ns(a,[],-1),!1,null);c=nj(c);b=Ks.g?Ks.g(b,a,c):Ks.call(null,b,a,c);return bw(b)});ia("datascript.js.db_with",function(b,a){return Cv(b,$v(a))});ia("datascript.js.entity",function(b,a){var c=nj(a);return du.b?du.b(b,c):du.call(null,b,c)});ia("datascript.js.touch",ju);ia("datascript.js.entity_db",function(b){return b.db});
ia("datascript.js.filter",function(b,a){if(r(Av(b))){var c=b.Fa;return new Op(c,function(b,c){return function(f){var h=a.b?a.b(c,f):a.call(null,c,f);return r(h)?b.Qa.call(null,f):h}}(b,c),null,null,null)}return new Op(b,function(c){return a.b?a.b(b,c):a.call(null,b,c)},null,null,null)});ia("datascript.js.is_filtered",Av);var fw=function fw(){return fw.j(0<arguments.length?new Da(Array.prototype.slice.call(arguments,0),0):null)};ia("datascript.js.create_conn",fw);
fw.j=function(b){b=H(b,0);b=Vo(Yv,nj(b));b=Jp?Jp(b):Kp.call(null,b);var a=new m(null,1,[hm,Rf?Rf(je):Qf.call(null,je)],null);return Qf.g?Qf.g(b,za,a):Qf.call(null,b,za,a)};fw.G=0;fw.I=function(b){return fw.j(q(b))};ia("datascript.js.db",function(b){return $c.c?$c.c(b):$c.call(null,b)});var gw=function gw(){return gw.j(arguments[0],arguments[1],2<arguments.length?new Da(Array.prototype.slice.call(arguments,2),0):null)};ia("datascript.js.transact",gw);
gw.j=function(b,a,c){c=H(c,0);a=$v(a);a=Fv(b,a,c);c=jl.c(a);for(var d=ik.c(a),e=Ea(kl.c(a)),f=Aj.c(a),h={},f=q(f),k=null,l=0,p=0;;)if(p<l){var n=k.R(null,p),t=H(n,0),n=H(n,1);h[""+u(t)]=n;p+=1}else if(f=q(f))$d(f)?(l=hc(f),f=ic(f),k=l,l=G(l)):(l=B(f),k=H(l,0),l=H(l,1),h[""+u(k)]=l,f=C(f),k=null,l=0),p=0;else break;a={db_before:c,db_after:d,tx_data:e,tempids:h,tx_meta:$l.c(a)};c=q;b=hm.c(Rd(b));b=$c.c?$c.c(b):$c.call(null,b);b=c(b);c=null;for(e=d=0;;)if(e<d)h=c.R(null,e),H(h,0),h=H(h,1),f=a,h.c?h.c(f):
h.call(null,f),e+=1;else if(b=q(b))$d(b)?(d=hc(b),b=ic(b),c=d,d=G(d)):(c=B(b),H(c,0),c=H(c,1),d=a,c.c?c.c(d):c.call(null,d),b=C(b),c=null,d=0),e=0;else break;return a};gw.G=2;gw.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return gw.j(a,b,c)};ia("datascript.js.listen",Gv);ia("datascript.js.unlisten",function(b,a){return Vf.g(hm.c(Rd(b)),Nd,a)});ia("datascript.js.resolve_tempid",function(b,a){return b[""+u(a)]});
var hw=function hw(){return hw.j(arguments[0],arguments[1],2<arguments.length?new Da(Array.prototype.slice.call(arguments,2),0):null)};ia("datascript.js.datoms",hw);hw.j=function(b,a,c){return Ea(zf(Dv,b,Yv(a),c))};hw.G=2;hw.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return hw.j(a,b,c)};var iw=function iw(){return iw.j(arguments[0],arguments[1],2<arguments.length?new Da(Array.prototype.slice.call(arguments,2),0):null)};ia("datascript.js.seek_datoms",iw);
iw.j=function(b,a,c){return Ea(zf(Ev,b,Yv(a),c))};iw.G=2;iw.I=function(b){var a=B(b),c=C(b);b=B(c);c=C(c);return iw.j(a,b,c)};ia("datascript.js.index_range",function(b,a,c,d){return Ea(Ap(b,a,c,d))});ia("datascript.js.squuid",function(){var b=u,a=[u(Xv((new Date).getTime()/1E3|0,8)),u("-"),u(Xv(pj(65536),4)),u("-"),u(Xv(pj(65536)&4095|16384,4)),u("-"),u(Xv(pj(65536)&16383|32768,4)),u("-"),u(Xv(pj(65536),4)),u(Xv(pj(65536),4)),u(Xv(pj(65536),4))].join("");return""+b(new sj(a,null))});
ia("datascript.js.squuid_time_millis",function(b){b=""+u(new sj(b,null));return 1E3*parseInt(b.substring(0,8),16)});var lw=function lw(){switch(arguments.length){case 2:return lw.b(arguments[0],arguments[1]);case 3:return lw.g(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};lw.b=function(b,a){return lw.g(b,a,a)};
lw.g=function(b,a,c){var d=Qn(null),e=function(a,b,c){return function(d){d=nj(d);d=dg.b(function(){return function(a){return xf(cp,a)}}(d,a,b,c),d);return Tn(c,d)}}(a,c,d);b.g?b.g(a,c,e):b.call(null,a,c,e);return d};lw.G=3;var mw=function mw(){switch(arguments.length){case 2:return mw.b(arguments[0],arguments[1]);case 3:return mw.g(arguments[0],arguments[1],arguments[2]);default:throw Error([u("Invalid arity: "),u(arguments.length)].join(""));}};mw.b=function(b,a){return mw.g(b,a,a)};
mw.g=function(b,a,c){var d=Qn(null),e=function(a,b,c){return function(d){d=nj(d);d=dg.b(function(){return function(a){return xf(cp,a)}}(d,a,b,c),d);return Tn(c,d)}}(a,c,d);b.g?b.g(a,c,e):b.call(null,a,c,e);return d};mw.G=3;ia("datascript.js.set_indexes",function(b,a){return Fp(new m(null,7,[Bj,null,el,Nf(lw,b),Zj,null,wk,Nf(mw,a),Pk,0,Oj,0,Zl,je],null))});Oa=function(){return Nc};Ca();function nw(b){var a=pe(me,b),c=G(b)-1;b=.5*G(b)|0;return Hd(a,c<b?c:b)}function ow(b){b=""+u(1<b?b.toFixed(1):.1<b?b.toFixed(2):.001<b?b.toFixed(4):1E-6<b?b.toFixed(7):b);return 6>=G(b)?[u(xf(u,jg(6-G(b)," "))),u(b)].join(""):b}function Z(){return Date.now()}function pw(){return new Date};var qw=process;Ca();var rw=Zf(0),sw=new m(null,1,[Qk,new m(null,2,[uk,Ak,El,am],null)],null),tw=kg(function(){return new m(null,6,[Hl,mc(rw,Cb(rw)+1),yk,qj(new R(null,8,5,S,"Ivan Petr Sergei Oleg Yuri Dmitry Fedor Denis".split(" "),null)),Lj,qj(new R(null,6,5,S,"Ivanov Petrov Sidorov Kovalev Kuznetsov Voronoi".split(" "),null)),Yj,qj(new R(null,2,5,S,[hk,Cj],null)),Xj,pj(10),Nm,pj(1E5)],null)}),uw;uw=Mf.b(dg.c(function(b){return ue(function(a,c,d){return Dd.b(a,cp.g(Hl.c(b),c,d))},Ed,Nd.b(b,Hl))}),aj);
function vw(b,a){return Cv(Jp?Jp(sw):Kp.call(null,sw),ww(1,b,a))}function ww(b,a,c){if(0<a){var d=dg.b(function(a){return b*c+a},Ji(c));return N.b(dg.b(function(){return function(a){return new m(null,3,[Sl,b,yk,"Ivan",Qk,a],null)}}(d),d),mg(function(){return function(b){return ww(b,a-1,c)}}(d),F([d],0)))}return new R(null,1,5,S,[new m(null,2,[Hl,b,yk,"Ivan"],null)],null)}
function xw(b,a){return Cv(Jp?Jp(sw):Kp.call(null,sw),xf(N,function(){return function d(a){return new af(null,function(){for(var f=a;;){var h=q(f);if(h){var k=h,l=B(k);if(h=q(function(a,d,e,f){return function D(h){return new af(null,function(a,d){return function(){for(;;){var a=q(h);if(a){if($d(a)){var e=hc(a),f=G(e),k=ef(f);a:for(var l=0;;)if(l<f){var n=x.b(e,l),p=d*(b+1)+n+1;k.add(new R(null,2,5,S,[new m(null,3,[Hl,d*(b+1)+n,yk,"Ivan",Qk,p],null),new m(null,2,[Hl,p,yk,"Ivan"],null)],null));l+=1}else{e=
!0;break a}return e?gf(jf(k),D(ic(a))):gf(jf(k),null)}k=B(a);e=d*(b+1)+k+1;return td(new R(null,2,5,S,[new m(null,3,[Hl,d*(b+1)+k,yk,"Ivan",Qk,e],null),new m(null,2,[Hl,e,yk,"Ivan"],null)],null),D(Mc(a)))}return null}}}(a,d,e,f),null,null)}}(f,l,k,h)(Ji(b))))return N.b(h,d(Mc(f)));f=Mc(f)}else return null}},null,null)}(Ji(a))}()))}
function yw(){for(var b=q(new R(null,3,5,S,[100,500,2E3],null)),a=null,c=0,d=0;;)if(d<c){for(var e=a.R(null,d),f=q(new R(null,1,5,S,[1],null)),h=null,k=0,l=0;;)if(l<k){var p=h.R(null,l),n=Fi(p,p,fg(e,tw)),t=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[km,"db_with",dl,e,gl,p],null))].join("")],0)),y=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)w(Cv,Vp?Vp():Kp.call(null),n),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),v=O.b(Ed,function(){return function(a,b,c,d,e,f,h,
k,l,n,p,t,v){return function yc(y){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p){return function(){for(;;){var a=q(y);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l)w(Cv,Vp?Vp():Kp.call(null),p),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),yc(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=
0;;)if(10>d)w(Cv,Vp?Vp():Kp.call(null),p),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),yc(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v),null,null)}}(f,h,k,l,b,a,c,d,t,y,n,p,e)(Ji(5))}()),D=te(Ge,v),z=nw(v),L=te(Fe,v);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[km,"db_with",dl,e,gl,p],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,z,Gj,D,xl,L,lk,v],null)],0)),"}"],0)):Zi(F(["[ min:",ow(D),"] [ med:",
ow(z),"] [ max:",ow(L),"] ms"],0));l+=1}else{var V=q(f);if(V){var ta=V;if($d(ta))z=hc(ta),v=ic(ta),D=z,z=G(z),f=v,h=D,k=z;else{var Na=B(ta),Ma=Fi(Na,Na,fg(e,tw)),Fa=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[km,"db_with",dl,e,gl,Na],null))].join("")],0)),J=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)w(Cv,Vp?Vp():Kp.call(null),Ma),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),v=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z){return function rf(D){return new af(null,
function(a,b,c,d,e,f,h,k,l,n,p){return function(){for(;;){var a=q(D);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l)w(Cv,Vp?Vp():Kp.call(null),p),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),rf(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d)w(Cv,Vp?Vp():Kp.call(null),p),d+=1;else break;
d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),rf(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z),null,null)}}(f,h,k,l,b,a,c,d,Fa,J,Ma,Na,ta,V,e)(Ji(5))}()),D=te(Ge,v),z=nw(v),L=te(Fe,v);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[km,"db_with",dl,e,gl,Na],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,z,Gj,D,xl,L,lk,v],null)],0)),"}"],0)):Zi(F(["[ min:",ow(D),"] [ med:",ow(z),"] [ max:",ow(L),"] ms"],0));f=C(ta);
h=null;k=0}l=0}else break}d+=1}else{var ib=q(b);if(ib){var W=ib;if($d(W))z=hc(W),v=ic(W),D=z,z=G(z),b=v,a=D,c=z;else{for(var e=B(W),Q=q(new R(null,1,5,S,[1],null)),P=null,ea=0,pa=0;;)if(pa<ea){var na=P.R(null,pa),$a=Fi(na,na,fg(e,tw)),lb=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[km,"db_with",dl,e,gl,na],null))].join("")],0)),jb=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)w(Cv,Vp?Vp():Kp.call(null),$a),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),v=O.b(Ed,function(){return function(a,
b,c,d,e,f,h,k,l,n,p,t,v,y,z){return function rf(D){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p){return function(){for(;;){var a=q(D);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l)w(Cv,Vp?Vp():Kp.call(null),p),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),rf(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,
c=10;;){for(var d=0;;)if(10>d)w(Cv,Vp?Vp():Kp.call(null),p),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),rf(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z),null,null)}}(Q,P,ea,pa,b,a,c,d,lb,jb,$a,na,e,W,ib)(Ji(5))}()),D=te(Ge,v),z=nw(v),L=te(Fe,v);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[km,"db_with",dl,e,gl,na],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,z,Gj,D,xl,L,lk,v],null)],0)),"}"],
0)):Zi(F(["[ min:",ow(D),"] [ med:",ow(z),"] [ max:",ow(L),"] ms"],0));pa+=1}else{var gb=q(Q);if(gb){var zb=gb;if($d(zb))z=hc(zb),v=ic(zb),D=z,z=G(z),Q=v,P=D,ea=z;else{var ob=B(zb),Eb=Fi(ob,ob,fg(e,tw)),Lb=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[km,"db_with",dl,e,gl,ob],null))].join("")],0)),Xb=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)w(Cv,Vp?Vp():Kp.call(null),Eb),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),v=O.b(Ed,function(){return function(a,b,c,d,e,f,
h,k,l,n,p,t,v,y,z,D,J){return function sf(L){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p){return function(){for(;;){var a=q(L);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l)w(Cv,Vp?Vp():Kp.call(null),p),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),sf(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=
0;;)if(10>d)w(Cv,Vp?Vp():Kp.call(null),p),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),sf(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J),null,null)}}(Q,P,ea,pa,b,a,c,d,Lb,Xb,Eb,ob,zb,gb,e,W,ib)(Ji(5))}()),D=te(Ge,v),z=nw(v),L=te(Fe,v);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[km,"db_with",dl,e,gl,ob],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,z,Gj,D,xl,L,lk,v],null)],0)),"}"],0)):
Zi(F(["[ min:",ow(D),"] [ med:",ow(z),"] [ max:",ow(L),"] ms"],0));Q=C(zb);P=null;ea=0}pa=0}else break}b=C(W);a=null;c=0}d=0}else return null}}ia("datascript.bench.bench_db_with",yw);
function zw(){for(var b=q(new R(null,5,5,S,[100,500,2E3,5E3,2E4],null)),a=null,c=0,d=0;;)if(d<c){var e=a.R(null,d),f=O.g(Ed,Mf.b(uw,eg(e)),tw),h=r(null)?null:Zi(F([[u("\n"),u(new m(null,2,[km,"init_db",dl,e],null))].join("")],0)),k=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){var e=f;Xp?Xp(e):Wp.call(null,e);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),l=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k){return function P(l){return new af(null,function(a,b,c,d,e,f,
h){return function(){for(;;){var a=q(l);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var k=1E3+f,l=10;;){for(var n=0;;)if(10>n){var p=h;Xp?Xp(p):Wp.call(null,p);n+=1}else break;n=Z();if(n<k)l=10+l;else{f=(n-f)/l;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),P(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){var e=h;Xp?Xp(e):Wp.call(null,e);d+=1}else break;d=Z();if(d<b)c=10+
c;else return(d-a)/c}}(),P(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k),null,null)}}(b,a,c,d,h,k,f,e)(Ji(5))}()),p=te(Ge,l),n=nw(l),t=te(Fe,l);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,2,[km,"init_db",dl,e],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,n,Gj,p,xl,t,lk,l],null)],0)),"}"],0)):Zi(F(["[ min:",ow(p),"] [ med:",ow(n),"] [ max:",ow(t),"] ms"],0));d+=1}else{var y=q(b);if(y){var v=y;if($d(v))n=hc(v),l=ic(v),p=
n,n=G(n),b=l,a=p,c=n;else{var e=B(v),D=O.g(Ed,Mf.b(uw,eg(e)),tw),z=r(null)?null:Zi(F([[u("\n"),u(new m(null,2,[km,"init_db",dl,e],null))].join("")],0)),L=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){var e=D;Xp?Xp(e):Wp.call(null,e);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),l=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n){return function pa(p){return new af(null,function(a,b,c,d,e,f,h){return function(){for(;;){var a=q(p);if(a){if($d(a)){var b=hc(a),c=G(b),
d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var k=1E3+f,l=10;;){for(var n=0;;)if(10>n){var p=h;Xp?Xp(p):Wp.call(null,p);n+=1}else break;n=Z();if(n<k)l=10+l;else{f=(n-f)/l;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),pa(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){var e=h;Xp?Xp(e):Wp.call(null,e);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),pa(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n),
null,null)}}(b,a,c,d,z,L,D,e,v,y)(Ji(5))}()),p=te(Ge,l),n=nw(l),t=te(Fe,l);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,2,[km,"init_db",dl,e],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,n,Gj,p,xl,t,lk,l],null)],0)),"}"],0)):Zi(F(["[ min:",ow(p),"] [ med:",ow(n),"] [ max:",ow(t),"] ms"],0));b=C(v);a=null;c=0}d=0}else return null}}ia("datascript.bench.bench_init_db",zw);
function Aw(){for(var b=q(new R(null,4,5,S,[new R(null,2,5,S,["q1",new R(null,4,5,S,[zj,new A(null,"?e","?e",-1194391683,null),Qj,new R(null,3,5,S,[new A(null,"?e","?e",-1194391683,null),yk,"Ivan"],null)],null)],null),new R(null,2,5,S,["q2",new R(null,6,5,S,[zj,new A(null,"?e","?e",-1194391683,null),new A(null,"?a","?a",1314302913,null),Qj,new R(null,3,5,S,[new A(null,"?e","?e",-1194391683,null),yk,"Ivan"],null),new R(null,3,5,S,[new A(null,"?e","?e",-1194391683,null),Xj,new A(null,"?a","?a",1314302913,
null)],null)],null)],null),new R(null,2,5,S,["q3",new R(null,7,5,S,[zj,new A(null,"?e","?e",-1194391683,null),new A(null,"?a","?a",1314302913,null),Qj,new R(null,3,5,S,[new A(null,"?e","?e",-1194391683,null),yk,"Ivan"],null),new R(null,3,5,S,[new A(null,"?e","?e",-1194391683,null),Xj,new A(null,"?a","?a",1314302913,null)],null),new R(null,3,5,S,[new A(null,"?e","?e",-1194391683,null),Yj,hk],null)],null)],null),new R(null,2,5,S,["q4",new R(null,9,5,S,[zj,new A(null,"?e","?e",-1194391683,null),new A(null,
"?l","?l",550795544,null),new A(null,"?a","?a",1314302913,null),Qj,new R(null,3,5,S,[new A(null,"?e","?e",-1194391683,null),yk,"Ivan"],null),new R(null,3,5,S,[new A(null,"?e","?e",-1194391683,null),Lj,new A(null,"?l","?l",550795544,null)],null),new R(null,3,5,S,[new A(null,"?e","?e",-1194391683,null),Xj,new A(null,"?a","?a",1314302913,null)],null),new R(null,3,5,S,[new A(null,"?e","?e",-1194391683,null),Yj,hk],null)],null)],null)],null)),a=null,c=0,d=0;;)if(d<c){for(var e=a.R(null,d),f=H(e,0),h=H(e,
1),k=q(new R(null,4,5,S,[100,500,2E3,2E4],null)),l=null,p=0,n=0;;)if(n<p){var t=l.R(null,n),y=Cv(Vp?Vp():Kp.call(null),fg(t,tw)),v=r(null)?null:Zi(F([[u("\n"),u(new m(null,2,[km,f,dl,t],null))].join("")],0)),D=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){var e=h,f=y;zv.b?zv.b(e,f):zv.call(null,e,f);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),z=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z){return function Gh(D){return new af(null,function(a,b,c,
d,e,f,h,k,l,n,p,t,v,y,z){return function(){for(;;){var a=q(D);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l){var n=z,t=p;zv.b?zv.b(n,t):zv.call(null,n,t);l+=1}else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Gh(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){var e=z,f=p;zv.b?zv.b(e,f):zv.call(null,
e,f);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Gh(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z),null,null)}}(k,l,p,n,b,a,c,d,v,D,y,t,e,f,h)(Ji(5))}()),L=te(Ge,z),V=nw(z),ta=te(Fe,z);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,2,[km,f,dl,t],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,V,Gj,L,xl,ta,lk,z],null)],0)),"}"],0)):Zi(F(["[ min:",ow(L),"] [ med:",ow(V),"] [ max:",ow(ta),"] ms"],0));
n+=1}else{var Na=q(k);if(Na){var Ma=Na;if($d(Ma))V=hc(Ma),z=ic(Ma),L=V,V=G(V),k=z,l=L,p=V;else{var Fa=B(Ma),J=Cv(Vp?Vp():Kp.call(null),fg(Fa,tw)),ib=r(null)?null:Zi(F([[u("\n"),u(new m(null,2,[km,f,dl,Fa],null))].join("")],0)),W=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){var e=h,f=J;zv.b?zv.b(e,f):zv.call(null,e,f);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),z=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J){return function tf(L){return new af(null,
function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J){return function(){for(;;){var a=q(L);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l){var n=J,t=p;zv.b?zv.b(n,t):zv.call(null,n,t);l+=1}else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),tf(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){var e=J,f=p;
zv.b?zv.b(e,f):zv.call(null,e,f);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),tf(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J),null,null)}}(k,l,p,n,b,a,c,d,ib,W,J,Fa,Ma,Na,e,f,h)(Ji(5))}()),L=te(Ge,z),V=nw(z),ta=te(Fe,z);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,2,[km,f,dl,Fa],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,V,Gj,L,xl,ta,lk,z],null)],0)),"}"],0)):Zi(F(["[ min:",ow(L),"] [ med:",
ow(V),"] [ max:",ow(ta),"] ms"],0));k=C(Ma);l=null;p=0}n=0}else break}d+=1}else{var Q=q(b);if(Q){var P=Q;if($d(P))V=hc(P),z=ic(P),L=V,V=G(V),b=z,a=L,c=V;else{for(var ea=B(P),f=H(ea,0),h=H(ea,1),pa=q(new R(null,4,5,S,[100,500,2E3,2E4],null)),na=null,$a=0,lb=0;;)if(lb<$a){var jb=na.R(null,lb),gb=Cv(Vp?Vp():Kp.call(null),fg(jb,tw)),zb=r(null)?null:Zi(F([[u("\n"),u(new m(null,2,[km,f,dl,jb],null))].join("")],0)),ob=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){var e=h,f=gb;zv.b?zv.b(e,
f):zv.call(null,e,f);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),z=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J){return function tf(L){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z){return function(){for(;;){var a=q(L);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l){var n=z,t=p;zv.b?zv.b(n,t):zv.call(null,n,t);l+=1}else break;l=Z();if(l<h)k=
10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),tf(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){var e=z,f=p;zv.b?zv.b(e,f):zv.call(null,e,f);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),tf(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J),null,null)}}(pa,na,$a,lb,b,a,c,d,zb,ob,gb,jb,ea,f,h,P,Q)(Ji(5))}()),L=te(Ge,z),V=nw(z),ta=te(Fe,z);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,
2,[km,f,dl,jb],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,V,Gj,L,xl,ta,lk,z],null)],0)),"}"],0)):Zi(F(["[ min:",ow(L),"] [ med:",ow(V),"] [ max:",ow(ta),"] ms"],0));lb+=1}else{var Eb=q(pa);if(Eb){var Lb=Eb;if($d(Lb))V=hc(Lb),z=ic(Lb),L=V,V=G(V),pa=z,na=L,$a=V;else{var Xb=B(Lb),Dc=Cv(Vp?Vp():Kp.call(null),fg(Xb,tw)),Lc=r(null)?null:Zi(F([[u("\n"),u(new m(null,2,[km,f,dl,Xb],null))].join("")],0)),Ec=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=
0;;)if(10>d){var e=h,f=Dc;zv.b?zv.b(e,f):zv.call(null,e,f);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),z=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P){return function Hh(Q){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J){return function(){for(;;){var a=q(Q);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l){var n=J,t=p;zv.b?zv.b(n,t):zv.call(null,
n,t);l+=1}else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Hh(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){var e=J,f=p;zv.b?zv.b(e,f):zv.call(null,e,f);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Hh(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P),null,null)}}(pa,na,$a,lb,b,a,c,d,Lc,Ec,Dc,Xb,Lb,Eb,ea,f,h,P,Q)(Ji(5))}()),L=te(Ge,z),V=nw(z),ta=te(Fe,z);r(null)?Zi(F(["{ :context",
U(F([null],0)),"\n  :spec   ",U(F([new m(null,2,[km,f,dl,Xb],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,V,Gj,L,xl,ta,lk,z],null)],0)),"}"],0)):Zi(F(["[ min:",ow(L),"] [ med:",ow(V),"] [ max:",ow(ta),"] ms"],0));pa=C(Lb);na=null;$a=0}lb=0}else break}b=C(P);a=null;c=0}d=0}else return null}}ia("datascript.bench.bench_queries",Aw);
function Bw(){for(var b=q(new R(null,7,5,S,[new R(null,2,5,S,["wide 3\u00d73",vw(3,3)],null),new R(null,2,5,S,["wide 5\u00d73",vw(5,3)],null),new R(null,2,5,S,["wide 7\u00d73",vw(7,3)],null),new R(null,2,5,S,["wide 4\u00d76",vw(4,6)],null),new R(null,2,5,S,["long 10\u00d73",xw(10,3)],null),new R(null,2,5,S,["long 30\u00d73",xw(30,3)],null),new R(null,2,5,S,["long 30\u00d75",xw(30,5)],null)],null)),a=null,c=0,d=0;;)if(d<c){var e=a.R(null,d),f=H(e,0),h=H(e,1),k=r(null)?null:Zi(F([[u("\n"),u(new m(null,
2,[km,"rules",Ul,f],null))].join("")],0)),l=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){var e=new R(null,8,5,S,[zj,new A(null,"?e","?e",-1194391683,null),new A(null,"?e2","?e2",-1790911809,null),qm,new A(null,"$","$",-1580747756,null),new A(null,"%","%",-950237169,null),Qj,Ve(new A(null,"follows","follows",883339250,null),new A(null,"?e","?e",-1194391683,null),new A(null,"?e2","?e2",-1790911809,null))],null),f=h,k=new R(null,2,5,S,[new R(null,2,5,S,[Ve(new A(null,"follows","follows",
883339250,null),new A(null,"?x","?x",-555096650,null),new A(null,"?y","?y",-1454470631,null)),new R(null,3,5,S,[new A(null,"?x","?x",-555096650,null),Qk,new A(null,"?y","?y",-1454470631,null)],null)],null),new R(null,3,5,S,[Ve(new A(null,"follows","follows",883339250,null),new A(null,"?x","?x",-555096650,null),new A(null,"?y","?y",-1454470631,null)),new R(null,3,5,S,[new A(null,"?x","?x",-555096650,null),Qk,new A(null,"?t","?t",1786819229,null)],null),Ve(new A(null,"follows","follows",883339250,null),
new A(null,"?t","?t",1786819229,null),new A(null,"?y","?y",-1454470631,null))],null)],null);zv.g?zv.g(e,f,k):zv.call(null,e,f,k);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),p=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l){return function pa(n){return new af(null,function(a,b,c,d,e,f,h,k,l){return function(){for(;;){var a=q(n);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var n=0;;)if(10>
n){var p=new R(null,8,5,S,[zj,new A(null,"?e","?e",-1194391683,null),new A(null,"?e2","?e2",-1790911809,null),qm,new A(null,"$","$",-1580747756,null),new A(null,"%","%",-950237169,null),Qj,Ve(new A(null,"follows","follows",883339250,null),new A(null,"?e","?e",-1194391683,null),new A(null,"?e2","?e2",-1790911809,null))],null),t=l,v=new R(null,2,5,S,[new R(null,2,5,S,[Ve(new A(null,"follows","follows",883339250,null),new A(null,"?x","?x",-555096650,null),new A(null,"?y","?y",-1454470631,null)),new R(null,
3,5,S,[new A(null,"?x","?x",-555096650,null),Qk,new A(null,"?y","?y",-1454470631,null)],null)],null),new R(null,3,5,S,[Ve(new A(null,"follows","follows",883339250,null),new A(null,"?x","?x",-555096650,null),new A(null,"?y","?y",-1454470631,null)),new R(null,3,5,S,[new A(null,"?x","?x",-555096650,null),Qk,new A(null,"?t","?t",1786819229,null)],null),Ve(new A(null,"follows","follows",883339250,null),new A(null,"?t","?t",1786819229,null),new A(null,"?y","?y",-1454470631,null))],null)],null);zv.g?zv.g(p,
t,v):zv.call(null,p,t,v);n+=1}else break;n=Z();if(n<h)k=10+k;else{f=(n-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),pa(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){var e=new R(null,8,5,S,[zj,new A(null,"?e","?e",-1194391683,null),new A(null,"?e2","?e2",-1790911809,null),qm,new A(null,"$","$",-1580747756,null),new A(null,"%","%",-950237169,null),Qj,Ve(new A(null,"follows","follows",883339250,null),new A(null,"?e","?e",-1194391683,null),
new A(null,"?e2","?e2",-1790911809,null))],null),f=l,h=new R(null,2,5,S,[new R(null,2,5,S,[Ve(new A(null,"follows","follows",883339250,null),new A(null,"?x","?x",-555096650,null),new A(null,"?y","?y",-1454470631,null)),new R(null,3,5,S,[new A(null,"?x","?x",-555096650,null),Qk,new A(null,"?y","?y",-1454470631,null)],null)],null),new R(null,3,5,S,[Ve(new A(null,"follows","follows",883339250,null),new A(null,"?x","?x",-555096650,null),new A(null,"?y","?y",-1454470631,null)),new R(null,3,5,S,[new A(null,
"?x","?x",-555096650,null),Qk,new A(null,"?t","?t",1786819229,null)],null),Ve(new A(null,"follows","follows",883339250,null),new A(null,"?t","?t",1786819229,null),new A(null,"?y","?y",-1454470631,null))],null)],null);zv.g?zv.g(e,f,h):zv.call(null,e,f,h);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),pa(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l),null,null)}}(b,a,c,d,k,l,e,f,h)(Ji(5))}()),n=te(Ge,p),t=nw(p),y=te(Fe,p);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,
2,[km,"rules",Ul,f],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,t,Gj,n,xl,y,lk,p],null)],0)),"}"],0)):Zi(F(["[ min:",ow(n),"] [ med:",ow(t),"] [ max:",ow(y),"] ms"],0));d+=1}else{var v=q(b);if(v){var D=v;if($d(D))t=hc(D),p=ic(D),n=t,t=G(t),b=p,a=n,c=t;else{var z=B(D),f=H(z,0),h=H(z,1),L=r(null)?null:Zi(F([[u("\n"),u(new m(null,2,[km,"rules",Ul,f],null))].join("")],0)),V=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){var e=
new R(null,8,5,S,[zj,new A(null,"?e","?e",-1194391683,null),new A(null,"?e2","?e2",-1790911809,null),qm,new A(null,"$","$",-1580747756,null),new A(null,"%","%",-950237169,null),Qj,Ve(new A(null,"follows","follows",883339250,null),new A(null,"?e","?e",-1194391683,null),new A(null,"?e2","?e2",-1790911809,null))],null),f=h,k=new R(null,2,5,S,[new R(null,2,5,S,[Ve(new A(null,"follows","follows",883339250,null),new A(null,"?x","?x",-555096650,null),new A(null,"?y","?y",-1454470631,null)),new R(null,3,
5,S,[new A(null,"?x","?x",-555096650,null),Qk,new A(null,"?y","?y",-1454470631,null)],null)],null),new R(null,3,5,S,[Ve(new A(null,"follows","follows",883339250,null),new A(null,"?x","?x",-555096650,null),new A(null,"?y","?y",-1454470631,null)),new R(null,3,5,S,[new A(null,"?x","?x",-555096650,null),Qk,new A(null,"?t","?t",1786819229,null)],null),Ve(new A(null,"follows","follows",883339250,null),new A(null,"?t","?t",1786819229,null),new A(null,"?y","?y",-1454470631,null))],null)],null);zv.g?zv.g(e,
f,k):zv.call(null,e,f,k);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),p=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p){return function $a(t){return new af(null,function(a,b,c,d,e,f,h,k,l){return function(){for(;;){var a=q(t);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var n=0;;)if(10>n){var p=new R(null,8,5,S,[zj,new A(null,"?e","?e",-1194391683,null),new A(null,"?e2","?e2",-1790911809,
null),qm,new A(null,"$","$",-1580747756,null),new A(null,"%","%",-950237169,null),Qj,Ve(new A(null,"follows","follows",883339250,null),new A(null,"?e","?e",-1194391683,null),new A(null,"?e2","?e2",-1790911809,null))],null),t=l,v=new R(null,2,5,S,[new R(null,2,5,S,[Ve(new A(null,"follows","follows",883339250,null),new A(null,"?x","?x",-555096650,null),new A(null,"?y","?y",-1454470631,null)),new R(null,3,5,S,[new A(null,"?x","?x",-555096650,null),Qk,new A(null,"?y","?y",-1454470631,null)],null)],null),
new R(null,3,5,S,[Ve(new A(null,"follows","follows",883339250,null),new A(null,"?x","?x",-555096650,null),new A(null,"?y","?y",-1454470631,null)),new R(null,3,5,S,[new A(null,"?x","?x",-555096650,null),Qk,new A(null,"?t","?t",1786819229,null)],null),Ve(new A(null,"follows","follows",883339250,null),new A(null,"?t","?t",1786819229,null),new A(null,"?y","?y",-1454470631,null))],null)],null);zv.g?zv.g(p,t,v):zv.call(null,p,t,v);n+=1}else break;n=Z();if(n<h)k=10+k;else{f=(n-f)/k;break a}}}e.add(f);a+=
1}else return!0}()?gf(jf(d),$a(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){var e=new R(null,8,5,S,[zj,new A(null,"?e","?e",-1194391683,null),new A(null,"?e2","?e2",-1790911809,null),qm,new A(null,"$","$",-1580747756,null),new A(null,"%","%",-950237169,null),Qj,Ve(new A(null,"follows","follows",883339250,null),new A(null,"?e","?e",-1194391683,null),new A(null,"?e2","?e2",-1790911809,null))],null),f=l,h=new R(null,2,5,S,[new R(null,2,5,S,[Ve(new A(null,
"follows","follows",883339250,null),new A(null,"?x","?x",-555096650,null),new A(null,"?y","?y",-1454470631,null)),new R(null,3,5,S,[new A(null,"?x","?x",-555096650,null),Qk,new A(null,"?y","?y",-1454470631,null)],null)],null),new R(null,3,5,S,[Ve(new A(null,"follows","follows",883339250,null),new A(null,"?x","?x",-555096650,null),new A(null,"?y","?y",-1454470631,null)),new R(null,3,5,S,[new A(null,"?x","?x",-555096650,null),Qk,new A(null,"?t","?t",1786819229,null)],null),Ve(new A(null,"follows","follows",
883339250,null),new A(null,"?t","?t",1786819229,null),new A(null,"?y","?y",-1454470631,null))],null)],null);zv.g?zv.g(e,f,h):zv.call(null,e,f,h);d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),$a(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p),null,null)}}(b,a,c,d,L,V,z,f,h,D,v)(Ji(5))}()),n=te(Ge,p),t=nw(p),y=te(Fe,p);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,2,[km,"rules",Ul,f],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",
U(F([new m(null,4,[tl,t,Gj,n,xl,y,lk,p],null)],0)),"}"],0)):Zi(F(["[ min:",ow(n),"] [ med:",ow(t),"] [ max:",ow(y),"] ms"],0));b=C(D);a=null;c=0}d=0}else return null}}ia("datascript.bench.bench_rules",Bw);
function Cw(){for(var b=q(new R(null,3,5,S,[new R(null,2,5,S,["sorted-set",Ai()],null),new R(null,2,5,S,["vector",Ed],null),new R(null,2,5,S,["btset",Uo(me)],null)],null)),a=null,c=0,d=0;;)if(d<c){for(var e=a.R(null,d),f=H(e,0),h=H(e,1),k=q(new R(null,3,5,S,[100,500,2E4],null)),l=null,p=0,n=0;;)if(n<p){var t=l.R(null,n),y=re(Ji(t)),v=re(y),D=O.b(h,y),z=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-conj",dl,t],null))].join("")],0)),L=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>
d)O.b(h,y),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),V=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J){return function Kd(L){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,Xk){return function(){for(;;){var a=q(L);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l)O.b(Xk,p),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);
a+=1}else return!0}()?gf(jf(d),Kd(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d)O.b(Xk,p),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Kd(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J),null,null)}}(k,l,p,n,b,a,c,d,z,L,y,v,D,t,e,f,h)(Ji(5))}()),ta=te(Ge,V),Na=nw(V),Ma=te(Fe,V);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-conj",dl,t],null)],0)),"\n  :env    ",U(F([new m(null,1,
[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,Na,Gj,ta,xl,Ma,lk,V],null)],0)),"}"],0)):Zi(F(["[ min:",ow(ta),"] [ med:",ow(Na),"] [ max:",ow(Ma),"] ms"],0));if(r(Ni(/set/,f))){var Fa=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-disj",dl,t],null))].join("")],0)),J=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)w(Sd,D,v),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),ib=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J){return function Kd(L){return new af(null,
function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(L);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l)w(Sd,v,t),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Kd(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d)w(Sd,v,t),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-
a)/c}}(),Kd(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J),null,null)}}(k,l,p,n,b,a,c,d,Fa,J,y,v,D,t,e,f,h)(Ji(5))}()),W=te(Ge,ib),Q=nw(ib),P=te(Fe,ib);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-disj",dl,t],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,Q,Gj,W,xl,P,lk,ib],null)],0)),"}"],0)):Zi(F(["[ min:",ow(W),"] [ med:",ow(Q),"] [ max:",ow(P),"] ms"],0));var ea=r(null)?null:Zi(F([[u("\n"),
u(new m(null,3,[Xl,f,km,"set-lookup",dl,t],null))].join("")],0)),pa=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(v),f=null,h=0,k=0;;)if(k<h){var l=f.R(null,k);ge(D,l);k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),ge(D,e),e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),na=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J){return function Kd(L){return new af(null,function(a,b,c,d,e,
f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(L);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l){for(var n=q(t),p=null,y=0,z=0;;)if(z<y){var D=p.R(null,z);ge(v,D);z+=1}else if(n=q(n))p=n,$d(p)?(n=hc(p),z=ic(p),p=n,y=G(n),n=z):(n=B(p),ge(v,n),n=C(p),p=null,y=0),z=0;else break;l+=1}else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Kd(ic(a))):
gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(t),f=null,h=0,k=0;;)if(k<h){var l=f.R(null,k);ge(v,l);k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),ge(v,e),e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Kd(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J),null,null)}}(k,l,p,n,b,a,c,d,ea,pa,y,v,D,t,e,f,h)(Ji(5))}()),$a=te(Ge,na),lb=nw(na),jb=te(Fe,na);r(null)?Zi(F(["{ :context",
U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-lookup",dl,t],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,lb,Gj,$a,xl,jb,lk,na],null)],0)),"}"],0)):Zi(F(["[ min:",ow($a),"] [ med:",ow(lb),"] [ max:",ow(jb),"] ms"],0))}var gb=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-iterate",dl,t],null))].join("")],0)),zb=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(D),f=null,h=0,k=0;;)if(k<h){var l=
f.R(null,k);1+l;k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),1+e,e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),ob=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J){return function Kd(L){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(L);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=
0;;)if(10>l){for(var n=q(v),p=null,t=0,y=0;;)if(y<t){var z=p.R(null,y);1+z;y+=1}else if(n=q(n))p=n,$d(p)?(n=hc(p),y=ic(p),p=n,t=G(n),n=y):(n=B(p),1+n,n=C(p),p=null,t=0),y=0;else break;l+=1}else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Kd(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(v),f=null,h=0,k=0;;)if(k<h){var l=f.R(null,k);1+l;k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=
e,h=G(e),e=k):(e=B(f),1+e,e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Kd(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J),null,null)}}(k,l,p,n,b,a,c,d,gb,zb,y,v,D,t,e,f,h)(Ji(5))}()),Eb=te(Ge,ob),Lb=nw(ob),Xb=te(Fe,ob);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-iterate",dl,t],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,Lb,Gj,Eb,xl,Xb,lk,
ob],null)],0)),"}"],0)):Zi(F(["[ min:",ow(Eb),"] [ med:",ow(Lb),"] [ max:",ow(Xb),"] ms"],0));var Dc=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-reduce",dl,t],null))].join("")],0)),Lc=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)w(xe,0,D),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Ec=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J){return function Kd(L){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=
q(L);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l)w(xe,0,v),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Kd(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d)w(xe,0,v),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Kd(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,
D,J),null,null)}}(k,l,p,n,b,a,c,d,Dc,Lc,y,v,D,t,e,f,h)(Ji(5))}()),Tc=te(Ge,Ec),vd=nw(Ec),id=te(Fe,Ec);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-reduce",dl,t],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,vd,Gj,Tc,xl,id,lk,Ec],null)],0)),"}"],0)):Zi(F(["[ min:",ow(Tc),"] [ med:",ow(vd),"] [ max:",ow(id),"] ms"],0));n+=1}else{var bd=q(k);if(bd){var Oc=bd;if($d(Oc))var nd=hc(Oc),qf=ic(Oc),Lg=nd,Xf=
G(nd),k=qf,l=Lg,p=Xf;else{var Tb=B(Oc),xc=re(Ji(Tb)),yc=re(xc),cd=O.b(h,xc),rf=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-conj",dl,Tb],null))].join("")],0)),hp=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)O.b(h,xc),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),sf=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P){return function Gb(Q){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,Xk){return function(){for(;;){var a=
q(Q);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l)O.b(Xk,p),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Gb(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d)O.b(Xk,p),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Gb(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,
D,J,L,P),null,null)}}(k,l,p,n,b,a,c,d,rf,hp,xc,yc,cd,Tb,Oc,bd,e,f,h)(Ji(5))}()),Gh=te(Ge,sf),Dk=nw(sf),tf=te(Fe,sf);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-conj",dl,Tb],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,Dk,Gj,Gh,xl,tf,lk,sf],null)],0)),"}"],0)):Zi(F(["[ min:",ow(Gh),"] [ med:",ow(Dk),"] [ max:",ow(tf),"] ms"],0));if(r(Ni(/set/,f))){var tm=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,
[Xl,f,km,"set-disj",dl,Tb],null))].join("")],0)),Hh=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)w(Sd,cd,yc),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),hj=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P){return function Gb(Q){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(Q);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+
f,k=10;;){for(var l=0;;)if(10>l)w(Sd,v,t),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Gb(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d)w(Sd,v,t),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Gb(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P),null,null)}}(k,l,p,n,b,a,c,d,tm,Hh,xc,yc,cd,Tb,Oc,bd,e,f,h)(Ji(5))}()),um=te(Ge,hj),Ek=nw(hj),Fk=te(Fe,hj);r(null)?Zi(F(["{ :context",
U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-disj",dl,Tb],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,Ek,Gj,um,xl,Fk,lk,hj],null)],0)),"}"],0)):Zi(F(["[ min:",ow(um),"] [ med:",ow(Ek),"] [ max:",ow(Fk),"] ms"],0));var ip=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-lookup",dl,Tb],null))].join("")],0)),jp=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(yc),f=null,h=0,k=0;;)if(k<h){var l=
f.R(null,k);ge(cd,l);k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),ge(cd,e),e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Ih=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P){return function Gb(Q){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(Q);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=
1E3+f,k=10;;){for(var l=0;;)if(10>l){for(var n=q(t),p=null,y=0,z=0;;)if(z<y){var D=p.R(null,z);ge(v,D);z+=1}else if(n=q(n))p=n,$d(p)?(n=hc(p),z=ic(p),p=n,y=G(n),n=z):(n=B(p),ge(v,n),n=C(p),p=null,y=0),z=0;else break;l+=1}else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Gb(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(t),f=null,h=0,k=0;;)if(k<h){var l=f.R(null,k);ge(v,l);k+=1}else if(e=
q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),ge(v,e),e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Gb(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P),null,null)}}(k,l,p,n,b,a,c,d,ip,jp,xc,yc,cd,Tb,Oc,bd,e,f,h)(Ji(5))}()),vm=te(Ge,Ih),ij=nw(Ih),wm=te(Fe,Ih);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-lookup",dl,Tb],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",
U(F([new m(null,4,[tl,ij,Gj,vm,xl,wm,lk,Ih],null)],0)),"}"],0)):Zi(F(["[ min:",ow(vm),"] [ med:",ow(ij),"] [ max:",ow(wm),"] ms"],0))}var xm=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-iterate",dl,Tb],null))].join("")],0)),ym=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(cd),f=null,h=0,k=0;;)if(k<h){var l=f.R(null,k);1+l;k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),1+e,e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<
b)c=10+c;else return(d-a)/c}}(),jj=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P){return function Gb(Q){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(Q);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l){for(var n=q(v),p=null,t=0,y=0;;)if(y<t){var z=p.R(null,y);1+z;y+=1}else if(n=q(n))p=n,$d(p)?(n=hc(p),y=ic(p),p=n,t=G(n),n=
y):(n=B(p),1+n,n=C(p),p=null,t=0),y=0;else break;l+=1}else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Gb(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(v),f=null,h=0,k=0;;)if(k<h){var l=f.R(null,k);1+l;k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),1+e,e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Gb(Mc(a)))}return null}}}(a,
b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P),null,null)}}(k,l,p,n,b,a,c,d,xm,ym,xc,yc,cd,Tb,Oc,bd,e,f,h)(Ji(5))}()),zm=te(Ge,jj),Gk=nw(jj),Am=te(Fe,jj);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-iterate",dl,Tb],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,Gk,Gj,zm,xl,Am,lk,jj],null)],0)),"}"],0)):Zi(F(["[ min:",ow(zm),"] [ med:",ow(Gk),"] [ max:",ow(Am),"] ms"],0));var Bm=r(null)?null:Zi(F([[u("\n"),u(new m(null,
3,[Xl,f,km,"set-reduce",dl,Tb],null))].join("")],0)),kp=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)w(xe,0,cd),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),kj=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P){return function Gb(Q){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(Q);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+
f,k=10;;){for(var l=0;;)if(10>l)w(xe,0,v),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Gb(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d)w(xe,0,v),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Gb(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P),null,null)}}(k,l,p,n,b,a,c,d,Bm,kp,xc,yc,cd,Tb,Oc,bd,e,f,h)(Ji(5))}()),Hk=te(Ge,kj),Cm=nw(kj),Ik=te(Fe,kj);r(null)?Zi(F(["{ :context",
U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-reduce",dl,Tb],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,Cm,Gj,Hk,xl,Ik,lk,kj],null)],0)),"}"],0)):Zi(F(["[ min:",ow(Hk),"] [ med:",ow(Cm),"] [ max:",ow(Ik),"] ms"],0));k=C(Oc);l=null;p=0}n=0}else break}d+=1}else{var Gd=q(b);if(Gd){var zc=Gd;if($d(zc))var Dm=hc(zc),Em=ic(zc),Fm=Dm,lp=G(Dm),b=Em,a=Fm,c=lp;else{for(var od=B(zc),f=H(od,0),h=H(od,1),pd=q(new R(null,3,5,S,[100,500,
2E4],null)),qd=null,rd=0,Jc=0;;)if(Jc<rd){var Ac=qd.R(null,Jc),uf=re(Ji(Ac)),Yf=re(uf),Xd=O.b(h,uf),mp=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-conj",dl,Ac],null))].join("")],0)),Gm=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)O.b(h,uf),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Jh=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P){return function Gb(Q){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J){return function(){for(;;){var a=
q(Q);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l)O.b(J,p),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Gb(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d)O.b(J,p),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Gb(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,
J,L,P),null,null)}}(pd,qd,rd,Jc,b,a,c,d,mp,Gm,uf,Yf,Xd,Ac,od,f,h,zc,Gd)(Ji(5))}()),Hm=te(Ge,Jh),Jk=nw(Jh),Im=te(Fe,Jh);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-conj",dl,Ac],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,Jk,Gj,Hm,xl,Im,lk,Jh],null)],0)),"}"],0)):Zi(F(["[ min:",ow(Hm),"] [ med:",ow(Jk),"] [ max:",ow(Im),"] ms"],0));if(r(Ni(/set/,f))){var np=r(null)?null:Zi(F([[u("\n"),u(new m(null,
3,[Xl,f,km,"set-disj",dl,Ac],null))].join("")],0)),Jm=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)w(Sd,Xd,Yf),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),lj=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P){return function Gb(Q){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(Q);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+
f,k=10;;){for(var l=0;;)if(10>l)w(Sd,v,t),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Gb(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d)w(Sd,v,t),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Gb(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P),null,null)}}(pd,qd,rd,Jc,b,a,c,d,np,Jm,uf,Yf,Xd,Ac,od,f,h,zc,Gd)(Ji(5))}()),Mg=te(Ge,lj),Km=nw(lj),Kk=te(Fe,lj);r(null)?
Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-disj",dl,Ac],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,Km,Gj,Mg,xl,Kk,lk,lj],null)],0)),"}"],0)):Zi(F(["[ min:",ow(Mg),"] [ med:",ow(Km),"] [ max:",ow(Kk),"] ms"],0));var op=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-lookup",dl,Ac],null))].join("")],0)),Lm=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(Yf),f=null,h=
0,k=0;;)if(k<h){var l=f.R(null,k);ge(Xd,l);k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),ge(Xd,e),e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),mj=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P){return function Gb(Q){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(Q);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=
d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l){for(var n=q(t),p=null,y=0,z=0;;)if(z<y){var D=p.R(null,z);ge(v,D);z+=1}else if(n=q(n))p=n,$d(p)?(n=hc(p),z=ic(p),p=n,y=G(n),n=z):(n=B(p),ge(v,n),n=C(p),p=null,y=0),z=0;else break;l+=1}else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Gb(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(t),f=null,h=0,k=0;;)if(k<h){var l=f.R(null,k);
ge(v,l);k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),ge(v,e),e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Gb(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P),null,null)}}(pd,qd,rd,Jc,b,a,c,d,op,Lm,uf,Yf,Xd,Ac,od,f,h,zc,Gd)(Ji(5))}()),Lk=te(Ge,mj),Zr=nw(mj),$r=te(Fe,mj);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-lookup",dl,Ac],null)],0)),"\n  :env    ",U(F([new m(null,
1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,Zr,Gj,Lk,xl,$r,lk,mj],null)],0)),"}"],0)):Zi(F(["[ min:",ow(Lk),"] [ med:",ow(Zr),"] [ max:",ow($r),"] ms"],0))}var Tu=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-iterate",dl,Ac],null))].join("")],0)),Uu=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(Xd),f=null,h=0,k=0;;)if(k<h){var l=f.R(null,k);1+l;k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),1+e,e=C(f),f=null,h=0),k=0;
else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),sm=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P){return function Gb(Q){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(Q);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l){for(var n=q(v),p=null,t=0,y=0;;)if(y<t){var z=p.R(null,y);1+z;y+=1}else if(n=q(n))p=
n,$d(p)?(n=hc(p),y=ic(p),p=n,t=G(n),n=y):(n=B(p),1+n,n=C(p),p=null,t=0),y=0;else break;l+=1}else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Gb(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(v),f=null,h=0,k=0;;)if(k<h){var l=f.R(null,k);1+l;k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),1+e,e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-
a)/c}}(),Gb(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P),null,null)}}(pd,qd,rd,Jc,b,a,c,d,Tu,Uu,uf,Yf,Xd,Ac,od,f,h,zc,Gd)(Ji(5))}()),as=te(Ge,sm),at=nw(sm),bt=te(Fe,sm);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-iterate",dl,Ac],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,at,Gj,as,xl,bt,lk,sm],null)],0)),"}"],0)):Zi(F(["[ min:",ow(as),"] [ med:",ow(at),"] [ max:",ow(bt),"] ms"],
0));var jw=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-reduce",dl,Ac],null))].join("")],0)),kw=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)w(xe,0,Xd),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),cn=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P){return function Gb(Q){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(Q);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=
0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l)w(xe,0,v),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Gb(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d)w(xe,0,v),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Gb(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P),null,null)}}(pd,qd,rd,Jc,b,a,c,d,jw,kw,uf,Yf,Xd,Ac,od,f,h,zc,Gd)(Ji(5))}()),
ct=te(Ge,cn),dt=nw(cn),et=te(Fe,cn);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-reduce",dl,Ac],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,dt,Gj,ct,xl,et,lk,cn],null)],0)),"}"],0)):Zi(F(["[ min:",ow(ct),"] [ med:",ow(dt),"] [ max:",ow(et),"] ms"],0));Jc+=1}else{var oi=q(pd);if(oi){var Cf=oi;if($d(Cf))var ut=hc(Cf),Dw=ic(Cf),Ew=ut,Fw=G(ut),pd=Dw,qd=Ew,rd=Fw;else{var dd=B(Cf),$g=re(Ji(dd)),pi=re($g),
Df=O.b(h,$g),Gw=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-conj",dl,dd],null))].join("")],0)),Hw=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)O.b(h,$g),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),jn=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P,Q,V){return function Ld(W){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P){return function(){for(;;){var a=q(W);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=
0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l)O.b(P,p),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Ld(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d)O.b(P,p),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Ld(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P,Q,V),null,null)}}(pd,qd,rd,Jc,b,a,c,d,Gw,Hw,$g,pi,Df,dd,Cf,oi,od,f,h,
zc,Gd)(Ji(5))}()),vt=te(Ge,jn),wt=nw(jn),xt=te(Fe,jn);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-conj",dl,dd],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,wt,Gj,vt,xl,xt,lk,jn],null)],0)),"}"],0)):Zi(F(["[ min:",ow(vt),"] [ med:",ow(wt),"] [ max:",ow(xt),"] ms"],0));if(r(Ni(/set/,f))){var Iw=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-disj",dl,dd],null))].join("")],0)),Jw=function(){for(var a=
Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)w(Sd,Df,pi),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),kn=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P,Q,V){return function Ld(W){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(W);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l)w(Sd,v,t),l+=1;else break;l=Z();if(l<
h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Ld(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d)w(Sd,v,t),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Ld(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P,Q,V),null,null)}}(pd,qd,rd,Jc,b,a,c,d,Iw,Jw,$g,pi,Df,dd,Cf,oi,od,f,h,zc,Gd)(Ji(5))}()),yt=te(Ge,kn),zt=nw(kn),At=te(Fe,kn);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,
3,[Xl,f,km,"set-disj",dl,dd],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,zt,Gj,yt,xl,At,lk,kn],null)],0)),"}"],0)):Zi(F(["[ min:",ow(yt),"] [ med:",ow(zt),"] [ max:",ow(At),"] ms"],0));var Kw=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-lookup",dl,dd],null))].join("")],0)),Lw=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(pi),f=null,h=0,k=0;;)if(k<h){var l=f.R(null,k);ge(Df,l);k+=1}else if(e=q(e))f=
e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),ge(Df,e),e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),ln=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P,Q,V){return function Ld(W){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(W);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l){for(var n=
q(t),p=null,y=0,z=0;;)if(z<y){var D=p.R(null,z);ge(v,D);z+=1}else if(n=q(n))p=n,$d(p)?(n=hc(p),z=ic(p),p=n,y=G(n),n=z):(n=B(p),ge(v,n),n=C(p),p=null,y=0),z=0;else break;l+=1}else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Ld(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(t),f=null,h=0,k=0;;)if(k<h){var l=f.R(null,k);ge(v,l);k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=
k):(e=B(f),ge(v,e),e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Ld(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P,Q,V),null,null)}}(pd,qd,rd,Jc,b,a,c,d,Kw,Lw,$g,pi,Df,dd,Cf,oi,od,f,h,zc,Gd)(Ji(5))}()),Bt=te(Ge,ln),Ct=nw(ln),Dt=te(Fe,ln);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-lookup",dl,dd],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,
[tl,Ct,Gj,Bt,xl,Dt,lk,ln],null)],0)),"}"],0)):Zi(F(["[ min:",ow(Bt),"] [ med:",ow(Ct),"] [ max:",ow(Dt),"] ms"],0))}var Mw=r(null)?null:Zi(F([[u("\n"),u(new m(null,3,[Xl,f,km,"set-iterate",dl,dd],null))].join("")],0)),Nw=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(Df),f=null,h=0,k=0;;)if(k<h){var l=f.R(null,k);1+l;k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),1+e,e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-
a)/c}}(),mn=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P,Q,V){return function Ld(W){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(W);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l){for(var n=q(v),p=null,t=0,y=0;;)if(y<t){var z=p.R(null,y);1+z;y+=1}else if(n=q(n))p=n,$d(p)?(n=hc(p),y=ic(p),p=n,t=G(n),n=y):(n=B(p),1+n,n=C(p),
p=null,t=0),y=0;else break;l+=1}else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Ld(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d){for(var e=q(v),f=null,h=0,k=0;;)if(k<h){var l=f.R(null,k);1+l;k+=1}else if(e=q(e))f=e,$d(f)?(e=hc(f),k=ic(f),f=e,h=G(e),e=k):(e=B(f),1+e,e=C(f),f=null,h=0),k=0;else break;d+=1}else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Ld(Mc(a)))}return null}}}(a,b,c,d,e,f,
h,k,l,n,p,t,v,y,z,D,J,L,P,Q,V),null,null)}}(pd,qd,rd,Jc,b,a,c,d,Mw,Nw,$g,pi,Df,dd,Cf,oi,od,f,h,zc,Gd)(Ji(5))}()),Et=te(Ge,mn),Ft=nw(mn),Gt=te(Fe,mn);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-iterate",dl,dd],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,Ft,Gj,Et,xl,Gt,lk,mn],null)],0)),"}"],0)):Zi(F(["[ min:",ow(Et),"] [ med:",ow(Ft),"] [ max:",ow(Gt),"] ms"],0));var Ow=r(null)?null:Zi(F([[u("\n"),
u(new m(null,3,[Xl,f,km,"set-reduce",dl,dd],null))].join("")],0)),Pw=function(){for(var a=Z(),b=500+a,c=10;;){for(var d=0;;)if(10>d)w(xe,0,Df),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),nn=O.b(Ed,function(){return function(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P,Q,V){return function Ld(W){return new af(null,function(a,b,c,d,e,f,h,k,l,n,p,t,v){return function(){for(;;){var a=q(W);if(a){if($d(a)){var b=hc(a),c=G(b),d=ef(c);return function(){for(var a=0;;)if(a<c){x.b(b,a);var e=d,f;a:{f=
Z();for(var h=1E3+f,k=10;;){for(var l=0;;)if(10>l)w(xe,0,v),l+=1;else break;l=Z();if(l<h)k=10+k;else{f=(l-f)/k;break a}}}e.add(f);a+=1}else return!0}()?gf(jf(d),Ld(ic(a))):gf(jf(d),null)}B(a);return td(function(){for(var a=Z(),b=1E3+a,c=10;;){for(var d=0;;)if(10>d)w(xe,0,v),d+=1;else break;d=Z();if(d<b)c=10+c;else return(d-a)/c}}(),Ld(Mc(a)))}return null}}}(a,b,c,d,e,f,h,k,l,n,p,t,v,y,z,D,J,L,P,Q,V),null,null)}}(pd,qd,rd,Jc,b,a,c,d,Ow,Pw,$g,pi,Df,dd,Cf,oi,od,f,h,zc,Gd)(Ji(5))}()),Ht=te(Ge,nn),It=
nw(nn),Jt=te(Fe,nn);r(null)?Zi(F(["{ :context",U(F([null],0)),"\n  :spec   ",U(F([new m(null,3,[Xl,f,km,"set-reduce",dl,dd],null)],0)),"\n  :env    ",U(F([new m(null,1,[il,pw()],null)],0)),"\n  :results",U(F([new m(null,4,[tl,It,Gj,Ht,xl,Jt,lk,nn],null)],0)),"}"],0)):Zi(F(["[ min:",ow(Ht),"] [ med:",ow(It),"] [ max:",ow(Jt),"] ms"],0));pd=C(Cf);qd=null;rd=0}Jc=0}else break}b=C(zc);a=null;c=0}d=0}else return null}}ia("datascript.bench.bench_btset",Cw);
ia("datascript.bench.bench_all",function(){yw();zw();Aw();Bw();return Cw()});aa=global;if(null!=Oa&&Od(Oa))xf(Oa,gg(2,qw.le));else throw Error("cljs.core/*main-cli-fn* not set");
        ;return this.datascript.js;

    }.call({});

});
